% Initializing of fishnet parameters
% Martin Austad, march 2004

% Setting up initial positions

     % Position of net hauler on vessel
     Net.Hauler.Pos = [-0.2 0.2 -0.15];
     
     % Position of lower end of Fishing net, in earth-fixed coordinates
     Net.End.Pos = [10 10 30];    % [x y z]
     
     % Tolerance intervall for fi_relative, in degrees 
     Fi.Tolerance = [-30 0];
     
     % Tolerance intervall for theta_relative, in degrees
     Theta.Tolerance = [-10 10];
     
     % Tolerance intervall for tension, in Newtons
     Net.Tension.Tolerance = [5 100];