/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c124_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c124_IN_NO_ACTIVE_CHILD        (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc124_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c124_MCSim(void);
static void initialize_params_c124_MCSim(void);
static void enable_c124_MCSim(void);
static void disable_c124_MCSim(void);
static void c124_update_debugger_state_c124_MCSim(void);
static const mxArray *get_sim_state_c124_MCSim(void);
static void set_sim_state_c124_MCSim(const mxArray *c124_st);
static void finalize_c124_MCSim(void);
static void sf_c124_MCSim(void);
static void init_script_number_translation(uint32_T c124_machineNumber, uint32_T
  c124_chartNumber);
static const mxArray *c124_sf_marshall(void *c124_chartInstance, void *c124_u);
static const mxArray *c124_b_sf_marshall(void *c124_chartInstance, void *c124_u);
static const mxArray *c124_c_sf_marshall(void *c124_chartInstance, void *c124_u);
static const mxArray *c124_emlrt_marshallOut(uint8_T c124_u);
static void c124_emlrt_marshallIn(const mxArray *c124_delta_alpha, char
  *c124_name, real_T c124_y[3]);
static uint8_T c124_b_emlrt_marshallIn(const mxArray
  *c124_b_is_active_c124_MCSim, char *c124_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c124_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c124_is_active_c124_MCSim = 0U;
}

static void initialize_params_c124_MCSim(void)
{
}

static void enable_c124_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c124_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c124_update_debugger_state_c124_MCSim(void)
{
}

static const mxArray *get_sim_state_c124_MCSim(void)
{
  const mxArray *c124_st = NULL;
  const mxArray *c124_y = NULL;
  int32_T c124_i0;
  real_T c124_u[3];
  const mxArray *c124_b_y = NULL;
  real_T (*c124_delta_alpha)[3];
  c124_delta_alpha = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 1);
  c124_st = NULL;
  c124_y = NULL;
  sf_mex_assign(&c124_y, sf_mex_createcellarray(2));
  for (c124_i0 = 0; c124_i0 < 3; c124_i0 = c124_i0 + 1) {
    c124_u[c124_i0] = (*c124_delta_alpha)[c124_i0];
  }

  c124_b_y = NULL;
  sf_mex_assign(&c124_b_y, sf_mex_create("y", &c124_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_setcell(c124_y, 0, c124_b_y);
  sf_mex_setcell(c124_y, 1, c124_emlrt_marshallOut
                 (chartInstance.c124_is_active_c124_MCSim));
  sf_mex_assign(&c124_st, c124_y);
  return c124_st;
}

static void set_sim_state_c124_MCSim(const mxArray *c124_st)
{
  const mxArray *c124_u;
  real_T c124_dv0[3];
  int32_T c124_i1;
  real_T (*c124_delta_alpha)[3];
  c124_delta_alpha = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c124_doneDoubleBufferReInit = true;
  c124_u = sf_mex_dup(c124_st);
  c124_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c124_u, 0)), "delta_alpha",
                        c124_dv0);
  for (c124_i1 = 0; c124_i1 < 3; c124_i1 = c124_i1 + 1) {
    (*c124_delta_alpha)[c124_i1] = c124_dv0[c124_i1];
  }

  chartInstance.c124_is_active_c124_MCSim = c124_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c124_u, 1)), "is_active_c124_MCSim");
  sf_mex_destroy(&c124_u);
  c124_update_debugger_state_c124_MCSim();
  sf_mex_destroy(&c124_st);
}

static void finalize_c124_MCSim(void)
{
}

static void sf_c124_MCSim(void)
{
  int32_T c124_i2;
  int32_T c124_i3;
  uint8_T c124_previousEvent;
  int32_T c124_i4;
  real_T c124_x[9];
  real_T c124_nargout = 1.0;
  real_T c124_nargin = 1.0;
  real_T c124_delta_alpha[3];
  int32_T c124_i5;
  int32_T c124_i6;
  real_T (*c124_b_delta_alpha)[3];
  real_T (*c124_b_x)[9];
  c124_b_delta_alpha = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 1);
  c124_b_x = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,123);
  for (c124_i2 = 0; c124_i2 < 9; c124_i2 = c124_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c124_b_x)[c124_i2], 0U);
  }

  for (c124_i3 = 0; c124_i3 < 3; c124_i3 = c124_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c124_b_delta_alpha)[c124_i3], 1U);
  }

  c124_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,123);
  for (c124_i4 = 0; c124_i4 < 9; c124_i4 = c124_i4 + 1) {
    c124_x[c124_i4] = (*c124_b_x)[c124_i4];
  }

  sf_debug_symbol_scope_push(4U, 0U);
  sf_debug_symbol_scope_add("nargout", &c124_nargout, c124_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c124_nargin, c124_c_sf_marshall);
  sf_debug_symbol_scope_add("delta_alpha", &c124_delta_alpha, c124_b_sf_marshall);
  sf_debug_symbol_scope_add("x", &c124_x, c124_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  for (c124_i5 = 0; c124_i5 < 3; c124_i5 = c124_i5 + 1) {
    c124_delta_alpha[c124_i5] = 0.0;
  }

  _SFD_EML_CALL(0,4);
  c124_delta_alpha[0] = c124_x[3];
  _SFD_EML_CALL(0,5);
  c124_delta_alpha[1] = c124_x[4];
  _SFD_EML_CALL(0,6);
  c124_delta_alpha[2] = c124_x[5];
  _SFD_EML_CALL(0,-6);
  sf_debug_symbol_scope_pop();
  for (c124_i6 = 0; c124_i6 < 3; c124_i6 = c124_i6 + 1) {
    (*c124_b_delta_alpha)[c124_i6] = c124_delta_alpha[c124_i6];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,123);
  _sfEvent_ = c124_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c124_machineNumber, uint32_T
  c124_chartNumber)
{
}

static const mxArray *c124_sf_marshall(void *c124_chartInstance, void *c124_u)
{
  const mxArray *c124_y = NULL;
  int32_T c124_i7;
  real_T c124_b_u[9];
  const mxArray *c124_b_y = NULL;
  c124_y = NULL;
  for (c124_i7 = 0; c124_i7 < 9; c124_i7 = c124_i7 + 1) {
    c124_b_u[c124_i7] = (*((real_T (*)[9])c124_u))[c124_i7];
  }

  c124_b_y = NULL;
  sf_mex_assign(&c124_b_y, sf_mex_create("y", &c124_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_assign(&c124_y, c124_b_y);
  return c124_y;
}

static const mxArray *c124_b_sf_marshall(void *c124_chartInstance, void *c124_u)
{
  const mxArray *c124_y = NULL;
  int32_T c124_i8;
  real_T c124_b_u[3];
  const mxArray *c124_b_y = NULL;
  c124_y = NULL;
  for (c124_i8 = 0; c124_i8 < 3; c124_i8 = c124_i8 + 1) {
    c124_b_u[c124_i8] = (*((real_T (*)[3])c124_u))[c124_i8];
  }

  c124_b_y = NULL;
  sf_mex_assign(&c124_b_y, sf_mex_create("y", &c124_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c124_y, c124_b_y);
  return c124_y;
}

static const mxArray *c124_c_sf_marshall(void *c124_chartInstance, void *c124_u)
{
  const mxArray *c124_y = NULL;
  real_T c124_b_u;
  const mxArray *c124_b_y = NULL;
  c124_y = NULL;
  c124_b_u = *((real_T *)c124_u);
  c124_b_y = NULL;
  sf_mex_assign(&c124_b_y, sf_mex_create("y", &c124_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c124_y, c124_b_y);
  return c124_y;
}

const mxArray *sf_c124_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c124_nameCaptureInfo = NULL;
  c124_nameCaptureInfo = NULL;
  sf_mex_assign(&c124_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1));
  return c124_nameCaptureInfo;
}

static const mxArray *c124_emlrt_marshallOut(uint8_T c124_u)
{
  const mxArray *c124_y = NULL;
  c124_y = NULL;
  sf_mex_assign(&c124_y, sf_mex_create("y", &c124_u, 3, 0U, 0U, 0U, 0));
  return c124_y;
}

static void c124_emlrt_marshallIn(const mxArray *c124_delta_alpha, char
  *c124_name, real_T c124_y[3])
{
  real_T c124_dv1[3];
  int32_T c124_i9;
  sf_mex_import(c124_name, sf_mex_dup(c124_delta_alpha), &c124_dv1, 1, 0, 0U, 1,
                0U, 1, 3);
  for (c124_i9 = 0; c124_i9 < 3; c124_i9 = c124_i9 + 1) {
    c124_y[c124_i9] = c124_dv1[c124_i9];
  }

  sf_mex_destroy(&c124_delta_alpha);
}

static uint8_T c124_b_emlrt_marshallIn(const mxArray
  *c124_b_is_active_c124_MCSim, char *c124_name)
{
  uint8_T c124_y;
  uint8_T c124_u0;
  sf_mex_import(c124_name, sf_mex_dup(c124_b_is_active_c124_MCSim), &c124_u0, 1,
                3, 0U, 0, 0U, 0);
  c124_y = c124_u0;
  sf_mex_destroy(&c124_b_is_active_c124_MCSim);
  return c124_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c124_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(203083483U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(824856574U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(623455327U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3927429195U);
}

mxArray *sf_c124_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(933458826U);
    pr[1] = (double)(1485098331U);
    pr[2] = (double)(757040592U);
    pr[3] = (double)(4277283772U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c124_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"delta_alpha\",},{M[8],M[0],T\"is_active_c124_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c124_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          124,
          1,
          1,
          2,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"x",0,c124_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"delta_alpha",0,c124_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,146);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c124_x)[9];
          real_T (*c124_delta_alpha)[3];
          c124_delta_alpha = (real_T (*)[3])ssGetOutputPortSignal
            (chartInstance.S, 1);
          c124_x = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c124_x);
          _SFD_SET_DATA_VALUE_PTR(1U, c124_delta_alpha);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c124_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c124_MCSim();
  initialize_c124_MCSim();
}

static void sf_opaque_enable_c124_MCSim(void *chartInstanceVar)
{
  enable_c124_MCSim();
}

static void sf_opaque_disable_c124_MCSim(void *chartInstanceVar)
{
  disable_c124_MCSim();
}

static void sf_opaque_gateway_c124_MCSim(void *chartInstanceVar)
{
  sf_c124_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c124_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c124_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c124_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c124_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c124_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c124_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c124_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c124_MCSim();
  }
}

static void mdlSetWorkWidths_c124_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",124);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",124,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",124,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",124,1);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",124,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",124);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2684582078U));
  ssSetChecksum1(S,(49588846U));
  ssSetChecksum2(S,(1941840515U));
  ssSetChecksum3(S,(1938403620U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c124_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",124);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c124_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c124_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c124_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c124_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c124_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c124_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c124_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c124_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c124_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c124_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c124_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c124_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c124_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c124_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c124_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c124_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c124_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
