/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c126_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c126_IN_NO_ACTIVE_CHILD        (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc126_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c126_MCSim(void);
static void initialize_params_c126_MCSim(void);
static void enable_c126_MCSim(void);
static void disable_c126_MCSim(void);
static void c126_update_debugger_state_c126_MCSim(void);
static const mxArray *get_sim_state_c126_MCSim(void);
static void set_sim_state_c126_MCSim(const mxArray *c126_st);
static void finalize_c126_MCSim(void);
static void sf_c126_MCSim(void);
static void init_script_number_translation(uint32_T c126_machineNumber, uint32_T
  c126_chartNumber);
static const mxArray *c126_sf_marshall(void *c126_chartInstance, void *c126_u);
static const mxArray *c126_b_sf_marshall(void *c126_chartInstance, void *c126_u);
static const mxArray *c126_c_sf_marshall(void *c126_chartInstance, void *c126_u);
static const mxArray *c126_emlrt_marshallOut(uint8_T c126_u);
static void c126_emlrt_marshallIn(const mxArray *c126_delta_T, char *c126_name,
  real_T c126_y[3]);
static void c126_b_emlrt_marshallIn(const mxArray *c126_delta_alpha, char
  *c126_name, real_T c126_y[3]);
static void c126_c_emlrt_marshallIn(const mxArray *c126_s, char *c126_name,
  real_T c126_y[3]);
static uint8_T c126_d_emlrt_marshallIn(const mxArray
  *c126_b_is_active_c126_MCSim, char *c126_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c126_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c126_is_active_c126_MCSim = 0U;
}

static void initialize_params_c126_MCSim(void)
{
}

static void enable_c126_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c126_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c126_update_debugger_state_c126_MCSim(void)
{
}

static const mxArray *get_sim_state_c126_MCSim(void)
{
  const mxArray *c126_st = NULL;
  const mxArray *c126_y = NULL;
  int32_T c126_i0;
  real_T c126_u[3];
  const mxArray *c126_b_y = NULL;
  int32_T c126_i1;
  real_T c126_b_u[3];
  const mxArray *c126_c_y = NULL;
  int32_T c126_i2;
  real_T c126_c_u[3];
  const mxArray *c126_d_y = NULL;
  real_T (*c126_s)[3];
  real_T (*c126_delta_alpha)[3];
  real_T (*c126_delta_T)[3];
  c126_s = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 3);
  c126_delta_alpha = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 2);
  c126_delta_T = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 1);
  c126_st = NULL;
  c126_y = NULL;
  sf_mex_assign(&c126_y, sf_mex_createcellarray(4));
  for (c126_i0 = 0; c126_i0 < 3; c126_i0 = c126_i0 + 1) {
    c126_u[c126_i0] = (*c126_delta_T)[c126_i0];
  }

  c126_b_y = NULL;
  sf_mex_assign(&c126_b_y, sf_mex_create("y", &c126_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_setcell(c126_y, 0, c126_b_y);
  for (c126_i1 = 0; c126_i1 < 3; c126_i1 = c126_i1 + 1) {
    c126_b_u[c126_i1] = (*c126_delta_alpha)[c126_i1];
  }

  c126_c_y = NULL;
  sf_mex_assign(&c126_c_y, sf_mex_create("y", &c126_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_setcell(c126_y, 1, c126_c_y);
  for (c126_i2 = 0; c126_i2 < 3; c126_i2 = c126_i2 + 1) {
    c126_c_u[c126_i2] = (*c126_s)[c126_i2];
  }

  c126_d_y = NULL;
  sf_mex_assign(&c126_d_y, sf_mex_create("y", &c126_c_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_setcell(c126_y, 2, c126_d_y);
  sf_mex_setcell(c126_y, 3, c126_emlrt_marshallOut
                 (chartInstance.c126_is_active_c126_MCSim));
  sf_mex_assign(&c126_st, c126_y);
  return c126_st;
}

static void set_sim_state_c126_MCSim(const mxArray *c126_st)
{
  const mxArray *c126_u;
  real_T c126_dv0[3];
  int32_T c126_i3;
  real_T c126_dv1[3];
  int32_T c126_i4;
  real_T c126_dv2[3];
  int32_T c126_i5;
  real_T (*c126_delta_T)[3];
  real_T (*c126_delta_alpha)[3];
  real_T (*c126_s)[3];
  c126_s = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 3);
  c126_delta_alpha = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 2);
  c126_delta_T = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c126_doneDoubleBufferReInit = true;
  c126_u = sf_mex_dup(c126_st);
  c126_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c126_u, 0)), "delta_T",
                        c126_dv0);
  for (c126_i3 = 0; c126_i3 < 3; c126_i3 = c126_i3 + 1) {
    (*c126_delta_T)[c126_i3] = c126_dv0[c126_i3];
  }

  c126_b_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c126_u, 1)), "delta_alpha",
    c126_dv1);
  for (c126_i4 = 0; c126_i4 < 3; c126_i4 = c126_i4 + 1) {
    (*c126_delta_alpha)[c126_i4] = c126_dv1[c126_i4];
  }

  c126_c_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c126_u, 2)), "s", c126_dv2);
  for (c126_i5 = 0; c126_i5 < 3; c126_i5 = c126_i5 + 1) {
    (*c126_s)[c126_i5] = c126_dv2[c126_i5];
  }

  chartInstance.c126_is_active_c126_MCSim = c126_d_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c126_u, 3)), "is_active_c126_MCSim");
  sf_mex_destroy(&c126_u);
  c126_update_debugger_state_c126_MCSim();
  sf_mex_destroy(&c126_st);
}

static void finalize_c126_MCSim(void)
{
}

static void sf_c126_MCSim(void)
{
  int32_T c126_i6;
  int32_T c126_i7;
  int32_T c126_i8;
  int32_T c126_i9;
  uint8_T c126_previousEvent;
  int32_T c126_i10;
  real_T c126_solution[9];
  real_T c126_nargout = 3.0;
  real_T c126_nargin = 1.0;
  real_T c126_s[3];
  real_T c126_delta_alpha[3];
  real_T c126_delta_T[3];
  int32_T c126_i11;
  int32_T c126_i12;
  int32_T c126_i13;
  int32_T c126_i14;
  int32_T c126_i15;
  int32_T c126_i16;
  real_T (*c126_b_delta_T)[3];
  real_T (*c126_b_delta_alpha)[3];
  real_T (*c126_b_s)[3];
  real_T (*c126_b_solution)[9];
  c126_b_s = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 3);
  c126_b_solution = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 0);
  c126_b_delta_alpha = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 2);
  c126_b_delta_T = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,125);
  for (c126_i6 = 0; c126_i6 < 9; c126_i6 = c126_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c126_b_solution)[c126_i6], 0U);
  }

  for (c126_i7 = 0; c126_i7 < 3; c126_i7 = c126_i7 + 1) {
    _SFD_DATA_RANGE_CHECK((*c126_b_delta_T)[c126_i7], 1U);
  }

  for (c126_i8 = 0; c126_i8 < 3; c126_i8 = c126_i8 + 1) {
    _SFD_DATA_RANGE_CHECK((*c126_b_delta_alpha)[c126_i8], 2U);
  }

  for (c126_i9 = 0; c126_i9 < 3; c126_i9 = c126_i9 + 1) {
    _SFD_DATA_RANGE_CHECK((*c126_b_s)[c126_i9], 3U);
  }

  c126_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,125);
  for (c126_i10 = 0; c126_i10 < 9; c126_i10 = c126_i10 + 1) {
    c126_solution[c126_i10] = (*c126_b_solution)[c126_i10];
  }

  sf_debug_symbol_scope_push(6U, 0U);
  sf_debug_symbol_scope_add("nargout", &c126_nargout, c126_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c126_nargin, c126_c_sf_marshall);
  sf_debug_symbol_scope_add("s", &c126_s, c126_b_sf_marshall);
  sf_debug_symbol_scope_add("delta_alpha", &c126_delta_alpha, c126_b_sf_marshall);
  sf_debug_symbol_scope_add("delta_T", &c126_delta_T, c126_b_sf_marshall);
  sf_debug_symbol_scope_add("solution", &c126_solution, c126_sf_marshall);
  CV_EML_FCN(0, 0);

  /* numOfThrusters and numOfAzimuths are parameters thus not an input and should be decleared in the workspace. */
  _SFD_EML_CALL(0,3);
  for (c126_i11 = 0; c126_i11 < 3; c126_i11 = c126_i11 + 1) {
    c126_delta_T[c126_i11] = c126_solution[c126_i11];
  }

  _SFD_EML_CALL(0,4);
  for (c126_i12 = 0; c126_i12 < 3; c126_i12 = c126_i12 + 1) {
    c126_delta_alpha[c126_i12] = c126_solution[c126_i12 + 3];
  }

  _SFD_EML_CALL(0,5);
  for (c126_i13 = 0; c126_i13 < 3; c126_i13 = c126_i13 + 1) {
    c126_s[c126_i13] = c126_solution[c126_i13 + 6];
  }

  _SFD_EML_CALL(0,-5);
  sf_debug_symbol_scope_pop();
  for (c126_i14 = 0; c126_i14 < 3; c126_i14 = c126_i14 + 1) {
    (*c126_b_delta_T)[c126_i14] = c126_delta_T[c126_i14];
  }

  for (c126_i15 = 0; c126_i15 < 3; c126_i15 = c126_i15 + 1) {
    (*c126_b_delta_alpha)[c126_i15] = c126_delta_alpha[c126_i15];
  }

  for (c126_i16 = 0; c126_i16 < 3; c126_i16 = c126_i16 + 1) {
    (*c126_b_s)[c126_i16] = c126_s[c126_i16];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,125);
  _sfEvent_ = c126_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c126_machineNumber, uint32_T
  c126_chartNumber)
{
}

static const mxArray *c126_sf_marshall(void *c126_chartInstance, void *c126_u)
{
  const mxArray *c126_y = NULL;
  int32_T c126_i17;
  real_T c126_b_u[9];
  const mxArray *c126_b_y = NULL;
  c126_y = NULL;
  for (c126_i17 = 0; c126_i17 < 9; c126_i17 = c126_i17 + 1) {
    c126_b_u[c126_i17] = (*((real_T (*)[9])c126_u))[c126_i17];
  }

  c126_b_y = NULL;
  sf_mex_assign(&c126_b_y, sf_mex_create("y", &c126_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_assign(&c126_y, c126_b_y);
  return c126_y;
}

static const mxArray *c126_b_sf_marshall(void *c126_chartInstance, void *c126_u)
{
  const mxArray *c126_y = NULL;
  int32_T c126_i18;
  real_T c126_b_u[3];
  const mxArray *c126_b_y = NULL;
  c126_y = NULL;
  for (c126_i18 = 0; c126_i18 < 3; c126_i18 = c126_i18 + 1) {
    c126_b_u[c126_i18] = (*((real_T (*)[3])c126_u))[c126_i18];
  }

  c126_b_y = NULL;
  sf_mex_assign(&c126_b_y, sf_mex_create("y", &c126_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c126_y, c126_b_y);
  return c126_y;
}

static const mxArray *c126_c_sf_marshall(void *c126_chartInstance, void *c126_u)
{
  const mxArray *c126_y = NULL;
  real_T c126_b_u;
  const mxArray *c126_b_y = NULL;
  c126_y = NULL;
  c126_b_u = *((real_T *)c126_u);
  c126_b_y = NULL;
  sf_mex_assign(&c126_b_y, sf_mex_create("y", &c126_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c126_y, c126_b_y);
  return c126_y;
}

const mxArray *sf_c126_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c126_nameCaptureInfo = NULL;
  c126_nameCaptureInfo = NULL;
  sf_mex_assign(&c126_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1));
  return c126_nameCaptureInfo;
}

static const mxArray *c126_emlrt_marshallOut(uint8_T c126_u)
{
  const mxArray *c126_y = NULL;
  c126_y = NULL;
  sf_mex_assign(&c126_y, sf_mex_create("y", &c126_u, 3, 0U, 0U, 0U, 0));
  return c126_y;
}

static void c126_emlrt_marshallIn(const mxArray *c126_delta_T, char *c126_name,
  real_T c126_y[3])
{
  real_T c126_dv3[3];
  int32_T c126_i19;
  sf_mex_import(c126_name, sf_mex_dup(c126_delta_T), &c126_dv3, 1, 0, 0U, 1, 0U,
                1, 3);
  for (c126_i19 = 0; c126_i19 < 3; c126_i19 = c126_i19 + 1) {
    c126_y[c126_i19] = c126_dv3[c126_i19];
  }

  sf_mex_destroy(&c126_delta_T);
}

static void c126_b_emlrt_marshallIn(const mxArray *c126_delta_alpha, char
  *c126_name, real_T c126_y[3])
{
  real_T c126_dv4[3];
  int32_T c126_i20;
  sf_mex_import(c126_name, sf_mex_dup(c126_delta_alpha), &c126_dv4, 1, 0, 0U, 1,
                0U, 1, 3);
  for (c126_i20 = 0; c126_i20 < 3; c126_i20 = c126_i20 + 1) {
    c126_y[c126_i20] = c126_dv4[c126_i20];
  }

  sf_mex_destroy(&c126_delta_alpha);
}

static void c126_c_emlrt_marshallIn(const mxArray *c126_s, char *c126_name,
  real_T c126_y[3])
{
  real_T c126_dv5[3];
  int32_T c126_i21;
  sf_mex_import(c126_name, sf_mex_dup(c126_s), &c126_dv5, 1, 0, 0U, 1, 0U, 1, 3);
  for (c126_i21 = 0; c126_i21 < 3; c126_i21 = c126_i21 + 1) {
    c126_y[c126_i21] = c126_dv5[c126_i21];
  }

  sf_mex_destroy(&c126_s);
}

static uint8_T c126_d_emlrt_marshallIn(const mxArray
  *c126_b_is_active_c126_MCSim, char *c126_name)
{
  uint8_T c126_y;
  uint8_T c126_u0;
  sf_mex_import(c126_name, sf_mex_dup(c126_b_is_active_c126_MCSim), &c126_u0, 1,
                3, 0U, 0, 0U, 0);
  c126_y = c126_u0;
  sf_mex_destroy(&c126_b_is_active_c126_MCSim);
  return c126_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c126_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3289415941U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1670931852U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1821292167U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3392108305U);
}

mxArray *sf_c126_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3816047666U);
    pr[1] = (double)(1765182744U);
    pr[2] = (double)(1325906799U);
    pr[3] = (double)(3644889106U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c126_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[10],T\"delta_T\",},{M[1],M[12],T\"delta_alpha\",},{M[1],M[13],T\"s\",},{M[8],M[0],T\"is_active_c126_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c126_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          126,
          1,
          1,
          4,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"solution",0,c126_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"delta_T",0,c126_b_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"delta_alpha",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(3,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,265);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c126_solution)[9];
          real_T (*c126_delta_T)[3];
          real_T (*c126_delta_alpha)[3];
          real_T (*c126_s)[3];
          c126_s = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 3);
          c126_solution = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 0);
          c126_delta_alpha = (real_T (*)[3])ssGetOutputPortSignal
            (chartInstance.S, 2);
          c126_delta_T = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c126_solution);
          _SFD_SET_DATA_VALUE_PTR(1U, c126_delta_T);
          _SFD_SET_DATA_VALUE_PTR(2U, c126_delta_alpha);
          _SFD_SET_DATA_VALUE_PTR(3U, c126_s);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c126_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c126_MCSim();
  initialize_c126_MCSim();
}

static void sf_opaque_enable_c126_MCSim(void *chartInstanceVar)
{
  enable_c126_MCSim();
}

static void sf_opaque_disable_c126_MCSim(void *chartInstanceVar)
{
  disable_c126_MCSim();
}

static void sf_opaque_gateway_c126_MCSim(void *chartInstanceVar)
{
  sf_c126_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c126_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c126_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c126_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c126_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c126_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c126_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c126_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c126_MCSim();
  }
}

static void mdlSetWorkWidths_c126_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",126);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",126,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",126,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",126,1);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",126,3);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",126);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2152792308U));
  ssSetChecksum1(S,(1775227880U));
  ssSetChecksum2(S,(2933829311U));
  ssSetChecksum3(S,(47364918U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c126_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",126);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c126_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c126_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c126_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c126_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c126_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c126_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c126_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c126_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c126_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c126_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c126_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c126_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c126_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c126_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c126_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c126_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c126_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
