/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c128_MCSim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c128_IN_NO_ACTIVE_CHILD        (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc128_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c128_MCSim(void);
static void initialize_params_c128_MCSim(void);
static void enable_c128_MCSim(void);
static void disable_c128_MCSim(void);
static void c128_update_debugger_state_c128_MCSim(void);
static const mxArray *get_sim_state_c128_MCSim(void);
static void set_sim_state_c128_MCSim(const mxArray *c128_st);
static void finalize_c128_MCSim(void);
static void sf_c128_MCSim(void);
static void init_script_number_translation(uint32_T c128_machineNumber, uint32_T
  c128_chartNumber);
static const mxArray *c128_sf_marshall(void *c128_chartInstance, void *c128_u);
static void c128_info_helper(c128_ResolvedFunctionInfo c128_info[15]);
static const mxArray *c128_emlrt_marshallOut(uint8_T c128_u);
static real_T c128_emlrt_marshallIn(const mxArray *c128_alpha_local, char
  *c128_name);
static uint8_T c128_b_emlrt_marshallIn(const mxArray
  *c128_b_is_active_c128_MCSim, char *c128_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c128_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c128_is_active_c128_MCSim = 0U;
}

static void initialize_params_c128_MCSim(void)
{
}

static void enable_c128_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c128_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c128_update_debugger_state_c128_MCSim(void)
{
}

static const mxArray *get_sim_state_c128_MCSim(void)
{
  const mxArray *c128_st = NULL;
  const mxArray *c128_y = NULL;
  real_T c128_u;
  const mxArray *c128_b_y = NULL;
  real_T *c128_alpha_local;
  c128_alpha_local = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c128_st = NULL;
  c128_y = NULL;
  sf_mex_assign(&c128_y, sf_mex_createcellarray(2));
  c128_u = *c128_alpha_local;
  c128_b_y = NULL;
  sf_mex_assign(&c128_b_y, sf_mex_create("y", &c128_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c128_y, 0, c128_b_y);
  sf_mex_setcell(c128_y, 1, c128_emlrt_marshallOut
                 (chartInstance.c128_is_active_c128_MCSim));
  sf_mex_assign(&c128_st, c128_y);
  return c128_st;
}

static void set_sim_state_c128_MCSim(const mxArray *c128_st)
{
  const mxArray *c128_u;
  real_T *c128_alpha_local;
  c128_alpha_local = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c128_doneDoubleBufferReInit = true;
  c128_u = sf_mex_dup(c128_st);
  *c128_alpha_local = c128_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c128_u, 0)),
    "alpha_local");
  chartInstance.c128_is_active_c128_MCSim = c128_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c128_u, 1)), "is_active_c128_MCSim");
  sf_mex_destroy(&c128_u);
  c128_update_debugger_state_c128_MCSim();
  sf_mex_destroy(&c128_st);
}

static void finalize_c128_MCSim(void)
{
}

static void sf_c128_MCSim(void)
{
  uint8_T c128_previousEvent;
  real_T c128_alpha_prev;
  real_T c128_diffMaxConstraint;
  real_T c128_diffMinConstraint;
  real_T c128_alpha_max;
  real_T c128_alpha_min;
  real_T c128_nargout = 1.0;
  real_T c128_nargin = 5.0;
  real_T c128_alpha_local;
  real_T c128_x;
  real_T c128_b_x;
  real_T c128_y;
  real_T c128_c_x;
  real_T c128_d_x;
  real_T c128_b_y;
  real_T *c128_b_alpha_prev;
  real_T *c128_b_diffMaxConstraint;
  real_T *c128_b_diffMinConstraint;
  real_T *c128_b_alpha_max;
  real_T *c128_b_alpha_min;
  real_T *c128_b_alpha_local;
  c128_b_diffMinConstraint = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c128_b_alpha_max = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
  c128_b_alpha_min = (real_T *)ssGetInputPortSignal(chartInstance.S, 4);
  c128_b_alpha_prev = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c128_b_alpha_local = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c128_b_diffMaxConstraint = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,127);
  _SFD_DATA_RANGE_CHECK(*c128_b_alpha_prev, 0U);
  _SFD_DATA_RANGE_CHECK(*c128_b_diffMaxConstraint, 1U);
  _SFD_DATA_RANGE_CHECK(*c128_b_diffMinConstraint, 2U);
  _SFD_DATA_RANGE_CHECK(*c128_b_alpha_max, 3U);
  _SFD_DATA_RANGE_CHECK(*c128_b_alpha_min, 4U);
  _SFD_DATA_RANGE_CHECK(*c128_b_alpha_local, 5U);
  c128_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,127);
  c128_alpha_prev = *c128_b_alpha_prev;
  c128_diffMaxConstraint = *c128_b_diffMaxConstraint;
  c128_diffMinConstraint = *c128_b_diffMinConstraint;
  c128_alpha_max = *c128_b_alpha_max;
  c128_alpha_min = *c128_b_alpha_min;
  sf_debug_symbol_scope_push(8U, 0U);
  sf_debug_symbol_scope_add("nargout", &c128_nargout, c128_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c128_nargin, c128_sf_marshall);
  sf_debug_symbol_scope_add("alpha_local", &c128_alpha_local, c128_sf_marshall);
  sf_debug_symbol_scope_add("alpha_min", &c128_alpha_min, c128_sf_marshall);
  sf_debug_symbol_scope_add("alpha_max", &c128_alpha_max, c128_sf_marshall);
  sf_debug_symbol_scope_add("diffMinConstraint", &c128_diffMinConstraint,
    c128_sf_marshall);
  sf_debug_symbol_scope_add("diffMaxConstraint", &c128_diffMaxConstraint,
    c128_sf_marshall);
  sf_debug_symbol_scope_add("alpha_prev", &c128_alpha_prev, c128_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  if (CV_EML_COND(0, 0, c128_alpha_prev <= c128_alpha_max)) {
    if (CV_EML_COND(0, 1, c128_alpha_prev >= c128_alpha_min)) {
      CV_EML_MCDC(0, 0, true);
      CV_EML_IF(0, 0, true);
      _SFD_EML_CALL(0,4);
      c128_alpha_local = c128_alpha_prev;
      goto label_1;
    }
  }

  CV_EML_MCDC(0, 0, false);
  CV_EML_IF(0, 0, false);
  _SFD_EML_CALL(0,6);
  c128_x = c128_diffMinConstraint;
  c128_b_x = c128_x;
  c128_y = muDoubleScalarAbs(c128_b_x);
  c128_c_x = c128_diffMaxConstraint;
  c128_d_x = c128_c_x;
  c128_b_y = muDoubleScalarAbs(c128_d_x);
  if (CV_EML_IF(0, 1, c128_b_y < c128_y)) {
    _SFD_EML_CALL(0,7);
    c128_alpha_local = c128_alpha_max;
  } else {
    _SFD_EML_CALL(0,9);
    c128_alpha_local = c128_alpha_min;
  }

 label_1:
  ;
  _SFD_EML_CALL(0,-9);
  sf_debug_symbol_scope_pop();
  *c128_b_alpha_local = c128_alpha_local;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,127);
  _sfEvent_ = c128_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c128_machineNumber, uint32_T
  c128_chartNumber)
{
}

static const mxArray *c128_sf_marshall(void *c128_chartInstance, void *c128_u)
{
  const mxArray *c128_y = NULL;
  real_T c128_b_u;
  const mxArray *c128_b_y = NULL;
  c128_y = NULL;
  c128_b_u = *((real_T *)c128_u);
  c128_b_y = NULL;
  sf_mex_assign(&c128_b_y, sf_mex_create("y", &c128_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c128_y, c128_b_y);
  return c128_y;
}

const mxArray *sf_c128_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c128_nameCaptureInfo = NULL;
  c128_ResolvedFunctionInfo c128_info[15];
  const mxArray *c128_m0 = NULL;
  int32_T c128_i0;
  c128_ResolvedFunctionInfo *c128_r0;
  c128_nameCaptureInfo = NULL;
  c128_info_helper(c128_info);
  sf_mex_assign(&c128_m0, sf_mex_createstruct("nameCaptureInfo", 1, 15));
  for (c128_i0 = 0; c128_i0 < 15; c128_i0 = c128_i0 + 1) {
    c128_r0 = &c128_info[c128_i0];
    sf_mex_addfield(c128_m0, sf_mex_create("nameCaptureInfo", c128_r0->context,
      15, 0U, 0U, 0U, 2, 1, strlen(c128_r0->context)),
                    "context", "nameCaptureInfo", c128_i0);
    sf_mex_addfield(c128_m0, sf_mex_create("nameCaptureInfo", c128_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c128_r0->name)), "name",
                    "nameCaptureInfo", c128_i0);
    sf_mex_addfield(c128_m0, sf_mex_create("nameCaptureInfo",
      c128_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c128_r0->dominantType)
      ), "dominantType", "nameCaptureInfo", c128_i0);
    sf_mex_addfield(c128_m0, sf_mex_create("nameCaptureInfo", c128_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c128_r0->resolved)),
                    "resolved", "nameCaptureInfo", c128_i0);
    sf_mex_addfield(c128_m0, sf_mex_create("nameCaptureInfo",
      &c128_r0->fileLength, 7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c128_i0);
    sf_mex_addfield(c128_m0, sf_mex_create("nameCaptureInfo",
      &c128_r0->fileTime1, 7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c128_i0);
    sf_mex_addfield(c128_m0, sf_mex_create("nameCaptureInfo",
      &c128_r0->fileTime2, 7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c128_i0);
  }

  sf_mex_assign(&c128_nameCaptureInfo, c128_m0);
  return c128_nameCaptureInfo;
}

static void c128_info_helper(c128_ResolvedFunctionInfo c128_info[15])
{
  c128_info[0].context = "";
  c128_info[0].name = "le";
  c128_info[0].dominantType = "double";
  c128_info[0].resolved = "[B]le";
  c128_info[0].fileLength = 0U;
  c128_info[0].fileTime1 = 0U;
  c128_info[0].fileTime2 = 0U;
  c128_info[1].context = "";
  c128_info[1].name = "ge";
  c128_info[1].dominantType = "double";
  c128_info[1].resolved = "[B]ge";
  c128_info[1].fileLength = 0U;
  c128_info[1].fileTime1 = 0U;
  c128_info[1].fileTime2 = 0U;
  c128_info[2].context = "";
  c128_info[2].name = "abs";
  c128_info[2].dominantType = "double";
  c128_info[2].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[2].fileLength = 566U;
  c128_info[2].fileTime1 = 1221267134U;
  c128_info[2].fileTime2 = 0U;
  c128_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[3].name = "nargin";
  c128_info[3].dominantType = "";
  c128_info[3].resolved = "[B]nargin";
  c128_info[3].fileLength = 0U;
  c128_info[3].fileTime1 = 0U;
  c128_info[3].fileTime2 = 0U;
  c128_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[4].name = "gt";
  c128_info[4].dominantType = "double";
  c128_info[4].resolved = "[B]gt";
  c128_info[4].fileLength = 0U;
  c128_info[4].fileTime1 = 0U;
  c128_info[4].fileTime2 = 0U;
  c128_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[5].name = "isa";
  c128_info[5].dominantType = "double";
  c128_info[5].resolved = "[B]isa";
  c128_info[5].fileLength = 0U;
  c128_info[5].fileTime1 = 0U;
  c128_info[5].fileTime2 = 0U;
  c128_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[6].name = "ischar";
  c128_info[6].dominantType = "double";
  c128_info[6].resolved = "[B]ischar";
  c128_info[6].fileLength = 0U;
  c128_info[6].fileTime1 = 0U;
  c128_info[6].fileTime2 = 0U;
  c128_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[7].name = "islogical";
  c128_info[7].dominantType = "double";
  c128_info[7].resolved = "[B]islogical";
  c128_info[7].fileLength = 0U;
  c128_info[7].fileTime1 = 0U;
  c128_info[7].fileTime2 = 0U;
  c128_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[8].name = "size";
  c128_info[8].dominantType = "double";
  c128_info[8].resolved = "[B]size";
  c128_info[8].fileLength = 0U;
  c128_info[8].fileTime1 = 0U;
  c128_info[8].fileTime2 = 0U;
  c128_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[9].name = "class";
  c128_info[9].dominantType = "double";
  c128_info[9].resolved = "[B]class";
  c128_info[9].fileLength = 0U;
  c128_info[9].fileTime1 = 0U;
  c128_info[9].fileTime2 = 0U;
  c128_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[10].name = "zeros";
  c128_info[10].dominantType = "double";
  c128_info[10].resolved = "[B]zeros";
  c128_info[10].fileLength = 0U;
  c128_info[10].fileTime1 = 0U;
  c128_info[10].fileTime2 = 0U;
  c128_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c128_info[11].name = "eml_scalar_abs";
  c128_info[11].dominantType = "double";
  c128_info[11].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c128_info[11].fileLength = 461U;
  c128_info[11].fileTime1 = 1203447960U;
  c128_info[11].fileTime2 = 0U;
  c128_info[12].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c128_info[12].name = "isinteger";
  c128_info[12].dominantType = "double";
  c128_info[12].resolved = "[B]isinteger";
  c128_info[12].fileLength = 0U;
  c128_info[12].fileTime1 = 0U;
  c128_info[12].fileTime2 = 0U;
  c128_info[13].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c128_info[13].name = "isreal";
  c128_info[13].dominantType = "double";
  c128_info[13].resolved = "[B]isreal";
  c128_info[13].fileLength = 0U;
  c128_info[13].fileTime1 = 0U;
  c128_info[13].fileTime2 = 0U;
  c128_info[14].context = "";
  c128_info[14].name = "lt";
  c128_info[14].dominantType = "double";
  c128_info[14].resolved = "[B]lt";
  c128_info[14].fileLength = 0U;
  c128_info[14].fileTime1 = 0U;
  c128_info[14].fileTime2 = 0U;
}

static const mxArray *c128_emlrt_marshallOut(uint8_T c128_u)
{
  const mxArray *c128_y = NULL;
  c128_y = NULL;
  sf_mex_assign(&c128_y, sf_mex_create("y", &c128_u, 3, 0U, 0U, 0U, 0));
  return c128_y;
}

static real_T c128_emlrt_marshallIn(const mxArray *c128_alpha_local, char
  *c128_name)
{
  real_T c128_y;
  real_T c128_d0;
  sf_mex_import(c128_name, sf_mex_dup(c128_alpha_local), &c128_d0, 1, 0, 0U, 0,
                0U, 0);
  c128_y = c128_d0;
  sf_mex_destroy(&c128_alpha_local);
  return c128_y;
}

static uint8_T c128_b_emlrt_marshallIn(const mxArray
  *c128_b_is_active_c128_MCSim, char *c128_name)
{
  uint8_T c128_y;
  uint8_T c128_u0;
  sf_mex_import(c128_name, sf_mex_dup(c128_b_is_active_c128_MCSim), &c128_u0, 1,
                3, 0U, 0, 0U, 0);
  c128_y = c128_u0;
  sf_mex_destroy(&c128_b_is_active_c128_MCSim);
  return c128_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c128_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2816516817U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(302650834U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4235674134U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2273603611U);
}

mxArray *sf_c128_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1999271983U);
    pr[1] = (double)(3808452088U);
    pr[2] = (double)(1309100563U);
    pr[3] = (double)(2079495799U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c128_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"alpha_local\",},{M[8],M[0],T\"is_active_c128_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c128_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          128,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "alpha_prev",0,c128_sf_marshall);
          _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "diffMaxConstraint",0,NULL);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "diffMinConstraint",0,NULL);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "alpha_max",0,NULL);
          _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "alpha_min",0,NULL);
          _SFD_SET_DATA_PROPS(5,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "alpha_local",0,NULL);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,2,0,0,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,396);
        _SFD_CV_INIT_EML_IF(0,0,123,181,220,391);
        _SFD_CV_INIT_EML_IF(0,1,233,284,330,383);

        {
          static int condStart[] = { 127, 156 };

          static int condEnd[] = { 150, 179 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,0,126,180,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T *c128_alpha_prev;
          real_T *c128_diffMaxConstraint;
          real_T *c128_diffMinConstraint;
          real_T *c128_alpha_max;
          real_T *c128_alpha_min;
          real_T *c128_alpha_local;
          c128_diffMinConstraint = (real_T *)ssGetInputPortSignal
            (chartInstance.S, 2);
          c128_alpha_max = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
          c128_alpha_min = (real_T *)ssGetInputPortSignal(chartInstance.S, 4);
          c128_alpha_prev = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
          c128_alpha_local = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          c128_diffMaxConstraint = (real_T *)ssGetInputPortSignal
            (chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c128_alpha_prev);
          _SFD_SET_DATA_VALUE_PTR(1U, c128_diffMaxConstraint);
          _SFD_SET_DATA_VALUE_PTR(2U, c128_diffMinConstraint);
          _SFD_SET_DATA_VALUE_PTR(3U, c128_alpha_max);
          _SFD_SET_DATA_VALUE_PTR(4U, c128_alpha_min);
          _SFD_SET_DATA_VALUE_PTR(5U, c128_alpha_local);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c128_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c128_MCSim();
  initialize_c128_MCSim();
}

static void sf_opaque_enable_c128_MCSim(void *chartInstanceVar)
{
  enable_c128_MCSim();
}

static void sf_opaque_disable_c128_MCSim(void *chartInstanceVar)
{
  disable_c128_MCSim();
}

static void sf_opaque_gateway_c128_MCSim(void *chartInstanceVar)
{
  sf_c128_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c128_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c128_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c128_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c128_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c128_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c128_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c128_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c128_MCSim();
  }
}

static void mdlSetWorkWidths_c128_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",128);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",128,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",128,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",128,5);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",128,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",128);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3748838673U));
  ssSetChecksum1(S,(3186095788U));
  ssSetChecksum2(S,(1835755715U));
  ssSetChecksum3(S,(1975901257U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c128_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",128);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c128_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c128_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c128_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c128_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c128_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c128_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c128_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c128_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c128_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c128_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c128_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c128_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c128_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c128_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c128_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c128_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c128_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
