/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c151_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c151_IN_NO_ACTIVE_CHILD        (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc151_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c151_MCSim(void);
static void initialize_params_c151_MCSim(void);
static void enable_c151_MCSim(void);
static void disable_c151_MCSim(void);
static void c151_update_debugger_state_c151_MCSim(void);
static const mxArray *get_sim_state_c151_MCSim(void);
static void set_sim_state_c151_MCSim(const mxArray *c151_st);
static void finalize_c151_MCSim(void);
static void sf_c151_MCSim(void);
static void init_script_number_translation(uint32_T c151_machineNumber, uint32_T
  c151_chartNumber);
static const mxArray *c151_sf_marshall(void *c151_chartInstance, void *c151_u);
static const mxArray *c151_b_sf_marshall(void *c151_chartInstance, void *c151_u);
static const mxArray *c151_c_sf_marshall(void *c151_chartInstance, void *c151_u);
static const mxArray *c151_emlrt_marshallOut(uint8_T c151_u);
static void c151_emlrt_marshallIn(const mxArray *c151_lbX_new, char *c151_name,
  real_T c151_y[9]);
static void c151_b_emlrt_marshallIn(const mxArray *c151_ubX_new, char *c151_name,
  real_T c151_y[9]);
static uint8_T c151_c_emlrt_marshallIn(const mxArray
  *c151_b_is_active_c151_MCSim, char *c151_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c151_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c151_is_active_c151_MCSim = 0U;
}

static void initialize_params_c151_MCSim(void)
{
}

static void enable_c151_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c151_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c151_update_debugger_state_c151_MCSim(void)
{
}

static const mxArray *get_sim_state_c151_MCSim(void)
{
  const mxArray *c151_st = NULL;
  const mxArray *c151_y = NULL;
  int32_T c151_i0;
  real_T c151_u[9];
  const mxArray *c151_b_y = NULL;
  int32_T c151_i1;
  real_T c151_b_u[9];
  const mxArray *c151_c_y = NULL;
  real_T (*c151_ubX_new)[9];
  real_T (*c151_lbX_new)[9];
  c151_ubX_new = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 2);
  c151_lbX_new = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  c151_st = NULL;
  c151_y = NULL;
  sf_mex_assign(&c151_y, sf_mex_createcellarray(3));
  for (c151_i0 = 0; c151_i0 < 9; c151_i0 = c151_i0 + 1) {
    c151_u[c151_i0] = (*c151_lbX_new)[c151_i0];
  }

  c151_b_y = NULL;
  sf_mex_assign(&c151_b_y, sf_mex_create("y", &c151_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_setcell(c151_y, 0, c151_b_y);
  for (c151_i1 = 0; c151_i1 < 9; c151_i1 = c151_i1 + 1) {
    c151_b_u[c151_i1] = (*c151_ubX_new)[c151_i1];
  }

  c151_c_y = NULL;
  sf_mex_assign(&c151_c_y, sf_mex_create("y", &c151_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_setcell(c151_y, 1, c151_c_y);
  sf_mex_setcell(c151_y, 2, c151_emlrt_marshallOut
                 (chartInstance.c151_is_active_c151_MCSim));
  sf_mex_assign(&c151_st, c151_y);
  return c151_st;
}

static void set_sim_state_c151_MCSim(const mxArray *c151_st)
{
  const mxArray *c151_u;
  real_T c151_dv0[9];
  int32_T c151_i2;
  real_T c151_dv1[9];
  int32_T c151_i3;
  real_T (*c151_lbX_new)[9];
  real_T (*c151_ubX_new)[9];
  c151_ubX_new = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 2);
  c151_lbX_new = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c151_doneDoubleBufferReInit = true;
  c151_u = sf_mex_dup(c151_st);
  c151_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c151_u, 0)), "lbX_new",
                        c151_dv0);
  for (c151_i2 = 0; c151_i2 < 9; c151_i2 = c151_i2 + 1) {
    (*c151_lbX_new)[c151_i2] = c151_dv0[c151_i2];
  }

  c151_b_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c151_u, 1)), "ubX_new",
    c151_dv1);
  for (c151_i3 = 0; c151_i3 < 9; c151_i3 = c151_i3 + 1) {
    (*c151_ubX_new)[c151_i3] = c151_dv1[c151_i3];
  }

  chartInstance.c151_is_active_c151_MCSim = c151_c_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c151_u, 2)), "is_active_c151_MCSim");
  sf_mex_destroy(&c151_u);
  c151_update_debugger_state_c151_MCSim();
  sf_mex_destroy(&c151_st);
}

static void finalize_c151_MCSim(void)
{
}

static void sf_c151_MCSim(void)
{
  int32_T c151_i4;
  int32_T c151_i5;
  int32_T c151_i6;
  int32_T c151_i7;
  int32_T c151_i8;
  uint8_T c151_previousEvent;
  int32_T c151_i9;
  real_T c151_preCalculated_delta_alpha[3];
  int32_T c151_i10;
  real_T c151_lbX[9];
  int32_T c151_i11;
  real_T c151_ubX[9];
  real_T c151_nargout = 2.0;
  real_T c151_nargin = 3.0;
  real_T c151_i;
  real_T c151_ubX_new[9];
  real_T c151_lbX_new[9];
  int32_T c151_i12;
  int32_T c151_i13;
  real_T c151_b_i;
  int32_T c151_i14;
  int32_T c151_i15;
  real_T (*c151_b_lbX_new)[9];
  real_T (*c151_b_ubX_new)[9];
  real_T (*c151_b_ubX)[9];
  real_T (*c151_b_lbX)[9];
  real_T (*c151_b_preCalculated_delta_alpha)[3];
  c151_b_ubX = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 2);
  c151_b_ubX_new = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 2);
  c151_b_preCalculated_delta_alpha = (real_T (*)[3])ssGetInputPortSignal
    (chartInstance.S, 0);
  c151_b_lbX = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 1);
  c151_b_lbX_new = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,150);
  for (c151_i4 = 0; c151_i4 < 3; c151_i4 = c151_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c151_b_preCalculated_delta_alpha)[c151_i4], 0U);
  }

  for (c151_i5 = 0; c151_i5 < 9; c151_i5 = c151_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c151_b_lbX)[c151_i5], 1U);
  }

  for (c151_i6 = 0; c151_i6 < 9; c151_i6 = c151_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c151_b_lbX_new)[c151_i6], 2U);
  }

  for (c151_i7 = 0; c151_i7 < 9; c151_i7 = c151_i7 + 1) {
    _SFD_DATA_RANGE_CHECK((*c151_b_ubX)[c151_i7], 3U);
  }

  for (c151_i8 = 0; c151_i8 < 9; c151_i8 = c151_i8 + 1) {
    _SFD_DATA_RANGE_CHECK((*c151_b_ubX_new)[c151_i8], 4U);
  }

  c151_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,150);
  for (c151_i9 = 0; c151_i9 < 3; c151_i9 = c151_i9 + 1) {
    c151_preCalculated_delta_alpha[c151_i9] = (*c151_b_preCalculated_delta_alpha)
      [c151_i9];
  }

  for (c151_i10 = 0; c151_i10 < 9; c151_i10 = c151_i10 + 1) {
    c151_lbX[c151_i10] = (*c151_b_lbX)[c151_i10];
  }

  for (c151_i11 = 0; c151_i11 < 9; c151_i11 = c151_i11 + 1) {
    c151_ubX[c151_i11] = (*c151_b_ubX)[c151_i11];
  }

  sf_debug_symbol_scope_push(8U, 0U);
  sf_debug_symbol_scope_add("nargout", &c151_nargout, c151_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c151_nargin, c151_c_sf_marshall);
  sf_debug_symbol_scope_add("i", &c151_i, c151_c_sf_marshall);
  sf_debug_symbol_scope_add("ubX_new", &c151_ubX_new, c151_b_sf_marshall);
  sf_debug_symbol_scope_add("lbX_new", &c151_lbX_new, c151_b_sf_marshall);
  sf_debug_symbol_scope_add("ubX", &c151_ubX, c151_b_sf_marshall);
  sf_debug_symbol_scope_add("lbX", &c151_lbX, c151_b_sf_marshall);
  sf_debug_symbol_scope_add("preCalculated_delta_alpha",
    &c151_preCalculated_delta_alpha, c151_sf_marshall);
  CV_EML_FCN(0, 0);

  /* Modifying the lower and upper bound for the allocation variables. */
  /*  lbX and ubX are equal in alpha, except a small deviation. */
  _SFD_EML_CALL(0,5);
  for (c151_i12 = 0; c151_i12 < 9; c151_i12 = c151_i12 + 1) {
    c151_lbX_new[c151_i12] = c151_lbX[c151_i12];
  }

  _SFD_EML_CALL(0,6);
  for (c151_i13 = 0; c151_i13 < 9; c151_i13 = c151_i13 + 1) {
    c151_ubX_new[c151_i13] = c151_ubX[c151_i13];
  }

  /* Modify the constraints in alpha */
  _SFD_EML_CALL(0,9);
  c151_lbX_new[3] = 0.0;
  _SFD_EML_CALL(0,10);
  c151_ubX_new[3] = 0.0;
  c151_i = 5.0;
  c151_b_i = 5.0;
  while (c151_b_i <= 6.0) {
    c151_i = c151_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,12);
    c151_lbX_new[_SFD_EML_ARRAY_BOUNDS_CHECK("lbX_new", (int32_T)
      _SFD_INTEGER_CHECK("i", c151_i), 1, 9, 1, 0) - 1] =
      c151_preCalculated_delta_alpha[_SFD_EML_ARRAY_BOUNDS_CHECK(
      "preCalculated_delta_alpha", (int32_T)_SFD_INTEGER_CHECK("", c151_i - 3.0
      ), 1, 3, 1, 0) - 1] - 1.0E-008;
    _SFD_EML_CALL(0,13);
    c151_ubX_new[_SFD_EML_ARRAY_BOUNDS_CHECK("ubX_new", (int32_T)
      _SFD_INTEGER_CHECK("i", c151_i), 1, 9, 1, 0) - 1] =
      c151_preCalculated_delta_alpha[_SFD_EML_ARRAY_BOUNDS_CHECK(
      "preCalculated_delta_alpha", (int32_T)_SFD_INTEGER_CHECK("", c151_i - 3.0
      ), 1, 3, 1, 0) - 1] + 1.0E-008;
    c151_b_i = c151_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,-13);
  sf_debug_symbol_scope_pop();
  for (c151_i14 = 0; c151_i14 < 9; c151_i14 = c151_i14 + 1) {
    (*c151_b_lbX_new)[c151_i14] = c151_lbX_new[c151_i14];
  }

  for (c151_i15 = 0; c151_i15 < 9; c151_i15 = c151_i15 + 1) {
    (*c151_b_ubX_new)[c151_i15] = c151_ubX_new[c151_i15];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,150);
  _sfEvent_ = c151_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c151_machineNumber, uint32_T
  c151_chartNumber)
{
}

static const mxArray *c151_sf_marshall(void *c151_chartInstance, void *c151_u)
{
  const mxArray *c151_y = NULL;
  int32_T c151_i16;
  real_T c151_b_u[3];
  const mxArray *c151_b_y = NULL;
  c151_y = NULL;
  for (c151_i16 = 0; c151_i16 < 3; c151_i16 = c151_i16 + 1) {
    c151_b_u[c151_i16] = (*((real_T (*)[3])c151_u))[c151_i16];
  }

  c151_b_y = NULL;
  sf_mex_assign(&c151_b_y, sf_mex_create("y", &c151_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c151_y, c151_b_y);
  return c151_y;
}

static const mxArray *c151_b_sf_marshall(void *c151_chartInstance, void *c151_u)
{
  const mxArray *c151_y = NULL;
  int32_T c151_i17;
  real_T c151_b_u[9];
  const mxArray *c151_b_y = NULL;
  c151_y = NULL;
  for (c151_i17 = 0; c151_i17 < 9; c151_i17 = c151_i17 + 1) {
    c151_b_u[c151_i17] = (*((real_T (*)[9])c151_u))[c151_i17];
  }

  c151_b_y = NULL;
  sf_mex_assign(&c151_b_y, sf_mex_create("y", &c151_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_assign(&c151_y, c151_b_y);
  return c151_y;
}

static const mxArray *c151_c_sf_marshall(void *c151_chartInstance, void *c151_u)
{
  const mxArray *c151_y = NULL;
  real_T c151_b_u;
  const mxArray *c151_b_y = NULL;
  c151_y = NULL;
  c151_b_u = *((real_T *)c151_u);
  c151_b_y = NULL;
  sf_mex_assign(&c151_b_y, sf_mex_create("y", &c151_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c151_y, c151_b_y);
  return c151_y;
}

const mxArray *sf_c151_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c151_nameCaptureInfo = NULL;
  c151_ResolvedFunctionInfo c151_info[2];
  c151_ResolvedFunctionInfo (*c151_b_info)[2];
  const mxArray *c151_m0 = NULL;
  int32_T c151_i18;
  c151_ResolvedFunctionInfo *c151_r0;
  c151_nameCaptureInfo = NULL;
  c151_b_info = (c151_ResolvedFunctionInfo (*)[2])c151_info;
  (*c151_b_info)[0].context = "";
  (*c151_b_info)[0].name = "minus";
  (*c151_b_info)[0].dominantType = "double";
  (*c151_b_info)[0].resolved = "[B]minus";
  (*c151_b_info)[0].fileLength = 0U;
  (*c151_b_info)[0].fileTime1 = 0U;
  (*c151_b_info)[0].fileTime2 = 0U;
  (*c151_b_info)[1].context = "";
  (*c151_b_info)[1].name = "plus";
  (*c151_b_info)[1].dominantType = "double";
  (*c151_b_info)[1].resolved = "[B]plus";
  (*c151_b_info)[1].fileLength = 0U;
  (*c151_b_info)[1].fileTime1 = 0U;
  (*c151_b_info)[1].fileTime2 = 0U;
  sf_mex_assign(&c151_m0, sf_mex_createstruct("nameCaptureInfo", 1, 2));
  for (c151_i18 = 0; c151_i18 < 2; c151_i18 = c151_i18 + 1) {
    c151_r0 = &c151_info[c151_i18];
    sf_mex_addfield(c151_m0, sf_mex_create("nameCaptureInfo", c151_r0->context,
      15, 0U, 0U, 0U, 2, 1, strlen(c151_r0->context)),
                    "context", "nameCaptureInfo", c151_i18);
    sf_mex_addfield(c151_m0, sf_mex_create("nameCaptureInfo", c151_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c151_r0->name)), "name",
                    "nameCaptureInfo", c151_i18);
    sf_mex_addfield(c151_m0, sf_mex_create("nameCaptureInfo",
      c151_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c151_r0->dominantType)
      ), "dominantType", "nameCaptureInfo", c151_i18);
    sf_mex_addfield(c151_m0, sf_mex_create("nameCaptureInfo", c151_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c151_r0->resolved)),
                    "resolved", "nameCaptureInfo", c151_i18);
    sf_mex_addfield(c151_m0, sf_mex_create("nameCaptureInfo",
      &c151_r0->fileLength, 7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c151_i18);
    sf_mex_addfield(c151_m0, sf_mex_create("nameCaptureInfo",
      &c151_r0->fileTime1, 7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c151_i18);
    sf_mex_addfield(c151_m0, sf_mex_create("nameCaptureInfo",
      &c151_r0->fileTime2, 7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c151_i18);
  }

  sf_mex_assign(&c151_nameCaptureInfo, c151_m0);
  return c151_nameCaptureInfo;
}

static const mxArray *c151_emlrt_marshallOut(uint8_T c151_u)
{
  const mxArray *c151_y = NULL;
  c151_y = NULL;
  sf_mex_assign(&c151_y, sf_mex_create("y", &c151_u, 3, 0U, 0U, 0U, 0));
  return c151_y;
}

static void c151_emlrt_marshallIn(const mxArray *c151_lbX_new, char *c151_name,
  real_T c151_y[9])
{
  real_T c151_dv2[9];
  int32_T c151_i19;
  sf_mex_import(c151_name, sf_mex_dup(c151_lbX_new), &c151_dv2, 1, 0, 0U, 1, 0U,
                1, 9);
  for (c151_i19 = 0; c151_i19 < 9; c151_i19 = c151_i19 + 1) {
    c151_y[c151_i19] = c151_dv2[c151_i19];
  }

  sf_mex_destroy(&c151_lbX_new);
}

static void c151_b_emlrt_marshallIn(const mxArray *c151_ubX_new, char *c151_name,
  real_T c151_y[9])
{
  real_T c151_dv3[9];
  int32_T c151_i20;
  sf_mex_import(c151_name, sf_mex_dup(c151_ubX_new), &c151_dv3, 1, 0, 0U, 1, 0U,
                1, 9);
  for (c151_i20 = 0; c151_i20 < 9; c151_i20 = c151_i20 + 1) {
    c151_y[c151_i20] = c151_dv3[c151_i20];
  }

  sf_mex_destroy(&c151_ubX_new);
}

static uint8_T c151_c_emlrt_marshallIn(const mxArray
  *c151_b_is_active_c151_MCSim, char *c151_name)
{
  uint8_T c151_y;
  uint8_T c151_u0;
  sf_mex_import(c151_name, sf_mex_dup(c151_b_is_active_c151_MCSim), &c151_u0, 1,
                3, 0U, 0, 0U, 0);
  c151_y = c151_u0;
  sf_mex_destroy(&c151_b_is_active_c151_MCSim);
  return c151_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c151_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3905519109U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2299502916U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(576326044U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2737699832U);
}

mxArray *sf_c151_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1147134479U);
    pr[1] = (double)(3887620084U);
    pr[2] = (double)(1808205730U);
    pr[3] = (double)(716731264U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c151_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[5],T\"lbX_new\",},{M[1],M[7],T\"ubX_new\",},{M[8],M[0],T\"is_active_c151_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c151_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          151,
          1,
          1,
          5,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"preCalculated_delta_alpha",0,
                                c151_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"lbX",0,c151_b_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"lbX_new",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"ubX",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(4,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"ubX_new",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,1,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,450);
        _SFD_CV_INIT_EML_FOR(0,0,323,335,450);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c151_preCalculated_delta_alpha)[3];
          real_T (*c151_lbX)[9];
          real_T (*c151_lbX_new)[9];
          real_T (*c151_ubX)[9];
          real_T (*c151_ubX_new)[9];
          c151_ubX = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 2);
          c151_ubX_new = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 2);
          c151_preCalculated_delta_alpha = (real_T (*)[3])ssGetInputPortSignal
            (chartInstance.S, 0);
          c151_lbX = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 1);
          c151_lbX_new = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c151_preCalculated_delta_alpha);
          _SFD_SET_DATA_VALUE_PTR(1U, c151_lbX);
          _SFD_SET_DATA_VALUE_PTR(2U, c151_lbX_new);
          _SFD_SET_DATA_VALUE_PTR(3U, c151_ubX);
          _SFD_SET_DATA_VALUE_PTR(4U, c151_ubX_new);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c151_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c151_MCSim();
  initialize_c151_MCSim();
}

static void sf_opaque_enable_c151_MCSim(void *chartInstanceVar)
{
  enable_c151_MCSim();
}

static void sf_opaque_disable_c151_MCSim(void *chartInstanceVar)
{
  disable_c151_MCSim();
}

static void sf_opaque_gateway_c151_MCSim(void *chartInstanceVar)
{
  sf_c151_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c151_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c151_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c151_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c151_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c151_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c151_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c151_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c151_MCSim();
  }
}

static void mdlSetWorkWidths_c151_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",151);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",151,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",151,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",151,3);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",151,2);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",151);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2199510190U));
  ssSetChecksum1(S,(3475697262U));
  ssSetChecksum2(S,(1303849244U));
  ssSetChecksum3(S,(2169257697U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c151_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",151);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c151_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c151_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c151_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c151_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c151_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c151_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c151_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c151_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c151_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c151_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c151_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c151_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c151_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c151_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c151_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c151_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c151_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
