/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c163_MCSim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c163_IN_NO_ACTIVE_CHILD        (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc163_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c163_MCSim(void);
static void initialize_params_c163_MCSim(void);
static void enable_c163_MCSim(void);
static void disable_c163_MCSim(void);
static void c163_update_debugger_state_c163_MCSim(void);
static const mxArray *get_sim_state_c163_MCSim(void);
static void set_sim_state_c163_MCSim(const mxArray *c163_st);
static void finalize_c163_MCSim(void);
static void sf_c163_MCSim(void);
static void init_script_number_translation(uint32_T c163_machineNumber, uint32_T
  c163_chartNumber);
static const mxArray *c163_sf_marshall(void *c163_chartInstance, void *c163_u);
static void c163_info_helper(c163_ResolvedFunctionInfo c163_info[26]);
static const mxArray *c163_emlrt_marshallOut(uint8_T c163_u);
static real_T c163_emlrt_marshallIn(const mxArray *c163_angleInfInf, char
  *c163_name);
static uint8_T c163_b_emlrt_marshallIn(const mxArray
  *c163_b_is_active_c163_MCSim, char *c163_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c163_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c163_is_active_c163_MCSim = 0U;
}

static void initialize_params_c163_MCSim(void)
{
}

static void enable_c163_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c163_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c163_update_debugger_state_c163_MCSim(void)
{
}

static const mxArray *get_sim_state_c163_MCSim(void)
{
  const mxArray *c163_st = NULL;
  const mxArray *c163_y = NULL;
  real_T c163_u;
  const mxArray *c163_b_y = NULL;
  real_T *c163_angleInfInf;
  c163_angleInfInf = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c163_st = NULL;
  c163_y = NULL;
  sf_mex_assign(&c163_y, sf_mex_createcellarray(2));
  c163_u = *c163_angleInfInf;
  c163_b_y = NULL;
  sf_mex_assign(&c163_b_y, sf_mex_create("y", &c163_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c163_y, 0, c163_b_y);
  sf_mex_setcell(c163_y, 1, c163_emlrt_marshallOut
                 (chartInstance.c163_is_active_c163_MCSim));
  sf_mex_assign(&c163_st, c163_y);
  return c163_st;
}

static void set_sim_state_c163_MCSim(const mxArray *c163_st)
{
  const mxArray *c163_u;
  real_T *c163_angleInfInf;
  c163_angleInfInf = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c163_doneDoubleBufferReInit = true;
  c163_u = sf_mex_dup(c163_st);
  *c163_angleInfInf = c163_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c163_u, 0)),
    "angleInfInf");
  chartInstance.c163_is_active_c163_MCSim = c163_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c163_u, 1)), "is_active_c163_MCSim");
  sf_mex_destroy(&c163_u);
  c163_update_debugger_state_c163_MCSim();
  sf_mex_destroy(&c163_st);
}

static void finalize_c163_MCSim(void)
{
}

static void sf_c163_MCSim(void)
{
  uint8_T c163_previousEvent;
  real_T c163_meas;
  real_T c163_meas_prev;
  real_T c163_prevAngleInfInf;
  real_T c163_nargout = 1.0;
  real_T c163_nargin = 3.0;
  real_T c163_counter;
  real_T c163_angleInfInf;
  real_T c163_A;
  real_T c163_x;
  real_T c163_b_x;
  real_T c163_c_x;
  real_T c163_d_x;
  real_T c163_e_x;
  real_T c163_y;
  real_T c163_a;
  real_T c163_b_y;
  real_T *c163_b_angleInfInf;
  real_T *c163_b_prevAngleInfInf;
  real_T *c163_b_meas_prev;
  real_T *c163_b_meas;
  c163_b_meas = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c163_b_angleInfInf = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c163_b_prevAngleInfInf = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c163_b_meas_prev = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,162);
  _SFD_DATA_RANGE_CHECK(*c163_b_meas, 0U);
  _SFD_DATA_RANGE_CHECK(*c163_b_angleInfInf, 1U);
  _SFD_DATA_RANGE_CHECK(*c163_b_meas_prev, 2U);
  _SFD_DATA_RANGE_CHECK(*c163_b_prevAngleInfInf, 3U);
  c163_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,162);
  c163_meas = *c163_b_meas;
  c163_meas_prev = *c163_b_meas_prev;
  c163_prevAngleInfInf = *c163_b_prevAngleInfInf;
  sf_debug_symbol_scope_push(7U, 0U);
  sf_debug_symbol_scope_add("nargout", &c163_nargout, c163_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c163_nargin, c163_sf_marshall);
  sf_debug_symbol_scope_add("counter", &c163_counter, c163_sf_marshall);
  sf_debug_symbol_scope_add("angleInfInf", &c163_angleInfInf, c163_sf_marshall);
  sf_debug_symbol_scope_add("prevAngleInfInf", &c163_prevAngleInfInf,
    c163_sf_marshall);
  sf_debug_symbol_scope_add("meas_prev", &c163_meas_prev, c163_sf_marshall);
  sf_debug_symbol_scope_add("meas", &c163_meas, c163_sf_marshall);
  CV_EML_FCN(0, 0);

  /* --- Conversion from [-180,180] to [0,360] */
  _SFD_EML_CALL(0,4);
  if (CV_EML_IF(0, 0, c163_meas < 0.0)) {
    _SFD_EML_CALL(0,5);
    c163_meas = c163_meas + 360.0;
  }

  _SFD_EML_CALL(0,7);
  if (CV_EML_IF(0, 1, c163_meas_prev < 0.0)) {
    _SFD_EML_CALL(0,8);
    c163_meas_prev = c163_meas_prev + 360.0;
  }

  _SFD_EML_CALL(0,11);
  c163_A = c163_prevAngleInfInf - c163_meas_prev;
  c163_x = c163_A;
  c163_b_x = c163_x;
  c163_c_x = c163_b_x;
  c163_counter = c163_c_x / 360.0;

  /* --- Conversion from [0,360] to [-Inf,Inf] */
  _SFD_EML_CALL(0,14);
  c163_d_x = c163_meas - c163_meas_prev;
  c163_e_x = c163_d_x;
  c163_y = muDoubleScalarAbs(c163_e_x);
  if (CV_EML_IF(0, 2, c163_y > 270.0)) {
    /* --- Flip detected */
    _SFD_EML_CALL(0,16);
    if (CV_EML_COND(0, 0, c163_meas < 90.0)) {
      if (CV_EML_COND(0, 1, c163_meas_prev > 270.0)) {
        CV_EML_MCDC(0, 0, true);
        CV_EML_IF(0, 3, true);

        /* --- Flip from 360 to 0 */
        _SFD_EML_CALL(0,18);
        c163_counter = c163_counter + 1.0;
        goto label_1;
      }
    }

    CV_EML_MCDC(0, 0, false);
    CV_EML_IF(0, 3, false);
    _SFD_EML_CALL(0,19);
    if (CV_EML_COND(0, 2, c163_meas > 270.0)) {
      if (CV_EML_COND(0, 3, c163_meas_prev < 90.0)) {
        CV_EML_MCDC(0, 1, true);
        CV_EML_IF(0, 4, true);

        /* --- Flip from 0 to 360 */
        _SFD_EML_CALL(0,21);
        c163_counter = c163_counter - 1.0;
        goto label_2;
      }
    }

    CV_EML_MCDC(0, 1, false);
    CV_EML_IF(0, 4, false);
   label_2:
    ;
   label_1:
    ;
  }

  _SFD_EML_CALL(0,25);
  c163_a = c163_counter;
  c163_b_y = c163_a * 360.0;
  c163_angleInfInf = c163_meas + c163_b_y;
  _SFD_EML_CALL(0,-25);
  sf_debug_symbol_scope_pop();
  *c163_b_angleInfInf = c163_angleInfInf;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,162);
  _sfEvent_ = c163_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c163_machineNumber, uint32_T
  c163_chartNumber)
{
}

static const mxArray *c163_sf_marshall(void *c163_chartInstance, void *c163_u)
{
  const mxArray *c163_y = NULL;
  real_T c163_b_u;
  const mxArray *c163_b_y = NULL;
  c163_y = NULL;
  c163_b_u = *((real_T *)c163_u);
  c163_b_y = NULL;
  sf_mex_assign(&c163_b_y, sf_mex_create("y", &c163_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c163_y, c163_b_y);
  return c163_y;
}

const mxArray *sf_c163_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c163_nameCaptureInfo = NULL;
  c163_ResolvedFunctionInfo c163_info[26];
  const mxArray *c163_m0 = NULL;
  int32_T c163_i0;
  c163_ResolvedFunctionInfo *c163_r0;
  c163_nameCaptureInfo = NULL;
  c163_info_helper(c163_info);
  sf_mex_assign(&c163_m0, sf_mex_createstruct("nameCaptureInfo", 1, 26));
  for (c163_i0 = 0; c163_i0 < 26; c163_i0 = c163_i0 + 1) {
    c163_r0 = &c163_info[c163_i0];
    sf_mex_addfield(c163_m0, sf_mex_create("nameCaptureInfo", c163_r0->context,
      15, 0U, 0U, 0U, 2, 1, strlen(c163_r0->context)),
                    "context", "nameCaptureInfo", c163_i0);
    sf_mex_addfield(c163_m0, sf_mex_create("nameCaptureInfo", c163_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c163_r0->name)), "name",
                    "nameCaptureInfo", c163_i0);
    sf_mex_addfield(c163_m0, sf_mex_create("nameCaptureInfo",
      c163_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c163_r0->dominantType)
      ), "dominantType", "nameCaptureInfo", c163_i0);
    sf_mex_addfield(c163_m0, sf_mex_create("nameCaptureInfo", c163_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c163_r0->resolved)),
                    "resolved", "nameCaptureInfo", c163_i0);
    sf_mex_addfield(c163_m0, sf_mex_create("nameCaptureInfo",
      &c163_r0->fileLength, 7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c163_i0);
    sf_mex_addfield(c163_m0, sf_mex_create("nameCaptureInfo",
      &c163_r0->fileTime1, 7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c163_i0);
    sf_mex_addfield(c163_m0, sf_mex_create("nameCaptureInfo",
      &c163_r0->fileTime2, 7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c163_i0);
  }

  sf_mex_assign(&c163_nameCaptureInfo, c163_m0);
  return c163_nameCaptureInfo;
}

static void c163_info_helper(c163_ResolvedFunctionInfo c163_info[26])
{
  c163_info[0].context = "";
  c163_info[0].name = "lt";
  c163_info[0].dominantType = "double";
  c163_info[0].resolved = "[B]lt";
  c163_info[0].fileLength = 0U;
  c163_info[0].fileTime1 = 0U;
  c163_info[0].fileTime2 = 0U;
  c163_info[1].context = "";
  c163_info[1].name = "plus";
  c163_info[1].dominantType = "double";
  c163_info[1].resolved = "[B]plus";
  c163_info[1].fileLength = 0U;
  c163_info[1].fileTime1 = 0U;
  c163_info[1].fileTime2 = 0U;
  c163_info[2].context = "";
  c163_info[2].name = "minus";
  c163_info[2].dominantType = "double";
  c163_info[2].resolved = "[B]minus";
  c163_info[2].fileLength = 0U;
  c163_info[2].fileTime1 = 0U;
  c163_info[2].fileTime2 = 0U;
  c163_info[3].context = "";
  c163_info[3].name = "mrdivide";
  c163_info[3].dominantType = "double";
  c163_info[3].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c163_info[3].fileLength = 771U;
  c163_info[3].fileTime1 = 1219752936U;
  c163_info[3].fileTime2 = 0U;
  c163_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c163_info[4].name = "nargin";
  c163_info[4].dominantType = "";
  c163_info[4].resolved = "[B]nargin";
  c163_info[4].fileLength = 0U;
  c163_info[4].fileTime1 = 0U;
  c163_info[4].fileTime2 = 0U;
  c163_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c163_info[5].name = "ge";
  c163_info[5].dominantType = "double";
  c163_info[5].resolved = "[B]ge";
  c163_info[5].fileLength = 0U;
  c163_info[5].fileTime1 = 0U;
  c163_info[5].fileTime2 = 0U;
  c163_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c163_info[6].name = "isscalar";
  c163_info[6].dominantType = "double";
  c163_info[6].resolved = "[B]isscalar";
  c163_info[6].fileLength = 0U;
  c163_info[6].fileTime1 = 0U;
  c163_info[6].fileTime2 = 0U;
  c163_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c163_info[7].name = "rdivide";
  c163_info[7].dominantType = "double";
  c163_info[7].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c163_info[7].fileLength = 620U;
  c163_info[7].fileTime1 = 1213926766U;
  c163_info[7].fileTime2 = 0U;
  c163_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c163_info[8].name = "gt";
  c163_info[8].dominantType = "double";
  c163_info[8].resolved = "[B]gt";
  c163_info[8].fileLength = 0U;
  c163_info[8].fileTime1 = 0U;
  c163_info[8].fileTime2 = 0U;
  c163_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c163_info[9].name = "isa";
  c163_info[9].dominantType = "double";
  c163_info[9].resolved = "[B]isa";
  c163_info[9].fileLength = 0U;
  c163_info[9].fileTime1 = 0U;
  c163_info[9].fileTime2 = 0U;
  c163_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c163_info[10].name = "isempty";
  c163_info[10].dominantType = "double";
  c163_info[10].resolved = "[B]isempty";
  c163_info[10].fileLength = 0U;
  c163_info[10].fileTime1 = 0U;
  c163_info[10].fileTime2 = 0U;
  c163_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c163_info[11].name = "not";
  c163_info[11].dominantType = "logical";
  c163_info[11].resolved = "[B]not";
  c163_info[11].fileLength = 0U;
  c163_info[11].fileTime1 = 0U;
  c163_info[11].fileTime2 = 0U;
  c163_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c163_info[12].name = "strcmp";
  c163_info[12].dominantType = "char";
  c163_info[12].resolved = "[B]strcmp";
  c163_info[12].fileLength = 0U;
  c163_info[12].fileTime1 = 0U;
  c163_info[12].fileTime2 = 0U;
  c163_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c163_info[13].name = "eq";
  c163_info[13].dominantType = "double";
  c163_info[13].resolved = "[B]eq";
  c163_info[13].fileLength = 0U;
  c163_info[13].fileTime1 = 0U;
  c163_info[13].fileTime2 = 0U;
  c163_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c163_info[14].name = "eml_warning";
  c163_info[14].dominantType = "char";
  c163_info[14].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c163_info[14].fileLength = 274U;
  c163_info[14].fileTime1 = 1227613396U;
  c163_info[14].fileTime2 = 0U;
  c163_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c163_info[15].name = "eml_div";
  c163_info[15].dominantType = "double";
  c163_info[15].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c163_info[15].fileLength = 4269U;
  c163_info[15].fileTime1 = 1227613386U;
  c163_info[15].fileTime2 = 0U;
  c163_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c163_info[16].name = "isinteger";
  c163_info[16].dominantType = "double";
  c163_info[16].resolved = "[B]isinteger";
  c163_info[16].fileLength = 0U;
  c163_info[16].fileTime1 = 0U;
  c163_info[16].fileTime2 = 0U;
  c163_info[17].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m/eml_fldiv";
  c163_info[17].name = "isreal";
  c163_info[17].dominantType = "double";
  c163_info[17].resolved = "[B]isreal";
  c163_info[17].fileLength = 0U;
  c163_info[17].fileTime1 = 0U;
  c163_info[17].fileTime2 = 0U;
  c163_info[18].context = "";
  c163_info[18].name = "abs";
  c163_info[18].dominantType = "double";
  c163_info[18].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c163_info[18].fileLength = 566U;
  c163_info[18].fileTime1 = 1221267134U;
  c163_info[18].fileTime2 = 0U;
  c163_info[19].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c163_info[19].name = "ischar";
  c163_info[19].dominantType = "double";
  c163_info[19].resolved = "[B]ischar";
  c163_info[19].fileLength = 0U;
  c163_info[19].fileTime1 = 0U;
  c163_info[19].fileTime2 = 0U;
  c163_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c163_info[20].name = "islogical";
  c163_info[20].dominantType = "double";
  c163_info[20].resolved = "[B]islogical";
  c163_info[20].fileLength = 0U;
  c163_info[20].fileTime1 = 0U;
  c163_info[20].fileTime2 = 0U;
  c163_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c163_info[21].name = "size";
  c163_info[21].dominantType = "double";
  c163_info[21].resolved = "[B]size";
  c163_info[21].fileLength = 0U;
  c163_info[21].fileTime1 = 0U;
  c163_info[21].fileTime2 = 0U;
  c163_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c163_info[22].name = "class";
  c163_info[22].dominantType = "double";
  c163_info[22].resolved = "[B]class";
  c163_info[22].fileLength = 0U;
  c163_info[22].fileTime1 = 0U;
  c163_info[22].fileTime2 = 0U;
  c163_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c163_info[23].name = "zeros";
  c163_info[23].dominantType = "double";
  c163_info[23].resolved = "[B]zeros";
  c163_info[23].fileLength = 0U;
  c163_info[23].fileTime1 = 0U;
  c163_info[23].fileTime2 = 0U;
  c163_info[24].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c163_info[24].name = "eml_scalar_abs";
  c163_info[24].dominantType = "double";
  c163_info[24].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c163_info[24].fileLength = 461U;
  c163_info[24].fileTime1 = 1203447960U;
  c163_info[24].fileTime2 = 0U;
  c163_info[25].context = "";
  c163_info[25].name = "mtimes";
  c163_info[25].dominantType = "double";
  c163_info[25].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c163_info[25].fileLength = 2408U;
  c163_info[25].fileTime1 = 1227613402U;
  c163_info[25].fileTime2 = 0U;
}

static const mxArray *c163_emlrt_marshallOut(uint8_T c163_u)
{
  const mxArray *c163_y = NULL;
  c163_y = NULL;
  sf_mex_assign(&c163_y, sf_mex_create("y", &c163_u, 3, 0U, 0U, 0U, 0));
  return c163_y;
}

static real_T c163_emlrt_marshallIn(const mxArray *c163_angleInfInf, char
  *c163_name)
{
  real_T c163_y;
  real_T c163_d0;
  sf_mex_import(c163_name, sf_mex_dup(c163_angleInfInf), &c163_d0, 1, 0, 0U, 0,
                0U, 0);
  c163_y = c163_d0;
  sf_mex_destroy(&c163_angleInfInf);
  return c163_y;
}

static uint8_T c163_b_emlrt_marshallIn(const mxArray
  *c163_b_is_active_c163_MCSim, char *c163_name)
{
  uint8_T c163_y;
  uint8_T c163_u0;
  sf_mex_import(c163_name, sf_mex_dup(c163_b_is_active_c163_MCSim), &c163_u0, 1,
                3, 0U, 0, 0U, 0);
  c163_y = c163_u0;
  sf_mex_destroy(&c163_b_is_active_c163_MCSim);
  return c163_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c163_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3449534900U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(117606724U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2652827133U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4025134916U);
}

mxArray *sf_c163_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2282175482U);
    pr[1] = (double)(654535647U);
    pr[2] = (double)(3465337604U);
    pr[3] = (double)(662709345U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c163_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"angleInfInf\",},{M[8],M[0],T\"is_active_c163_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c163_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          163,
          1,
          1,
          4,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"meas",0,
                              c163_sf_marshall);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "angleInfInf",0,NULL);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "meas_prev",0,NULL);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "prevAngleInfInf",0,NULL);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,5,0,0,0,4,2);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,579);
        _SFD_CV_INIT_EML_IF(0,0,123,136,-1,160);
        _SFD_CV_INIT_EML_IF(0,1,161,179,-1,213);
        _SFD_CV_INIT_EML_IF(0,2,304,334,-1,539);
        _SFD_CV_INIT_EML_IF(0,3,356,389,442,535);
        _SFD_CV_INIT_EML_IF(0,4,442,479,-1,479);

        {
          static int condStart[] = { 360, 373 };

          static int condEnd[] = { 369, 388 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,0,360,388,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        {
          static int condStart[] = { 450, 464 };

          static int condEnd[] = { 460, 478 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,450,478,2,2,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T *c163_meas;
          real_T *c163_angleInfInf;
          real_T *c163_meas_prev;
          real_T *c163_prevAngleInfInf;
          c163_meas = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
          c163_angleInfInf = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          c163_prevAngleInfInf = (real_T *)ssGetInputPortSignal(chartInstance.S,
            2);
          c163_meas_prev = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c163_meas);
          _SFD_SET_DATA_VALUE_PTR(1U, c163_angleInfInf);
          _SFD_SET_DATA_VALUE_PTR(2U, c163_meas_prev);
          _SFD_SET_DATA_VALUE_PTR(3U, c163_prevAngleInfInf);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c163_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c163_MCSim();
  initialize_c163_MCSim();
}

static void sf_opaque_enable_c163_MCSim(void *chartInstanceVar)
{
  enable_c163_MCSim();
}

static void sf_opaque_disable_c163_MCSim(void *chartInstanceVar)
{
  disable_c163_MCSim();
}

static void sf_opaque_gateway_c163_MCSim(void *chartInstanceVar)
{
  sf_c163_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c163_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c163_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c163_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c163_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c163_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c163_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c163_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c163_MCSim();
  }
}

static void mdlSetWorkWidths_c163_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",163);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",163,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",163,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",163,3);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",163,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",163);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1747958923U));
  ssSetChecksum1(S,(441318945U));
  ssSetChecksum2(S,(2376015116U));
  ssSetChecksum3(S,(1868294785U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c163_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",163);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c163_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c163_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c163_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c163_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c163_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c163_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c163_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c163_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c163_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c163_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c163_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c163_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c163_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c163_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c163_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c163_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c163_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
