/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c166_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c166_IN_NO_ACTIVE_CHILD        (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc166_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c166_MCSim(void);
static void initialize_params_c166_MCSim(void);
static void enable_c166_MCSim(void);
static void disable_c166_MCSim(void);
static void c166_update_debugger_state_c166_MCSim(void);
static const mxArray *get_sim_state_c166_MCSim(void);
static void set_sim_state_c166_MCSim(const mxArray *c166_st);
static void finalize_c166_MCSim(void);
static void sf_c166_MCSim(void);
static void init_script_number_translation(uint32_T c166_machineNumber, uint32_T
  c166_chartNumber);
static void c166_eml_warning(void);
static const mxArray *c166_sf_marshall(void *c166_chartInstance, void *c166_u);
static const mxArray *c166_b_sf_marshall(void *c166_chartInstance, void *c166_u);
static void c166_info_helper(c166_ResolvedFunctionInfo c166_info[16]);
static const mxArray *c166_emlrt_marshallOut(real_T c166_u);
static const mxArray *c166_b_emlrt_marshallOut(uint8_T c166_u);
static real_T c166_emlrt_marshallIn(const mxArray *c166_y, char *c166_name);
static real_T c166_b_emlrt_marshallIn(const mxArray *c166_b_time, char
  *c166_name);
static uint8_T c166_c_emlrt_marshallIn(const mxArray
  *c166_b_is_active_c166_MCSim, char *c166_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c166_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c166_time_not_empty = false;
  chartInstance.c166_is_active_c166_MCSim = 0U;
}

static void initialize_params_c166_MCSim(void)
{
}

static void enable_c166_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c166_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c166_update_debugger_state_c166_MCSim(void)
{
}

static const mxArray *get_sim_state_c166_MCSim(void)
{
  const mxArray *c166_st = NULL;
  const mxArray *c166_y = NULL;
  real_T c166_u;
  const mxArray *c166_b_y = NULL;
  real_T *c166_c_y;
  c166_c_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c166_st = NULL;
  c166_y = NULL;
  sf_mex_assign(&c166_y, sf_mex_createcellarray(3));
  sf_mex_setcell(c166_y, 0, c166_emlrt_marshallOut(*c166_c_y));
  c166_u = chartInstance.c166_time;
  c166_b_y = NULL;
  if (!chartInstance.c166_time_not_empty) {
    sf_mex_assign(&c166_b_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c166_b_y, sf_mex_create("y", &c166_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_setcell(c166_y, 1, c166_b_y);
  sf_mex_setcell(c166_y, 2, c166_b_emlrt_marshallOut
                 (chartInstance.c166_is_active_c166_MCSim));
  sf_mex_assign(&c166_st, c166_y);
  return c166_st;
}

static void set_sim_state_c166_MCSim(const mxArray *c166_st)
{
  const mxArray *c166_u;
  real_T *c166_y;
  c166_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c166_doneDoubleBufferReInit = true;
  c166_u = sf_mex_dup(c166_st);
  *c166_y = c166_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c166_u, 0)), "y");
  chartInstance.c166_time = c166_b_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell
    (c166_u, 1)), "time");
  chartInstance.c166_is_active_c166_MCSim = c166_c_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c166_u, 2)), "is_active_c166_MCSim");
  sf_mex_destroy(&c166_u);
  c166_update_debugger_state_c166_MCSim();
  sf_mex_destroy(&c166_st);
}

static void finalize_c166_MCSim(void)
{
}

static void sf_c166_MCSim(void)
{
  uint8_T c166_previousEvent;
  real_T c166_u;
  real_T c166_sim_time;
  real_T c166_nargout = 1.0;
  real_T c166_nargin = 2.0;
  real_T c166_y;
  real_T c166_A;
  real_T c166_B;
  real_T c166_x;
  real_T c166_b_y;
  real_T c166_b_x;
  real_T c166_c_y;
  real_T c166_c_x;
  real_T c166_d_y;
  real_T c166_b_u;
  const mxArray *c166_e_y = NULL;
  real_T c166_b_A;
  real_T c166_b_B;
  real_T c166_d_x;
  real_T c166_f_y;
  real_T c166_e_x;
  real_T c166_g_y;
  real_T c166_f_x;
  real_T c166_h_y;
  real_T c166_c_u;
  const mxArray *c166_i_y = NULL;
  real_T *c166_d_u;
  real_T *c166_j_y;
  real_T *c166_b_sim_time;
  c166_b_sim_time = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c166_d_u = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c166_j_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,165);
  _SFD_DATA_RANGE_CHECK(*c166_d_u, 0U);
  _SFD_DATA_RANGE_CHECK(*c166_j_y, 1U);
  _SFD_DATA_RANGE_CHECK(*c166_b_sim_time, 2U);
  c166_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,165);
  c166_u = *c166_d_u;
  c166_sim_time = *c166_b_sim_time;
  sf_debug_symbol_scope_push(6U, 0U);
  sf_debug_symbol_scope_add("time", &chartInstance.c166_time, c166_b_sf_marshall);
  sf_debug_symbol_scope_add("nargout", &c166_nargout, c166_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c166_nargin, c166_sf_marshall);
  sf_debug_symbol_scope_add("y", &c166_y, c166_sf_marshall);
  sf_debug_symbol_scope_add("sim_time", &c166_sim_time, c166_sf_marshall);
  sf_debug_symbol_scope_add("u", &c166_u, c166_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  _SFD_EML_CALL(0,6);
  if (CV_EML_IF(0, 0, !chartInstance.c166_time_not_empty)) {
    _SFD_EML_CALL(0,7);
    chartInstance.c166_time = 0.0;
    chartInstance.c166_time_not_empty = true;
  }

  _SFD_EML_CALL(0,10);
  if (CV_EML_IF(0, 1, c166_u > chartInstance.c166_time + 1.0)) {
    _SFD_EML_CALL(0,11);
    c166_A = c166_u;
    c166_B = c166_sim_time;
    c166_x = c166_A;
    c166_b_y = c166_B;
    if (c166_b_y == 0.0) {
      c166_eml_warning();
    }

    c166_b_x = c166_x;
    c166_c_y = c166_b_y;
    c166_c_x = c166_b_x;
    c166_d_y = c166_c_y;
    c166_b_u = c166_c_x / c166_d_y;
    c166_e_y = NULL;
    sf_mex_assign(&c166_e_y, sf_mex_create("y", &c166_b_u, 0, 0U, 0U, 0U, 0));
    sf_mex_call_debug("waitbar", 0U, 1U, 14, c166_e_y);
    _SFD_EML_CALL(0,12);
    chartInstance.c166_time = c166_u;
  } else {
    _SFD_EML_CALL(0,13);
    if (CV_EML_IF(0, 2, c166_u == c166_sim_time)) {
      _SFD_EML_CALL(0,14);
      c166_b_A = c166_u;
      c166_b_B = c166_sim_time;
      c166_d_x = c166_b_A;
      c166_f_y = c166_b_B;
      if (c166_f_y == 0.0) {
        c166_eml_warning();
      }

      c166_e_x = c166_d_x;
      c166_g_y = c166_f_y;
      c166_f_x = c166_e_x;
      c166_h_y = c166_g_y;
      c166_c_u = c166_f_x / c166_h_y;
      c166_i_y = NULL;
      sf_mex_assign(&c166_i_y, sf_mex_create("y", &c166_c_u, 0, 0U, 0U, 0U, 0));
      sf_mex_call_debug("waitbar", 0U, 1U, 14, c166_i_y);
    }
  }

  _SFD_EML_CALL(0,17);
  c166_y = 0.0;
  _SFD_EML_CALL(0,-17);
  sf_debug_symbol_scope_pop();
  *c166_j_y = c166_y;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,165);
  _sfEvent_ = c166_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c166_machineNumber, uint32_T
  c166_chartNumber)
{
}

static void c166_eml_warning(void)
{
  int32_T c166_i0;
  static char_T c166_cv0[15] = { 'D', 'i', 'v', 'i', 'd', 'e', ' ', 'b', 'y',
    ' ', 'z', 'e', 'r', 'o', '.' };

  char_T c166_u[15];
  const mxArray *c166_y = NULL;
  int32_T c166_i1;
  static char_T c166_cv1[19] = { 'M', 'A', 'T', 'L', 'A', 'B', ':', 'd', 'i',
    'v', 'i', 'd', 'e', 'B', 'y', 'Z', 'e', 'r', 'o' };

  char_T c166_b_u[19];
  const mxArray *c166_b_y = NULL;
  for (c166_i0 = 0; c166_i0 < 15; c166_i0 = c166_i0 + 1) {
    c166_u[c166_i0] = c166_cv0[c166_i0];
  }

  c166_y = NULL;
  sf_mex_assign(&c166_y, sf_mex_create("y", &c166_u, 10, 0U, 1U, 0U, 2, 1, 15));
  for (c166_i1 = 0; c166_i1 < 19; c166_i1 = c166_i1 + 1) {
    c166_b_u[c166_i1] = c166_cv1[c166_i1];
  }

  c166_b_y = NULL;
  sf_mex_assign(&c166_b_y, sf_mex_create("y", &c166_b_u, 10, 0U, 1U, 0U, 2, 1,
    19));
  sf_mex_call_debug("warning", 0U, 2U, 14, c166_b_y, 14, c166_y);
}

static const mxArray *c166_sf_marshall(void *c166_chartInstance, void *c166_u)
{
  const mxArray *c166_y = NULL;
  real_T c166_b_u;
  const mxArray *c166_b_y = NULL;
  c166_y = NULL;
  c166_b_u = *((real_T *)c166_u);
  c166_b_y = NULL;
  sf_mex_assign(&c166_b_y, sf_mex_create("y", &c166_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c166_y, c166_b_y);
  return c166_y;
}

static const mxArray *c166_b_sf_marshall(void *c166_chartInstance, void *c166_u)
{
  const mxArray *c166_y = NULL;
  real_T c166_b_u;
  const mxArray *c166_b_y = NULL;
  c166_y = NULL;
  c166_b_u = *((real_T *)c166_u);
  c166_b_y = NULL;
  if (!chartInstance.c166_time_not_empty) {
    sf_mex_assign(&c166_b_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c166_b_y, sf_mex_create("y", &c166_b_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_assign(&c166_y, c166_b_y);
  return c166_y;
}

const mxArray *sf_c166_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c166_nameCaptureInfo = NULL;
  c166_ResolvedFunctionInfo c166_info[16];
  const mxArray *c166_m0 = NULL;
  int32_T c166_i2;
  c166_ResolvedFunctionInfo *c166_r0;
  c166_nameCaptureInfo = NULL;
  c166_info_helper(c166_info);
  sf_mex_assign(&c166_m0, sf_mex_createstruct("nameCaptureInfo", 1, 16));
  for (c166_i2 = 0; c166_i2 < 16; c166_i2 = c166_i2 + 1) {
    c166_r0 = &c166_info[c166_i2];
    sf_mex_addfield(c166_m0, sf_mex_create("nameCaptureInfo", c166_r0->context,
      15, 0U, 0U, 0U, 2, 1, strlen(c166_r0->context)),
                    "context", "nameCaptureInfo", c166_i2);
    sf_mex_addfield(c166_m0, sf_mex_create("nameCaptureInfo", c166_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c166_r0->name)), "name",
                    "nameCaptureInfo", c166_i2);
    sf_mex_addfield(c166_m0, sf_mex_create("nameCaptureInfo",
      c166_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c166_r0->dominantType)
      ), "dominantType", "nameCaptureInfo", c166_i2);
    sf_mex_addfield(c166_m0, sf_mex_create("nameCaptureInfo", c166_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c166_r0->resolved)),
                    "resolved", "nameCaptureInfo", c166_i2);
    sf_mex_addfield(c166_m0, sf_mex_create("nameCaptureInfo",
      &c166_r0->fileLength, 7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c166_i2);
    sf_mex_addfield(c166_m0, sf_mex_create("nameCaptureInfo",
      &c166_r0->fileTime1, 7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c166_i2);
    sf_mex_addfield(c166_m0, sf_mex_create("nameCaptureInfo",
      &c166_r0->fileTime2, 7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c166_i2);
  }

  sf_mex_assign(&c166_nameCaptureInfo, c166_m0);
  return c166_nameCaptureInfo;
}

static void c166_info_helper(c166_ResolvedFunctionInfo c166_info[16])
{
  c166_info[0].context = "";
  c166_info[0].name = "plus";
  c166_info[0].dominantType = "double";
  c166_info[0].resolved = "[B]plus";
  c166_info[0].fileLength = 0U;
  c166_info[0].fileTime1 = 0U;
  c166_info[0].fileTime2 = 0U;
  c166_info[1].context = "";
  c166_info[1].name = "gt";
  c166_info[1].dominantType = "double";
  c166_info[1].resolved = "[B]gt";
  c166_info[1].fileLength = 0U;
  c166_info[1].fileTime1 = 0U;
  c166_info[1].fileTime2 = 0U;
  c166_info[2].context = "";
  c166_info[2].name = "mrdivide";
  c166_info[2].dominantType = "double";
  c166_info[2].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c166_info[2].fileLength = 771U;
  c166_info[2].fileTime1 = 1219752936U;
  c166_info[2].fileTime2 = 0U;
  c166_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c166_info[3].name = "nargin";
  c166_info[3].dominantType = "";
  c166_info[3].resolved = "[B]nargin";
  c166_info[3].fileLength = 0U;
  c166_info[3].fileTime1 = 0U;
  c166_info[3].fileTime2 = 0U;
  c166_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c166_info[4].name = "ge";
  c166_info[4].dominantType = "double";
  c166_info[4].resolved = "[B]ge";
  c166_info[4].fileLength = 0U;
  c166_info[4].fileTime1 = 0U;
  c166_info[4].fileTime2 = 0U;
  c166_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c166_info[5].name = "isscalar";
  c166_info[5].dominantType = "double";
  c166_info[5].resolved = "[B]isscalar";
  c166_info[5].fileLength = 0U;
  c166_info[5].fileTime1 = 0U;
  c166_info[5].fileTime2 = 0U;
  c166_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c166_info[6].name = "rdivide";
  c166_info[6].dominantType = "double";
  c166_info[6].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c166_info[6].fileLength = 620U;
  c166_info[6].fileTime1 = 1213926766U;
  c166_info[6].fileTime2 = 0U;
  c166_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c166_info[7].name = "isa";
  c166_info[7].dominantType = "double";
  c166_info[7].resolved = "[B]isa";
  c166_info[7].fileLength = 0U;
  c166_info[7].fileTime1 = 0U;
  c166_info[7].fileTime2 = 0U;
  c166_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c166_info[8].name = "isempty";
  c166_info[8].dominantType = "double";
  c166_info[8].resolved = "[B]isempty";
  c166_info[8].fileLength = 0U;
  c166_info[8].fileTime1 = 0U;
  c166_info[8].fileTime2 = 0U;
  c166_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c166_info[9].name = "not";
  c166_info[9].dominantType = "logical";
  c166_info[9].resolved = "[B]not";
  c166_info[9].fileLength = 0U;
  c166_info[9].fileTime1 = 0U;
  c166_info[9].fileTime2 = 0U;
  c166_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c166_info[10].name = "strcmp";
  c166_info[10].dominantType = "char";
  c166_info[10].resolved = "[B]strcmp";
  c166_info[10].fileLength = 0U;
  c166_info[10].fileTime1 = 0U;
  c166_info[10].fileTime2 = 0U;
  c166_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c166_info[11].name = "eq";
  c166_info[11].dominantType = "double";
  c166_info[11].resolved = "[B]eq";
  c166_info[11].fileLength = 0U;
  c166_info[11].fileTime1 = 0U;
  c166_info[11].fileTime2 = 0U;
  c166_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c166_info[12].name = "eml_warning";
  c166_info[12].dominantType = "char";
  c166_info[12].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c166_info[12].fileLength = 274U;
  c166_info[12].fileTime1 = 1227613396U;
  c166_info[12].fileTime2 = 0U;
  c166_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c166_info[13].name = "eml_div";
  c166_info[13].dominantType = "double";
  c166_info[13].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c166_info[13].fileLength = 4269U;
  c166_info[13].fileTime1 = 1227613386U;
  c166_info[13].fileTime2 = 0U;
  c166_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c166_info[14].name = "isinteger";
  c166_info[14].dominantType = "double";
  c166_info[14].resolved = "[B]isinteger";
  c166_info[14].fileLength = 0U;
  c166_info[14].fileTime1 = 0U;
  c166_info[14].fileTime2 = 0U;
  c166_info[15].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m/eml_fldiv";
  c166_info[15].name = "isreal";
  c166_info[15].dominantType = "double";
  c166_info[15].resolved = "[B]isreal";
  c166_info[15].fileLength = 0U;
  c166_info[15].fileTime1 = 0U;
  c166_info[15].fileTime2 = 0U;
}

static const mxArray *c166_emlrt_marshallOut(real_T c166_u)
{
  const mxArray *c166_y = NULL;
  c166_y = NULL;
  sf_mex_assign(&c166_y, sf_mex_create("y", &c166_u, 0, 0U, 0U, 0U, 0));
  return c166_y;
}

static const mxArray *c166_b_emlrt_marshallOut(uint8_T c166_u)
{
  const mxArray *c166_y = NULL;
  c166_y = NULL;
  sf_mex_assign(&c166_y, sf_mex_create("y", &c166_u, 3, 0U, 0U, 0U, 0));
  return c166_y;
}

static real_T c166_emlrt_marshallIn(const mxArray *c166_y, char *c166_name)
{
  real_T c166_b_y;
  real_T c166_d0;
  sf_mex_import(c166_name, sf_mex_dup(c166_y), &c166_d0, 1, 0, 0U, 0, 0U, 0);
  c166_b_y = c166_d0;
  sf_mex_destroy(&c166_y);
  return c166_b_y;
}

static real_T c166_b_emlrt_marshallIn(const mxArray *c166_b_time, char
  *c166_name)
{
  real_T c166_y;
  real_T c166_d1;
  if (mxIsEmpty(c166_b_time)) {
    chartInstance.c166_time_not_empty = false;
  } else {
    chartInstance.c166_time_not_empty = true;
    sf_mex_import(c166_name, sf_mex_dup(c166_b_time), &c166_d1, 1, 0, 0U, 0, 0U,
                  0);
    c166_y = c166_d1;
  }

  sf_mex_destroy(&c166_b_time);
  return c166_y;
}

static uint8_T c166_c_emlrt_marshallIn(const mxArray
  *c166_b_is_active_c166_MCSim, char *c166_name)
{
  uint8_T c166_y;
  uint8_T c166_u0;
  sf_mex_import(c166_name, sf_mex_dup(c166_b_is_active_c166_MCSim), &c166_u0, 1,
                3, 0U, 0, 0U, 0);
  c166_y = c166_u0;
  sf_mex_destroy(&c166_b_is_active_c166_MCSim);
  return c166_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c166_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(190549967U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1661843655U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2102101728U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(521533553U);
}

mxArray *sf_c166_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(770582615U);
    pr[1] = (double)(1998888204U);
    pr[2] = (double)(924456533U);
    pr[3] = (double)(606399900U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c166_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[5],T\"y\",},{M[4],M[0],T\"time\",S'l','i','p'{{M1x2[72 76],M[0],}}},{M[8],M[0],T\"is_active_c166_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c166_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          166,
          1,
          1,
          3,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"u",0,
                              c166_sf_marshall);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"y",0,
                              NULL);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "sim_time",0,NULL);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,3,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,222);
        _SFD_CV_INIT_EML_IF(0,0,78,94,-1,112);
        _SFD_CV_INIT_EML_IF(0,1,114,127,166,214);
        _SFD_CV_INIT_EML_IF(0,2,166,186,-1,186);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T *c166_u;
          real_T *c166_y;
          real_T *c166_sim_time;
          c166_sim_time = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
          c166_u = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
          c166_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c166_u);
          _SFD_SET_DATA_VALUE_PTR(1U, c166_y);
          _SFD_SET_DATA_VALUE_PTR(2U, c166_sim_time);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c166_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c166_MCSim();
  initialize_c166_MCSim();
}

static void sf_opaque_enable_c166_MCSim(void *chartInstanceVar)
{
  enable_c166_MCSim();
}

static void sf_opaque_disable_c166_MCSim(void *chartInstanceVar)
{
  disable_c166_MCSim();
}

static void sf_opaque_gateway_c166_MCSim(void *chartInstanceVar)
{
  sf_c166_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c166_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c166_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c166_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c166_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c166_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c166_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c166_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c166_MCSim();
  }
}

static void mdlSetWorkWidths_c166_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",166);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",166,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",166,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",166,2);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",166,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",166);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2976441123U));
  ssSetChecksum1(S,(1011067765U));
  ssSetChecksum2(S,(643449366U));
  ssSetChecksum3(S,(2310115832U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c166_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",166);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c166_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c166_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c166_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c166_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c166_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c166_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c166_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c166_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c166_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c166_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c166_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c166_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c166_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c166_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c166_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c166_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c166_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
