/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c29_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c29_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc29_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c29_MCSim(void);
static void initialize_params_c29_MCSim(void);
static void enable_c29_MCSim(void);
static void disable_c29_MCSim(void);
static void c29_update_debugger_state_c29_MCSim(void);
static const mxArray *get_sim_state_c29_MCSim(void);
static void set_sim_state_c29_MCSim(const mxArray *c29_st);
static void finalize_c29_MCSim(void);
static void sf_c29_MCSim(void);
static void init_script_number_translation(uint32_T c29_machineNumber, uint32_T
  c29_chartNumber);
static const mxArray *c29_sf_marshall(void *c29_chartInstance, void *c29_u);
static const mxArray *c29_b_sf_marshall(void *c29_chartInstance, void *c29_u);
static const mxArray *c29_c_sf_marshall(void *c29_chartInstance, void *c29_u);
static const mxArray *c29_emlrt_marshallOut(uint8_T c29_u);
static real_T c29_emlrt_marshallIn(const mxArray *c29_obj, char *c29_name);
static real_T c29_b_emlrt_marshallIn(const mxArray *c29_status, char *c29_name);
static void c29_c_emlrt_marshallIn(const mxArray *c29_x, char *c29_name, real_T
  c29_y[9]);
static uint8_T c29_d_emlrt_marshallIn(const mxArray *c29_b_is_active_c29_MCSim,
  char *c29_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c29_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c29_is_active_c29_MCSim = 0U;
}

static void initialize_params_c29_MCSim(void)
{
}

static void enable_c29_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c29_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c29_update_debugger_state_c29_MCSim(void)
{
}

static const mxArray *get_sim_state_c29_MCSim(void)
{
  const mxArray *c29_st = NULL;
  const mxArray *c29_y = NULL;
  real_T c29_u;
  const mxArray *c29_b_y = NULL;
  real_T c29_b_u;
  const mxArray *c29_c_y = NULL;
  int32_T c29_i0;
  real_T c29_c_u[9];
  const mxArray *c29_d_y = NULL;
  real_T *c29_obj;
  real_T *c29_status;
  real_T (*c29_x)[9];
  c29_status = (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c29_obj = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c29_x = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 2);
  c29_st = NULL;
  c29_y = NULL;
  sf_mex_assign(&c29_y, sf_mex_createcellarray(4));
  c29_u = *c29_obj;
  c29_b_y = NULL;
  sf_mex_assign(&c29_b_y, sf_mex_create("y", &c29_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c29_y, 0, c29_b_y);
  c29_b_u = *c29_status;
  c29_c_y = NULL;
  sf_mex_assign(&c29_c_y, sf_mex_create("y", &c29_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c29_y, 1, c29_c_y);
  for (c29_i0 = 0; c29_i0 < 9; c29_i0 = c29_i0 + 1) {
    c29_c_u[c29_i0] = (*c29_x)[c29_i0];
  }

  c29_d_y = NULL;
  sf_mex_assign(&c29_d_y, sf_mex_create("y", &c29_c_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_setcell(c29_y, 2, c29_d_y);
  sf_mex_setcell(c29_y, 3, c29_emlrt_marshallOut
                 (chartInstance.c29_is_active_c29_MCSim));
  sf_mex_assign(&c29_st, c29_y);
  return c29_st;
}

static void set_sim_state_c29_MCSim(const mxArray *c29_st)
{
  const mxArray *c29_u;
  real_T c29_dv0[9];
  int32_T c29_i1;
  real_T *c29_obj;
  real_T *c29_status;
  real_T (*c29_x)[9];
  c29_status = (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c29_obj = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c29_x = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 2);
  chartInstance.c29_doneDoubleBufferReInit = true;
  c29_u = sf_mex_dup(c29_st);
  *c29_obj = c29_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c29_u, 0)), "obj");
  *c29_status = c29_b_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c29_u, 1)),
    "status");
  c29_c_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c29_u, 2)), "x", c29_dv0);
  for (c29_i1 = 0; c29_i1 < 9; c29_i1 = c29_i1 + 1) {
    (*c29_x)[c29_i1] = c29_dv0[c29_i1];
  }

  chartInstance.c29_is_active_c29_MCSim = c29_d_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c29_u, 3)), "is_active_c29_MCSim");
  sf_mex_destroy(&c29_u);
  c29_update_debugger_state_c29_MCSim();
  sf_mex_destroy(&c29_st);
}

static void finalize_c29_MCSim(void)
{
}

static void sf_c29_MCSim(void)
{
  int32_T c29_i2;
  int32_T c29_i3;
  uint8_T c29_previousEvent;
  int32_T c29_i4;
  real_T c29_solution[11];
  real_T c29_nargout = 3.0;
  real_T c29_nargin = 1.0;
  real_T c29_status;
  real_T c29_x[9];
  real_T c29_obj;
  real_T c29_b_solution[9];
  int32_T c29_i5;
  int32_T c29_i6;
  real_T *c29_b_obj;
  real_T *c29_b_status;
  real_T (*c29_b_x)[9];
  real_T (*c29_c_solution)[11];
  c29_c_solution = (real_T (*)[11])ssGetInputPortSignal(chartInstance.S, 0);
  c29_b_status = (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c29_b_obj = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c29_b_x = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 2);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,28);
  for (c29_i2 = 0; c29_i2 < 11; c29_i2 = c29_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c29_c_solution)[c29_i2], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c29_b_obj, 1U);
  for (c29_i3 = 0; c29_i3 < 9; c29_i3 = c29_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c29_b_x)[c29_i3], 2U);
  }

  _SFD_DATA_RANGE_CHECK(*c29_b_status, 3U);
  c29_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,28);
  for (c29_i4 = 0; c29_i4 < 11; c29_i4 = c29_i4 + 1) {
    c29_solution[c29_i4] = (*c29_c_solution)[c29_i4];
  }

  sf_debug_symbol_scope_push(6U, 0U);
  sf_debug_symbol_scope_add("nargout", &c29_nargout, c29_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c29_nargin, c29_b_sf_marshall);
  sf_debug_symbol_scope_add("status", &c29_status, c29_b_sf_marshall);
  sf_debug_symbol_scope_add("x", &c29_x, c29_c_sf_marshall);
  sf_debug_symbol_scope_add("obj", &c29_obj, c29_b_sf_marshall);
  sf_debug_symbol_scope_add("solution", &c29_solution, c29_sf_marshall);
  CV_EML_FCN(0, 0);

  /* numOfThrusters and numOfAzimuths are parameters thus not an input and should be decleared in the workspace. */
  _SFD_EML_CALL(0,3);
  c29_obj = c29_solution[0];
  _SFD_EML_CALL(0,4);
  c29_b_solution[0] = c29_solution[1];
  c29_b_solution[1] = c29_solution[2];
  c29_b_solution[2] = c29_solution[3];
  c29_b_solution[3] = c29_solution[4];
  c29_b_solution[4] = c29_solution[5];
  c29_b_solution[5] = c29_solution[6];
  c29_b_solution[6] = c29_solution[7];
  c29_b_solution[7] = c29_solution[8];
  c29_b_solution[8] = c29_solution[9];
  for (c29_i5 = 0; c29_i5 < 9; c29_i5 = c29_i5 + 1) {
    c29_x[c29_i5] = c29_b_solution[c29_i5];
  }

  _SFD_EML_CALL(0,5);
  c29_status = c29_solution[10];
  _SFD_EML_CALL(0,-5);
  sf_debug_symbol_scope_pop();
  *c29_b_obj = c29_obj;
  for (c29_i6 = 0; c29_i6 < 9; c29_i6 = c29_i6 + 1) {
    (*c29_b_x)[c29_i6] = c29_x[c29_i6];
  }

  *c29_b_status = c29_status;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,28);
  _sfEvent_ = c29_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c29_machineNumber, uint32_T
  c29_chartNumber)
{
}

static const mxArray *c29_sf_marshall(void *c29_chartInstance, void *c29_u)
{
  const mxArray *c29_y = NULL;
  int32_T c29_i7;
  real_T c29_b_u[11];
  const mxArray *c29_b_y = NULL;
  c29_y = NULL;
  for (c29_i7 = 0; c29_i7 < 11; c29_i7 = c29_i7 + 1) {
    c29_b_u[c29_i7] = (*((real_T (*)[11])c29_u))[c29_i7];
  }

  c29_b_y = NULL;
  sf_mex_assign(&c29_b_y, sf_mex_create("y", &c29_b_u, 0, 0U, 1U, 0U, 1, 11));
  sf_mex_assign(&c29_y, c29_b_y);
  return c29_y;
}

static const mxArray *c29_b_sf_marshall(void *c29_chartInstance, void *c29_u)
{
  const mxArray *c29_y = NULL;
  real_T c29_b_u;
  const mxArray *c29_b_y = NULL;
  c29_y = NULL;
  c29_b_u = *((real_T *)c29_u);
  c29_b_y = NULL;
  sf_mex_assign(&c29_b_y, sf_mex_create("y", &c29_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c29_y, c29_b_y);
  return c29_y;
}

static const mxArray *c29_c_sf_marshall(void *c29_chartInstance, void *c29_u)
{
  const mxArray *c29_y = NULL;
  int32_T c29_i8;
  real_T c29_b_u[9];
  const mxArray *c29_b_y = NULL;
  c29_y = NULL;
  for (c29_i8 = 0; c29_i8 < 9; c29_i8 = c29_i8 + 1) {
    c29_b_u[c29_i8] = (*((real_T (*)[9])c29_u))[c29_i8];
  }

  c29_b_y = NULL;
  sf_mex_assign(&c29_b_y, sf_mex_create("y", &c29_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_assign(&c29_y, c29_b_y);
  return c29_y;
}

const mxArray *sf_c29_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c29_nameCaptureInfo = NULL;
  c29_ResolvedFunctionInfo c29_info[1];
  c29_ResolvedFunctionInfo (*c29_b_info)[1];
  const mxArray *c29_m0 = NULL;
  int32_T c29_i9;
  c29_ResolvedFunctionInfo *c29_r0;
  c29_nameCaptureInfo = NULL;
  c29_b_info = (c29_ResolvedFunctionInfo (*)[1])c29_info;
  (*c29_b_info)[0].context = "";
  (*c29_b_info)[0].name = "ctranspose";
  (*c29_b_info)[0].dominantType = "double";
  (*c29_b_info)[0].resolved = "[B]ctranspose";
  (*c29_b_info)[0].fileLength = 0U;
  (*c29_b_info)[0].fileTime1 = 0U;
  (*c29_b_info)[0].fileTime2 = 0U;
  sf_mex_assign(&c29_m0, sf_mex_createstruct("nameCaptureInfo", 1, 1));
  for (c29_i9 = 0; c29_i9 < 1; c29_i9 = c29_i9 + 1) {
    c29_r0 = &c29_info[c29_i9];
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", c29_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c29_r0->context)), "context"
                    , "nameCaptureInfo", c29_i9);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", c29_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c29_r0->name)), "name",
                    "nameCaptureInfo", c29_i9);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo",
      c29_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c29_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c29_i9);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", c29_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c29_r0->resolved)),
                    "resolved", "nameCaptureInfo", c29_i9);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", &c29_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c29_i9);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", &c29_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c29_i9);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", &c29_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c29_i9);
  }

  sf_mex_assign(&c29_nameCaptureInfo, c29_m0);
  return c29_nameCaptureInfo;
}

static const mxArray *c29_emlrt_marshallOut(uint8_T c29_u)
{
  const mxArray *c29_y = NULL;
  c29_y = NULL;
  sf_mex_assign(&c29_y, sf_mex_create("y", &c29_u, 3, 0U, 0U, 0U, 0));
  return c29_y;
}

static real_T c29_emlrt_marshallIn(const mxArray *c29_obj, char *c29_name)
{
  real_T c29_y;
  real_T c29_d0;
  sf_mex_import(c29_name, sf_mex_dup(c29_obj), &c29_d0, 1, 0, 0U, 0, 0U, 0);
  c29_y = c29_d0;
  sf_mex_destroy(&c29_obj);
  return c29_y;
}

static real_T c29_b_emlrt_marshallIn(const mxArray *c29_status, char *c29_name)
{
  real_T c29_y;
  real_T c29_d1;
  sf_mex_import(c29_name, sf_mex_dup(c29_status), &c29_d1, 1, 0, 0U, 0, 0U, 0);
  c29_y = c29_d1;
  sf_mex_destroy(&c29_status);
  return c29_y;
}

static void c29_c_emlrt_marshallIn(const mxArray *c29_x, char *c29_name, real_T
  c29_y[9])
{
  real_T c29_dv1[9];
  int32_T c29_i10;
  sf_mex_import(c29_name, sf_mex_dup(c29_x), &c29_dv1, 1, 0, 0U, 1, 0U, 1, 9);
  for (c29_i10 = 0; c29_i10 < 9; c29_i10 = c29_i10 + 1) {
    c29_y[c29_i10] = c29_dv1[c29_i10];
  }

  sf_mex_destroy(&c29_x);
}

static uint8_T c29_d_emlrt_marshallIn(const mxArray *c29_b_is_active_c29_MCSim,
  char *c29_name)
{
  uint8_T c29_y;
  uint8_T c29_u0;
  sf_mex_import(c29_name, sf_mex_dup(c29_b_is_active_c29_MCSim), &c29_u0, 1, 3,
                0U, 0, 0U, 0);
  c29_y = c29_u0;
  sf_mex_destroy(&c29_b_is_active_c29_MCSim);
  return c29_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c29_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(939711952U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3051255288U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2965438228U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2565707688U);
}

mxArray *sf_c29_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(4045385981U);
    pr[1] = (double)(2314791118U);
    pr[2] = (double)(656315146U);
    pr[3] = (double)(2892056378U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(11);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c29_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[10],T\"obj\",},{M[1],M[13],T\"status\",},{M[1],M[12],T\"x\",},{M[8],M[0],T\"is_active_c29_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c29_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          29,
          1,
          1,
          4,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 11;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"solution",0,c29_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"obj",0,
                              c29_b_sf_marshall);

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"x",0,c29_c_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(3,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"status",
                              0,NULL);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,342);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c29_solution)[11];
          real_T *c29_obj;
          real_T (*c29_x)[9];
          real_T *c29_status;
          c29_solution = (real_T (*)[11])ssGetInputPortSignal(chartInstance.S, 0);
          c29_status = (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
          c29_obj = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          c29_x = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 2);
          _SFD_SET_DATA_VALUE_PTR(0U, c29_solution);
          _SFD_SET_DATA_VALUE_PTR(1U, c29_obj);
          _SFD_SET_DATA_VALUE_PTR(2U, c29_x);
          _SFD_SET_DATA_VALUE_PTR(3U, c29_status);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c29_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c29_MCSim();
  initialize_c29_MCSim();
}

static void sf_opaque_enable_c29_MCSim(void *chartInstanceVar)
{
  enable_c29_MCSim();
}

static void sf_opaque_disable_c29_MCSim(void *chartInstanceVar)
{
  disable_c29_MCSim();
}

static void sf_opaque_gateway_c29_MCSim(void *chartInstanceVar)
{
  sf_c29_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c29_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c29_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c29_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c29_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c29_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c29_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c29_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c29_MCSim();
  }
}

static void mdlSetWorkWidths_c29_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",29);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",29,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",29,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",29,1);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",29,3);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",29);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3044856657U));
  ssSetChecksum1(S,(3509678078U));
  ssSetChecksum2(S,(1420798892U));
  ssSetChecksum3(S,(1440570976U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c29_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",29);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c29_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c29_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c29_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c29_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c29_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c29_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c29_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c29_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c29_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c29_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c29_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c29_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c29_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c29_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c29_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c29_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c29_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
