/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c33_MCSim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c33_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc33_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c33_MCSim(void);
static void initialize_params_c33_MCSim(void);
static void enable_c33_MCSim(void);
static void disable_c33_MCSim(void);
static void c33_update_debugger_state_c33_MCSim(void);
static const mxArray *get_sim_state_c33_MCSim(void);
static void set_sim_state_c33_MCSim(const mxArray *c33_st);
static void finalize_c33_MCSim(void);
static void sf_c33_MCSim(void);
static void init_script_number_translation(uint32_T c33_machineNumber, uint32_T
  c33_chartNumber);
static const mxArray *c33_sf_marshall(void *c33_chartInstance, void *c33_u);
static const mxArray *c33_b_sf_marshall(void *c33_chartInstance, void *c33_u);
static const mxArray *c33_c_sf_marshall(void *c33_chartInstance, void *c33_u);
static void c33_info_helper(c33_ResolvedFunctionInfo c33_info[18]);
static const mxArray *c33_emlrt_marshallOut(uint8_T c33_u);
static void c33_emlrt_marshallIn(const mxArray *c33_B_alphaPrev, char *c33_name,
  real_T c33_y[9]);
static uint8_T c33_b_emlrt_marshallIn(const mxArray *c33_b_is_active_c33_MCSim,
  char *c33_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c33_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c33_is_active_c33_MCSim = 0U;
}

static void initialize_params_c33_MCSim(void)
{
}

static void enable_c33_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c33_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c33_update_debugger_state_c33_MCSim(void)
{
}

static const mxArray *get_sim_state_c33_MCSim(void)
{
  const mxArray *c33_st = NULL;
  const mxArray *c33_y = NULL;
  int32_T c33_i0;
  real_T c33_u[9];
  const mxArray *c33_b_y = NULL;
  real_T (*c33_B_alphaPrev)[9];
  c33_B_alphaPrev = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  c33_st = NULL;
  c33_y = NULL;
  sf_mex_assign(&c33_y, sf_mex_createcellarray(2));
  for (c33_i0 = 0; c33_i0 < 9; c33_i0 = c33_i0 + 1) {
    c33_u[c33_i0] = (*c33_B_alphaPrev)[c33_i0];
  }

  c33_b_y = NULL;
  sf_mex_assign(&c33_b_y, sf_mex_create("y", &c33_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_setcell(c33_y, 0, c33_b_y);
  sf_mex_setcell(c33_y, 1, c33_emlrt_marshallOut
                 (chartInstance.c33_is_active_c33_MCSim));
  sf_mex_assign(&c33_st, c33_y);
  return c33_st;
}

static void set_sim_state_c33_MCSim(const mxArray *c33_st)
{
  const mxArray *c33_u;
  real_T c33_dv0[9];
  int32_T c33_i1;
  real_T (*c33_B_alphaPrev)[9];
  c33_B_alphaPrev = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c33_doneDoubleBufferReInit = true;
  c33_u = sf_mex_dup(c33_st);
  c33_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c33_u, 0)), "B_alphaPrev",
                       c33_dv0);
  for (c33_i1 = 0; c33_i1 < 9; c33_i1 = c33_i1 + 1) {
    (*c33_B_alphaPrev)[c33_i1] = c33_dv0[c33_i1];
  }

  chartInstance.c33_is_active_c33_MCSim = c33_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c33_u, 1)), "is_active_c33_MCSim");
  sf_mex_destroy(&c33_u);
  c33_update_debugger_state_c33_MCSim();
  sf_mex_destroy(&c33_st);
}

static void finalize_c33_MCSim(void)
{
}

static void sf_c33_MCSim(void)
{
  int32_T c33_i2;
  int32_T c33_i3;
  int32_T c33_i4;
  int32_T c33_i5;
  uint8_T c33_previousEvent;
  int32_T c33_i6;
  real_T c33_alpha_prev[3];
  int32_T c33_i7;
  real_T c33_ly[3];
  int32_T c33_i8;
  real_T c33_lx[3];
  real_T c33_nargout = 1.0;
  real_T c33_nargin = 3.0;
  real_T c33_B_alphaPrev[9];
  real_T c33_x;
  real_T c33_a;
  real_T c33_b_x;
  real_T c33_b;
  real_T c33_y;
  real_T c33_c_x;
  real_T c33_d_x;
  real_T c33_e_x;
  real_T c33_b_a;
  real_T c33_b_b;
  real_T c33_b_y;
  real_T c33_f_x;
  real_T c33_c_a;
  real_T c33_g_x;
  real_T c33_c_b;
  real_T c33_c_y;
  real_T c33_h_x;
  real_T c33_i_x;
  real_T c33_j_x;
  real_T c33_d_a;
  real_T c33_d_b;
  real_T c33_d_y;
  real_T c33_k_x;
  real_T c33_e_a;
  real_T c33_l_x;
  real_T c33_e_b;
  real_T c33_e_y;
  real_T c33_m_x;
  real_T c33_n_x;
  real_T c33_o_x;
  real_T c33_f_a;
  real_T c33_f_b;
  real_T c33_f_y;
  real_T c33_p_x;
  real_T c33_q_x;
  real_T c33_r_x;
  real_T c33_s_x;
  real_T c33_t_x;
  real_T c33_u_x;
  real_T c33_v_x;
  real_T c33_w_x;
  real_T c33_x_x;
  real_T c33_y_x;
  real_T c33_ab_x;
  real_T c33_bb_x;
  real_T c33_cb_x;
  real_T c33_db_x;
  real_T c33_eb_x;
  real_T c33_fb_x;
  real_T c33_gb_x;
  real_T c33_hb_x;
  int32_T c33_i9;
  real_T (*c33_b_B_alphaPrev)[9];
  real_T (*c33_b_lx)[3];
  real_T (*c33_b_ly)[3];
  real_T (*c33_b_alpha_prev)[3];
  c33_b_alpha_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c33_b_B_alphaPrev = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  c33_b_ly = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  c33_b_lx = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,32);
  for (c33_i2 = 0; c33_i2 < 9; c33_i2 = c33_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c33_b_B_alphaPrev)[c33_i2], 0U);
  }

  for (c33_i3 = 0; c33_i3 < 3; c33_i3 = c33_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c33_b_alpha_prev)[c33_i3], 1U);
  }

  for (c33_i4 = 0; c33_i4 < 3; c33_i4 = c33_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c33_b_ly)[c33_i4], 2U);
  }

  for (c33_i5 = 0; c33_i5 < 3; c33_i5 = c33_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c33_b_lx)[c33_i5], 3U);
  }

  c33_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,32);
  for (c33_i6 = 0; c33_i6 < 3; c33_i6 = c33_i6 + 1) {
    c33_alpha_prev[c33_i6] = (*c33_b_alpha_prev)[c33_i6];
  }

  for (c33_i7 = 0; c33_i7 < 3; c33_i7 = c33_i7 + 1) {
    c33_ly[c33_i7] = (*c33_b_ly)[c33_i7];
  }

  for (c33_i8 = 0; c33_i8 < 3; c33_i8 = c33_i8 + 1) {
    c33_lx[c33_i8] = (*c33_b_lx)[c33_i8];
  }

  sf_debug_symbol_scope_push(6U, 0U);
  sf_debug_symbol_scope_add("nargout", &c33_nargout, c33_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c33_nargin, c33_c_sf_marshall);
  sf_debug_symbol_scope_add("B_alphaPrev", &c33_B_alphaPrev, c33_b_sf_marshall);
  sf_debug_symbol_scope_add("lx", &c33_lx, c33_sf_marshall);
  sf_debug_symbol_scope_add("ly", &c33_ly, c33_sf_marshall);
  sf_debug_symbol_scope_add("alpha_prev", &c33_alpha_prev, c33_sf_marshall);
  CV_EML_FCN(0, 0);

  /*  Please see the article Constrained Nonlinear Control Allocation with Singularity Avoidance using  */
  /*  Sequential Quadratic Programmming by Tor.A.Johansen, Thor I. Fossen ... (2004) */
  _SFD_EML_CALL(0,6);
  c33_x = c33_alpha_prev[2];
  c33_a = c33_x;
  c33_b_x = c33_a;
  c33_a = c33_b_x;
  c33_a = muDoubleScalarSin(c33_a);
  c33_b = c33_lx[2];
  c33_y = c33_a * c33_b;
  c33_c_x = c33_alpha_prev[2];
  c33_d_x = c33_c_x;
  c33_e_x = c33_d_x;
  c33_d_x = c33_e_x;
  c33_d_x = muDoubleScalarCos(c33_d_x);
  c33_b_a = -c33_d_x;
  c33_b_b = c33_ly[2];
  c33_b_y = c33_b_a * c33_b_b;
  c33_f_x = c33_alpha_prev[1];
  c33_c_a = c33_f_x;
  c33_g_x = c33_c_a;
  c33_c_a = c33_g_x;
  c33_c_a = muDoubleScalarSin(c33_c_a);
  c33_c_b = c33_lx[1];
  c33_c_y = c33_c_a * c33_c_b;
  c33_h_x = c33_alpha_prev[1];
  c33_i_x = c33_h_x;
  c33_j_x = c33_i_x;
  c33_i_x = c33_j_x;
  c33_i_x = muDoubleScalarCos(c33_i_x);
  c33_d_a = -c33_i_x;
  c33_d_b = c33_ly[1];
  c33_d_y = c33_d_a * c33_d_b;
  c33_k_x = c33_alpha_prev[0];
  c33_e_a = c33_k_x;
  c33_l_x = c33_e_a;
  c33_e_a = c33_l_x;
  c33_e_a = muDoubleScalarSin(c33_e_a);
  c33_e_b = c33_lx[0];
  c33_e_y = c33_e_a * c33_e_b;
  c33_m_x = c33_alpha_prev[0];
  c33_n_x = c33_m_x;
  c33_o_x = c33_n_x;
  c33_n_x = c33_o_x;
  c33_n_x = muDoubleScalarCos(c33_n_x);
  c33_f_a = -c33_n_x;
  c33_f_b = c33_ly[0];
  c33_f_y = c33_f_a * c33_f_b;
  c33_p_x = c33_alpha_prev[2];
  c33_q_x = c33_p_x;
  c33_r_x = c33_q_x;
  c33_q_x = c33_r_x;
  c33_q_x = muDoubleScalarSin(c33_q_x);
  c33_s_x = c33_alpha_prev[1];
  c33_t_x = c33_s_x;
  c33_u_x = c33_t_x;
  c33_t_x = c33_u_x;
  c33_t_x = muDoubleScalarSin(c33_t_x);
  c33_v_x = c33_alpha_prev[0];
  c33_w_x = c33_v_x;
  c33_x_x = c33_w_x;
  c33_w_x = c33_x_x;
  c33_w_x = muDoubleScalarSin(c33_w_x);
  c33_y_x = c33_alpha_prev[2];
  c33_ab_x = c33_y_x;
  c33_bb_x = c33_ab_x;
  c33_ab_x = c33_bb_x;
  c33_ab_x = muDoubleScalarCos(c33_ab_x);
  c33_cb_x = c33_alpha_prev[1];
  c33_db_x = c33_cb_x;
  c33_eb_x = c33_db_x;
  c33_db_x = c33_eb_x;
  c33_db_x = muDoubleScalarCos(c33_db_x);
  c33_fb_x = c33_alpha_prev[0];
  c33_gb_x = c33_fb_x;
  c33_hb_x = c33_gb_x;
  c33_gb_x = c33_hb_x;
  c33_gb_x = muDoubleScalarCos(c33_gb_x);
  c33_B_alphaPrev[0] = c33_gb_x;
  c33_B_alphaPrev[3] = c33_db_x;
  c33_B_alphaPrev[6] = c33_ab_x;
  c33_B_alphaPrev[1] = c33_w_x;
  c33_B_alphaPrev[4] = c33_t_x;
  c33_B_alphaPrev[7] = c33_q_x;
  c33_B_alphaPrev[2] = c33_f_y + c33_e_y;
  c33_B_alphaPrev[5] = c33_d_y + c33_c_y;
  c33_B_alphaPrev[8] = c33_b_y + c33_y;
  _SFD_EML_CALL(0,-6);
  sf_debug_symbol_scope_pop();
  for (c33_i9 = 0; c33_i9 < 9; c33_i9 = c33_i9 + 1) {
    (*c33_b_B_alphaPrev)[c33_i9] = c33_B_alphaPrev[c33_i9];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,32);
  _sfEvent_ = c33_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c33_machineNumber, uint32_T
  c33_chartNumber)
{
}

static const mxArray *c33_sf_marshall(void *c33_chartInstance, void *c33_u)
{
  const mxArray *c33_y = NULL;
  int32_T c33_i10;
  real_T c33_b_u[3];
  const mxArray *c33_b_y = NULL;
  c33_y = NULL;
  for (c33_i10 = 0; c33_i10 < 3; c33_i10 = c33_i10 + 1) {
    c33_b_u[c33_i10] = (*((real_T (*)[3])c33_u))[c33_i10];
  }

  c33_b_y = NULL;
  sf_mex_assign(&c33_b_y, sf_mex_create("y", &c33_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c33_y, c33_b_y);
  return c33_y;
}

static const mxArray *c33_b_sf_marshall(void *c33_chartInstance, void *c33_u)
{
  const mxArray *c33_y = NULL;
  int32_T c33_i11;
  int32_T c33_i12;
  int32_T c33_i13;
  real_T c33_b_u[9];
  const mxArray *c33_b_y = NULL;
  c33_y = NULL;
  c33_i11 = 0;
  for (c33_i12 = 0; c33_i12 < 3; c33_i12 = c33_i12 + 1) {
    for (c33_i13 = 0; c33_i13 < 3; c33_i13 = c33_i13 + 1) {
      c33_b_u[c33_i13 + c33_i11] = (*((real_T (*)[9])c33_u))[c33_i13 + c33_i11];
    }

    c33_i11 = c33_i11 + 3;
  }

  c33_b_y = NULL;
  sf_mex_assign(&c33_b_y, sf_mex_create("y", &c33_b_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_assign(&c33_y, c33_b_y);
  return c33_y;
}

static const mxArray *c33_c_sf_marshall(void *c33_chartInstance, void *c33_u)
{
  const mxArray *c33_y = NULL;
  real_T c33_b_u;
  const mxArray *c33_b_y = NULL;
  c33_y = NULL;
  c33_b_u = *((real_T *)c33_u);
  c33_b_y = NULL;
  sf_mex_assign(&c33_b_y, sf_mex_create("y", &c33_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c33_y, c33_b_y);
  return c33_y;
}

const mxArray *sf_c33_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c33_nameCaptureInfo = NULL;
  c33_ResolvedFunctionInfo c33_info[18];
  const mxArray *c33_m0 = NULL;
  int32_T c33_i14;
  c33_ResolvedFunctionInfo *c33_r0;
  c33_nameCaptureInfo = NULL;
  c33_info_helper(c33_info);
  sf_mex_assign(&c33_m0, sf_mex_createstruct("nameCaptureInfo", 1, 18));
  for (c33_i14 = 0; c33_i14 < 18; c33_i14 = c33_i14 + 1) {
    c33_r0 = &c33_info[c33_i14];
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", c33_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c33_r0->context)), "context"
                    , "nameCaptureInfo", c33_i14);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", c33_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c33_r0->name)), "name",
                    "nameCaptureInfo", c33_i14);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo",
      c33_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c33_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c33_i14);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", c33_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c33_r0->resolved)),
                    "resolved", "nameCaptureInfo", c33_i14);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", &c33_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c33_i14);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", &c33_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c33_i14);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", &c33_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c33_i14);
  }

  sf_mex_assign(&c33_nameCaptureInfo, c33_m0);
  return c33_nameCaptureInfo;
}

static void c33_info_helper(c33_ResolvedFunctionInfo c33_info[18])
{
  c33_info[0].context = "";
  c33_info[0].name = "cos";
  c33_info[0].dominantType = "double";
  c33_info[0].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c33_info[0].fileLength = 324U;
  c33_info[0].fileTime1 = 1203447952U;
  c33_info[0].fileTime2 = 0U;
  c33_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c33_info[1].name = "nargin";
  c33_info[1].dominantType = "";
  c33_info[1].resolved = "[B]nargin";
  c33_info[1].fileLength = 0U;
  c33_info[1].fileTime1 = 0U;
  c33_info[1].fileTime2 = 0U;
  c33_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c33_info[2].name = "gt";
  c33_info[2].dominantType = "double";
  c33_info[2].resolved = "[B]gt";
  c33_info[2].fileLength = 0U;
  c33_info[2].fileTime1 = 0U;
  c33_info[2].fileTime2 = 0U;
  c33_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c33_info[3].name = "isa";
  c33_info[3].dominantType = "double";
  c33_info[3].resolved = "[B]isa";
  c33_info[3].fileLength = 0U;
  c33_info[3].fileTime1 = 0U;
  c33_info[3].fileTime2 = 0U;
  c33_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c33_info[4].name = "eml_scalar_cos";
  c33_info[4].dominantType = "double";
  c33_info[4].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c33_info[4].fileLength = 602U;
  c33_info[4].fileTime1 = 1209330788U;
  c33_info[4].fileTime2 = 0U;
  c33_info[5].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c33_info[5].name = "isreal";
  c33_info[5].dominantType = "double";
  c33_info[5].resolved = "[B]isreal";
  c33_info[5].fileLength = 0U;
  c33_info[5].fileTime1 = 0U;
  c33_info[5].fileTime2 = 0U;
  c33_info[6].context = "";
  c33_info[6].name = "sin";
  c33_info[6].dominantType = "double";
  c33_info[6].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c33_info[6].fileLength = 324U;
  c33_info[6].fileTime1 = 1203448042U;
  c33_info[6].fileTime2 = 0U;
  c33_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c33_info[7].name = "eml_scalar_sin";
  c33_info[7].dominantType = "double";
  c33_info[7].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c33_info[7].fileLength = 601U;
  c33_info[7].fileTime1 = 1209330792U;
  c33_info[7].fileTime2 = 0U;
  c33_info[8].context = "";
  c33_info[8].name = "uminus";
  c33_info[8].dominantType = "double";
  c33_info[8].resolved = "[B]uminus";
  c33_info[8].fileLength = 0U;
  c33_info[8].fileTime1 = 0U;
  c33_info[8].fileTime2 = 0U;
  c33_info[9].context = "";
  c33_info[9].name = "mtimes";
  c33_info[9].dominantType = "double";
  c33_info[9].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c33_info[9].fileLength = 2408U;
  c33_info[9].fileTime1 = 1227613402U;
  c33_info[9].fileTime2 = 0U;
  c33_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c33_info[10].name = "isinteger";
  c33_info[10].dominantType = "double";
  c33_info[10].resolved = "[B]isinteger";
  c33_info[10].fileLength = 0U;
  c33_info[10].fileTime1 = 0U;
  c33_info[10].fileTime2 = 0U;
  c33_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c33_info[11].name = "isscalar";
  c33_info[11].dominantType = "double";
  c33_info[11].resolved = "[B]isscalar";
  c33_info[11].fileLength = 0U;
  c33_info[11].fileTime1 = 0U;
  c33_info[11].fileTime2 = 0U;
  c33_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c33_info[12].name = "strcmp";
  c33_info[12].dominantType = "char";
  c33_info[12].resolved = "[B]strcmp";
  c33_info[12].fileLength = 0U;
  c33_info[12].fileTime1 = 0U;
  c33_info[12].fileTime2 = 0U;
  c33_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c33_info[13].name = "size";
  c33_info[13].dominantType = "double";
  c33_info[13].resolved = "[B]size";
  c33_info[13].fileLength = 0U;
  c33_info[13].fileTime1 = 0U;
  c33_info[13].fileTime2 = 0U;
  c33_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c33_info[14].name = "eq";
  c33_info[14].dominantType = "double";
  c33_info[14].resolved = "[B]eq";
  c33_info[14].fileLength = 0U;
  c33_info[14].fileTime1 = 0U;
  c33_info[14].fileTime2 = 0U;
  c33_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c33_info[15].name = "class";
  c33_info[15].dominantType = "double";
  c33_info[15].resolved = "[B]class";
  c33_info[15].fileLength = 0U;
  c33_info[15].fileTime1 = 0U;
  c33_info[15].fileTime2 = 0U;
  c33_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c33_info[16].name = "not";
  c33_info[16].dominantType = "logical";
  c33_info[16].resolved = "[B]not";
  c33_info[16].fileLength = 0U;
  c33_info[16].fileTime1 = 0U;
  c33_info[16].fileTime2 = 0U;
  c33_info[17].context = "";
  c33_info[17].name = "plus";
  c33_info[17].dominantType = "double";
  c33_info[17].resolved = "[B]plus";
  c33_info[17].fileLength = 0U;
  c33_info[17].fileTime1 = 0U;
  c33_info[17].fileTime2 = 0U;
}

static const mxArray *c33_emlrt_marshallOut(uint8_T c33_u)
{
  const mxArray *c33_y = NULL;
  c33_y = NULL;
  sf_mex_assign(&c33_y, sf_mex_create("y", &c33_u, 3, 0U, 0U, 0U, 0));
  return c33_y;
}

static void c33_emlrt_marshallIn(const mxArray *c33_B_alphaPrev, char *c33_name,
  real_T c33_y[9])
{
  real_T c33_dv1[9];
  int32_T c33_i15;
  sf_mex_import(c33_name, sf_mex_dup(c33_B_alphaPrev), &c33_dv1, 1, 0, 0U, 1, 0U,
                2, 3, 3);
  for (c33_i15 = 0; c33_i15 < 9; c33_i15 = c33_i15 + 1) {
    c33_y[c33_i15] = c33_dv1[c33_i15];
  }

  sf_mex_destroy(&c33_B_alphaPrev);
}

static uint8_T c33_b_emlrt_marshallIn(const mxArray *c33_b_is_active_c33_MCSim,
  char *c33_name)
{
  uint8_T c33_y;
  uint8_T c33_u0;
  sf_mex_import(c33_name, sf_mex_dup(c33_b_is_active_c33_MCSim), &c33_u0, 1, 3,
                0U, 0, 0U, 0);
  c33_y = c33_u0;
  sf_mex_destroy(&c33_b_is_active_c33_MCSim);
  return c33_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c33_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(272990720U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1301662088U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4231250491U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2825884721U);
}

mxArray *sf_c33_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2081849140U);
    pr[1] = (double)(2736806433U);
    pr[2] = (double)(2789260076U);
    pr[3] = (double)(2247808238U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c33_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"B_alphaPrev\",},{M[8],M[0],T\"is_active_c33_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c33_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          33,
          1,
          1,
          4,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(0,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"B_alphaPrev",0,c33_b_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"alpha_prev",0,c33_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"ly",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"lx",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,654);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c33_B_alphaPrev)[9];
          real_T (*c33_alpha_prev)[3];
          real_T (*c33_ly)[3];
          real_T (*c33_lx)[3];
          c33_alpha_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S,
            0);
          c33_B_alphaPrev = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S,
            1);
          c33_ly = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
          c33_lx = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
          _SFD_SET_DATA_VALUE_PTR(0U, c33_B_alphaPrev);
          _SFD_SET_DATA_VALUE_PTR(1U, c33_alpha_prev);
          _SFD_SET_DATA_VALUE_PTR(2U, c33_ly);
          _SFD_SET_DATA_VALUE_PTR(3U, c33_lx);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c33_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c33_MCSim();
  initialize_c33_MCSim();
}

static void sf_opaque_enable_c33_MCSim(void *chartInstanceVar)
{
  enable_c33_MCSim();
}

static void sf_opaque_disable_c33_MCSim(void *chartInstanceVar)
{
  disable_c33_MCSim();
}

static void sf_opaque_gateway_c33_MCSim(void *chartInstanceVar)
{
  sf_c33_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c33_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c33_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c33_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c33_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c33_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c33_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c33_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c33_MCSim();
  }
}

static void mdlSetWorkWidths_c33_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",33);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",33,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",33,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",33,3);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",33,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",33);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(4037392952U));
  ssSetChecksum1(S,(2637713160U));
  ssSetChecksum2(S,(313856505U));
  ssSetChecksum3(S,(2564037237U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c33_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",33);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c33_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c33_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c33_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c33_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c33_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c33_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c33_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c33_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c33_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c33_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c33_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c33_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c33_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c33_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c33_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c33_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c33_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
