/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c39_MCSim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c39_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc39_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c39_MCSim(void);
static void initialize_params_c39_MCSim(void);
static void enable_c39_MCSim(void);
static void disable_c39_MCSim(void);
static void c39_update_debugger_state_c39_MCSim(void);
static const mxArray *get_sim_state_c39_MCSim(void);
static void set_sim_state_c39_MCSim(const mxArray *c39_st);
static void finalize_c39_MCSim(void);
static void sf_c39_MCSim(void);
static void init_script_number_translation(uint32_T c39_machineNumber, uint32_T
  c39_chartNumber);
static void c39_eml_warning(void);
static const mxArray *c39_sf_marshall(void *c39_chartInstance, void *c39_u);
static const mxArray *c39_b_sf_marshall(void *c39_chartInstance, void *c39_u);
static const mxArray *c39_c_sf_marshall(void *c39_chartInstance, void *c39_u);
static const mxArray *c39_d_sf_marshall(void *c39_chartInstance, void *c39_u);
static void c39_info_helper(c39_ResolvedFunctionInfo c39_info[23]);
static const mxArray *c39_emlrt_marshallOut(uint8_T c39_u);
static void c39_emlrt_marshallIn(const mxArray *c39_H, char *c39_name, real_T
  c39_y[81]);
static uint8_T c39_b_emlrt_marshallIn(const mxArray *c39_b_is_active_c39_MCSim,
  char *c39_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c39_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c39_is_active_c39_MCSim = 0U;
}

static void initialize_params_c39_MCSim(void)
{
}

static void enable_c39_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c39_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c39_update_debugger_state_c39_MCSim(void)
{
}

static const mxArray *get_sim_state_c39_MCSim(void)
{
  const mxArray *c39_st = NULL;
  const mxArray *c39_y = NULL;
  int32_T c39_i0;
  real_T c39_u[81];
  const mxArray *c39_b_y = NULL;
  real_T (*c39_H)[81];
  c39_H = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
  c39_st = NULL;
  c39_y = NULL;
  sf_mex_assign(&c39_y, sf_mex_createcellarray(2));
  for (c39_i0 = 0; c39_i0 < 81; c39_i0 = c39_i0 + 1) {
    c39_u[c39_i0] = (*c39_H)[c39_i0];
  }

  c39_b_y = NULL;
  sf_mex_assign(&c39_b_y, sf_mex_create("y", &c39_u, 0, 0U, 1U, 0U, 2, 9, 9));
  sf_mex_setcell(c39_y, 0, c39_b_y);
  sf_mex_setcell(c39_y, 1, c39_emlrt_marshallOut
                 (chartInstance.c39_is_active_c39_MCSim));
  sf_mex_assign(&c39_st, c39_y);
  return c39_st;
}

static void set_sim_state_c39_MCSim(const mxArray *c39_st)
{
  const mxArray *c39_u;
  real_T c39_dv0[81];
  int32_T c39_i1;
  real_T (*c39_H)[81];
  c39_H = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c39_doneDoubleBufferReInit = true;
  c39_u = sf_mex_dup(c39_st);
  c39_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c39_u, 0)), "H", c39_dv0);
  for (c39_i1 = 0; c39_i1 < 81; c39_i1 = c39_i1 + 1) {
    (*c39_H)[c39_i1] = c39_dv0[c39_i1];
  }

  chartInstance.c39_is_active_c39_MCSim = c39_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c39_u, 1)), "is_active_c39_MCSim");
  sf_mex_destroy(&c39_u);
  c39_update_debugger_state_c39_MCSim();
  sf_mex_destroy(&c39_st);
}

static void finalize_c39_MCSim(void)
{
}

static void sf_c39_MCSim(void)
{
  int32_T c39_i2;
  int32_T c39_i3;
  int32_T c39_i4;
  int32_T c39_i5;
  int32_T c39_i6;
  uint8_T c39_previousEvent;
  int32_T c39_i7;
  real_T c39_W_u[9];
  int32_T c39_i8;
  real_T c39_Omega[9];
  int32_T c39_i9;
  real_T c39_Q[9];
  int32_T c39_i10;
  real_T c39_T_d_prev[3];
  real_T c39_nargout = 1.0;
  real_T c39_nargin = 4.0;
  real_T c39_i;
  real_T c39_W[9];
  real_T c39_H[81];
  int32_T c39_i11;
  real_T c39_b_i;
  real_T c39_A;
  real_T c39_x;
  real_T c39_b_x;
  real_T c39_y;
  real_T c39_B;
  real_T c39_c_x;
  real_T c39_b_y;
  real_T c39_d_x;
  real_T c39_c_y;
  real_T c39_e_x;
  real_T c39_d_y;
  real_T c39_e_y;
  int32_T c39_i12;
  int32_T c39_i13;
  int32_T c39_i14;
  int32_T c39_i15;
  int32_T c39_i16;
  int32_T c39_i17;
  int32_T c39_i18;
  int32_T c39_i19;
  int32_T c39_i20;
  int32_T c39_i21;
  int32_T c39_i22;
  int32_T c39_i23;
  int32_T c39_i24;
  int32_T c39_i25;
  int32_T c39_i26;
  int32_T c39_i27;
  int32_T c39_i28;
  int32_T c39_i29;
  int32_T c39_i30;
  int32_T c39_i31;
  int32_T c39_i32;
  int32_T c39_i33;
  int32_T c39_i34;
  int32_T c39_i35;
  int32_T c39_i36;
  int32_T c39_i37;
  int32_T c39_i38;
  int32_T c39_i39;
  int32_T c39_i40;
  int32_T c39_i41;
  int32_T c39_i42;
  real_T (*c39_b_H)[81];
  real_T (*c39_b_T_d_prev)[3];
  real_T (*c39_b_Q)[9];
  real_T (*c39_b_Omega)[9];
  real_T (*c39_b_W_u)[9];
  c39_b_T_d_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
  c39_b_H = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
  c39_b_Omega = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 1);
  c39_b_Q = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 2);
  c39_b_W_u = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,38);
  for (c39_i2 = 0; c39_i2 < 9; c39_i2 = c39_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c39_b_W_u)[c39_i2], 0U);
  }

  for (c39_i3 = 0; c39_i3 < 81; c39_i3 = c39_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c39_b_H)[c39_i3], 1U);
  }

  for (c39_i4 = 0; c39_i4 < 9; c39_i4 = c39_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c39_b_Omega)[c39_i4], 2U);
  }

  for (c39_i5 = 0; c39_i5 < 9; c39_i5 = c39_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c39_b_Q)[c39_i5], 3U);
  }

  for (c39_i6 = 0; c39_i6 < 3; c39_i6 = c39_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c39_b_T_d_prev)[c39_i6], 4U);
  }

  c39_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,38);
  for (c39_i7 = 0; c39_i7 < 9; c39_i7 = c39_i7 + 1) {
    c39_W_u[c39_i7] = (*c39_b_W_u)[c39_i7];
  }

  for (c39_i8 = 0; c39_i8 < 9; c39_i8 = c39_i8 + 1) {
    c39_Omega[c39_i8] = (*c39_b_Omega)[c39_i8];
  }

  for (c39_i9 = 0; c39_i9 < 9; c39_i9 = c39_i9 + 1) {
    c39_Q[c39_i9] = (*c39_b_Q)[c39_i9];
  }

  for (c39_i10 = 0; c39_i10 < 3; c39_i10 = c39_i10 + 1) {
    c39_T_d_prev[c39_i10] = (*c39_b_T_d_prev)[c39_i10];
  }

  sf_debug_symbol_scope_push(9U, 0U);
  sf_debug_symbol_scope_add("nargout", &c39_nargout, c39_d_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c39_nargin, c39_d_sf_marshall);
  sf_debug_symbol_scope_add("i", &c39_i, c39_d_sf_marshall);
  sf_debug_symbol_scope_add("W", &c39_W, c39_sf_marshall);
  sf_debug_symbol_scope_add("H", &c39_H, c39_c_sf_marshall);
  sf_debug_symbol_scope_add("T_d_prev", &c39_T_d_prev, c39_b_sf_marshall);
  sf_debug_symbol_scope_add("Q", &c39_Q, c39_sf_marshall);
  sf_debug_symbol_scope_add("Omega", &c39_Omega, c39_sf_marshall);
  sf_debug_symbol_scope_add("W_u", &c39_W_u, c39_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  for (c39_i11 = 0; c39_i11 < 9; c39_i11 = c39_i11 + 1) {
    c39_W[c39_i11] = 0.0;
  }

  c39_i = 1.0;
  c39_b_i = 1.0;
  while (c39_b_i <= 3.0) {
    c39_i = c39_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,5);
    c39_A = c39_W_u[(_SFD_EML_ARRAY_BOUNDS_CHECK("W_u", (int32_T)
      _SFD_INTEGER_CHECK("i", c39_i), 1, 3, 1, 0) - 1) + 3 * (
      _SFD_EML_ARRAY_BOUNDS_CHECK("W_u", (int32_T)_SFD_INTEGER_CHECK("i", c39_i),
      1, 3, 2, 0) - 1)];
    c39_x = c39_T_d_prev[_SFD_EML_ARRAY_BOUNDS_CHECK("T_d_prev", (int32_T)
      _SFD_INTEGER_CHECK("i", c39_i), 1, 3, 1, 0) - 1];
    c39_b_x = c39_x;
    c39_y = muDoubleScalarAbs(c39_b_x);
    c39_B = c39_y + 1.0E-006;
    c39_c_x = c39_A;
    c39_b_y = c39_B;
    if (c39_b_y == 0.0) {
      c39_eml_warning();
    }

    c39_d_x = c39_c_x;
    c39_c_y = c39_b_y;
    c39_e_x = c39_d_x;
    c39_d_y = c39_c_y;
    c39_e_y = c39_e_x / c39_d_y;
    c39_W[(_SFD_EML_ARRAY_BOUNDS_CHECK("W", (int32_T)_SFD_INTEGER_CHECK("i",
             c39_i), 1, 3, 1, 0) - 1) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK
      ("W", (int32_T)_SFD_INTEGER_CHECK("i", c39_i), 1, 3, 2, 0) - 1)] = c39_e_y;
    c39_b_i = c39_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,8);
  c39_i12 = 0;
  c39_i13 = 0;
  for (c39_i14 = 0; c39_i14 < 3; c39_i14 = c39_i14 + 1) {
    for (c39_i15 = 0; c39_i15 < 3; c39_i15 = c39_i15 + 1) {
      c39_H[c39_i15 + c39_i12] = c39_W[c39_i15 + c39_i13];
    }

    c39_i12 = c39_i12 + 9;
    c39_i13 = c39_i13 + 3;
  }

  c39_i16 = 0;
  for (c39_i17 = 0; c39_i17 < 3; c39_i17 = c39_i17 + 1) {
    for (c39_i18 = 0; c39_i18 < 3; c39_i18 = c39_i18 + 1) {
      c39_H[(c39_i18 + c39_i16) + 27] = 0.0;
    }

    c39_i16 = c39_i16 + 9;
  }

  c39_i19 = 0;
  for (c39_i20 = 0; c39_i20 < 3; c39_i20 = c39_i20 + 1) {
    for (c39_i21 = 0; c39_i21 < 3; c39_i21 = c39_i21 + 1) {
      c39_H[(c39_i21 + c39_i19) + 54] = 0.0;
    }

    c39_i19 = c39_i19 + 9;
  }

  c39_i22 = 0;
  for (c39_i23 = 0; c39_i23 < 3; c39_i23 = c39_i23 + 1) {
    for (c39_i24 = 0; c39_i24 < 3; c39_i24 = c39_i24 + 1) {
      c39_H[(c39_i24 + c39_i22) + 3] = 0.0;
    }

    c39_i22 = c39_i22 + 9;
  }

  c39_i25 = 0;
  c39_i26 = 0;
  for (c39_i27 = 0; c39_i27 < 3; c39_i27 = c39_i27 + 1) {
    for (c39_i28 = 0; c39_i28 < 3; c39_i28 = c39_i28 + 1) {
      c39_H[(c39_i28 + c39_i25) + 30] = c39_Omega[c39_i28 + c39_i26];
    }

    c39_i25 = c39_i25 + 9;
    c39_i26 = c39_i26 + 3;
  }

  c39_i29 = 0;
  for (c39_i30 = 0; c39_i30 < 3; c39_i30 = c39_i30 + 1) {
    for (c39_i31 = 0; c39_i31 < 3; c39_i31 = c39_i31 + 1) {
      c39_H[(c39_i31 + c39_i29) + 57] = 0.0;
    }

    c39_i29 = c39_i29 + 9;
  }

  c39_i32 = 0;
  for (c39_i33 = 0; c39_i33 < 3; c39_i33 = c39_i33 + 1) {
    for (c39_i34 = 0; c39_i34 < 3; c39_i34 = c39_i34 + 1) {
      c39_H[(c39_i34 + c39_i32) + 6] = 0.0;
    }

    c39_i32 = c39_i32 + 9;
  }

  c39_i35 = 0;
  for (c39_i36 = 0; c39_i36 < 3; c39_i36 = c39_i36 + 1) {
    for (c39_i37 = 0; c39_i37 < 3; c39_i37 = c39_i37 + 1) {
      c39_H[(c39_i37 + c39_i35) + 33] = 0.0;
    }

    c39_i35 = c39_i35 + 9;
  }

  c39_i38 = 0;
  c39_i39 = 0;
  for (c39_i40 = 0; c39_i40 < 3; c39_i40 = c39_i40 + 1) {
    for (c39_i41 = 0; c39_i41 < 3; c39_i41 = c39_i41 + 1) {
      c39_H[(c39_i41 + c39_i38) + 60] = c39_Q[c39_i41 + c39_i39];
    }

    c39_i38 = c39_i38 + 9;
    c39_i39 = c39_i39 + 3;
  }

  _SFD_EML_CALL(0,-8);
  sf_debug_symbol_scope_pop();
  for (c39_i42 = 0; c39_i42 < 81; c39_i42 = c39_i42 + 1) {
    (*c39_b_H)[c39_i42] = c39_H[c39_i42];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,38);
  _sfEvent_ = c39_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c39_machineNumber, uint32_T
  c39_chartNumber)
{
}

static void c39_eml_warning(void)
{
  int32_T c39_i43;
  static char_T c39_cv0[15] = { 'D', 'i', 'v', 'i', 'd', 'e', ' ', 'b', 'y', ' ',
    'z', 'e', 'r', 'o', '.' };

  char_T c39_u[15];
  const mxArray *c39_y = NULL;
  int32_T c39_i44;
  static char_T c39_cv1[19] = { 'M', 'A', 'T', 'L', 'A', 'B', ':', 'd', 'i', 'v',
    'i', 'd', 'e', 'B', 'y', 'Z', 'e', 'r', 'o' };

  char_T c39_b_u[19];
  const mxArray *c39_b_y = NULL;
  for (c39_i43 = 0; c39_i43 < 15; c39_i43 = c39_i43 + 1) {
    c39_u[c39_i43] = c39_cv0[c39_i43];
  }

  c39_y = NULL;
  sf_mex_assign(&c39_y, sf_mex_create("y", &c39_u, 10, 0U, 1U, 0U, 2, 1, 15));
  for (c39_i44 = 0; c39_i44 < 19; c39_i44 = c39_i44 + 1) {
    c39_b_u[c39_i44] = c39_cv1[c39_i44];
  }

  c39_b_y = NULL;
  sf_mex_assign(&c39_b_y, sf_mex_create("y", &c39_b_u, 10, 0U, 1U, 0U, 2, 1, 19));
  sf_mex_call_debug("warning", 0U, 2U, 14, c39_b_y, 14, c39_y);
}

static const mxArray *c39_sf_marshall(void *c39_chartInstance, void *c39_u)
{
  const mxArray *c39_y = NULL;
  int32_T c39_i45;
  int32_T c39_i46;
  int32_T c39_i47;
  real_T c39_b_u[9];
  const mxArray *c39_b_y = NULL;
  c39_y = NULL;
  c39_i45 = 0;
  for (c39_i46 = 0; c39_i46 < 3; c39_i46 = c39_i46 + 1) {
    for (c39_i47 = 0; c39_i47 < 3; c39_i47 = c39_i47 + 1) {
      c39_b_u[c39_i47 + c39_i45] = (*((real_T (*)[9])c39_u))[c39_i47 + c39_i45];
    }

    c39_i45 = c39_i45 + 3;
  }

  c39_b_y = NULL;
  sf_mex_assign(&c39_b_y, sf_mex_create("y", &c39_b_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_assign(&c39_y, c39_b_y);
  return c39_y;
}

static const mxArray *c39_b_sf_marshall(void *c39_chartInstance, void *c39_u)
{
  const mxArray *c39_y = NULL;
  int32_T c39_i48;
  real_T c39_b_u[3];
  const mxArray *c39_b_y = NULL;
  c39_y = NULL;
  for (c39_i48 = 0; c39_i48 < 3; c39_i48 = c39_i48 + 1) {
    c39_b_u[c39_i48] = (*((real_T (*)[3])c39_u))[c39_i48];
  }

  c39_b_y = NULL;
  sf_mex_assign(&c39_b_y, sf_mex_create("y", &c39_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c39_y, c39_b_y);
  return c39_y;
}

static const mxArray *c39_c_sf_marshall(void *c39_chartInstance, void *c39_u)
{
  const mxArray *c39_y = NULL;
  int32_T c39_i49;
  int32_T c39_i50;
  int32_T c39_i51;
  real_T c39_b_u[81];
  const mxArray *c39_b_y = NULL;
  c39_y = NULL;
  c39_i49 = 0;
  for (c39_i50 = 0; c39_i50 < 9; c39_i50 = c39_i50 + 1) {
    for (c39_i51 = 0; c39_i51 < 9; c39_i51 = c39_i51 + 1) {
      c39_b_u[c39_i51 + c39_i49] = (*((real_T (*)[81])c39_u))[c39_i51 + c39_i49];
    }

    c39_i49 = c39_i49 + 9;
  }

  c39_b_y = NULL;
  sf_mex_assign(&c39_b_y, sf_mex_create("y", &c39_b_u, 0, 0U, 1U, 0U, 2, 9, 9));
  sf_mex_assign(&c39_y, c39_b_y);
  return c39_y;
}

static const mxArray *c39_d_sf_marshall(void *c39_chartInstance, void *c39_u)
{
  const mxArray *c39_y = NULL;
  real_T c39_b_u;
  const mxArray *c39_b_y = NULL;
  c39_y = NULL;
  c39_b_u = *((real_T *)c39_u);
  c39_b_y = NULL;
  sf_mex_assign(&c39_b_y, sf_mex_create("y", &c39_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c39_y, c39_b_y);
  return c39_y;
}

const mxArray *sf_c39_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c39_nameCaptureInfo = NULL;
  c39_ResolvedFunctionInfo c39_info[23];
  const mxArray *c39_m0 = NULL;
  int32_T c39_i52;
  c39_ResolvedFunctionInfo *c39_r0;
  c39_nameCaptureInfo = NULL;
  c39_info_helper(c39_info);
  sf_mex_assign(&c39_m0, sf_mex_createstruct("nameCaptureInfo", 1, 23));
  for (c39_i52 = 0; c39_i52 < 23; c39_i52 = c39_i52 + 1) {
    c39_r0 = &c39_info[c39_i52];
    sf_mex_addfield(c39_m0, sf_mex_create("nameCaptureInfo", c39_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c39_r0->context)), "context"
                    , "nameCaptureInfo", c39_i52);
    sf_mex_addfield(c39_m0, sf_mex_create("nameCaptureInfo", c39_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c39_r0->name)), "name",
                    "nameCaptureInfo", c39_i52);
    sf_mex_addfield(c39_m0, sf_mex_create("nameCaptureInfo",
      c39_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c39_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c39_i52);
    sf_mex_addfield(c39_m0, sf_mex_create("nameCaptureInfo", c39_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c39_r0->resolved)),
                    "resolved", "nameCaptureInfo", c39_i52);
    sf_mex_addfield(c39_m0, sf_mex_create("nameCaptureInfo", &c39_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c39_i52);
    sf_mex_addfield(c39_m0, sf_mex_create("nameCaptureInfo", &c39_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c39_i52);
    sf_mex_addfield(c39_m0, sf_mex_create("nameCaptureInfo", &c39_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c39_i52);
  }

  sf_mex_assign(&c39_nameCaptureInfo, c39_m0);
  return c39_nameCaptureInfo;
}

static void c39_info_helper(c39_ResolvedFunctionInfo c39_info[23])
{
  c39_info[0].context = "";
  c39_info[0].name = "zeros";
  c39_info[0].dominantType = "double";
  c39_info[0].resolved = "[B]zeros";
  c39_info[0].fileLength = 0U;
  c39_info[0].fileTime1 = 0U;
  c39_info[0].fileTime2 = 0U;
  c39_info[1].context = "";
  c39_info[1].name = "abs";
  c39_info[1].dominantType = "double";
  c39_info[1].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c39_info[1].fileLength = 566U;
  c39_info[1].fileTime1 = 1221267134U;
  c39_info[1].fileTime2 = 0U;
  c39_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c39_info[2].name = "nargin";
  c39_info[2].dominantType = "";
  c39_info[2].resolved = "[B]nargin";
  c39_info[2].fileLength = 0U;
  c39_info[2].fileTime1 = 0U;
  c39_info[2].fileTime2 = 0U;
  c39_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c39_info[3].name = "gt";
  c39_info[3].dominantType = "double";
  c39_info[3].resolved = "[B]gt";
  c39_info[3].fileLength = 0U;
  c39_info[3].fileTime1 = 0U;
  c39_info[3].fileTime2 = 0U;
  c39_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c39_info[4].name = "isa";
  c39_info[4].dominantType = "double";
  c39_info[4].resolved = "[B]isa";
  c39_info[4].fileLength = 0U;
  c39_info[4].fileTime1 = 0U;
  c39_info[4].fileTime2 = 0U;
  c39_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c39_info[5].name = "ischar";
  c39_info[5].dominantType = "double";
  c39_info[5].resolved = "[B]ischar";
  c39_info[5].fileLength = 0U;
  c39_info[5].fileTime1 = 0U;
  c39_info[5].fileTime2 = 0U;
  c39_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c39_info[6].name = "islogical";
  c39_info[6].dominantType = "double";
  c39_info[6].resolved = "[B]islogical";
  c39_info[6].fileLength = 0U;
  c39_info[6].fileTime1 = 0U;
  c39_info[6].fileTime2 = 0U;
  c39_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c39_info[7].name = "size";
  c39_info[7].dominantType = "double";
  c39_info[7].resolved = "[B]size";
  c39_info[7].fileLength = 0U;
  c39_info[7].fileTime1 = 0U;
  c39_info[7].fileTime2 = 0U;
  c39_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c39_info[8].name = "class";
  c39_info[8].dominantType = "double";
  c39_info[8].resolved = "[B]class";
  c39_info[8].fileLength = 0U;
  c39_info[8].fileTime1 = 0U;
  c39_info[8].fileTime2 = 0U;
  c39_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c39_info[9].name = "eml_scalar_abs";
  c39_info[9].dominantType = "double";
  c39_info[9].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c39_info[9].fileLength = 461U;
  c39_info[9].fileTime1 = 1203447960U;
  c39_info[9].fileTime2 = 0U;
  c39_info[10].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c39_info[10].name = "isinteger";
  c39_info[10].dominantType = "double";
  c39_info[10].resolved = "[B]isinteger";
  c39_info[10].fileLength = 0U;
  c39_info[10].fileTime1 = 0U;
  c39_info[10].fileTime2 = 0U;
  c39_info[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c39_info[11].name = "isreal";
  c39_info[11].dominantType = "double";
  c39_info[11].resolved = "[B]isreal";
  c39_info[11].fileLength = 0U;
  c39_info[11].fileTime1 = 0U;
  c39_info[11].fileTime2 = 0U;
  c39_info[12].context = "";
  c39_info[12].name = "plus";
  c39_info[12].dominantType = "double";
  c39_info[12].resolved = "[B]plus";
  c39_info[12].fileLength = 0U;
  c39_info[12].fileTime1 = 0U;
  c39_info[12].fileTime2 = 0U;
  c39_info[13].context = "";
  c39_info[13].name = "mrdivide";
  c39_info[13].dominantType = "double";
  c39_info[13].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c39_info[13].fileLength = 771U;
  c39_info[13].fileTime1 = 1219752936U;
  c39_info[13].fileTime2 = 0U;
  c39_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c39_info[14].name = "ge";
  c39_info[14].dominantType = "double";
  c39_info[14].resolved = "[B]ge";
  c39_info[14].fileLength = 0U;
  c39_info[14].fileTime1 = 0U;
  c39_info[14].fileTime2 = 0U;
  c39_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c39_info[15].name = "isscalar";
  c39_info[15].dominantType = "double";
  c39_info[15].resolved = "[B]isscalar";
  c39_info[15].fileLength = 0U;
  c39_info[15].fileTime1 = 0U;
  c39_info[15].fileTime2 = 0U;
  c39_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c39_info[16].name = "rdivide";
  c39_info[16].dominantType = "double";
  c39_info[16].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c39_info[16].fileLength = 620U;
  c39_info[16].fileTime1 = 1213926766U;
  c39_info[16].fileTime2 = 0U;
  c39_info[17].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c39_info[17].name = "isempty";
  c39_info[17].dominantType = "double";
  c39_info[17].resolved = "[B]isempty";
  c39_info[17].fileLength = 0U;
  c39_info[17].fileTime1 = 0U;
  c39_info[17].fileTime2 = 0U;
  c39_info[18].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c39_info[18].name = "not";
  c39_info[18].dominantType = "logical";
  c39_info[18].resolved = "[B]not";
  c39_info[18].fileLength = 0U;
  c39_info[18].fileTime1 = 0U;
  c39_info[18].fileTime2 = 0U;
  c39_info[19].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c39_info[19].name = "strcmp";
  c39_info[19].dominantType = "char";
  c39_info[19].resolved = "[B]strcmp";
  c39_info[19].fileLength = 0U;
  c39_info[19].fileTime1 = 0U;
  c39_info[19].fileTime2 = 0U;
  c39_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c39_info[20].name = "eq";
  c39_info[20].dominantType = "double";
  c39_info[20].resolved = "[B]eq";
  c39_info[20].fileLength = 0U;
  c39_info[20].fileTime1 = 0U;
  c39_info[20].fileTime2 = 0U;
  c39_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c39_info[21].name = "eml_warning";
  c39_info[21].dominantType = "char";
  c39_info[21].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c39_info[21].fileLength = 274U;
  c39_info[21].fileTime1 = 1227613396U;
  c39_info[21].fileTime2 = 0U;
  c39_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c39_info[22].name = "eml_div";
  c39_info[22].dominantType = "double";
  c39_info[22].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c39_info[22].fileLength = 4269U;
  c39_info[22].fileTime1 = 1227613386U;
  c39_info[22].fileTime2 = 0U;
}

static const mxArray *c39_emlrt_marshallOut(uint8_T c39_u)
{
  const mxArray *c39_y = NULL;
  c39_y = NULL;
  sf_mex_assign(&c39_y, sf_mex_create("y", &c39_u, 3, 0U, 0U, 0U, 0));
  return c39_y;
}

static void c39_emlrt_marshallIn(const mxArray *c39_H, char *c39_name, real_T
  c39_y[81])
{
  real_T c39_dv1[81];
  int32_T c39_i53;
  sf_mex_import(c39_name, sf_mex_dup(c39_H), &c39_dv1, 1, 0, 0U, 1, 0U, 2, 9, 9);
  for (c39_i53 = 0; c39_i53 < 81; c39_i53 = c39_i53 + 1) {
    c39_y[c39_i53] = c39_dv1[c39_i53];
  }

  sf_mex_destroy(&c39_H);
}

static uint8_T c39_b_emlrt_marshallIn(const mxArray *c39_b_is_active_c39_MCSim,
  char *c39_name)
{
  uint8_T c39_y;
  uint8_T c39_u0;
  sf_mex_import(c39_name, sf_mex_dup(c39_b_is_active_c39_MCSim), &c39_u0, 1, 3,
                0U, 0, 0U, 0);
  c39_y = c39_u0;
  sf_mex_destroy(&c39_b_is_active_c39_MCSim);
  return c39_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c39_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2789913159U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2947208542U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3115255700U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3952090066U);
}

mxArray *sf_c39_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1490502351U);
    pr[1] = (double)(2425494531U);
    pr[2] = (double)(1724114462U);
    pr[3] = (double)(2829977019U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(9);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c39_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"H\",},{M[8],M[0],T\"is_active_c39_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c39_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          39,
          1,
          1,
          5,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"W_u",0,c39_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 9;
            dimVector[1]= 9;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"H",0,c39_c_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Omega",0,NULL);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Q",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"T_d_prev",0,c39_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,1,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,258);
        _SFD_CV_INIT_EML_FOR(0,0,72,84,138);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c39_W_u)[9];
          real_T (*c39_H)[81];
          real_T (*c39_Omega)[9];
          real_T (*c39_Q)[9];
          real_T (*c39_T_d_prev)[3];
          c39_T_d_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
          c39_H = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
          c39_Omega = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 1);
          c39_Q = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 2);
          c39_W_u = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c39_W_u);
          _SFD_SET_DATA_VALUE_PTR(1U, c39_H);
          _SFD_SET_DATA_VALUE_PTR(2U, c39_Omega);
          _SFD_SET_DATA_VALUE_PTR(3U, c39_Q);
          _SFD_SET_DATA_VALUE_PTR(4U, c39_T_d_prev);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c39_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c39_MCSim();
  initialize_c39_MCSim();
}

static void sf_opaque_enable_c39_MCSim(void *chartInstanceVar)
{
  enable_c39_MCSim();
}

static void sf_opaque_disable_c39_MCSim(void *chartInstanceVar)
{
  disable_c39_MCSim();
}

static void sf_opaque_gateway_c39_MCSim(void *chartInstanceVar)
{
  sf_c39_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c39_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c39_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c39_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c39_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c39_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c39_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c39_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c39_MCSim();
  }
}

static void mdlSetWorkWidths_c39_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",39);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",39,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",39,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",39,4);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",39,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",39);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2874126020U));
  ssSetChecksum1(S,(1431165833U));
  ssSetChecksum2(S,(2332525867U));
  ssSetChecksum3(S,(1126635148U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c39_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",39);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c39_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c39_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c39_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c39_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c39_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c39_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c39_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c39_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c39_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c39_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c39_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c39_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c39_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c39_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c39_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c39_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c39_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
