/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c98_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c98_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc98_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c98_MCSim(void);
static void initialize_params_c98_MCSim(void);
static void enable_c98_MCSim(void);
static void disable_c98_MCSim(void);
static void c98_update_debugger_state_c98_MCSim(void);
static const mxArray *get_sim_state_c98_MCSim(void);
static void set_sim_state_c98_MCSim(const mxArray *c98_st);
static void finalize_c98_MCSim(void);
static void sf_c98_MCSim(void);
static void init_script_number_translation(uint32_T c98_machineNumber, uint32_T
  c98_chartNumber);
static const mxArray *c98_sf_marshall(void *c98_chartInstance, void *c98_u);
static const mxArray *c98_b_sf_marshall(void *c98_chartInstance, void *c98_u);
static const mxArray *c98_c_sf_marshall(void *c98_chartInstance, void *c98_u);
static void c98_info_helper(c98_ResolvedFunctionInfo c98_info[44]);
static const mxArray *c98_emlrt_marshallOut(uint8_T c98_u);
static void c98_emlrt_marshallIn(const mxArray *c98_A, char *c98_name, real_T
  c98_y[27]);
static uint8_T c98_b_emlrt_marshallIn(const mxArray *c98_b_is_active_c98_MCSim,
  char *c98_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c98_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c98_is_active_c98_MCSim = 0U;
}

static void initialize_params_c98_MCSim(void)
{
}

static void enable_c98_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c98_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c98_update_debugger_state_c98_MCSim(void)
{
}

static const mxArray *get_sim_state_c98_MCSim(void)
{
  const mxArray *c98_st = NULL;
  const mxArray *c98_y = NULL;
  int32_T c98_i0;
  real_T c98_u[27];
  const mxArray *c98_b_y = NULL;
  real_T (*c98_A)[27];
  c98_A = (real_T (*)[27])ssGetOutputPortSignal(chartInstance.S, 1);
  c98_st = NULL;
  c98_y = NULL;
  sf_mex_assign(&c98_y, sf_mex_createcellarray(2));
  for (c98_i0 = 0; c98_i0 < 27; c98_i0 = c98_i0 + 1) {
    c98_u[c98_i0] = (*c98_A)[c98_i0];
  }

  c98_b_y = NULL;
  sf_mex_assign(&c98_b_y, sf_mex_create("y", &c98_u, 0, 0U, 1U, 0U, 2, 3, 9));
  sf_mex_setcell(c98_y, 0, c98_b_y);
  sf_mex_setcell(c98_y, 1, c98_emlrt_marshallOut
                 (chartInstance.c98_is_active_c98_MCSim));
  sf_mex_assign(&c98_st, c98_y);
  return c98_st;
}

static void set_sim_state_c98_MCSim(const mxArray *c98_st)
{
  const mxArray *c98_u;
  real_T c98_dv0[27];
  int32_T c98_i1;
  real_T (*c98_A)[27];
  c98_A = (real_T (*)[27])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c98_doneDoubleBufferReInit = true;
  c98_u = sf_mex_dup(c98_st);
  c98_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c98_u, 0)), "A", c98_dv0);
  for (c98_i1 = 0; c98_i1 < 27; c98_i1 = c98_i1 + 1) {
    (*c98_A)[c98_i1] = c98_dv0[c98_i1];
  }

  chartInstance.c98_is_active_c98_MCSim = c98_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c98_u, 1)), "is_active_c98_MCSim");
  sf_mex_destroy(&c98_u);
  c98_update_debugger_state_c98_MCSim();
  sf_mex_destroy(&c98_st);
}

static void finalize_c98_MCSim(void)
{
}

static void sf_c98_MCSim(void)
{
  int32_T c98_i2;
  int32_T c98_i3;
  int32_T c98_i4;
  uint8_T c98_previousEvent;
  int32_T c98_i5;
  real_T c98_B_alphaPrev[9];
  int32_T c98_i6;
  real_T c98_B_Jacobian[9];
  real_T c98_nargout = 1.0;
  real_T c98_nargin = 2.0;
  real_T c98_A[27];
  int32_T c98_i7;
  real_T c98_I[9];
  int32_T c98_i;
  int32_T c98_b_i;
  int32_T c98_i8;
  int32_T c98_i9;
  int32_T c98_i10;
  int32_T c98_i11;
  int32_T c98_i12;
  int32_T c98_i13;
  int32_T c98_i14;
  int32_T c98_i15;
  int32_T c98_i16;
  int32_T c98_i17;
  real_T (*c98_b_A)[27];
  real_T (*c98_b_B_Jacobian)[9];
  real_T (*c98_b_B_alphaPrev)[9];
  c98_b_B_alphaPrev = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 0);
  c98_b_B_Jacobian = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 1);
  c98_b_A = (real_T (*)[27])ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,97);
  for (c98_i2 = 0; c98_i2 < 9; c98_i2 = c98_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c98_b_B_alphaPrev)[c98_i2], 0U);
  }

  for (c98_i3 = 0; c98_i3 < 9; c98_i3 = c98_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c98_b_B_Jacobian)[c98_i3], 1U);
  }

  for (c98_i4 = 0; c98_i4 < 27; c98_i4 = c98_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c98_b_A)[c98_i4], 2U);
  }

  c98_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,97);
  for (c98_i5 = 0; c98_i5 < 9; c98_i5 = c98_i5 + 1) {
    c98_B_alphaPrev[c98_i5] = (*c98_b_B_alphaPrev)[c98_i5];
  }

  for (c98_i6 = 0; c98_i6 < 9; c98_i6 = c98_i6 + 1) {
    c98_B_Jacobian[c98_i6] = (*c98_b_B_Jacobian)[c98_i6];
  }

  sf_debug_symbol_scope_push(5U, 0U);
  sf_debug_symbol_scope_add("nargout", &c98_nargout, c98_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c98_nargin, c98_c_sf_marshall);
  sf_debug_symbol_scope_add("A", &c98_A, c98_b_sf_marshall);
  sf_debug_symbol_scope_add("B_Jacobian", &c98_B_Jacobian, c98_sf_marshall);
  sf_debug_symbol_scope_add("B_alphaPrev", &c98_B_alphaPrev, c98_sf_marshall);
  CV_EML_FCN(0, 0);

  /*  Please see the article Constrained Nonlinear Control Allocation with Singularity Avoidance using  */
  /*  Sequential Quadratic Programmming by Tor.A.Johansen, Thor I. Fossen ... (2004) */
  _SFD_EML_CALL(0,5);
  for (c98_i7 = 0; c98_i7 < 9; c98_i7 = c98_i7 + 1) {
    c98_I[c98_i7] = 0.0;
  }

  for (c98_i = 1; c98_i < 4; c98_i = c98_i + 1) {
    c98_b_i = c98_i;
    c98_I[(_SFD_EML_ARRAY_BOUNDS_CHECK("I", _SFD_INTEGER_CHECK("i", (real_T)
             c98_b_i), 1, 3, 1, 0) - 1) + 3 * (
      _SFD_EML_ARRAY_BOUNDS_CHECK("I", _SFD_INTEGER_CHECK("i", (real_T)c98_b_i),
      1, 3, 2, 0) - 1)] = 1.0;
  }

  c98_i8 = 0;
  for (c98_i9 = 0; c98_i9 < 3; c98_i9 = c98_i9 + 1) {
    for (c98_i10 = 0; c98_i10 < 3; c98_i10 = c98_i10 + 1) {
      c98_A[c98_i10 + c98_i8] = c98_B_alphaPrev[c98_i10 + c98_i8];
    }

    c98_i8 = c98_i8 + 3;
  }

  c98_i11 = 0;
  for (c98_i12 = 0; c98_i12 < 3; c98_i12 = c98_i12 + 1) {
    for (c98_i13 = 0; c98_i13 < 3; c98_i13 = c98_i13 + 1) {
      c98_A[(c98_i13 + c98_i11) + 9] = c98_B_Jacobian[c98_i13 + c98_i11];
    }

    c98_i11 = c98_i11 + 3;
  }

  c98_i14 = 0;
  for (c98_i15 = 0; c98_i15 < 3; c98_i15 = c98_i15 + 1) {
    for (c98_i16 = 0; c98_i16 < 3; c98_i16 = c98_i16 + 1) {
      c98_A[(c98_i16 + c98_i14) + 18] = c98_I[c98_i16 + c98_i14];
    }

    c98_i14 = c98_i14 + 3;
  }

  _SFD_EML_CALL(0,-5);
  sf_debug_symbol_scope_pop();
  for (c98_i17 = 0; c98_i17 < 27; c98_i17 = c98_i17 + 1) {
    (*c98_b_A)[c98_i17] = c98_A[c98_i17];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,97);
  _sfEvent_ = c98_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c98_machineNumber, uint32_T
  c98_chartNumber)
{
}

static const mxArray *c98_sf_marshall(void *c98_chartInstance, void *c98_u)
{
  const mxArray *c98_y = NULL;
  int32_T c98_i18;
  int32_T c98_i19;
  int32_T c98_i20;
  real_T c98_b_u[9];
  const mxArray *c98_b_y = NULL;
  c98_y = NULL;
  c98_i18 = 0;
  for (c98_i19 = 0; c98_i19 < 3; c98_i19 = c98_i19 + 1) {
    for (c98_i20 = 0; c98_i20 < 3; c98_i20 = c98_i20 + 1) {
      c98_b_u[c98_i20 + c98_i18] = (*((real_T (*)[9])c98_u))[c98_i20 + c98_i18];
    }

    c98_i18 = c98_i18 + 3;
  }

  c98_b_y = NULL;
  sf_mex_assign(&c98_b_y, sf_mex_create("y", &c98_b_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_assign(&c98_y, c98_b_y);
  return c98_y;
}

static const mxArray *c98_b_sf_marshall(void *c98_chartInstance, void *c98_u)
{
  const mxArray *c98_y = NULL;
  int32_T c98_i21;
  int32_T c98_i22;
  int32_T c98_i23;
  real_T c98_b_u[27];
  const mxArray *c98_b_y = NULL;
  c98_y = NULL;
  c98_i21 = 0;
  for (c98_i22 = 0; c98_i22 < 9; c98_i22 = c98_i22 + 1) {
    for (c98_i23 = 0; c98_i23 < 3; c98_i23 = c98_i23 + 1) {
      c98_b_u[c98_i23 + c98_i21] = (*((real_T (*)[27])c98_u))[c98_i23 + c98_i21];
    }

    c98_i21 = c98_i21 + 3;
  }

  c98_b_y = NULL;
  sf_mex_assign(&c98_b_y, sf_mex_create("y", &c98_b_u, 0, 0U, 1U, 0U, 2, 3, 9));
  sf_mex_assign(&c98_y, c98_b_y);
  return c98_y;
}

static const mxArray *c98_c_sf_marshall(void *c98_chartInstance, void *c98_u)
{
  const mxArray *c98_y = NULL;
  real_T c98_b_u;
  const mxArray *c98_b_y = NULL;
  c98_y = NULL;
  c98_b_u = *((real_T *)c98_u);
  c98_b_y = NULL;
  sf_mex_assign(&c98_b_y, sf_mex_create("y", &c98_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c98_y, c98_b_y);
  return c98_y;
}

const mxArray *sf_c98_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c98_nameCaptureInfo = NULL;
  c98_ResolvedFunctionInfo c98_info[44];
  const mxArray *c98_m0 = NULL;
  int32_T c98_i24;
  c98_ResolvedFunctionInfo *c98_r0;
  c98_nameCaptureInfo = NULL;
  c98_info_helper(c98_info);
  sf_mex_assign(&c98_m0, sf_mex_createstruct("nameCaptureInfo", 1, 44));
  for (c98_i24 = 0; c98_i24 < 44; c98_i24 = c98_i24 + 1) {
    c98_r0 = &c98_info[c98_i24];
    sf_mex_addfield(c98_m0, sf_mex_create("nameCaptureInfo", c98_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c98_r0->context)), "context"
                    , "nameCaptureInfo", c98_i24);
    sf_mex_addfield(c98_m0, sf_mex_create("nameCaptureInfo", c98_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c98_r0->name)), "name",
                    "nameCaptureInfo", c98_i24);
    sf_mex_addfield(c98_m0, sf_mex_create("nameCaptureInfo",
      c98_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c98_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c98_i24);
    sf_mex_addfield(c98_m0, sf_mex_create("nameCaptureInfo", c98_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c98_r0->resolved)),
                    "resolved", "nameCaptureInfo", c98_i24);
    sf_mex_addfield(c98_m0, sf_mex_create("nameCaptureInfo", &c98_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c98_i24);
    sf_mex_addfield(c98_m0, sf_mex_create("nameCaptureInfo", &c98_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c98_i24);
    sf_mex_addfield(c98_m0, sf_mex_create("nameCaptureInfo", &c98_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c98_i24);
  }

  sf_mex_assign(&c98_nameCaptureInfo, c98_m0);
  return c98_nameCaptureInfo;
}

static void c98_info_helper(c98_ResolvedFunctionInfo c98_info[44])
{
  c98_info[0].context = "";
  c98_info[0].name = "eye";
  c98_info[0].dominantType = "double";
  c98_info[0].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m";
  c98_info[0].fileLength = 1765U;
  c98_info[0].fileTime1 = 1219752890U;
  c98_info[0].fileTime2 = 0U;
  c98_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m";
  c98_info[1].name = "nargin";
  c98_info[1].dominantType = "";
  c98_info[1].resolved = "[B]nargin";
  c98_info[1].fileLength = 0U;
  c98_info[1].fileTime1 = 0U;
  c98_info[1].fileTime2 = 0U;
  c98_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m";
  c98_info[2].name = "ischar";
  c98_info[2].dominantType = "double";
  c98_info[2].resolved = "[B]ischar";
  c98_info[2].fileLength = 0U;
  c98_info[2].fileTime1 = 0U;
  c98_info[2].fileTime2 = 0U;
  c98_info[3].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m/eye_internal";
  c98_info[3].name = "eml_assert_valid_size_arg";
  c98_info[3].dominantType = "double";
  c98_info[3].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c98_info[3].fileLength = 3237U;
  c98_info[3].fileTime1 = 1227613384U;
  c98_info[3].fileTime2 = 0U;
  c98_info[4].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c98_info[4].name = "eq";
  c98_info[4].dominantType = "double";
  c98_info[4].resolved = "[B]eq";
  c98_info[4].fileLength = 0U;
  c98_info[4].fileTime1 = 0U;
  c98_info[4].fileTime2 = 0U;
  c98_info[5].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/isVariableSizing";
  c98_info[5].name = "false";
  c98_info[5].dominantType = "";
  c98_info[5].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c98_info[5].fileLength = 238U;
  c98_info[5].fileTime1 = 1192466720U;
  c98_info[5].fileTime2 = 0U;
  c98_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c98_info[6].name = "logical";
  c98_info[6].dominantType = "double";
  c98_info[6].resolved = "[B]logical";
  c98_info[6].fileLength = 0U;
  c98_info[6].fileTime1 = 0U;
  c98_info[6].fileTime2 = 0U;
  c98_info[7].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c98_info[7].name = "not";
  c98_info[7].dominantType = "logical";
  c98_info[7].resolved = "[B]not";
  c98_info[7].fileLength = 0U;
  c98_info[7].fileTime1 = 0U;
  c98_info[7].fileTime2 = 0U;
  c98_info[8].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c98_info[8].name = "isnumeric";
  c98_info[8].dominantType = "double";
  c98_info[8].resolved = "[B]isnumeric";
  c98_info[8].fileLength = 0U;
  c98_info[8].fileTime1 = 0U;
  c98_info[8].fileTime2 = 0U;
  c98_info[9].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c98_info[9].name = "isreal";
  c98_info[9].dominantType = "double";
  c98_info[9].resolved = "[B]isreal";
  c98_info[9].fileLength = 0U;
  c98_info[9].fileTime1 = 0U;
  c98_info[9].fileTime2 = 0U;
  c98_info[10].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c98_info[10].name = "isscalar";
  c98_info[10].dominantType = "double";
  c98_info[10].resolved = "[B]isscalar";
  c98_info[10].fileLength = 0U;
  c98_info[10].fileTime1 = 0U;
  c98_info[10].fileTime2 = 0U;
  c98_info[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/isintegral";
  c98_info[11].name = "isinteger";
  c98_info[11].dominantType = "double";
  c98_info[11].resolved = "[B]isinteger";
  c98_info[11].fileLength = 0U;
  c98_info[11].fileTime1 = 0U;
  c98_info[11].fileTime2 = 0U;
  c98_info[12].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/isintegral";
  c98_info[12].name = "ne";
  c98_info[12].dominantType = "double";
  c98_info[12].resolved = "[B]ne";
  c98_info[12].fileLength = 0U;
  c98_info[12].fileTime1 = 0U;
  c98_info[12].fileTime2 = 0U;
  c98_info[13].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/isintegral";
  c98_info[13].name = "isfinite";
  c98_info[13].dominantType = "double";
  c98_info[13].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c98_info[13].fileLength = 364U;
  c98_info[13].fileTime1 = 1225989456U;
  c98_info[13].fileTime2 = 0U;
  c98_info[14].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c98_info[14].name = "gt";
  c98_info[14].dominantType = "double";
  c98_info[14].resolved = "[B]gt";
  c98_info[14].fileLength = 0U;
  c98_info[14].fileTime1 = 0U;
  c98_info[14].fileTime2 = 0U;
  c98_info[15].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c98_info[15].name = "isa";
  c98_info[15].dominantType = "double";
  c98_info[15].resolved = "[B]isa";
  c98_info[15].fileLength = 0U;
  c98_info[15].fileTime1 = 0U;
  c98_info[15].fileTime2 = 0U;
  c98_info[16].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c98_info[16].name = "isinf";
  c98_info[16].dominantType = "double";
  c98_info[16].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c98_info[16].fileLength = 506U;
  c98_info[16].fileTime1 = 1227613388U;
  c98_info[16].fileTime2 = 0U;
  c98_info[17].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c98_info[17].name = "isnan";
  c98_info[17].dominantType = "double";
  c98_info[17].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c98_info[17].fileLength = 506U;
  c98_info[17].fileTime1 = 1227613388U;
  c98_info[17].fileTime2 = 0U;
  c98_info[18].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c98_info[18].name = "and";
  c98_info[18].dominantType = "logical";
  c98_info[18].resolved = "[B]and";
  c98_info[18].fileLength = 0U;
  c98_info[18].fileTime1 = 0U;
  c98_info[18].fileTime2 = 0U;
  c98_info[19].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/isintegral";
  c98_info[19].name = "true";
  c98_info[19].dominantType = "";
  c98_info[19].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/true.m";
  c98_info[19].fileLength = 237U;
  c98_info[19].fileTime1 = 1192466762U;
  c98_info[19].fileTime2 = 0U;
  c98_info[20].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/numel_for_size";
  c98_info[20].name = "le";
  c98_info[20].dominantType = "double";
  c98_info[20].resolved = "[B]le";
  c98_info[20].fileLength = 0U;
  c98_info[20].fileTime1 = 0U;
  c98_info[20].fileTime2 = 0U;
  c98_info[21].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/numel_for_size";
  c98_info[21].name = "double";
  c98_info[21].dominantType = "double";
  c98_info[21].resolved = "[B]double";
  c98_info[21].fileLength = 0U;
  c98_info[21].fileTime1 = 0U;
  c98_info[21].fileTime2 = 0U;
  c98_info[22].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/numel_for_size";
  c98_info[22].name = "mtimes";
  c98_info[22].dominantType = "double";
  c98_info[22].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c98_info[22].fileLength = 2408U;
  c98_info[22].fileTime1 = 1227613402U;
  c98_info[22].fileTime2 = 0U;
  c98_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c98_info[23].name = "strcmp";
  c98_info[23].dominantType = "char";
  c98_info[23].resolved = "[B]strcmp";
  c98_info[23].fileLength = 0U;
  c98_info[23].fileTime1 = 0U;
  c98_info[23].fileTime2 = 0U;
  c98_info[24].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c98_info[24].name = "size";
  c98_info[24].dominantType = "double";
  c98_info[24].resolved = "[B]size";
  c98_info[24].fileLength = 0U;
  c98_info[24].fileTime1 = 0U;
  c98_info[24].fileTime2 = 0U;
  c98_info[25].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c98_info[25].name = "class";
  c98_info[25].dominantType = "double";
  c98_info[25].resolved = "[B]class";
  c98_info[25].fileLength = 0U;
  c98_info[25].fileTime1 = 0U;
  c98_info[25].fileTime2 = 0U;
  c98_info[26].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c98_info[26].name = "eml_index_class";
  c98_info[26].dominantType = "";
  c98_info[26].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c98_info[26].fileLength = 909U;
  c98_info[26].fileTime1 = 1192466782U;
  c98_info[26].fileTime2 = 0U;
  c98_info[27].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c98_info[27].name = "intmax";
  c98_info[27].dominantType = "char";
  c98_info[27].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c98_info[27].fileLength = 1535U;
  c98_info[27].fileTime1 = 1192466728U;
  c98_info[27].fileTime2 = 0U;
  c98_info[28].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c98_info[28].name = "int32";
  c98_info[28].dominantType = "double";
  c98_info[28].resolved = "[B]int32";
  c98_info[28].fileLength = 0U;
  c98_info[28].fileTime1 = 0U;
  c98_info[28].fileTime2 = 0U;
  c98_info[29].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m/eye_internal";
  c98_info[29].name = "eml_is_float_class";
  c98_info[29].dominantType = "char";
  c98_info[29].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c98_info[29].fileLength = 226U;
  c98_info[29].fileTime1 = 1197850442U;
  c98_info[29].fileTime2 = 0U;
  c98_info[30].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m/eye_internal";
  c98_info[30].name = "zeros";
  c98_info[30].dominantType = "double";
  c98_info[30].resolved = "[B]zeros";
  c98_info[30].fileLength = 0U;
  c98_info[30].fileTime1 = 0U;
  c98_info[30].fileTime2 = 0U;
  c98_info[31].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m/eye_internal";
  c98_info[31].name = "real";
  c98_info[31].dominantType = "double";
  c98_info[31].resolved = "[B]real";
  c98_info[31].fileLength = 0U;
  c98_info[31].fileTime1 = 0U;
  c98_info[31].fileTime2 = 0U;
  c98_info[32].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m/eye_internal";
  c98_info[32].name = "min";
  c98_info[32].dominantType = "double";
  c98_info[32].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c98_info[32].fileLength = 308U;
  c98_info[32].fileTime1 = 1192466634U;
  c98_info[32].fileTime2 = 0U;
  c98_info[33].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c98_info[33].name = "nargout";
  c98_info[33].dominantType = "";
  c98_info[33].resolved = "[B]nargout";
  c98_info[33].fileLength = 0U;
  c98_info[33].fileTime1 = 0U;
  c98_info[33].fileTime2 = 0U;
  c98_info[34].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c98_info[34].name = "eml_min_or_max";
  c98_info[34].dominantType = "char";
  c98_info[34].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c98_info[34].fileLength = 8839U;
  c98_info[34].fileTime1 = 1227613388U;
  c98_info[34].fileTime2 = 0U;
  c98_info[35].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_bin_extremum";
  c98_info[35].name = "islogical";
  c98_info[35].dominantType = "double";
  c98_info[35].resolved = "[B]islogical";
  c98_info[35].fileLength = 0U;
  c98_info[35].fileTime1 = 0U;
  c98_info[35].fileTime2 = 0U;
  c98_info[36].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_bin_extremum";
  c98_info[36].name = "eml_scalar_eg";
  c98_info[36].dominantType = "double";
  c98_info[36].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c98_info[36].fileLength = 3524U;
  c98_info[36].fileTime1 = 1227613394U;
  c98_info[36].fileTime2 = 0U;
  c98_info[37].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c98_info[37].name = "isstruct";
  c98_info[37].dominantType = "double";
  c98_info[37].resolved = "[B]isstruct";
  c98_info[37].fileLength = 0U;
  c98_info[37].fileTime1 = 0U;
  c98_info[37].fileTime2 = 0U;
  c98_info[38].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/zerosum";
  c98_info[38].name = "cast";
  c98_info[38].dominantType = "double";
  c98_info[38].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c98_info[38].fileLength = 889U;
  c98_info[38].fileTime1 = 1225989442U;
  c98_info[38].fileTime2 = 0U;
  c98_info[39].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c98_info[39].name = "ge";
  c98_info[39].dominantType = "double";
  c98_info[39].resolved = "[B]ge";
  c98_info[39].fileLength = 0U;
  c98_info[39].fileTime1 = 0U;
  c98_info[39].fileTime2 = 0U;
  c98_info[40].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/zerosum";
  c98_info[40].name = "plus";
  c98_info[40].dominantType = "double";
  c98_info[40].resolved = "[B]plus";
  c98_info[40].fileLength = 0U;
  c98_info[40].fileTime1 = 0U;
  c98_info[40].fileTime2 = 0U;
  c98_info[41].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_bin_extremum";
  c98_info[41].name = "eml_scalexp_alloc";
  c98_info[41].dominantType = "double";
  c98_info[41].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c98_info[41].fileLength = 794U;
  c98_info[41].fileTime1 = 1227613394U;
  c98_info[41].fileTime2 = 0U;
  c98_info[42].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c98_info[42].name = "minus";
  c98_info[42].dominantType = "double";
  c98_info[42].resolved = "[B]minus";
  c98_info[42].fileLength = 0U;
  c98_info[42].fileTime1 = 0U;
  c98_info[42].fileTime2 = 0U;
  c98_info[43].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_bin_extremum";
  c98_info[43].name = "ones";
  c98_info[43].dominantType = "char";
  c98_info[43].resolved = "[B]ones";
  c98_info[43].fileLength = 0U;
  c98_info[43].fileTime1 = 0U;
  c98_info[43].fileTime2 = 0U;
}

static const mxArray *c98_emlrt_marshallOut(uint8_T c98_u)
{
  const mxArray *c98_y = NULL;
  c98_y = NULL;
  sf_mex_assign(&c98_y, sf_mex_create("y", &c98_u, 3, 0U, 0U, 0U, 0));
  return c98_y;
}

static void c98_emlrt_marshallIn(const mxArray *c98_A, char *c98_name, real_T
  c98_y[27])
{
  real_T c98_dv1[27];
  int32_T c98_i25;
  sf_mex_import(c98_name, sf_mex_dup(c98_A), &c98_dv1, 1, 0, 0U, 1, 0U, 2, 3, 9);
  for (c98_i25 = 0; c98_i25 < 27; c98_i25 = c98_i25 + 1) {
    c98_y[c98_i25] = c98_dv1[c98_i25];
  }

  sf_mex_destroy(&c98_A);
}

static uint8_T c98_b_emlrt_marshallIn(const mxArray *c98_b_is_active_c98_MCSim,
  char *c98_name)
{
  uint8_T c98_y;
  uint8_T c98_u0;
  sf_mex_import(c98_name, sf_mex_dup(c98_b_is_active_c98_MCSim), &c98_u0, 1, 3,
                0U, 0, 0U, 0);
  c98_y = c98_u0;
  sf_mex_destroy(&c98_b_is_active_c98_MCSim);
  return c98_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c98_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3580132761U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3392000353U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2706264882U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3990569885U);
}

mxArray *sf_c98_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3427907008U);
    pr[1] = (double)(2865971092U);
    pr[2] = (double)(787540354U);
    pr[3] = (double)(28826735U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(9);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c98_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[10],T\"A\",},{M[8],M[0],T\"is_active_c98_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c98_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          98,
          1,
          1,
          3,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"B_alphaPrev",0,c98_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"B_Jacobian",0,NULL);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 9;
            _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"A",0,c98_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,280);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c98_B_alphaPrev)[9];
          real_T (*c98_B_Jacobian)[9];
          real_T (*c98_A)[27];
          c98_B_alphaPrev = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S,
            0);
          c98_B_Jacobian = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S,
            1);
          c98_A = (real_T (*)[27])ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c98_B_alphaPrev);
          _SFD_SET_DATA_VALUE_PTR(1U, c98_B_Jacobian);
          _SFD_SET_DATA_VALUE_PTR(2U, c98_A);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c98_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c98_MCSim();
  initialize_c98_MCSim();
}

static void sf_opaque_enable_c98_MCSim(void *chartInstanceVar)
{
  enable_c98_MCSim();
}

static void sf_opaque_disable_c98_MCSim(void *chartInstanceVar)
{
  disable_c98_MCSim();
}

static void sf_opaque_gateway_c98_MCSim(void *chartInstanceVar)
{
  sf_c98_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c98_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c98_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c98_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c98_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c98_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c98_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c98_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c98_MCSim();
  }
}

static void mdlSetWorkWidths_c98_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",98);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",98,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",98,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",98,2);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",98,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",98);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1532738764U));
  ssSetChecksum1(S,(3058096531U));
  ssSetChecksum2(S,(3936183051U));
  ssSetChecksum3(S,(2087128908U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c98_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",98);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c98_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c98_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c98_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c98_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c98_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c98_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c98_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c98_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c98_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c98_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c98_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c98_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c98_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c98_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c98_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c98_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c98_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
