/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c99_MCSim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c99_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc99_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c99_MCSim(void);
static void initialize_params_c99_MCSim(void);
static void enable_c99_MCSim(void);
static void disable_c99_MCSim(void);
static void c99_update_debugger_state_c99_MCSim(void);
static const mxArray *get_sim_state_c99_MCSim(void);
static void set_sim_state_c99_MCSim(const mxArray *c99_st);
static void finalize_c99_MCSim(void);
static void sf_c99_MCSim(void);
static void init_script_number_translation(uint32_T c99_machineNumber, uint32_T
  c99_chartNumber);
static const mxArray *c99_sf_marshall(void *c99_chartInstance, void *c99_u);
static const mxArray *c99_b_sf_marshall(void *c99_chartInstance, void *c99_u);
static const mxArray *c99_c_sf_marshall(void *c99_chartInstance, void *c99_u);
static void c99_info_helper(c99_ResolvedFunctionInfo c99_info[18]);
static const mxArray *c99_emlrt_marshallOut(uint8_T c99_u);
static void c99_emlrt_marshallIn(const mxArray *c99_B_Jacobian, char *c99_name,
  real_T c99_y[9]);
static uint8_T c99_b_emlrt_marshallIn(const mxArray *c99_b_is_active_c99_MCSim,
  char *c99_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c99_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c99_is_active_c99_MCSim = 0U;
}

static void initialize_params_c99_MCSim(void)
{
}

static void enable_c99_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c99_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c99_update_debugger_state_c99_MCSim(void)
{
}

static const mxArray *get_sim_state_c99_MCSim(void)
{
  const mxArray *c99_st = NULL;
  const mxArray *c99_y = NULL;
  int32_T c99_i0;
  real_T c99_u[9];
  const mxArray *c99_b_y = NULL;
  real_T (*c99_B_Jacobian)[9];
  c99_B_Jacobian = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  c99_st = NULL;
  c99_y = NULL;
  sf_mex_assign(&c99_y, sf_mex_createcellarray(2));
  for (c99_i0 = 0; c99_i0 < 9; c99_i0 = c99_i0 + 1) {
    c99_u[c99_i0] = (*c99_B_Jacobian)[c99_i0];
  }

  c99_b_y = NULL;
  sf_mex_assign(&c99_b_y, sf_mex_create("y", &c99_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_setcell(c99_y, 0, c99_b_y);
  sf_mex_setcell(c99_y, 1, c99_emlrt_marshallOut
                 (chartInstance.c99_is_active_c99_MCSim));
  sf_mex_assign(&c99_st, c99_y);
  return c99_st;
}

static void set_sim_state_c99_MCSim(const mxArray *c99_st)
{
  const mxArray *c99_u;
  real_T c99_dv0[9];
  int32_T c99_i1;
  real_T (*c99_B_Jacobian)[9];
  c99_B_Jacobian = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c99_doneDoubleBufferReInit = true;
  c99_u = sf_mex_dup(c99_st);
  c99_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c99_u, 0)), "B_Jacobian",
                       c99_dv0);
  for (c99_i1 = 0; c99_i1 < 9; c99_i1 = c99_i1 + 1) {
    (*c99_B_Jacobian)[c99_i1] = c99_dv0[c99_i1];
  }

  chartInstance.c99_is_active_c99_MCSim = c99_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c99_u, 1)), "is_active_c99_MCSim");
  sf_mex_destroy(&c99_u);
  c99_update_debugger_state_c99_MCSim();
  sf_mex_destroy(&c99_st);
}

static void finalize_c99_MCSim(void)
{
}

static void sf_c99_MCSim(void)
{
  int32_T c99_i2;
  int32_T c99_i3;
  int32_T c99_i4;
  int32_T c99_i5;
  int32_T c99_i6;
  uint8_T c99_previousEvent;
  int32_T c99_i7;
  real_T c99_T_prev[3];
  int32_T c99_i8;
  real_T c99_alpha_prev[3];
  int32_T c99_i9;
  real_T c99_ly[3];
  int32_T c99_i10;
  real_T c99_lx[3];
  real_T c99_nargout = 1.0;
  real_T c99_nargin = 4.0;
  real_T c99_B_JacobianColum3[3];
  real_T c99_B_JacobianColum2[3];
  real_T c99_B_JacobianColum1[3];
  real_T c99_B_Jacobian[9];
  real_T c99_a;
  real_T c99_x;
  real_T c99_b_a;
  real_T c99_b_x;
  real_T c99_b;
  real_T c99_y;
  real_T c99_c_x;
  real_T c99_c_a;
  real_T c99_d_x;
  real_T c99_b_b;
  real_T c99_b_y;
  real_T c99_c_b;
  real_T c99_c_y;
  real_T c99_e_x;
  real_T c99_d_a;
  real_T c99_f_x;
  real_T c99_d_b;
  real_T c99_d_y;
  real_T c99_g_x;
  real_T c99_h_x;
  real_T c99_i_x;
  real_T c99_e_a;
  real_T c99_e_b;
  real_T c99_e_y;
  real_T c99_f_a;
  real_T c99_j_x;
  real_T c99_g_a;
  real_T c99_k_x;
  real_T c99_f_b;
  real_T c99_f_y;
  real_T c99_l_x;
  real_T c99_h_a;
  real_T c99_m_x;
  real_T c99_g_b;
  real_T c99_g_y;
  real_T c99_h_b;
  real_T c99_h_y;
  real_T c99_n_x;
  real_T c99_i_a;
  real_T c99_o_x;
  real_T c99_i_b;
  real_T c99_i_y;
  real_T c99_p_x;
  real_T c99_q_x;
  real_T c99_r_x;
  real_T c99_j_a;
  real_T c99_j_b;
  real_T c99_j_y;
  real_T c99_k_a;
  real_T c99_s_x;
  real_T c99_l_a;
  real_T c99_t_x;
  real_T c99_k_b;
  real_T c99_k_y;
  real_T c99_u_x;
  real_T c99_m_a;
  real_T c99_v_x;
  real_T c99_l_b;
  real_T c99_l_y;
  real_T c99_m_b;
  real_T c99_m_y;
  real_T c99_w_x;
  real_T c99_n_a;
  real_T c99_x_x;
  real_T c99_n_b;
  real_T c99_n_y;
  real_T c99_y_x;
  real_T c99_ab_x;
  real_T c99_bb_x;
  real_T c99_o_a;
  real_T c99_o_b;
  real_T c99_o_y;
  int32_T c99_i11;
  int32_T c99_i12;
  int32_T c99_i13;
  int32_T c99_i14;
  real_T (*c99_b_B_Jacobian)[9];
  real_T (*c99_b_lx)[3];
  real_T (*c99_b_ly)[3];
  real_T (*c99_b_alpha_prev)[3];
  real_T (*c99_b_T_prev)[3];
  c99_b_B_Jacobian = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  c99_b_T_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c99_b_lx = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
  c99_b_ly = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  c99_b_alpha_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,98);
  for (c99_i2 = 0; c99_i2 < 3; c99_i2 = c99_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c99_b_T_prev)[c99_i2], 0U);
  }

  for (c99_i3 = 0; c99_i3 < 9; c99_i3 = c99_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c99_b_B_Jacobian)[c99_i3], 1U);
  }

  for (c99_i4 = 0; c99_i4 < 3; c99_i4 = c99_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c99_b_alpha_prev)[c99_i4], 2U);
  }

  for (c99_i5 = 0; c99_i5 < 3; c99_i5 = c99_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c99_b_ly)[c99_i5], 3U);
  }

  for (c99_i6 = 0; c99_i6 < 3; c99_i6 = c99_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c99_b_lx)[c99_i6], 4U);
  }

  c99_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,98);
  for (c99_i7 = 0; c99_i7 < 3; c99_i7 = c99_i7 + 1) {
    c99_T_prev[c99_i7] = (*c99_b_T_prev)[c99_i7];
  }

  for (c99_i8 = 0; c99_i8 < 3; c99_i8 = c99_i8 + 1) {
    c99_alpha_prev[c99_i8] = (*c99_b_alpha_prev)[c99_i8];
  }

  for (c99_i9 = 0; c99_i9 < 3; c99_i9 = c99_i9 + 1) {
    c99_ly[c99_i9] = (*c99_b_ly)[c99_i9];
  }

  for (c99_i10 = 0; c99_i10 < 3; c99_i10 = c99_i10 + 1) {
    c99_lx[c99_i10] = (*c99_b_lx)[c99_i10];
  }

  sf_debug_symbol_scope_push(10U, 0U);
  sf_debug_symbol_scope_add("nargout", &c99_nargout, c99_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c99_nargin, c99_c_sf_marshall);
  sf_debug_symbol_scope_add("B_JacobianColum3", &c99_B_JacobianColum3,
    c99_sf_marshall);
  sf_debug_symbol_scope_add("B_JacobianColum2", &c99_B_JacobianColum2,
    c99_sf_marshall);
  sf_debug_symbol_scope_add("B_JacobianColum1", &c99_B_JacobianColum1,
    c99_sf_marshall);
  sf_debug_symbol_scope_add("B_Jacobian", &c99_B_Jacobian, c99_b_sf_marshall);
  sf_debug_symbol_scope_add("lx", &c99_lx, c99_sf_marshall);
  sf_debug_symbol_scope_add("ly", &c99_ly, c99_sf_marshall);
  sf_debug_symbol_scope_add("alpha_prev", &c99_alpha_prev, c99_sf_marshall);
  sf_debug_symbol_scope_add("T_prev", &c99_T_prev, c99_sf_marshall);
  CV_EML_FCN(0, 0);

  /*  Please see the article Constrained Nonlinear Control Allocation with Singularity Avoidance using  */
  /*  Sequential Quadratic Programmming by Tor.A.Johansen, Thor I. Fossen ... (2004) */
  _SFD_EML_CALL(0,5);
  c99_a = c99_T_prev[0];
  c99_x = c99_alpha_prev[0];
  c99_b_a = c99_x;
  c99_b_x = c99_b_a;
  c99_b_a = c99_b_x;
  c99_b_a = muDoubleScalarSin(c99_b_a);
  c99_b = c99_ly[0];
  c99_y = c99_b_a * c99_b;
  c99_c_x = c99_alpha_prev[0];
  c99_c_a = c99_c_x;
  c99_d_x = c99_c_a;
  c99_c_a = c99_d_x;
  c99_c_a = muDoubleScalarCos(c99_c_a);
  c99_b_b = c99_lx[0];
  c99_b_y = c99_c_a * c99_b_b;
  c99_c_b = c99_b_y + c99_y;
  c99_c_y = c99_a * c99_c_b;
  c99_e_x = c99_alpha_prev[0];
  c99_d_a = c99_e_x;
  c99_f_x = c99_d_a;
  c99_d_a = c99_f_x;
  c99_d_a = muDoubleScalarCos(c99_d_a);
  c99_d_b = c99_T_prev[0];
  c99_d_y = c99_d_a * c99_d_b;
  c99_g_x = c99_alpha_prev[0];
  c99_h_x = c99_g_x;
  c99_i_x = c99_h_x;
  c99_h_x = c99_i_x;
  c99_h_x = muDoubleScalarSin(c99_h_x);
  c99_e_a = -c99_h_x;
  c99_e_b = c99_T_prev[0];
  c99_e_y = c99_e_a * c99_e_b;
  c99_B_JacobianColum1[0] = c99_e_y;
  c99_B_JacobianColum1[1] = c99_d_y;
  c99_B_JacobianColum1[2] = c99_c_y;
  _SFD_EML_CALL(0,9);
  c99_f_a = c99_T_prev[1];
  c99_j_x = c99_alpha_prev[1];
  c99_g_a = c99_j_x;
  c99_k_x = c99_g_a;
  c99_g_a = c99_k_x;
  c99_g_a = muDoubleScalarSin(c99_g_a);
  c99_f_b = c99_ly[1];
  c99_f_y = c99_g_a * c99_f_b;
  c99_l_x = c99_alpha_prev[1];
  c99_h_a = c99_l_x;
  c99_m_x = c99_h_a;
  c99_h_a = c99_m_x;
  c99_h_a = muDoubleScalarCos(c99_h_a);
  c99_g_b = c99_lx[1];
  c99_g_y = c99_h_a * c99_g_b;
  c99_h_b = c99_g_y + c99_f_y;
  c99_h_y = c99_f_a * c99_h_b;
  c99_n_x = c99_alpha_prev[1];
  c99_i_a = c99_n_x;
  c99_o_x = c99_i_a;
  c99_i_a = c99_o_x;
  c99_i_a = muDoubleScalarCos(c99_i_a);
  c99_i_b = c99_T_prev[1];
  c99_i_y = c99_i_a * c99_i_b;
  c99_p_x = c99_alpha_prev[1];
  c99_q_x = c99_p_x;
  c99_r_x = c99_q_x;
  c99_q_x = c99_r_x;
  c99_q_x = muDoubleScalarSin(c99_q_x);
  c99_j_a = -c99_q_x;
  c99_j_b = c99_T_prev[1];
  c99_j_y = c99_j_a * c99_j_b;
  c99_B_JacobianColum2[0] = c99_j_y;
  c99_B_JacobianColum2[1] = c99_i_y;
  c99_B_JacobianColum2[2] = c99_h_y;
  _SFD_EML_CALL(0,13);
  c99_k_a = c99_T_prev[2];
  c99_s_x = c99_alpha_prev[2];
  c99_l_a = c99_s_x;
  c99_t_x = c99_l_a;
  c99_l_a = c99_t_x;
  c99_l_a = muDoubleScalarSin(c99_l_a);
  c99_k_b = c99_ly[2];
  c99_k_y = c99_l_a * c99_k_b;
  c99_u_x = c99_alpha_prev[2];
  c99_m_a = c99_u_x;
  c99_v_x = c99_m_a;
  c99_m_a = c99_v_x;
  c99_m_a = muDoubleScalarCos(c99_m_a);
  c99_l_b = c99_lx[2];
  c99_l_y = c99_m_a * c99_l_b;
  c99_m_b = c99_l_y + c99_k_y;
  c99_m_y = c99_k_a * c99_m_b;
  c99_w_x = c99_alpha_prev[2];
  c99_n_a = c99_w_x;
  c99_x_x = c99_n_a;
  c99_n_a = c99_x_x;
  c99_n_a = muDoubleScalarCos(c99_n_a);
  c99_n_b = c99_T_prev[2];
  c99_n_y = c99_n_a * c99_n_b;
  c99_y_x = c99_alpha_prev[2];
  c99_ab_x = c99_y_x;
  c99_bb_x = c99_ab_x;
  c99_ab_x = c99_bb_x;
  c99_ab_x = muDoubleScalarSin(c99_ab_x);
  c99_o_a = -c99_ab_x;
  c99_o_b = c99_T_prev[2];
  c99_o_y = c99_o_a * c99_o_b;
  c99_B_JacobianColum3[0] = c99_o_y;
  c99_B_JacobianColum3[1] = c99_n_y;
  c99_B_JacobianColum3[2] = c99_m_y;
  _SFD_EML_CALL(0,18);
  for (c99_i11 = 0; c99_i11 < 3; c99_i11 = c99_i11 + 1) {
    c99_B_Jacobian[c99_i11] = c99_B_JacobianColum1[c99_i11];
  }

  for (c99_i12 = 0; c99_i12 < 3; c99_i12 = c99_i12 + 1) {
    c99_B_Jacobian[c99_i12 + 3] = c99_B_JacobianColum2[c99_i12];
  }

  for (c99_i13 = 0; c99_i13 < 3; c99_i13 = c99_i13 + 1) {
    c99_B_Jacobian[c99_i13 + 6] = c99_B_JacobianColum3[c99_i13];
  }

  _SFD_EML_CALL(0,-18);
  sf_debug_symbol_scope_pop();
  for (c99_i14 = 0; c99_i14 < 9; c99_i14 = c99_i14 + 1) {
    (*c99_b_B_Jacobian)[c99_i14] = c99_B_Jacobian[c99_i14];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,98);
  _sfEvent_ = c99_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c99_machineNumber, uint32_T
  c99_chartNumber)
{
}

static const mxArray *c99_sf_marshall(void *c99_chartInstance, void *c99_u)
{
  const mxArray *c99_y = NULL;
  int32_T c99_i15;
  real_T c99_b_u[3];
  const mxArray *c99_b_y = NULL;
  c99_y = NULL;
  for (c99_i15 = 0; c99_i15 < 3; c99_i15 = c99_i15 + 1) {
    c99_b_u[c99_i15] = (*((real_T (*)[3])c99_u))[c99_i15];
  }

  c99_b_y = NULL;
  sf_mex_assign(&c99_b_y, sf_mex_create("y", &c99_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c99_y, c99_b_y);
  return c99_y;
}

static const mxArray *c99_b_sf_marshall(void *c99_chartInstance, void *c99_u)
{
  const mxArray *c99_y = NULL;
  int32_T c99_i16;
  int32_T c99_i17;
  int32_T c99_i18;
  real_T c99_b_u[9];
  const mxArray *c99_b_y = NULL;
  c99_y = NULL;
  c99_i16 = 0;
  for (c99_i17 = 0; c99_i17 < 3; c99_i17 = c99_i17 + 1) {
    for (c99_i18 = 0; c99_i18 < 3; c99_i18 = c99_i18 + 1) {
      c99_b_u[c99_i18 + c99_i16] = (*((real_T (*)[9])c99_u))[c99_i18 + c99_i16];
    }

    c99_i16 = c99_i16 + 3;
  }

  c99_b_y = NULL;
  sf_mex_assign(&c99_b_y, sf_mex_create("y", &c99_b_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_assign(&c99_y, c99_b_y);
  return c99_y;
}

static const mxArray *c99_c_sf_marshall(void *c99_chartInstance, void *c99_u)
{
  const mxArray *c99_y = NULL;
  real_T c99_b_u;
  const mxArray *c99_b_y = NULL;
  c99_y = NULL;
  c99_b_u = *((real_T *)c99_u);
  c99_b_y = NULL;
  sf_mex_assign(&c99_b_y, sf_mex_create("y", &c99_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c99_y, c99_b_y);
  return c99_y;
}

const mxArray *sf_c99_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c99_nameCaptureInfo = NULL;
  c99_ResolvedFunctionInfo c99_info[18];
  const mxArray *c99_m0 = NULL;
  int32_T c99_i19;
  c99_ResolvedFunctionInfo *c99_r0;
  c99_nameCaptureInfo = NULL;
  c99_info_helper(c99_info);
  sf_mex_assign(&c99_m0, sf_mex_createstruct("nameCaptureInfo", 1, 18));
  for (c99_i19 = 0; c99_i19 < 18; c99_i19 = c99_i19 + 1) {
    c99_r0 = &c99_info[c99_i19];
    sf_mex_addfield(c99_m0, sf_mex_create("nameCaptureInfo", c99_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c99_r0->context)), "context"
                    , "nameCaptureInfo", c99_i19);
    sf_mex_addfield(c99_m0, sf_mex_create("nameCaptureInfo", c99_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c99_r0->name)), "name",
                    "nameCaptureInfo", c99_i19);
    sf_mex_addfield(c99_m0, sf_mex_create("nameCaptureInfo",
      c99_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c99_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c99_i19);
    sf_mex_addfield(c99_m0, sf_mex_create("nameCaptureInfo", c99_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c99_r0->resolved)),
                    "resolved", "nameCaptureInfo", c99_i19);
    sf_mex_addfield(c99_m0, sf_mex_create("nameCaptureInfo", &c99_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c99_i19);
    sf_mex_addfield(c99_m0, sf_mex_create("nameCaptureInfo", &c99_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c99_i19);
    sf_mex_addfield(c99_m0, sf_mex_create("nameCaptureInfo", &c99_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c99_i19);
  }

  sf_mex_assign(&c99_nameCaptureInfo, c99_m0);
  return c99_nameCaptureInfo;
}

static void c99_info_helper(c99_ResolvedFunctionInfo c99_info[18])
{
  c99_info[0].context = "";
  c99_info[0].name = "sin";
  c99_info[0].dominantType = "double";
  c99_info[0].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c99_info[0].fileLength = 324U;
  c99_info[0].fileTime1 = 1203448042U;
  c99_info[0].fileTime2 = 0U;
  c99_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c99_info[1].name = "nargin";
  c99_info[1].dominantType = "";
  c99_info[1].resolved = "[B]nargin";
  c99_info[1].fileLength = 0U;
  c99_info[1].fileTime1 = 0U;
  c99_info[1].fileTime2 = 0U;
  c99_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c99_info[2].name = "gt";
  c99_info[2].dominantType = "double";
  c99_info[2].resolved = "[B]gt";
  c99_info[2].fileLength = 0U;
  c99_info[2].fileTime1 = 0U;
  c99_info[2].fileTime2 = 0U;
  c99_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c99_info[3].name = "isa";
  c99_info[3].dominantType = "double";
  c99_info[3].resolved = "[B]isa";
  c99_info[3].fileLength = 0U;
  c99_info[3].fileTime1 = 0U;
  c99_info[3].fileTime2 = 0U;
  c99_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c99_info[4].name = "eml_scalar_sin";
  c99_info[4].dominantType = "double";
  c99_info[4].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c99_info[4].fileLength = 601U;
  c99_info[4].fileTime1 = 1209330792U;
  c99_info[4].fileTime2 = 0U;
  c99_info[5].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c99_info[5].name = "isreal";
  c99_info[5].dominantType = "double";
  c99_info[5].resolved = "[B]isreal";
  c99_info[5].fileLength = 0U;
  c99_info[5].fileTime1 = 0U;
  c99_info[5].fileTime2 = 0U;
  c99_info[6].context = "";
  c99_info[6].name = "uminus";
  c99_info[6].dominantType = "double";
  c99_info[6].resolved = "[B]uminus";
  c99_info[6].fileLength = 0U;
  c99_info[6].fileTime1 = 0U;
  c99_info[6].fileTime2 = 0U;
  c99_info[7].context = "";
  c99_info[7].name = "mtimes";
  c99_info[7].dominantType = "double";
  c99_info[7].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c99_info[7].fileLength = 2408U;
  c99_info[7].fileTime1 = 1227613402U;
  c99_info[7].fileTime2 = 0U;
  c99_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c99_info[8].name = "isinteger";
  c99_info[8].dominantType = "double";
  c99_info[8].resolved = "[B]isinteger";
  c99_info[8].fileLength = 0U;
  c99_info[8].fileTime1 = 0U;
  c99_info[8].fileTime2 = 0U;
  c99_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c99_info[9].name = "isscalar";
  c99_info[9].dominantType = "double";
  c99_info[9].resolved = "[B]isscalar";
  c99_info[9].fileLength = 0U;
  c99_info[9].fileTime1 = 0U;
  c99_info[9].fileTime2 = 0U;
  c99_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c99_info[10].name = "strcmp";
  c99_info[10].dominantType = "char";
  c99_info[10].resolved = "[B]strcmp";
  c99_info[10].fileLength = 0U;
  c99_info[10].fileTime1 = 0U;
  c99_info[10].fileTime2 = 0U;
  c99_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c99_info[11].name = "size";
  c99_info[11].dominantType = "double";
  c99_info[11].resolved = "[B]size";
  c99_info[11].fileLength = 0U;
  c99_info[11].fileTime1 = 0U;
  c99_info[11].fileTime2 = 0U;
  c99_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c99_info[12].name = "eq";
  c99_info[12].dominantType = "double";
  c99_info[12].resolved = "[B]eq";
  c99_info[12].fileLength = 0U;
  c99_info[12].fileTime1 = 0U;
  c99_info[12].fileTime2 = 0U;
  c99_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c99_info[13].name = "class";
  c99_info[13].dominantType = "double";
  c99_info[13].resolved = "[B]class";
  c99_info[13].fileLength = 0U;
  c99_info[13].fileTime1 = 0U;
  c99_info[13].fileTime2 = 0U;
  c99_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c99_info[14].name = "not";
  c99_info[14].dominantType = "logical";
  c99_info[14].resolved = "[B]not";
  c99_info[14].fileLength = 0U;
  c99_info[14].fileTime1 = 0U;
  c99_info[14].fileTime2 = 0U;
  c99_info[15].context = "";
  c99_info[15].name = "cos";
  c99_info[15].dominantType = "double";
  c99_info[15].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c99_info[15].fileLength = 324U;
  c99_info[15].fileTime1 = 1203447952U;
  c99_info[15].fileTime2 = 0U;
  c99_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c99_info[16].name = "eml_scalar_cos";
  c99_info[16].dominantType = "double";
  c99_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c99_info[16].fileLength = 602U;
  c99_info[16].fileTime1 = 1209330788U;
  c99_info[16].fileTime2 = 0U;
  c99_info[17].context = "";
  c99_info[17].name = "plus";
  c99_info[17].dominantType = "double";
  c99_info[17].resolved = "[B]plus";
  c99_info[17].fileLength = 0U;
  c99_info[17].fileTime1 = 0U;
  c99_info[17].fileTime2 = 0U;
}

static const mxArray *c99_emlrt_marshallOut(uint8_T c99_u)
{
  const mxArray *c99_y = NULL;
  c99_y = NULL;
  sf_mex_assign(&c99_y, sf_mex_create("y", &c99_u, 3, 0U, 0U, 0U, 0));
  return c99_y;
}

static void c99_emlrt_marshallIn(const mxArray *c99_B_Jacobian, char *c99_name,
  real_T c99_y[9])
{
  real_T c99_dv1[9];
  int32_T c99_i20;
  sf_mex_import(c99_name, sf_mex_dup(c99_B_Jacobian), &c99_dv1, 1, 0, 0U, 1, 0U,
                2, 3, 3);
  for (c99_i20 = 0; c99_i20 < 9; c99_i20 = c99_i20 + 1) {
    c99_y[c99_i20] = c99_dv1[c99_i20];
  }

  sf_mex_destroy(&c99_B_Jacobian);
}

static uint8_T c99_b_emlrt_marshallIn(const mxArray *c99_b_is_active_c99_MCSim,
  char *c99_name)
{
  uint8_T c99_y;
  uint8_T c99_u0;
  sf_mex_import(c99_name, sf_mex_dup(c99_b_is_active_c99_MCSim), &c99_u0, 1, 3,
                0U, 0, 0U, 0);
  c99_y = c99_u0;
  sf_mex_destroy(&c99_b_is_active_c99_MCSim);
  return c99_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c99_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(486219162U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3585853849U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1225221214U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(812309947U);
}

mxArray *sf_c99_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1765131492U);
    pr[1] = (double)(3036214172U);
    pr[2] = (double)(199921450U);
    pr[3] = (double)(1531016512U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c99_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"B_Jacobian\",},{M[8],M[0],T\"is_active_c99_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c99_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          99,
          1,
          1,
          5,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"T_prev",0,c99_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"B_Jacobian",0,c99_b_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"alpha_prev",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"ly",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"lx",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,965);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c99_T_prev)[3];
          real_T (*c99_B_Jacobian)[9];
          real_T (*c99_alpha_prev)[3];
          real_T (*c99_ly)[3];
          real_T (*c99_lx)[3];
          c99_B_Jacobian = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S,
            1);
          c99_T_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
          c99_lx = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
          c99_ly = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
          c99_alpha_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S,
            1);
          _SFD_SET_DATA_VALUE_PTR(0U, c99_T_prev);
          _SFD_SET_DATA_VALUE_PTR(1U, c99_B_Jacobian);
          _SFD_SET_DATA_VALUE_PTR(2U, c99_alpha_prev);
          _SFD_SET_DATA_VALUE_PTR(3U, c99_ly);
          _SFD_SET_DATA_VALUE_PTR(4U, c99_lx);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c99_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c99_MCSim();
  initialize_c99_MCSim();
}

static void sf_opaque_enable_c99_MCSim(void *chartInstanceVar)
{
  enable_c99_MCSim();
}

static void sf_opaque_disable_c99_MCSim(void *chartInstanceVar)
{
  disable_c99_MCSim();
}

static void sf_opaque_gateway_c99_MCSim(void *chartInstanceVar)
{
  sf_c99_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c99_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c99_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c99_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c99_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c99_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c99_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c99_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c99_MCSim();
  }
}

static void mdlSetWorkWidths_c99_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",99);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",99,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",99,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",99,4);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",99,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",99);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1500778150U));
  ssSetChecksum1(S,(3987663509U));
  ssSetChecksum2(S,(742795059U));
  ssSetChecksum3(S,(2924241129U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c99_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",99);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c99_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c99_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c99_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c99_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c99_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c99_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c99_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c99_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c99_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c99_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c99_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c99_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c99_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c99_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c99_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c99_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c99_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
