% Sensor data

% GPS
Par.Sensor.GPS.Amp_multipath  		= 0.5;          % Amplitude of white noise in GPS positon [x,y], 
                                                % from multipath measurement effects
Par.Sensor.GPS.Amp_thermal 			= 0.2;        % Amplitude of white noise in GPS positon [x,y], 
                                                % from thermal effects 
Par.Sensor.GPS.Bias_residentual		= 0.2;        % Bias measurement noise for GPS postion [x,y], 
                                                % from residentual/atmosphere effects
Par.Sensor.GPS.Markow_Time_c 		= 100;        % Time constant in Markow model for GPS, in seconds

Par.Sensor.GPS.Sample_time			= 1;


% Compass/heading
Par.Sensor.Compass.Amp				= 0.5;         % Amplitude of white noise in compass measurement, in degrees
Par.Sensor.Compass.Bias				= 0.2;         % Bias in compass measurement, in degrees
Par.Sensor.Compass.Markow_Time_c	= 2000;        % Time constant in Markow model for Compass, in seconds
Par.Sensor.Compass.Sample_time		= 1;