/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c101_MCSim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c101_IN_NO_ACTIVE_CHILD        (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc101_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c101_MCSim(void);
static void initialize_params_c101_MCSim(void);
static void enable_c101_MCSim(void);
static void disable_c101_MCSim(void);
static void c101_update_debugger_state_c101_MCSim(void);
static const mxArray *get_sim_state_c101_MCSim(void);
static void set_sim_state_c101_MCSim(const mxArray *c101_st);
static void finalize_c101_MCSim(void);
static void sf_c101_MCSim(void);
static void init_script_number_translation(uint32_T c101_machineNumber, uint32_T
  c101_chartNumber);
static void c101_eml_error(void);
static const mxArray *c101_sf_marshall(void *c101_chartInstance, void *c101_u);
static const mxArray *c101_b_sf_marshall(void *c101_chartInstance, void *c101_u);
static const mxArray *c101_c_sf_marshall(void *c101_chartInstance, void *c101_u);
static void c101_info_helper(c101_ResolvedFunctionInfo c101_info[36]);
static const mxArray *c101_emlrt_marshallOut(uint8_T c101_u);
static void c101_emlrt_marshallIn(const mxArray *c101_g_delta_thrust, char
  *c101_name, real_T c101_y[3]);
static uint8_T c101_b_emlrt_marshallIn(const mxArray
  *c101_b_is_active_c101_MCSim, char *c101_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c101_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c101_is_active_c101_MCSim = 0U;
}

static void initialize_params_c101_MCSim(void)
{
}

static void enable_c101_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c101_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c101_update_debugger_state_c101_MCSim(void)
{
}

static const mxArray *get_sim_state_c101_MCSim(void)
{
  const mxArray *c101_st = NULL;
  const mxArray *c101_y = NULL;
  int32_T c101_i0;
  real_T c101_u[3];
  const mxArray *c101_b_y = NULL;
  real_T (*c101_g_delta_thrust)[3];
  c101_g_delta_thrust = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 1);
  c101_st = NULL;
  c101_y = NULL;
  sf_mex_assign(&c101_y, sf_mex_createcellarray(2));
  for (c101_i0 = 0; c101_i0 < 3; c101_i0 = c101_i0 + 1) {
    c101_u[c101_i0] = (*c101_g_delta_thrust)[c101_i0];
  }

  c101_b_y = NULL;
  sf_mex_assign(&c101_b_y, sf_mex_create("y", &c101_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_setcell(c101_y, 0, c101_b_y);
  sf_mex_setcell(c101_y, 1, c101_emlrt_marshallOut
                 (chartInstance.c101_is_active_c101_MCSim));
  sf_mex_assign(&c101_st, c101_y);
  return c101_st;
}

static void set_sim_state_c101_MCSim(const mxArray *c101_st)
{
  const mxArray *c101_u;
  real_T c101_dv0[3];
  int32_T c101_i1;
  real_T (*c101_g_delta_thrust)[3];
  c101_g_delta_thrust = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c101_doneDoubleBufferReInit = true;
  c101_u = sf_mex_dup(c101_st);
  c101_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c101_u, 0)), "g_delta_thrust",
                        c101_dv0);
  for (c101_i1 = 0; c101_i1 < 3; c101_i1 = c101_i1 + 1) {
    (*c101_g_delta_thrust)[c101_i1] = c101_dv0[c101_i1];
  }

  chartInstance.c101_is_active_c101_MCSim = c101_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c101_u, 1)), "is_active_c101_MCSim");
  sf_mex_destroy(&c101_u);
  c101_update_debugger_state_c101_MCSim();
  sf_mex_destroy(&c101_st);
}

static void finalize_c101_MCSim(void)
{
}

static void sf_c101_MCSim(void)
{
  int32_T c101_i2;
  int32_T c101_i3;
  int32_T c101_i4;
  uint8_T c101_previousEvent;
  int32_T c101_i5;
  real_T c101_T_d_prev[3];
  int32_T c101_i6;
  real_T c101_W_u[9];
  real_T c101_nargout = 1.0;
  real_T c101_nargin = 2.0;
  real_T c101_i;
  real_T c101_g_delta_thrust[3];
  int32_T c101_i7;
  real_T c101_b_i;
  real_T c101_x;
  real_T c101_a;
  real_T c101_b_x;
  real_T c101_c_x;
  boolean_T c101_b;
  real_T c101_b_b;
  real_T c101_b_a;
  real_T c101_d_x;
  real_T c101_e_x;
  real_T c101_y;
  real_T c101_f_x;
  real_T c101_c_b;
  real_T c101_g_x;
  real_T c101_b_y;
  int32_T c101_i8;
  real_T (*c101_b_g_delta_thrust)[3];
  real_T (*c101_b_W_u)[9];
  real_T (*c101_b_T_d_prev)[3];
  c101_b_W_u = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 1);
  c101_b_T_d_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c101_b_g_delta_thrust = (real_T (*)[3])ssGetOutputPortSignal(chartInstance.S,
    1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,100);
  for (c101_i2 = 0; c101_i2 < 3; c101_i2 = c101_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c101_b_T_d_prev)[c101_i2], 0U);
  }

  for (c101_i3 = 0; c101_i3 < 9; c101_i3 = c101_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c101_b_W_u)[c101_i3], 1U);
  }

  for (c101_i4 = 0; c101_i4 < 3; c101_i4 = c101_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c101_b_g_delta_thrust)[c101_i4], 2U);
  }

  c101_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,100);
  for (c101_i5 = 0; c101_i5 < 3; c101_i5 = c101_i5 + 1) {
    c101_T_d_prev[c101_i5] = (*c101_b_T_d_prev)[c101_i5];
  }

  for (c101_i6 = 0; c101_i6 < 9; c101_i6 = c101_i6 + 1) {
    c101_W_u[c101_i6] = (*c101_b_W_u)[c101_i6];
  }

  sf_debug_symbol_scope_push(6U, 0U);
  sf_debug_symbol_scope_add("nargout", &c101_nargout, c101_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c101_nargin, c101_c_sf_marshall);
  sf_debug_symbol_scope_add("i", &c101_i, c101_c_sf_marshall);
  sf_debug_symbol_scope_add("g_delta_thrust", &c101_g_delta_thrust,
    c101_sf_marshall);
  sf_debug_symbol_scope_add("W_u", &c101_W_u, c101_b_sf_marshall);
  sf_debug_symbol_scope_add("T_d_prev", &c101_T_d_prev, c101_sf_marshall);
  CV_EML_FCN(0, 0);

  /*  See equation 5.9 in Eivind Ruth's Phd */
  _SFD_EML_CALL(0,4);
  for (c101_i7 = 0; c101_i7 < 3; c101_i7 = c101_i7 + 1) {
    c101_g_delta_thrust[c101_i7] = 0.0;
  }

  c101_i = 1.0;
  c101_b_i = 1.0;
  while (c101_b_i <= 3.0) {
    c101_i = c101_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,6);
    c101_x = c101_T_d_prev[_SFD_EML_ARRAY_BOUNDS_CHECK("T_d_prev", (int32_T)
      _SFD_INTEGER_CHECK("i", c101_i), 1, 3, 1, 0) - 1];
    c101_a = c101_x;
    c101_b_x = c101_a;
    c101_a = c101_b_x;
    c101_c_x = c101_a;
    c101_b = rtIsNaN(c101_c_x);
    if (c101_b) {
      c101_a = rtNaN;
    } else if (c101_a > 0.0) {
      c101_a = 1.0;
    } else if (c101_a < 0.0) {
      c101_a = -1.0;
    } else {
      c101_a = 0.0;
    }

    c101_b_b = c101_W_u[(_SFD_EML_ARRAY_BOUNDS_CHECK("W_u", (int32_T)
      _SFD_INTEGER_CHECK("i", c101_i), 1, 3, 1, 0) - 1) + 3 * (
      _SFD_EML_ARRAY_BOUNDS_CHECK("W_u", (int32_T)_SFD_INTEGER_CHECK("i", c101_i),
      1, 3, 2, 0) - 1)];
    c101_b_a = c101_a * c101_b_b;
    c101_d_x = c101_T_d_prev[_SFD_EML_ARRAY_BOUNDS_CHECK("T_d_prev", (int32_T)
      _SFD_INTEGER_CHECK("i", c101_i), 1, 3, 1, 0) - 1];
    c101_e_x = c101_d_x;
    c101_y = muDoubleScalarAbs(c101_e_x);
    c101_f_x = c101_y + 1.0E-006;
    c101_c_b = c101_f_x;
    if (c101_c_b < 0.0) {
      c101_eml_error();
    }

    c101_g_x = c101_c_b;
    c101_c_b = c101_g_x;
    c101_c_b = muDoubleScalarSqrt(c101_c_b);
    c101_b_y = c101_b_a * c101_c_b;
    c101_g_delta_thrust[_SFD_EML_ARRAY_BOUNDS_CHECK("g_delta_thrust", (int32_T)
      _SFD_INTEGER_CHECK("i", c101_i), 1, 3, 1, 0) - 1] =
      c101_b_y;
    c101_b_i = c101_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,-6);
  sf_debug_symbol_scope_pop();
  for (c101_i8 = 0; c101_i8 < 3; c101_i8 = c101_i8 + 1) {
    (*c101_b_g_delta_thrust)[c101_i8] = c101_g_delta_thrust[c101_i8];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,100);
  _sfEvent_ = c101_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c101_machineNumber, uint32_T
  c101_chartNumber)
{
}

static void c101_eml_error(void)
{
  int32_T c101_i9;
  static char_T c101_cv0[77] = { 'D', 'o', 'm', 'a', 'i', 'n', ' ', 'e', 'r',
    'r', 'o', 'r', '.', ' ', 'T', 'o', ' ', 'c', 'o', 'm',
    'p', 'u', 't', 'e', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ', 'r', 'e',
    's', 'u', 'l', 't', 's',
    ' ', 'f', 'r', 'o', 'm', ' ', 'r', 'e', 'a', 'l', ' ', 'x', ',', ' ', 'u',
    's', 'e', ' ', '\'', 's',
    'q', 'r', 't', '(', 'c', 'o', 'm', 'p', 'l', 'e', 'x', '(', 'x', ')', ')',
    '\'', '.' };

  char_T c101_u[77];
  const mxArray *c101_y = NULL;
  int32_T c101_i10;
  static char_T c101_cv1[31] = { 'E', 'm', 'b', 'e', 'd', 'd', 'e', 'd', 'M',
    'A', 'T', 'L', 'A', 'B', ':', 's', 'q', 'r', 't', ':',
    'd', 'o', 'm', 'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c101_b_u[31];
  const mxArray *c101_b_y = NULL;
  for (c101_i9 = 0; c101_i9 < 77; c101_i9 = c101_i9 + 1) {
    c101_u[c101_i9] = c101_cv0[c101_i9];
  }

  c101_y = NULL;
  sf_mex_assign(&c101_y, sf_mex_create("y", &c101_u, 10, 0U, 1U, 0U, 2, 1, 77));
  for (c101_i10 = 0; c101_i10 < 31; c101_i10 = c101_i10 + 1) {
    c101_b_u[c101_i10] = c101_cv1[c101_i10];
  }

  c101_b_y = NULL;
  sf_mex_assign(&c101_b_y, sf_mex_create("y", &c101_b_u, 10, 0U, 1U, 0U, 2, 1,
    31));
  sf_mex_call_debug("error", 0U, 2U, 14, c101_b_y, 14, c101_y);
}

static const mxArray *c101_sf_marshall(void *c101_chartInstance, void *c101_u)
{
  const mxArray *c101_y = NULL;
  int32_T c101_i11;
  real_T c101_b_u[3];
  const mxArray *c101_b_y = NULL;
  c101_y = NULL;
  for (c101_i11 = 0; c101_i11 < 3; c101_i11 = c101_i11 + 1) {
    c101_b_u[c101_i11] = (*((real_T (*)[3])c101_u))[c101_i11];
  }

  c101_b_y = NULL;
  sf_mex_assign(&c101_b_y, sf_mex_create("y", &c101_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c101_y, c101_b_y);
  return c101_y;
}

static const mxArray *c101_b_sf_marshall(void *c101_chartInstance, void *c101_u)
{
  const mxArray *c101_y = NULL;
  int32_T c101_i12;
  int32_T c101_i13;
  int32_T c101_i14;
  real_T c101_b_u[9];
  const mxArray *c101_b_y = NULL;
  c101_y = NULL;
  c101_i12 = 0;
  for (c101_i13 = 0; c101_i13 < 3; c101_i13 = c101_i13 + 1) {
    for (c101_i14 = 0; c101_i14 < 3; c101_i14 = c101_i14 + 1) {
      c101_b_u[c101_i14 + c101_i12] = (*((real_T (*)[9])c101_u))[c101_i14 +
        c101_i12];
    }

    c101_i12 = c101_i12 + 3;
  }

  c101_b_y = NULL;
  sf_mex_assign(&c101_b_y, sf_mex_create("y", &c101_b_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_assign(&c101_y, c101_b_y);
  return c101_y;
}

static const mxArray *c101_c_sf_marshall(void *c101_chartInstance, void *c101_u)
{
  const mxArray *c101_y = NULL;
  real_T c101_b_u;
  const mxArray *c101_b_y = NULL;
  c101_y = NULL;
  c101_b_u = *((real_T *)c101_u);
  c101_b_y = NULL;
  sf_mex_assign(&c101_b_y, sf_mex_create("y", &c101_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c101_y, c101_b_y);
  return c101_y;
}

const mxArray *sf_c101_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c101_nameCaptureInfo = NULL;
  c101_ResolvedFunctionInfo c101_info[36];
  const mxArray *c101_m0 = NULL;
  int32_T c101_i15;
  c101_ResolvedFunctionInfo *c101_r0;
  c101_nameCaptureInfo = NULL;
  c101_info_helper(c101_info);
  sf_mex_assign(&c101_m0, sf_mex_createstruct("nameCaptureInfo", 1, 36));
  for (c101_i15 = 0; c101_i15 < 36; c101_i15 = c101_i15 + 1) {
    c101_r0 = &c101_info[c101_i15];
    sf_mex_addfield(c101_m0, sf_mex_create("nameCaptureInfo", c101_r0->context,
      15, 0U, 0U, 0U, 2, 1, strlen(c101_r0->context)),
                    "context", "nameCaptureInfo", c101_i15);
    sf_mex_addfield(c101_m0, sf_mex_create("nameCaptureInfo", c101_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c101_r0->name)), "name",
                    "nameCaptureInfo", c101_i15);
    sf_mex_addfield(c101_m0, sf_mex_create("nameCaptureInfo",
      c101_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c101_r0->dominantType)
      ), "dominantType", "nameCaptureInfo", c101_i15);
    sf_mex_addfield(c101_m0, sf_mex_create("nameCaptureInfo", c101_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c101_r0->resolved)),
                    "resolved", "nameCaptureInfo", c101_i15);
    sf_mex_addfield(c101_m0, sf_mex_create("nameCaptureInfo",
      &c101_r0->fileLength, 7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c101_i15);
    sf_mex_addfield(c101_m0, sf_mex_create("nameCaptureInfo",
      &c101_r0->fileTime1, 7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c101_i15);
    sf_mex_addfield(c101_m0, sf_mex_create("nameCaptureInfo",
      &c101_r0->fileTime2, 7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c101_i15);
  }

  sf_mex_assign(&c101_nameCaptureInfo, c101_m0);
  return c101_nameCaptureInfo;
}

static void c101_info_helper(c101_ResolvedFunctionInfo c101_info[36])
{
  c101_info[0].context = "";
  c101_info[0].name = "zeros";
  c101_info[0].dominantType = "double";
  c101_info[0].resolved = "[B]zeros";
  c101_info[0].fileLength = 0U;
  c101_info[0].fileTime1 = 0U;
  c101_info[0].fileTime2 = 0U;
  c101_info[1].context = "";
  c101_info[1].name = "sign";
  c101_info[1].dominantType = "double";
  c101_info[1].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c101_info[1].fileLength = 408U;
  c101_info[1].fileTime1 = 1203448042U;
  c101_info[1].fileTime2 = 0U;
  c101_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c101_info[2].name = "nargin";
  c101_info[2].dominantType = "";
  c101_info[2].resolved = "[B]nargin";
  c101_info[2].fileLength = 0U;
  c101_info[2].fileTime1 = 0U;
  c101_info[2].fileTime2 = 0U;
  c101_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c101_info[3].name = "eq";
  c101_info[3].dominantType = "double";
  c101_info[3].resolved = "[B]eq";
  c101_info[3].fileLength = 0U;
  c101_info[3].fileTime1 = 0U;
  c101_info[3].fileTime2 = 0U;
  c101_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c101_info[4].name = "isa";
  c101_info[4].dominantType = "double";
  c101_info[4].resolved = "[B]isa";
  c101_info[4].fileLength = 0U;
  c101_info[4].fileTime1 = 0U;
  c101_info[4].fileTime2 = 0U;
  c101_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c101_info[5].name = "isreal";
  c101_info[5].dominantType = "double";
  c101_info[5].resolved = "[B]isreal";
  c101_info[5].fileLength = 0U;
  c101_info[5].fileTime1 = 0U;
  c101_info[5].fileTime2 = 0U;
  c101_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c101_info[6].name = "eml_scalar_sign";
  c101_info[6].dominantType = "double";
  c101_info[6].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c101_info[6].fileLength = 543U;
  c101_info[6].fileTime1 = 1203448012U;
  c101_info[6].fileTime2 = 0U;
  c101_info[7].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c101_info[7].name = "isnan";
  c101_info[7].dominantType = "double";
  c101_info[7].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c101_info[7].fileLength = 506U;
  c101_info[7].fileTime1 = 1227613388U;
  c101_info[7].fileTime2 = 0U;
  c101_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c101_info[8].name = "gt";
  c101_info[8].dominantType = "double";
  c101_info[8].resolved = "[B]gt";
  c101_info[8].fileLength = 0U;
  c101_info[8].fileTime1 = 0U;
  c101_info[8].fileTime2 = 0U;
  c101_info[9].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c101_info[9].name = "class";
  c101_info[9].dominantType = "double";
  c101_info[9].resolved = "[B]class";
  c101_info[9].fileLength = 0U;
  c101_info[9].fileTime1 = 0U;
  c101_info[9].fileTime2 = 0U;
  c101_info[10].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c101_info[10].name = "eml_guarded_nan";
  c101_info[10].dominantType = "char";
  c101_info[10].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c101_info[10].fileLength = 485U;
  c101_info[10].fileTime1 = 1192466780U;
  c101_info[10].fileTime2 = 0U;
  c101_info[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c101_info[11].name = "eml_is_float_class";
  c101_info[11].dominantType = "char";
  c101_info[11].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c101_info[11].fileLength = 226U;
  c101_info[11].fileTime1 = 1197850442U;
  c101_info[11].fileTime2 = 0U;
  c101_info[12].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c101_info[12].name = "ischar";
  c101_info[12].dominantType = "char";
  c101_info[12].resolved = "[B]ischar";
  c101_info[12].fileLength = 0U;
  c101_info[12].fileTime1 = 0U;
  c101_info[12].fileTime2 = 0U;
  c101_info[13].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c101_info[13].name = "strcmp";
  c101_info[13].dominantType = "char";
  c101_info[13].resolved = "[B]strcmp";
  c101_info[13].fileLength = 0U;
  c101_info[13].fileTime1 = 0U;
  c101_info[13].fileTime2 = 0U;
  c101_info[14].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c101_info[14].name = "nan";
  c101_info[14].dominantType = "char";
  c101_info[14].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/nan.m";
  c101_info[14].fileLength = 474U;
  c101_info[14].fileTime1 = 1192466744U;
  c101_info[14].fileTime2 = 0U;
  c101_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/nan.m";
  c101_info[15].name = "minus";
  c101_info[15].dominantType = "double";
  c101_info[15].resolved = "[B]minus";
  c101_info[15].fileLength = 0U;
  c101_info[15].fileTime1 = 0U;
  c101_info[15].fileTime2 = 0U;
  c101_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/nan.m";
  c101_info[16].name = "eml_varargin_to_size";
  c101_info[16].dominantType = "";
  c101_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_varargin_to_size.m";
  c101_info[16].fileLength = 630U;
  c101_info[16].fileTime1 = 1209330844U;
  c101_info[16].fileTime2 = 0U;
  c101_info[17].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_varargin_to_size.m";
  c101_info[17].name = "eml_assert_valid_size_arg";
  c101_info[17].dominantType = "";
  c101_info[17].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c101_info[17].fileLength = 3237U;
  c101_info[17].fileTime1 = 1227613384U;
  c101_info[17].fileTime2 = 0U;
  c101_info[18].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/nan.m";
  c101_info[18].name = "cast";
  c101_info[18].dominantType = "double";
  c101_info[18].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c101_info[18].fileLength = 889U;
  c101_info[18].fileTime1 = 1225989442U;
  c101_info[18].fileTime2 = 0U;
  c101_info[19].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c101_info[19].name = "ge";
  c101_info[19].dominantType = "double";
  c101_info[19].resolved = "[B]ge";
  c101_info[19].fileLength = 0U;
  c101_info[19].fileTime1 = 0U;
  c101_info[19].fileTime2 = 0U;
  c101_info[20].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c101_info[20].name = "double";
  c101_info[20].dominantType = "double";
  c101_info[20].resolved = "[B]double";
  c101_info[20].fileLength = 0U;
  c101_info[20].fileTime1 = 0U;
  c101_info[20].fileTime2 = 0U;
  c101_info[21].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c101_info[21].name = "ones";
  c101_info[21].dominantType = "char";
  c101_info[21].resolved = "[B]ones";
  c101_info[21].fileLength = 0U;
  c101_info[21].fileTime1 = 0U;
  c101_info[21].fileTime2 = 0U;
  c101_info[22].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c101_info[22].name = "lt";
  c101_info[22].dominantType = "double";
  c101_info[22].resolved = "[B]lt";
  c101_info[22].fileLength = 0U;
  c101_info[22].fileTime1 = 0U;
  c101_info[22].fileTime2 = 0U;
  c101_info[23].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c101_info[23].name = "uminus";
  c101_info[23].dominantType = "double";
  c101_info[23].resolved = "[B]uminus";
  c101_info[23].fileLength = 0U;
  c101_info[23].fileTime1 = 0U;
  c101_info[23].fileTime2 = 0U;
  c101_info[24].context = "";
  c101_info[24].name = "mtimes";
  c101_info[24].dominantType = "double";
  c101_info[24].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c101_info[24].fileLength = 2408U;
  c101_info[24].fileTime1 = 1227613402U;
  c101_info[24].fileTime2 = 0U;
  c101_info[25].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c101_info[25].name = "isinteger";
  c101_info[25].dominantType = "double";
  c101_info[25].resolved = "[B]isinteger";
  c101_info[25].fileLength = 0U;
  c101_info[25].fileTime1 = 0U;
  c101_info[25].fileTime2 = 0U;
  c101_info[26].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c101_info[26].name = "isscalar";
  c101_info[26].dominantType = "double";
  c101_info[26].resolved = "[B]isscalar";
  c101_info[26].fileLength = 0U;
  c101_info[26].fileTime1 = 0U;
  c101_info[26].fileTime2 = 0U;
  c101_info[27].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c101_info[27].name = "size";
  c101_info[27].dominantType = "double";
  c101_info[27].resolved = "[B]size";
  c101_info[27].fileLength = 0U;
  c101_info[27].fileTime1 = 0U;
  c101_info[27].fileTime2 = 0U;
  c101_info[28].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c101_info[28].name = "not";
  c101_info[28].dominantType = "logical";
  c101_info[28].resolved = "[B]not";
  c101_info[28].fileLength = 0U;
  c101_info[28].fileTime1 = 0U;
  c101_info[28].fileTime2 = 0U;
  c101_info[29].context = "";
  c101_info[29].name = "abs";
  c101_info[29].dominantType = "double";
  c101_info[29].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c101_info[29].fileLength = 566U;
  c101_info[29].fileTime1 = 1221267134U;
  c101_info[29].fileTime2 = 0U;
  c101_info[30].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c101_info[30].name = "islogical";
  c101_info[30].dominantType = "double";
  c101_info[30].resolved = "[B]islogical";
  c101_info[30].fileLength = 0U;
  c101_info[30].fileTime1 = 0U;
  c101_info[30].fileTime2 = 0U;
  c101_info[31].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c101_info[31].name = "eml_scalar_abs";
  c101_info[31].dominantType = "double";
  c101_info[31].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c101_info[31].fileLength = 461U;
  c101_info[31].fileTime1 = 1203447960U;
  c101_info[31].fileTime2 = 0U;
  c101_info[32].context = "";
  c101_info[32].name = "plus";
  c101_info[32].dominantType = "double";
  c101_info[32].resolved = "[B]plus";
  c101_info[32].fileLength = 0U;
  c101_info[32].fileTime1 = 0U;
  c101_info[32].fileTime2 = 0U;
  c101_info[33].context = "";
  c101_info[33].name = "sqrt";
  c101_info[33].dominantType = "double";
  c101_info[33].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c101_info[33].fileLength = 572U;
  c101_info[33].fileTime1 = 1203448046U;
  c101_info[33].fileTime2 = 0U;
  c101_info[34].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c101_info[34].name = "eml_error";
  c101_info[34].dominantType = "char";
  c101_info[34].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c101_info[34].fileLength = 315U;
  c101_info[34].fileTime1 = 1213926746U;
  c101_info[34].fileTime2 = 0U;
  c101_info[35].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c101_info[35].name = "eml_scalar_sqrt";
  c101_info[35].dominantType = "double";
  c101_info[35].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  c101_info[35].fileLength = 664U;
  c101_info[35].fileTime1 = 1209330794U;
  c101_info[35].fileTime2 = 0U;
}

static const mxArray *c101_emlrt_marshallOut(uint8_T c101_u)
{
  const mxArray *c101_y = NULL;
  c101_y = NULL;
  sf_mex_assign(&c101_y, sf_mex_create("y", &c101_u, 3, 0U, 0U, 0U, 0));
  return c101_y;
}

static void c101_emlrt_marshallIn(const mxArray *c101_g_delta_thrust, char
  *c101_name, real_T c101_y[3])
{
  real_T c101_dv1[3];
  int32_T c101_i16;
  sf_mex_import(c101_name, sf_mex_dup(c101_g_delta_thrust), &c101_dv1, 1, 0, 0U,
                1, 0U, 1, 3);
  for (c101_i16 = 0; c101_i16 < 3; c101_i16 = c101_i16 + 1) {
    c101_y[c101_i16] = c101_dv1[c101_i16];
  }

  sf_mex_destroy(&c101_g_delta_thrust);
}

static uint8_T c101_b_emlrt_marshallIn(const mxArray
  *c101_b_is_active_c101_MCSim, char *c101_name)
{
  uint8_T c101_y;
  uint8_T c101_u0;
  sf_mex_import(c101_name, sf_mex_dup(c101_b_is_active_c101_MCSim), &c101_u0, 1,
                3, 0U, 0, 0U, 0);
  c101_y = c101_u0;
  sf_mex_destroy(&c101_b_is_active_c101_MCSim);
  return c101_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c101_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(927872470U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2994584063U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(864185172U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1353075312U);
}

mxArray *sf_c101_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3518108716U);
    pr[1] = (double)(2707765546U);
    pr[2] = (double)(3978222200U);
    pr[3] = (double)(3686967090U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c101_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"g_delta_thrust\",},{M[8],M[0],T\"is_active_c101_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c101_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          101,
          1,
          1,
          3,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"T_d_prev",0,c101_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"W_u",0,c101_b_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"g_delta_thrust",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,1,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,235);
        _SFD_CV_INIT_EML_FOR(0,0,129,141,230);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c101_T_d_prev)[3];
          real_T (*c101_W_u)[9];
          real_T (*c101_g_delta_thrust)[3];
          c101_W_u = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 1);
          c101_T_d_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
          c101_g_delta_thrust = (real_T (*)[3])ssGetOutputPortSignal
            (chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c101_T_d_prev);
          _SFD_SET_DATA_VALUE_PTR(1U, c101_W_u);
          _SFD_SET_DATA_VALUE_PTR(2U, c101_g_delta_thrust);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c101_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c101_MCSim();
  initialize_c101_MCSim();
}

static void sf_opaque_enable_c101_MCSim(void *chartInstanceVar)
{
  enable_c101_MCSim();
}

static void sf_opaque_disable_c101_MCSim(void *chartInstanceVar)
{
  disable_c101_MCSim();
}

static void sf_opaque_gateway_c101_MCSim(void *chartInstanceVar)
{
  sf_c101_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c101_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c101_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c101_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c101_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c101_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c101_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c101_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c101_MCSim();
  }
}

static void mdlSetWorkWidths_c101_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",101);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",101,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",101,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",101,2);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",101,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",101);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3539119047U));
  ssSetChecksum1(S,(1261642301U));
  ssSetChecksum2(S,(2369881147U));
  ssSetChecksum3(S,(2106268170U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c101_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",101);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c101_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c101_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c101_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c101_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c101_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c101_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c101_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c101_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c101_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c101_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c101_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c101_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c101_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c101_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c101_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c101_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c101_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
