/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c154_MCSim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c154_IN_NO_ACTIVE_CHILD        (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc154_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c154_MCSim(void);
static void initialize_params_c154_MCSim(void);
static void enable_c154_MCSim(void);
static void disable_c154_MCSim(void);
static void c154_update_debugger_state_c154_MCSim(void);
static const mxArray *get_sim_state_c154_MCSim(void);
static void set_sim_state_c154_MCSim(const mxArray *c154_st);
static void finalize_c154_MCSim(void);
static void sf_c154_MCSim(void);
static void c154_c154_MCSim(void);
static void init_script_number_translation(uint32_T c154_machineNumber, uint32_T
  c154_chartNumber);
static real_T c154_abs(real_T c154_x);
static void c154_sortingFunc(real_T c154_SumSlackVar[18], real_T c154_Sorted[18]);
static real_T c154_mpower(real_T c154_a);
static void c154_eml_error(void);
static const mxArray *c154_sf_marshall(void *c154_chartInstance, void *c154_u);
static const mxArray *c154_b_sf_marshall(void *c154_chartInstance, void *c154_u);
static const mxArray *c154_c_sf_marshall(void *c154_chartInstance, void *c154_u);
static const mxArray *c154_d_sf_marshall(void *c154_chartInstance, void *c154_u);
static const mxArray *c154_e_sf_marshall(void *c154_chartInstance, void *c154_u);
static void c154_info_helper(c154_ResolvedFunctionInfo c154_info[40]);
static const mxArray *c154_emlrt_marshallOut(uint8_T c154_u);
static real_T c154_emlrt_marshallIn(const mxArray *c154_CurrentlyBestSolution,
  char *c154_name);
static void c154_b_emlrt_marshallIn(const mxArray *c154_TotalSectorConsumption,
  char *c154_name, real_T c154_y[9]);
static void c154_c_emlrt_marshallIn(const mxArray *c154_TotalSumofSlackVariables,
  char *c154_name, real_T c154_y[18]);
static uint8_T c154_d_emlrt_marshallIn(const mxArray
  *c154_b_is_active_c154_MCSim, char *c154_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c154_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c154_is_active_c154_MCSim = 0U;
}

static void initialize_params_c154_MCSim(void)
{
}

static void enable_c154_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c154_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c154_update_debugger_state_c154_MCSim(void)
{
}

static const mxArray *get_sim_state_c154_MCSim(void)
{
  const mxArray *c154_st = NULL;
  const mxArray *c154_y = NULL;
  real_T c154_u;
  const mxArray *c154_b_y = NULL;
  int32_T c154_i0;
  real_T c154_b_u[9];
  const mxArray *c154_c_y = NULL;
  int32_T c154_i1;
  real_T c154_c_u[18];
  const mxArray *c154_d_y = NULL;
  real_T *c154_CurrentlyBestSolution;
  real_T (*c154_TotalSumofSlackVariables)[18];
  real_T (*c154_TotalSectorConsumption)[9];
  c154_TotalSumofSlackVariables = (real_T (*)[18])ssGetOutputPortSignal
    (chartInstance.S, 3);
  c154_TotalSectorConsumption = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 2);
  c154_CurrentlyBestSolution = (real_T *)ssGetOutputPortSignal(chartInstance.S,
    1);
  c154_st = NULL;
  c154_y = NULL;
  sf_mex_assign(&c154_y, sf_mex_createcellarray(4));
  c154_u = *c154_CurrentlyBestSolution;
  c154_b_y = NULL;
  sf_mex_assign(&c154_b_y, sf_mex_create("y", &c154_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c154_y, 0, c154_b_y);
  for (c154_i0 = 0; c154_i0 < 9; c154_i0 = c154_i0 + 1) {
    c154_b_u[c154_i0] = (*c154_TotalSectorConsumption)[c154_i0];
  }

  c154_c_y = NULL;
  sf_mex_assign(&c154_c_y, sf_mex_create("y", &c154_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_setcell(c154_y, 1, c154_c_y);
  for (c154_i1 = 0; c154_i1 < 18; c154_i1 = c154_i1 + 1) {
    c154_c_u[c154_i1] = (*c154_TotalSumofSlackVariables)[c154_i1];
  }

  c154_d_y = NULL;
  sf_mex_assign(&c154_d_y, sf_mex_create("y", &c154_c_u, 0, 0U, 1U, 0U, 2, 9, 2));
  sf_mex_setcell(c154_y, 2, c154_d_y);
  sf_mex_setcell(c154_y, 3, c154_emlrt_marshallOut
                 (chartInstance.c154_is_active_c154_MCSim));
  sf_mex_assign(&c154_st, c154_y);
  return c154_st;
}

static void set_sim_state_c154_MCSim(const mxArray *c154_st)
{
  const mxArray *c154_u;
  real_T c154_dv0[9];
  int32_T c154_i2;
  real_T c154_dv1[18];
  int32_T c154_i3;
  real_T *c154_CurrentlyBestSolution;
  real_T (*c154_TotalSectorConsumption)[9];
  real_T (*c154_TotalSumofSlackVariables)[18];
  c154_TotalSumofSlackVariables = (real_T (*)[18])ssGetOutputPortSignal
    (chartInstance.S, 3);
  c154_TotalSectorConsumption = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 2);
  c154_CurrentlyBestSolution = (real_T *)ssGetOutputPortSignal(chartInstance.S,
    1);
  chartInstance.c154_doneDoubleBufferReInit = true;
  c154_u = sf_mex_dup(c154_st);
  *c154_CurrentlyBestSolution = c154_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell
    (c154_u, 0)), "CurrentlyBestSolution");
  c154_b_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c154_u, 1)),
    "TotalSectorConsumption", c154_dv0);
  for (c154_i2 = 0; c154_i2 < 9; c154_i2 = c154_i2 + 1) {
    (*c154_TotalSectorConsumption)[c154_i2] = c154_dv0[c154_i2];
  }

  c154_c_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c154_u, 2)),
    "TotalSumofSlackVariables", c154_dv1);
  for (c154_i3 = 0; c154_i3 < 18; c154_i3 = c154_i3 + 1) {
    (*c154_TotalSumofSlackVariables)[c154_i3] = c154_dv1[c154_i3];
  }

  chartInstance.c154_is_active_c154_MCSim = c154_d_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c154_u, 3)), "is_active_c154_MCSim");
  sf_mex_destroy(&c154_u);
  c154_update_debugger_state_c154_MCSim();
  sf_mex_destroy(&c154_st);
}

static void finalize_c154_MCSim(void)
{
}

static void sf_c154_MCSim(void)
{
  int32_T c154_i4;
  int32_T c154_i5;
  int32_T c154_i6;
  int32_T c154_i7;
  int32_T c154_i8;
  int32_T c154_i9;
  int32_T c154_i10;
  int32_T c154_i11;
  int32_T c154_i12;
  int32_T c154_i13;
  int32_T c154_i14;
  int32_T c154_i15;
  int32_T c154_i16;
  int32_T c154_i17;
  int32_T c154_i18;
  int32_T c154_i19;
  int32_T c154_i20;
  int32_T c154_i21;
  int32_T c154_i22;
  int32_T c154_i23;
  int32_T c154_i24;
  int32_T c154_i25;
  uint8_T c154_previousEvent;
  real_T *c154_CurrentlyBestSolution;
  real_T *c154_Plim;
  real_T *c154_previousBestSolution;
  real_T (*c154_tau_c)[3];
  real_T (*c154_TotalSumofSlackVariables)[18];
  real_T (*c154_TotalSectorConsumption)[9];
  real_T (*c154_powerThrustRelationVec)[3];
  real_T (*c154_s9)[3];
  real_T (*c154_s8)[3];
  real_T (*c154_s7)[3];
  real_T (*c154_s6)[3];
  real_T (*c154_s5)[3];
  real_T (*c154_s4)[3];
  real_T (*c154_s3)[3];
  real_T (*c154_s2)[3];
  real_T (*c154_s1)[3];
  real_T (*c154_Td9)[3];
  real_T (*c154_Td8)[3];
  real_T (*c154_Td7)[3];
  real_T (*c154_Td6)[3];
  real_T (*c154_Td5)[3];
  real_T (*c154_Td4)[3];
  real_T (*c154_Td3)[3];
  real_T (*c154_Td2)[3];
  real_T (*c154_Td1)[3];
  c154_s7 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 15);
  c154_Plim = (real_T *)ssGetInputPortSignal(chartInstance.S, 18);
  c154_s4 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 12);
  c154_Td8 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 7);
  c154_s9 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 17);
  c154_Td4 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
  c154_s1 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 9);
  c154_Td2 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  c154_TotalSumofSlackVariables = (real_T (*)[18])ssGetOutputPortSignal
    (chartInstance.S, 3);
  c154_powerThrustRelationVec = (real_T (*)[3])ssGetInputPortSignal
    (chartInstance.S, 19);
  c154_Td3 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  c154_Td7 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 6);
  c154_s3 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 11);
  c154_TotalSectorConsumption = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 2);
  c154_Td6 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 5);
  c154_Td9 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 8);
  c154_s6 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 14);
  c154_s5 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 13);
  c154_CurrentlyBestSolution = (real_T *)ssGetOutputPortSignal(chartInstance.S,
    1);
  c154_tau_c = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 21);
  c154_Td1 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c154_s2 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 10);
  c154_Td5 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 4);
  c154_previousBestSolution = (real_T *)ssGetInputPortSignal(chartInstance.S, 20);
  c154_s8 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 16);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,153);
  for (c154_i4 = 0; c154_i4 < 3; c154_i4 = c154_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_Td1)[c154_i4], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c154_CurrentlyBestSolution, 1U);
  for (c154_i5 = 0; c154_i5 < 3; c154_i5 = c154_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_Td2)[c154_i5], 2U);
  }

  for (c154_i6 = 0; c154_i6 < 3; c154_i6 = c154_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_Td3)[c154_i6], 3U);
  }

  for (c154_i7 = 0; c154_i7 < 3; c154_i7 = c154_i7 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_Td4)[c154_i7], 4U);
  }

  for (c154_i8 = 0; c154_i8 < 3; c154_i8 = c154_i8 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_Td5)[c154_i8], 5U);
  }

  for (c154_i9 = 0; c154_i9 < 3; c154_i9 = c154_i9 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_Td6)[c154_i9], 6U);
  }

  for (c154_i10 = 0; c154_i10 < 3; c154_i10 = c154_i10 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_Td7)[c154_i10], 7U);
  }

  for (c154_i11 = 0; c154_i11 < 3; c154_i11 = c154_i11 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_Td8)[c154_i11], 8U);
  }

  for (c154_i12 = 0; c154_i12 < 3; c154_i12 = c154_i12 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_Td9)[c154_i12], 9U);
  }

  for (c154_i13 = 0; c154_i13 < 3; c154_i13 = c154_i13 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_s1)[c154_i13], 10U);
  }

  for (c154_i14 = 0; c154_i14 < 3; c154_i14 = c154_i14 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_s2)[c154_i14], 11U);
  }

  for (c154_i15 = 0; c154_i15 < 3; c154_i15 = c154_i15 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_s3)[c154_i15], 12U);
  }

  for (c154_i16 = 0; c154_i16 < 3; c154_i16 = c154_i16 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_s4)[c154_i16], 13U);
  }

  for (c154_i17 = 0; c154_i17 < 3; c154_i17 = c154_i17 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_s5)[c154_i17], 14U);
  }

  for (c154_i18 = 0; c154_i18 < 3; c154_i18 = c154_i18 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_s6)[c154_i18], 15U);
  }

  for (c154_i19 = 0; c154_i19 < 3; c154_i19 = c154_i19 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_s7)[c154_i19], 16U);
  }

  for (c154_i20 = 0; c154_i20 < 3; c154_i20 = c154_i20 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_s8)[c154_i20], 17U);
  }

  for (c154_i21 = 0; c154_i21 < 3; c154_i21 = c154_i21 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_s9)[c154_i21], 18U);
  }

  _SFD_DATA_RANGE_CHECK(*c154_Plim, 19U);
  for (c154_i22 = 0; c154_i22 < 3; c154_i22 = c154_i22 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_powerThrustRelationVec)[c154_i22], 20U);
  }

  _SFD_DATA_RANGE_CHECK(*c154_previousBestSolution, 21U);
  for (c154_i23 = 0; c154_i23 < 9; c154_i23 = c154_i23 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_TotalSectorConsumption)[c154_i23], 22U);
  }

  for (c154_i24 = 0; c154_i24 < 18; c154_i24 = c154_i24 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_TotalSumofSlackVariables)[c154_i24], 23U);
  }

  for (c154_i25 = 0; c154_i25 < 3; c154_i25 = c154_i25 + 1) {
    _SFD_DATA_RANGE_CHECK((*c154_tau_c)[c154_i25], 24U);
  }

  c154_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  c154_c154_MCSim();
  _sfEvent_ = c154_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void c154_c154_MCSim(void)
{
  int32_T c154_i26;
  real_T c154_Td1[3];
  int32_T c154_i27;
  real_T c154_Td2[3];
  int32_T c154_i28;
  real_T c154_Td3[3];
  int32_T c154_i29;
  real_T c154_Td4[3];
  int32_T c154_i30;
  real_T c154_Td5[3];
  int32_T c154_i31;
  real_T c154_Td6[3];
  int32_T c154_i32;
  real_T c154_Td7[3];
  int32_T c154_i33;
  real_T c154_Td8[3];
  int32_T c154_i34;
  real_T c154_Td9[3];
  int32_T c154_i35;
  real_T c154_s1[3];
  int32_T c154_i36;
  real_T c154_s2[3];
  int32_T c154_i37;
  real_T c154_s3[3];
  int32_T c154_i38;
  real_T c154_s4[3];
  int32_T c154_i39;
  real_T c154_s5[3];
  int32_T c154_i40;
  real_T c154_s6[3];
  int32_T c154_i41;
  real_T c154_s7[3];
  int32_T c154_i42;
  real_T c154_s8[3];
  int32_T c154_i43;
  real_T c154_s9[3];
  real_T c154_Plim;
  int32_T c154_i44;
  real_T c154_powerThrustRelationVec[3];
  real_T c154_previousBestSolution;
  int32_T c154_i45;
  real_T c154_tau_c[3];
  real_T c154_nargout = 3.0;
  real_T c154_nargin = 22.0;
  real_T c154_minSlackIndex;
  real_T c154_sumAbsTau_c;
  real_T c154_j;
  real_T c154_i;
  real_T c154_currentSectorSlackVariables;
  real_T c154_TotalSumofSlackVariables[18];
  real_T c154_TotalSectorConsumption[9];
  real_T c154_CurrentlyBestSolution;
  int32_T c154_i46;
  int32_T c154_i47;
  real_T c154_d0;
  static int32_T c154_iv0[2] = { 0, 1 };

  real_T c154_d1;
  real_T c154_d2;
  real_T c154_d3;
  real_T c154_d4;
  real_T c154_d5;
  real_T c154_d6;
  real_T c154_d7;
  real_T c154_d8;
  int32_T c154_i48;
  real_T c154_b_TotalSumofSlackVariables[18];
  real_T c154_dv2[18];
  int32_T c154_i49;
  real_T c154_b_i;
  real_T c154_b_j;
  real_T c154_a;
  real_T c154_b;
  real_T c154_y;
  real_T c154_c_j;
  real_T c154_b_a;
  real_T c154_b_b;
  real_T c154_b_y;
  real_T c154_d_j;
  real_T c154_c_a;
  real_T c154_c_b;
  real_T c154_c_y;
  real_T c154_e_j;
  real_T c154_d_a;
  real_T c154_d_b;
  real_T c154_d_y;
  real_T c154_f_j;
  real_T c154_e_a;
  real_T c154_e_b;
  real_T c154_e_y;
  real_T c154_g_j;
  real_T c154_f_a;
  real_T c154_f_b;
  real_T c154_f_y;
  real_T c154_h_j;
  real_T c154_g_a;
  real_T c154_g_b;
  real_T c154_g_y;
  real_T c154_i_j;
  real_T c154_h_a;
  real_T c154_h_b;
  real_T c154_h_y;
  real_T c154_j_j;
  real_T c154_i_a;
  real_T c154_i_b;
  real_T c154_i_y;
  real_T c154_c_i;
  real_T c154_j_b;
  real_T c154_j_y;
  real_T c154_k_b;
  real_T c154_k_y;
  real_T c154_l_b;
  real_T c154_l_y;
  real_T c154_m_b;
  real_T c154_m_y;
  int32_T c154_i50;
  int32_T c154_i51;
  real_T *c154_b_Plim;
  real_T *c154_b_previousBestSolution;
  real_T *c154_b_CurrentlyBestSolution;
  real_T (*c154_b_TotalSectorConsumption)[9];
  real_T (*c154_c_TotalSumofSlackVariables)[18];
  real_T (*c154_b_tau_c)[3];
  real_T (*c154_b_powerThrustRelationVec)[3];
  real_T (*c154_b_s9)[3];
  real_T (*c154_b_s8)[3];
  real_T (*c154_b_s7)[3];
  real_T (*c154_b_s6)[3];
  real_T (*c154_b_s5)[3];
  real_T (*c154_b_s4)[3];
  real_T (*c154_b_s3)[3];
  real_T (*c154_b_s2)[3];
  real_T (*c154_b_s1)[3];
  real_T (*c154_b_Td9)[3];
  real_T (*c154_b_Td8)[3];
  real_T (*c154_b_Td7)[3];
  real_T (*c154_b_Td6)[3];
  real_T (*c154_b_Td5)[3];
  real_T (*c154_b_Td4)[3];
  real_T (*c154_b_Td3)[3];
  real_T (*c154_b_Td2)[3];
  real_T (*c154_b_Td1)[3];
  c154_b_s7 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 15);
  c154_b_Plim = (real_T *)ssGetInputPortSignal(chartInstance.S, 18);
  c154_b_s4 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 12);
  c154_b_Td8 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 7);
  c154_b_s9 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 17);
  c154_b_Td4 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
  c154_b_s1 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 9);
  c154_b_Td2 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  c154_c_TotalSumofSlackVariables = (real_T (*)[18])ssGetOutputPortSignal
    (chartInstance.S, 3);
  c154_b_powerThrustRelationVec = (real_T (*)[3])ssGetInputPortSignal
    (chartInstance.S, 19);
  c154_b_Td3 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  c154_b_Td7 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 6);
  c154_b_s3 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 11);
  c154_b_TotalSectorConsumption = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 2);
  c154_b_Td6 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 5);
  c154_b_Td9 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 8);
  c154_b_s6 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 14);
  c154_b_s5 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 13);
  c154_b_CurrentlyBestSolution = (real_T *)ssGetOutputPortSignal(chartInstance.S,
    1);
  c154_b_tau_c = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 21);
  c154_b_Td1 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c154_b_s2 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 10);
  c154_b_Td5 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 4);
  c154_b_previousBestSolution = (real_T *)ssGetInputPortSignal(chartInstance.S,
    20);
  c154_b_s8 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 16);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,153);
  for (c154_i26 = 0; c154_i26 < 3; c154_i26 = c154_i26 + 1) {
    c154_Td1[c154_i26] = (*c154_b_Td1)[c154_i26];
  }

  for (c154_i27 = 0; c154_i27 < 3; c154_i27 = c154_i27 + 1) {
    c154_Td2[c154_i27] = (*c154_b_Td2)[c154_i27];
  }

  for (c154_i28 = 0; c154_i28 < 3; c154_i28 = c154_i28 + 1) {
    c154_Td3[c154_i28] = (*c154_b_Td3)[c154_i28];
  }

  for (c154_i29 = 0; c154_i29 < 3; c154_i29 = c154_i29 + 1) {
    c154_Td4[c154_i29] = (*c154_b_Td4)[c154_i29];
  }

  for (c154_i30 = 0; c154_i30 < 3; c154_i30 = c154_i30 + 1) {
    c154_Td5[c154_i30] = (*c154_b_Td5)[c154_i30];
  }

  for (c154_i31 = 0; c154_i31 < 3; c154_i31 = c154_i31 + 1) {
    c154_Td6[c154_i31] = (*c154_b_Td6)[c154_i31];
  }

  for (c154_i32 = 0; c154_i32 < 3; c154_i32 = c154_i32 + 1) {
    c154_Td7[c154_i32] = (*c154_b_Td7)[c154_i32];
  }

  for (c154_i33 = 0; c154_i33 < 3; c154_i33 = c154_i33 + 1) {
    c154_Td8[c154_i33] = (*c154_b_Td8)[c154_i33];
  }

  for (c154_i34 = 0; c154_i34 < 3; c154_i34 = c154_i34 + 1) {
    c154_Td9[c154_i34] = (*c154_b_Td9)[c154_i34];
  }

  for (c154_i35 = 0; c154_i35 < 3; c154_i35 = c154_i35 + 1) {
    c154_s1[c154_i35] = (*c154_b_s1)[c154_i35];
  }

  for (c154_i36 = 0; c154_i36 < 3; c154_i36 = c154_i36 + 1) {
    c154_s2[c154_i36] = (*c154_b_s2)[c154_i36];
  }

  for (c154_i37 = 0; c154_i37 < 3; c154_i37 = c154_i37 + 1) {
    c154_s3[c154_i37] = (*c154_b_s3)[c154_i37];
  }

  for (c154_i38 = 0; c154_i38 < 3; c154_i38 = c154_i38 + 1) {
    c154_s4[c154_i38] = (*c154_b_s4)[c154_i38];
  }

  for (c154_i39 = 0; c154_i39 < 3; c154_i39 = c154_i39 + 1) {
    c154_s5[c154_i39] = (*c154_b_s5)[c154_i39];
  }

  for (c154_i40 = 0; c154_i40 < 3; c154_i40 = c154_i40 + 1) {
    c154_s6[c154_i40] = (*c154_b_s6)[c154_i40];
  }

  for (c154_i41 = 0; c154_i41 < 3; c154_i41 = c154_i41 + 1) {
    c154_s7[c154_i41] = (*c154_b_s7)[c154_i41];
  }

  for (c154_i42 = 0; c154_i42 < 3; c154_i42 = c154_i42 + 1) {
    c154_s8[c154_i42] = (*c154_b_s8)[c154_i42];
  }

  for (c154_i43 = 0; c154_i43 < 3; c154_i43 = c154_i43 + 1) {
    c154_s9[c154_i43] = (*c154_b_s9)[c154_i43];
  }

  c154_Plim = *c154_b_Plim;
  for (c154_i44 = 0; c154_i44 < 3; c154_i44 = c154_i44 + 1) {
    c154_powerThrustRelationVec[c154_i44] = (*c154_b_powerThrustRelationVec)
      [c154_i44];
  }

  c154_previousBestSolution = *c154_b_previousBestSolution;
  for (c154_i45 = 0; c154_i45 < 3; c154_i45 = c154_i45 + 1) {
    c154_tau_c[c154_i45] = (*c154_b_tau_c)[c154_i45];
  }

  sf_debug_symbol_scope_push(32U, 0U);
  sf_debug_symbol_scope_add("nargout", &c154_nargout, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c154_nargin, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("minSlackIndex", &c154_minSlackIndex,
    c154_b_sf_marshall);
  sf_debug_symbol_scope_add("sumAbsTau_c", &c154_sumAbsTau_c, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("j", &c154_j, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("i", &c154_i, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("currentSectorSlackVariables",
    &c154_currentSectorSlackVariables, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("TotalSumofSlackVariables",
    &c154_TotalSumofSlackVariables, c154_d_sf_marshall);
  sf_debug_symbol_scope_add("TotalSectorConsumption",
    &c154_TotalSectorConsumption, c154_c_sf_marshall);
  sf_debug_symbol_scope_add("CurrentlyBestSolution", &c154_CurrentlyBestSolution,
    c154_b_sf_marshall);
  sf_debug_symbol_scope_add("tau_c", &c154_tau_c, c154_sf_marshall);
  sf_debug_symbol_scope_add("previousBestSolution", &c154_previousBestSolution,
    c154_b_sf_marshall);
  sf_debug_symbol_scope_add("powerThrustRelationVec",
    &c154_powerThrustRelationVec, c154_sf_marshall);
  sf_debug_symbol_scope_add("Plim", &c154_Plim, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("s9", &c154_s9, c154_sf_marshall);
  sf_debug_symbol_scope_add("s8", &c154_s8, c154_sf_marshall);
  sf_debug_symbol_scope_add("s7", &c154_s7, c154_sf_marshall);
  sf_debug_symbol_scope_add("s6", &c154_s6, c154_sf_marshall);
  sf_debug_symbol_scope_add("s5", &c154_s5, c154_sf_marshall);
  sf_debug_symbol_scope_add("s4", &c154_s4, c154_sf_marshall);
  sf_debug_symbol_scope_add("s3", &c154_s3, c154_sf_marshall);
  sf_debug_symbol_scope_add("s2", &c154_s2, c154_sf_marshall);
  sf_debug_symbol_scope_add("s1", &c154_s1, c154_sf_marshall);
  sf_debug_symbol_scope_add("Td9", &c154_Td9, c154_sf_marshall);
  sf_debug_symbol_scope_add("Td8", &c154_Td8, c154_sf_marshall);
  sf_debug_symbol_scope_add("Td7", &c154_Td7, c154_sf_marshall);
  sf_debug_symbol_scope_add("Td6", &c154_Td6, c154_sf_marshall);
  sf_debug_symbol_scope_add("Td5", &c154_Td5, c154_sf_marshall);
  sf_debug_symbol_scope_add("Td4", &c154_Td4, c154_sf_marshall);
  sf_debug_symbol_scope_add("Td3", &c154_Td3, c154_sf_marshall);
  sf_debug_symbol_scope_add("Td2", &c154_Td2, c154_sf_marshall);
  sf_debug_symbol_scope_add("Td1", &c154_Td1, c154_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  c154_CurrentlyBestSolution = c154_previousBestSolution;
  _SFD_EML_CALL(0,4);
  for (c154_i46 = 0; c154_i46 < 9; c154_i46 = c154_i46 + 1) {
    c154_TotalSectorConsumption[c154_i46] = 0.0;
  }

  _SFD_EML_CALL(0,5);
  for (c154_i47 = 0; c154_i47 < 18; c154_i47 = c154_i47 + 1) {
    c154_TotalSumofSlackVariables[c154_i47] = 0.0;
  }

  /*  Leftside the sum of the slack variables, right hand side index of sector */
  _SFD_EML_CALL(0,9);
  c154_d0 = (c154_abs(c154_s1[0]) + c154_abs(c154_s1[1])) + c154_abs(c154_s1[2]);
  c154_TotalSumofSlackVariables[9 * c154_iv0[0]] = c154_d0;
  c154_TotalSumofSlackVariables[9 * c154_iv0[1]] = 1.0;
  _SFD_EML_CALL(0,10);
  c154_d1 = (c154_abs(c154_s2[0]) + c154_abs(c154_s2[1])) + c154_abs(c154_s2[2]);
  c154_TotalSumofSlackVariables[1 + 9 * c154_iv0[0]] = c154_d1;
  c154_TotalSumofSlackVariables[1 + 9 * c154_iv0[1]] = 2.0;
  _SFD_EML_CALL(0,11);
  c154_d2 = (c154_abs(c154_s3[0]) + c154_abs(c154_s3[1])) + c154_abs(c154_s3[2]);
  c154_TotalSumofSlackVariables[2 + 9 * c154_iv0[0]] = c154_d2;
  c154_TotalSumofSlackVariables[2 + 9 * c154_iv0[1]] = 3.0;
  _SFD_EML_CALL(0,12);
  c154_d3 = (c154_abs(c154_s4[0]) + c154_abs(c154_s4[1])) + c154_abs(c154_s4[2]);
  c154_TotalSumofSlackVariables[3 + 9 * c154_iv0[0]] = c154_d3;
  c154_TotalSumofSlackVariables[3 + 9 * c154_iv0[1]] = 4.0;
  _SFD_EML_CALL(0,13);
  c154_d4 = (c154_abs(c154_s5[0]) + c154_abs(c154_s5[1])) + c154_abs(c154_s5[2]);
  c154_TotalSumofSlackVariables[4 + 9 * c154_iv0[0]] = c154_d4;
  c154_TotalSumofSlackVariables[4 + 9 * c154_iv0[1]] = 5.0;
  _SFD_EML_CALL(0,14);
  c154_d5 = (c154_abs(c154_s6[0]) + c154_abs(c154_s6[1])) + c154_abs(c154_s6[2]);
  c154_TotalSumofSlackVariables[5 + 9 * c154_iv0[0]] = c154_d5;
  c154_TotalSumofSlackVariables[5 + 9 * c154_iv0[1]] = 6.0;
  _SFD_EML_CALL(0,15);
  c154_d6 = (c154_abs(c154_s7[0]) + c154_abs(c154_s7[1])) + c154_abs(c154_s7[2]);
  c154_TotalSumofSlackVariables[6 + 9 * c154_iv0[0]] = c154_d6;
  c154_TotalSumofSlackVariables[6 + 9 * c154_iv0[1]] = 7.0;
  _SFD_EML_CALL(0,16);
  c154_d7 = (c154_abs(c154_s8[0]) + c154_abs(c154_s8[1])) + c154_abs(c154_s8[2]);
  c154_TotalSumofSlackVariables[7 + 9 * c154_iv0[0]] = c154_d7;
  c154_TotalSumofSlackVariables[7 + 9 * c154_iv0[1]] = 8.0;
  _SFD_EML_CALL(0,17);
  c154_d8 = (c154_abs(c154_s9[0]) + c154_abs(c154_s9[1])) + c154_abs(c154_s9[2]);
  c154_TotalSumofSlackVariables[8 + 9 * c154_iv0[0]] = c154_d8;
  c154_TotalSumofSlackVariables[8 + 9 * c154_iv0[1]] = 9.0;
  _SFD_EML_CALL(0,19);
  c154_currentSectorSlackVariables =
    c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
    "TotalSumofSlackVariables", (int32_T)
    _SFD_INTEGER_CHECK("previousBestSolution", c154_previousBestSolution), 1, 9,
    1, 0) - 1];

  /* Sort the best solutions - Sector with least slack variables is #1 */
  _SFD_EML_CALL(0,22);
  for (c154_i48 = 0; c154_i48 < 18; c154_i48 = c154_i48 + 1) {
    c154_b_TotalSumofSlackVariables[c154_i48] =
      c154_TotalSumofSlackVariables[c154_i48];
  }

  c154_sortingFunc(c154_b_TotalSumofSlackVariables, c154_dv2);
  for (c154_i49 = 0; c154_i49 < 18; c154_i49 = c154_i49 + 1) {
    c154_TotalSumofSlackVariables[c154_i49] = c154_dv2[c154_i49];
  }

  c154_i = 1.0;
  c154_b_i = 1.0;
  while (c154_b_i <= 9.0) {
    c154_i = c154_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,25);
    if (CV_EML_IF(0, 0, c154_i == 1.0)) {
      c154_j = 1.0;
      c154_b_j = 1.0;
      while (c154_b_j <= 3.0) {
        c154_j = c154_b_j;
        CV_EML_FOR(0, 1, 1);
        _SFD_EML_CALL(0,27);
        c154_a = c154_powerThrustRelationVec[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "powerThrustRelationVec", (int32_T)_SFD_INTEGER_CHECK("j", c154_j)
          , 1, 3, 1, 0) - 1];
        c154_b = c154_mpower(c154_abs(c154_Td1[_SFD_EML_ARRAY_BOUNDS_CHECK("Td1",
                               (int32_T)_SFD_INTEGER_CHECK("j", c154_j), 1, 3, 1,
          0) - 1]
          ));
        c154_y = c154_a * c154_b;
        c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i", c154_i), 1,
          9, 1
          , 0) - 1] = c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
          c154_i), 1, 9, 1, 0) - 1] + c154_y;
        c154_b_j = c154_b_j + 1.0;
        sf_mex_listen_for_ctrl_c(chartInstance.S);
      }

      CV_EML_FOR(0, 1, 0);
    } else {
      _SFD_EML_CALL(0,29);
      if (CV_EML_IF(0, 1, c154_i == 2.0)) {
        c154_j = 1.0;
        c154_c_j = 1.0;
        while (c154_c_j <= 3.0) {
          c154_j = c154_c_j;
          CV_EML_FOR(0, 2, 1);
          _SFD_EML_CALL(0,31);
          c154_b_a = c154_powerThrustRelationVec[_SFD_EML_ARRAY_BOUNDS_CHECK(
            "powerThrustRelationVec", (int32_T)_SFD_INTEGER_CHECK("j", c154_j
            ), 1, 3, 1, 0) - 1];
          c154_b_b = c154_mpower(c154_abs(c154_Td2[_SFD_EML_ARRAY_BOUNDS_CHECK(
            "Td2", (int32_T)_SFD_INTEGER_CHECK("j", c154_j), 1, 3, 1, 0) -
            1]));
          c154_b_y = c154_b_a * c154_b_b;
          c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
            "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i", c154_i),
            1, 9, 1
            , 0) - 1] = c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
            "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
            c154_i), 1, 9, 1, 0) - 1] + c154_b_y;
          c154_c_j = c154_c_j + 1.0;
          sf_mex_listen_for_ctrl_c(chartInstance.S);
        }

        CV_EML_FOR(0, 2, 0);
      } else {
        _SFD_EML_CALL(0,33);
        if (CV_EML_IF(0, 2, c154_i == 3.0)) {
          c154_j = 1.0;
          c154_d_j = 1.0;
          while (c154_d_j <= 3.0) {
            c154_j = c154_d_j;
            CV_EML_FOR(0, 3, 1);
            _SFD_EML_CALL(0,35);
            c154_c_a = c154_powerThrustRelationVec[_SFD_EML_ARRAY_BOUNDS_CHECK(
              "powerThrustRelationVec", (int32_T)_SFD_INTEGER_CHECK("j", c154_j
              ), 1, 3, 1, 0) - 1];
            c154_c_b = c154_mpower(c154_abs(c154_Td3[_SFD_EML_ARRAY_BOUNDS_CHECK
                                    ("Td3", (int32_T)_SFD_INTEGER_CHECK("j",
              c154_j), 1, 3, 1, 0) -
              1]));
            c154_c_y = c154_c_a * c154_c_b;
            c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
              "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i", c154_i),
              1, 9, 1
              , 0) - 1] =
              c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
              "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
              c154_i), 1, 9, 1, 0) - 1] + c154_c_y;
            c154_d_j = c154_d_j + 1.0;
            sf_mex_listen_for_ctrl_c(chartInstance.S);
          }

          CV_EML_FOR(0, 3, 0);
        } else {
          _SFD_EML_CALL(0,37);
          if (CV_EML_IF(0, 3, c154_i == 4.0)) {
            c154_j = 1.0;
            c154_e_j = 1.0;
            while (c154_e_j <= 3.0) {
              c154_j = c154_e_j;
              CV_EML_FOR(0, 4, 1);
              _SFD_EML_CALL(0,39);
              c154_d_a = c154_powerThrustRelationVec[_SFD_EML_ARRAY_BOUNDS_CHECK
                ("powerThrustRelationVec", (int32_T)_SFD_INTEGER_CHECK("j",
                  c154_j
                  ), 1, 3, 1, 0) - 1];
              c154_d_b = c154_mpower(c154_abs
                (c154_Td4[_SFD_EML_ARRAY_BOUNDS_CHECK("Td4", (int32_T)
                _SFD_INTEGER_CHECK("j", c154_j), 1, 3, 1, 0) -
                 1]));
              c154_d_y = c154_d_a * c154_d_b;
              c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
                c154_i), 1, 9, 1
                , 0) - 1] =
                c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
                c154_i), 1, 9, 1, 0) - 1] + c154_d_y;
              c154_e_j = c154_e_j + 1.0;
              sf_mex_listen_for_ctrl_c(chartInstance.S);
            }

            CV_EML_FOR(0, 4, 0);
          } else {
            _SFD_EML_CALL(0,41);
            if (CV_EML_IF(0, 4, c154_i == 5.0)) {
              c154_j = 1.0;
              c154_f_j = 1.0;
              while (c154_f_j <= 3.0) {
                c154_j = c154_f_j;
                CV_EML_FOR(0, 5, 1);
                _SFD_EML_CALL(0,43);
                c154_e_a =
                  c154_powerThrustRelationVec[_SFD_EML_ARRAY_BOUNDS_CHECK(
                  "powerThrustRelationVec", (int32_T)_SFD_INTEGER_CHECK("j",
                  c154_j
                  ), 1, 3, 1, 0) - 1];
                c154_e_b = c154_mpower(c154_abs
                  (c154_Td5[_SFD_EML_ARRAY_BOUNDS_CHECK("Td5", (int32_T)
                  _SFD_INTEGER_CHECK("j", c154_j), 1, 3, 1, 0) -
                   1]));
                c154_e_y = c154_e_a * c154_e_b;
                c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                  "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
                  c154_i), 1, 9, 1
                  , 0) - 1] =
                  c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                  "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
                  c154_i), 1, 9, 1, 0) - 1] + c154_e_y;
                c154_f_j = c154_f_j + 1.0;
                sf_mex_listen_for_ctrl_c(chartInstance.S);
              }

              CV_EML_FOR(0, 5, 0);
            } else {
              _SFD_EML_CALL(0,45);
              if (CV_EML_IF(0, 5, c154_i == 6.0)) {
                c154_j = 1.0;
                c154_g_j = 1.0;
                while (c154_g_j <= 3.0) {
                  c154_j = c154_g_j;
                  CV_EML_FOR(0, 6, 1);
                  _SFD_EML_CALL(0,47);
                  c154_f_a =
                    c154_powerThrustRelationVec[_SFD_EML_ARRAY_BOUNDS_CHECK(
                    "powerThrustRelationVec", (int32_T)_SFD_INTEGER_CHECK("j",
                    c154_j
                    ), 1, 3, 1, 0) - 1];
                  c154_f_b = c154_mpower(c154_abs
                    (c154_Td6[_SFD_EML_ARRAY_BOUNDS_CHECK("Td6", (int32_T)
                    _SFD_INTEGER_CHECK("j", c154_j), 1, 3, 1, 0) -
                     1]));
                  c154_f_y = c154_f_a * c154_f_b;
                  c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                    "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
                    c154_i), 1, 9, 1
                    , 0) - 1] =
                    c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                    "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
                    c154_i), 1, 9, 1, 0) - 1] + c154_f_y;
                  c154_g_j = c154_g_j + 1.0;
                  sf_mex_listen_for_ctrl_c(chartInstance.S);
                }

                CV_EML_FOR(0, 6, 0);
              } else {
                _SFD_EML_CALL(0,49);
                if (CV_EML_IF(0, 6, c154_i == 7.0)) {
                  c154_j = 1.0;
                  c154_h_j = 1.0;
                  while (c154_h_j <= 3.0) {
                    c154_j = c154_h_j;
                    CV_EML_FOR(0, 7, 1);
                    _SFD_EML_CALL(0,51);
                    c154_g_a =
                      c154_powerThrustRelationVec[_SFD_EML_ARRAY_BOUNDS_CHECK(
                      "powerThrustRelationVec", (int32_T)_SFD_INTEGER_CHECK("j",
                      c154_j
                      ), 1, 3, 1, 0) - 1];
                    c154_g_b = c154_mpower(c154_abs
                      (c154_Td7[_SFD_EML_ARRAY_BOUNDS_CHECK("Td7", (int32_T)
                      _SFD_INTEGER_CHECK("j", c154_j), 1, 3, 1, 0) -
                       1]));
                    c154_g_y = c154_g_a * c154_g_b;
                    c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                      "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
                      c154_i), 1, 9, 1
                      , 0) - 1] =
                      c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                      "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK("i",
                      c154_i), 1, 9, 1, 0) - 1] + c154_g_y;
                    c154_h_j = c154_h_j + 1.0;
                    sf_mex_listen_for_ctrl_c(chartInstance.S);
                  }

                  CV_EML_FOR(0, 7, 0);
                } else {
                  _SFD_EML_CALL(0,53);
                  if (CV_EML_IF(0, 7, c154_i == 8.0)) {
                    c154_j = 1.0;
                    c154_i_j = 1.0;
                    while (c154_i_j <= 3.0) {
                      c154_j = c154_i_j;
                      CV_EML_FOR(0, 8, 1);
                      _SFD_EML_CALL(0,55);
                      c154_h_a =
                        c154_powerThrustRelationVec[_SFD_EML_ARRAY_BOUNDS_CHECK(
                        "powerThrustRelationVec", (int32_T)_SFD_INTEGER_CHECK(
                        "j", c154_j
                        ), 1, 3, 1, 0) - 1];
                      c154_h_b = c154_mpower(c154_abs
                        (c154_Td8[_SFD_EML_ARRAY_BOUNDS_CHECK("Td8", (int32_T)
                        _SFD_INTEGER_CHECK("j", c154_j), 1, 3, 1, 0) -
                         1]));
                      c154_h_y = c154_h_a * c154_h_b;
                      c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                        "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK(
                        "i", c154_i), 1, 9, 1
                        , 0) - 1] =
                        c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                        "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK(
                        "i",
                        c154_i), 1, 9, 1, 0) - 1] + c154_h_y;
                      c154_i_j = c154_i_j + 1.0;
                      sf_mex_listen_for_ctrl_c(chartInstance.S);
                    }

                    CV_EML_FOR(0, 8, 0);
                  } else {
                    _SFD_EML_CALL(0,57);
                    if (CV_EML_IF(0, 8, c154_i == 9.0)) {
                      c154_j = 1.0;
                      c154_j_j = 1.0;
                      while (c154_j_j <= 3.0) {
                        c154_j = c154_j_j;
                        CV_EML_FOR(0, 9, 1);
                        _SFD_EML_CALL(0,59);
                        c154_i_a =
                          c154_powerThrustRelationVec[_SFD_EML_ARRAY_BOUNDS_CHECK
                          ("powerThrustRelationVec", (int32_T)_SFD_INTEGER_CHECK
                           ("j", c154_j
                            ), 1, 3, 1, 0) - 1];
                        c154_i_b = c154_mpower(c154_abs
                          (c154_Td9[_SFD_EML_ARRAY_BOUNDS_CHECK("Td9", (int32_T)
                          _SFD_INTEGER_CHECK("j", c154_j), 1, 3, 1, 0) -
                           1]));
                        c154_i_y = c154_i_a * c154_i_b;
                        c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
                          "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK(
                          "i", c154_i), 1, 9, 1
                          , 0) - 1] =
                          c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK
                          ("TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK
                           ("i",
                            c154_i), 1, 9, 1, 0) - 1] + c154_i_y;
                        c154_j_j = c154_j_j + 1.0;
                        sf_mex_listen_for_ctrl_c(chartInstance.S);
                      }

                      CV_EML_FOR(0, 9, 0);
                    }
                  }
                }
              }
            }
          }
        }
      }
    }

    c154_b_i = c154_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,66);
  c154_sumAbsTau_c = (c154_abs(c154_tau_c[0]) + c154_abs(c154_tau_c[1])) +
    c154_abs(c154_tau_c[2]);
  _SFD_EML_CALL(0,70);
  if (CV_EML_IF(0, 9, c154_sumAbsTau_c < 1.0E-007)) {
    _SFD_EML_CALL(0,71);
    c154_CurrentlyBestSolution = c154_previousBestSolution;
  } else {
    /* Setting the minSlackIndex to the sector with least sum of slack variables first */
    _SFD_EML_CALL(0,74);
    c154_minSlackIndex = 1.0;
    c154_i = 1.0;
    c154_c_i = 1.0;
    while (c154_c_i <= 4.0) {
      c154_i = c154_c_i;
      CV_EML_FOR(0, 10, 1);

      /*
         Some of the 4 best solutions might have a slack variable equal to the commanded thrust, ignore these sectors these. As they introduce more power into the system that is not required */
      _SFD_EML_CALL(0,77);
      if (CV_EML_IF(0, 10,
                    c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
            "TotalSumofSlackVariables", (int32_T)
            _SFD_INTEGER_CHECK("i", c154_i), 1, 9, 1, 0) - 1] < c154_sumAbsTau_c
                    - 1.0E-006)) {
        _SFD_EML_CALL(0,78);
        if (CV_EML_COND(0, 0,
                        c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
              "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK(
               "", c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
                "TotalSumofSlackVariables", (int32_T)_SFD_INTEGER_CHECK("i",
                 c154_i),
                1, 9, 1, 0) + 8]), 1, 9, 1, 0) - 1] <
                        c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
              "TotalSectorConsumption", (int32_T)
              _SFD_INTEGER_CHECK("",
               c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
                "TotalSumofSlackVariables", (int32_T)
                _SFD_INTEGER_CHECK("minSlackIndex", c154_minSlackIndex), 1, 9, 1,
                0) + 8]), 1, 9, 1, 0) - 1])) {
          c154_j_b = c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
            "TotalSumofSlackVariables", (int32_T)_SFD_INTEGER_CHECK(
            "minSlackIndex", c154_minSlackIndex), 1, 9, 1, 0) - 1];
          c154_j_y = 1.05 * c154_j_b;
          if (CV_EML_COND(0, 1,
                          c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK
                          ("TotalSumofSlackVariables", (int32_T)
                           _SFD_INTEGER_CHECK("i", c154_i), 1, 9, 1, 0) - 1] <=
                          c154_j_y)) {
            CV_EML_MCDC(0, 0, true);
            CV_EML_IF(0, 11, true);
            _SFD_EML_CALL(0,79);
            c154_minSlackIndex = c154_i;
            goto label_1;
          }
        }

        CV_EML_MCDC(0, 0, false);
        CV_EML_IF(0, 11, false);
       label_1:
        ;
      }

      c154_c_i = c154_c_i + 1.0;
      sf_mex_listen_for_ctrl_c(chartInstance.S);
    }

    CV_EML_FOR(0, 10, 0);

    /* In case previousSolution has very low power, and has almost same amount of sum in slack variable as in tau_c */
    _SFD_EML_CALL(0,85);
    if (CV_EML_COND(0, 2,
                    c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK(
           "previousBestSolution", c154_previousBestSolution), 1, 9, 1, 0) - 1] <
                    0.001)) {
      c154_k_b = c154_sumAbsTau_c;
      c154_k_y = 0.9 * c154_k_b;
      if (CV_EML_COND(0, 3, c154_currentSectorSlackVariables >= c154_k_y - 0.001))
      {
        CV_EML_MCDC(0, 1, true);
        CV_EML_IF(0, 12, true);
        _SFD_EML_CALL(0,86);
        if (CV_EML_IF(0, 13,
                      c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
              "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK(""
               , c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
                "TotalSumofSlackVariables", (int32_T)_SFD_INTEGER_CHECK(
                 "minSlackIndex"
                 , c154_minSlackIndex), 1, 9, 1, 0) + 8]), 1, 9, 1, 0) - 1] >
                      0.00001)) {
          _SFD_EML_CALL(0,87);
          c154_CurrentlyBestSolution =
            c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
            "TotalSumofSlackVariables", (int32_T)
            _SFD_INTEGER_CHECK("minSlackIndex", c154_minSlackIndex), 1, 9, 1, 0)
            + 8];
        }

        /* If previousSolution is not close to zero in power, a power drop must be expected to be able to change to a new sector. */
        goto label_2;
      }
    }

    CV_EML_MCDC(0, 1, false);
    CV_EML_IF(0, 12, false);

    /*  The new sector must also have to a significant similar or better solution when it comes to the slack variables in X, Y, N. */
    _SFD_EML_CALL(0,92);
    if (CV_EML_COND(0, 4,
                    c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK(
           "", c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
            "TotalSumofSlackVariables", (int32_T)_SFD_INTEGER_CHECK(
             "minSlackIndex", c154_minSlackIndex), 1, 9, 1, 0) + 8]), 1, 9, 1, 0)
                    - 1] <
                    c154_TotalSectorConsumption[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "TotalSectorConsumption", (int32_T)_SFD_INTEGER_CHECK(
           "previousBestSolution", c154_previousBestSolution), 1, 9, 1, 0) - 1]
                    -
                    c154_Plim)) {
      c154_l_b = c154_currentSectorSlackVariables;
      c154_l_y = 1.05 * c154_l_b;
      if (CV_EML_COND(0, 5,
                      c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
            "TotalSumofSlackVariables", (int32_T)
            _SFD_INTEGER_CHECK("minSlackIndex", c154_minSlackIndex), 1, 9, 1, 0)
                      - 1] <= c154_l_y)) {
        CV_EML_MCDC(0, 2, true);
        CV_EML_IF(0, 14, true);
        _SFD_EML_CALL(0,93);
        c154_CurrentlyBestSolution =
          c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "TotalSumofSlackVariables", (int32_T)
          _SFD_INTEGER_CHECK("minSlackIndex", c154_minSlackIndex), 1, 9, 1, 0) +
          8];
        goto label_3;
      }
    }

    CV_EML_MCDC(0, 2, false);
    CV_EML_IF(0, 14, false);
    _SFD_EML_CALL(0,94);
    c154_m_b = c154_currentSectorSlackVariables;
    c154_m_y = 0.6 * c154_m_b;
    if (CV_EML_IF(0, 15,
                  c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "TotalSumofSlackVariables", (int32_T)
          _SFD_INTEGER_CHECK("minSlackIndex", c154_minSlackIndex), 1, 9, 1, 0) -
                  1] <= c154_m_y)) {
      /*  && (currentSectorSlackVariables > 0.1*sumAbsTau_c)) */
      _SFD_EML_CALL(0,95);
      c154_CurrentlyBestSolution =
        c154_TotalSumofSlackVariables[_SFD_EML_ARRAY_BOUNDS_CHECK(
        "TotalSumofSlackVariables", (int32_T)
        _SFD_INTEGER_CHECK("minSlackIndex", c154_minSlackIndex), 1, 9, 1, 0) + 8];
    }

   label_3:
    ;
   label_2:
    ;
  }

  _SFD_EML_CALL(0,-95);
  sf_debug_symbol_scope_pop();
  *c154_b_CurrentlyBestSolution = c154_CurrentlyBestSolution;
  for (c154_i50 = 0; c154_i50 < 9; c154_i50 = c154_i50 + 1) {
    (*c154_b_TotalSectorConsumption)[c154_i50] =
      c154_TotalSectorConsumption[c154_i50];
  }

  for (c154_i51 = 0; c154_i51 < 18; c154_i51 = c154_i51 + 1) {
    (*c154_c_TotalSumofSlackVariables)[c154_i51] =
      c154_TotalSumofSlackVariables[c154_i51];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,153);
}

static void init_script_number_translation(uint32_T c154_machineNumber, uint32_T
  c154_chartNumber)
{
}

static real_T c154_abs(real_T c154_x)
{
  real_T c154_b_x;
  c154_b_x = c154_x;
  return muDoubleScalarAbs(c154_b_x);
}

static void c154_sortingFunc(real_T c154_SumSlackVar[18], real_T c154_Sorted[18])
{
  real_T c154_nargout = 1.0;
  real_T c154_nargin = 1.0;
  real_T c154_temp[2];
  real_T c154_j;
  real_T c154_BestSol;
  real_T c154_i;
  int32_T c154_i52;
  real_T c154_b_i;
  real_T c154_d9;
  real_T c154_b_j;
  int32_T c154_c_i;
  int32_T c154_i53;
  static int32_T c154_iv1[2] = { 0, 1 };

  int32_T c154_d_i;
  int32_T c154_b_BestSol;
  int32_T c154_i54;
  real_T c154_b_Sorted[2];
  int32_T c154_i55;
  int32_T c154_c_BestSol;
  int32_T c154_i56;
  sf_debug_symbol_scope_push(8U, 0U);
  sf_debug_symbol_scope_add("nargout", &c154_nargout, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c154_nargin, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("temp", &c154_temp, c154_e_sf_marshall);
  sf_debug_symbol_scope_add("j", &c154_j, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("BestSol", &c154_BestSol, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("i", &c154_i, c154_b_sf_marshall);
  sf_debug_symbol_scope_add("Sorted", c154_Sorted, c154_d_sf_marshall);
  sf_debug_symbol_scope_add("SumSlackVar", c154_SumSlackVar, c154_d_sf_marshall);
  CV_EML_FCN(0, 1);

  /* Standard selection sorting */
  _SFD_EML_CALL(0,106);
  for (c154_i52 = 0; c154_i52 < 18; c154_i52 = c154_i52 + 1) {
    c154_Sorted[c154_i52] = c154_SumSlackVar[c154_i52];
  }

  c154_i = 1.0;
  c154_b_i = 1.0;
  while (c154_b_i <= 9.0) {
    c154_i = c154_b_i;
    CV_EML_FOR(0, 11, 1);
    _SFD_EML_CALL(0,108);
    c154_BestSol = c154_i;
    c154_d9 = c154_i + 1.0;
    c154_j = c154_d9;
    c154_b_j = c154_d9;
    while (c154_b_j <= 9.0) {
      c154_j = c154_b_j;
      CV_EML_FOR(0, 12, 1);
      _SFD_EML_CALL(0,110);
      if (CV_EML_IF(0, 16, c154_Sorted[_SFD_EML_ARRAY_BOUNDS_CHECK("Sorted",
            (int32_T)_SFD_INTEGER_CHECK("BestSol", c154_BestSol), 1, 9, 1
            , 0) - 1] > c154_Sorted[_SFD_EML_ARRAY_BOUNDS_CHECK("Sorted",
            (int32_T)_SFD_INTEGER_CHECK("j", c154_j), 1, 9, 1, 0) - 1])) {
        _SFD_EML_CALL(0,111);
        c154_BestSol = c154_j;
      }

      c154_b_j = c154_b_j + 1.0;
      sf_mex_listen_for_ctrl_c(chartInstance.S);
    }

    CV_EML_FOR(0, 12, 0);
    _SFD_EML_CALL(0,114);
    if (CV_EML_IF(0, 17, c154_BestSol != c154_i)) {
      _SFD_EML_CALL(0,115);
      c154_c_i = _SFD_EML_ARRAY_BOUNDS_CHECK("Sorted", (int32_T)
        _SFD_INTEGER_CHECK("i", c154_i), 1, 9, 1, 0) - 1;
      for (c154_i53 = 0; c154_i53 < 2; c154_i53 = c154_i53 + 1) {
        c154_temp[c154_i53] = c154_Sorted[c154_c_i + 9 * c154_iv1[c154_i53]];
      }

      _SFD_EML_CALL(0,116);
      c154_d_i = _SFD_EML_ARRAY_BOUNDS_CHECK("Sorted", (int32_T)
        _SFD_INTEGER_CHECK("i", c154_i), 1, 9, 1, 0) - 1;
      c154_b_BestSol = _SFD_EML_ARRAY_BOUNDS_CHECK("Sorted", (int32_T)
        _SFD_INTEGER_CHECK("BestSol", c154_BestSol), 1, 9, 1, 0) - 1;
      for (c154_i54 = 0; c154_i54 < 2; c154_i54 = c154_i54 + 1) {
        c154_b_Sorted[c154_i54] = c154_Sorted[c154_b_BestSol + 9 *
          c154_iv1[c154_i54]];
      }

      for (c154_i55 = 0; c154_i55 < 2; c154_i55 = c154_i55 + 1) {
        c154_Sorted[c154_d_i + 9 * c154_iv1[c154_i55]] = c154_b_Sorted[c154_i55];
      }

      _SFD_EML_CALL(0,117);
      c154_c_BestSol = _SFD_EML_ARRAY_BOUNDS_CHECK("Sorted", (int32_T)
        _SFD_INTEGER_CHECK("BestSol", c154_BestSol), 1, 9, 1, 0) - 1;
      for (c154_i56 = 0; c154_i56 < 2; c154_i56 = c154_i56 + 1) {
        c154_Sorted[c154_c_BestSol + 9 * c154_iv1[c154_i56]] =
          c154_temp[c154_i56];
      }
    }

    c154_b_i = c154_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 11, 0);
  _SFD_EML_CALL(0,-117);
  sf_debug_symbol_scope_pop();
}

static real_T c154_mpower(real_T c154_a)
{
  real_T c154_b_a;
  real_T c154_ak;
  c154_b_a = c154_a;
  c154_ak = c154_b_a;
  if (c154_ak < 0.0) {
    c154_eml_error();
  }

  return muDoubleScalarPower(c154_ak, 1.5);
}

static void c154_eml_error(void)
{
  int32_T c154_i57;
  static char_T c154_cv0[102] = { 'D', 'o', 'm', 'a', 'i', 'n', ' ', 'e', 'r',
    'r', 'o', 'r', '.', ' ', 'T', 'o', ' ', 'c', 'o', 'm',
    'p', 'u', 't', 'e', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ', 'r', 'e',
    's', 'u', 'l', 't', 's',
    ',', ' ', 'm', 'a', 'k', 'e', ' ', 'a', 't', ' ', 'l', 'e', 'a', 's', 't',
    ' ', 'o', 'n', 'e', ' ',
    'i', 'n', 'p', 'u', 't', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ',', ' ',
    'e', '.', 'g', '.', ' ',
    '\'', 'p', 'o', 'w', 'e', 'r', '(', 'c', 'o', 'm', 'p', 'l', 'e', 'x', '(',
    'a', ')', ',', 'b', ')'
    , '\'', '.' };

  char_T c154_u[102];
  const mxArray *c154_y = NULL;
  int32_T c154_i58;
  static char_T c154_cv1[32] = { 'E', 'm', 'b', 'e', 'd', 'd', 'e', 'd', 'M',
    'A', 'T', 'L', 'A', 'B', ':', 'p', 'o', 'w', 'e', 'r',
    ':', 'd', 'o', 'm', 'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c154_b_u[32];
  const mxArray *c154_b_y = NULL;
  for (c154_i57 = 0; c154_i57 < 102; c154_i57 = c154_i57 + 1) {
    c154_u[c154_i57] = c154_cv0[c154_i57];
  }

  c154_y = NULL;
  sf_mex_assign(&c154_y, sf_mex_create("y", &c154_u, 10, 0U, 1U, 0U, 2, 1, 102));
  for (c154_i58 = 0; c154_i58 < 32; c154_i58 = c154_i58 + 1) {
    c154_b_u[c154_i58] = c154_cv1[c154_i58];
  }

  c154_b_y = NULL;
  sf_mex_assign(&c154_b_y, sf_mex_create("y", &c154_b_u, 10, 0U, 1U, 0U, 2, 1,
    32));
  sf_mex_call_debug("error", 0U, 2U, 14, c154_b_y, 14, c154_y);
}

static const mxArray *c154_sf_marshall(void *c154_chartInstance, void *c154_u)
{
  const mxArray *c154_y = NULL;
  int32_T c154_i59;
  real_T c154_b_u[3];
  const mxArray *c154_b_y = NULL;
  c154_y = NULL;
  for (c154_i59 = 0; c154_i59 < 3; c154_i59 = c154_i59 + 1) {
    c154_b_u[c154_i59] = (*((real_T (*)[3])c154_u))[c154_i59];
  }

  c154_b_y = NULL;
  sf_mex_assign(&c154_b_y, sf_mex_create("y", &c154_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c154_y, c154_b_y);
  return c154_y;
}

static const mxArray *c154_b_sf_marshall(void *c154_chartInstance, void *c154_u)
{
  const mxArray *c154_y = NULL;
  real_T c154_b_u;
  const mxArray *c154_b_y = NULL;
  c154_y = NULL;
  c154_b_u = *((real_T *)c154_u);
  c154_b_y = NULL;
  sf_mex_assign(&c154_b_y, sf_mex_create("y", &c154_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c154_y, c154_b_y);
  return c154_y;
}

static const mxArray *c154_c_sf_marshall(void *c154_chartInstance, void *c154_u)
{
  const mxArray *c154_y = NULL;
  int32_T c154_i60;
  real_T c154_b_u[9];
  const mxArray *c154_b_y = NULL;
  c154_y = NULL;
  for (c154_i60 = 0; c154_i60 < 9; c154_i60 = c154_i60 + 1) {
    c154_b_u[c154_i60] = (*((real_T (*)[9])c154_u))[c154_i60];
  }

  c154_b_y = NULL;
  sf_mex_assign(&c154_b_y, sf_mex_create("y", &c154_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_assign(&c154_y, c154_b_y);
  return c154_y;
}

static const mxArray *c154_d_sf_marshall(void *c154_chartInstance, void *c154_u)
{
  const mxArray *c154_y = NULL;
  int32_T c154_i61;
  int32_T c154_i62;
  int32_T c154_i63;
  real_T c154_b_u[18];
  const mxArray *c154_b_y = NULL;
  c154_y = NULL;
  c154_i61 = 0;
  for (c154_i62 = 0; c154_i62 < 2; c154_i62 = c154_i62 + 1) {
    for (c154_i63 = 0; c154_i63 < 9; c154_i63 = c154_i63 + 1) {
      c154_b_u[c154_i63 + c154_i61] = (*((real_T (*)[18])c154_u))[c154_i63 +
        c154_i61];
    }

    c154_i61 = c154_i61 + 9;
  }

  c154_b_y = NULL;
  sf_mex_assign(&c154_b_y, sf_mex_create("y", &c154_b_u, 0, 0U, 1U, 0U, 2, 9, 2));
  sf_mex_assign(&c154_y, c154_b_y);
  return c154_y;
}

static const mxArray *c154_e_sf_marshall(void *c154_chartInstance, void *c154_u)
{
  const mxArray *c154_y = NULL;
  int32_T c154_i64;
  real_T c154_b_u[2];
  const mxArray *c154_b_y = NULL;
  c154_y = NULL;
  for (c154_i64 = 0; c154_i64 < 2; c154_i64 = c154_i64 + 1) {
    c154_b_u[c154_i64] = (*((real_T (*)[2])c154_u))[c154_i64];
  }

  c154_b_y = NULL;
  sf_mex_assign(&c154_b_y, sf_mex_create("y", &c154_b_u, 0, 0U, 1U, 0U, 2, 1, 2));
  sf_mex_assign(&c154_y, c154_b_y);
  return c154_y;
}

const mxArray *sf_c154_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c154_nameCaptureInfo = NULL;
  c154_ResolvedFunctionInfo c154_info[40];
  const mxArray *c154_m0 = NULL;
  int32_T c154_i65;
  c154_ResolvedFunctionInfo *c154_r0;
  c154_nameCaptureInfo = NULL;
  c154_info_helper(c154_info);
  sf_mex_assign(&c154_m0, sf_mex_createstruct("nameCaptureInfo", 1, 40));
  for (c154_i65 = 0; c154_i65 < 40; c154_i65 = c154_i65 + 1) {
    c154_r0 = &c154_info[c154_i65];
    sf_mex_addfield(c154_m0, sf_mex_create("nameCaptureInfo", c154_r0->context,
      15, 0U, 0U, 0U, 2, 1, strlen(c154_r0->context)),
                    "context", "nameCaptureInfo", c154_i65);
    sf_mex_addfield(c154_m0, sf_mex_create("nameCaptureInfo", c154_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c154_r0->name)), "name",
                    "nameCaptureInfo", c154_i65);
    sf_mex_addfield(c154_m0, sf_mex_create("nameCaptureInfo",
      c154_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c154_r0->dominantType)
      ), "dominantType", "nameCaptureInfo", c154_i65);
    sf_mex_addfield(c154_m0, sf_mex_create("nameCaptureInfo", c154_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c154_r0->resolved)),
                    "resolved", "nameCaptureInfo", c154_i65);
    sf_mex_addfield(c154_m0, sf_mex_create("nameCaptureInfo",
      &c154_r0->fileLength, 7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c154_i65);
    sf_mex_addfield(c154_m0, sf_mex_create("nameCaptureInfo",
      &c154_r0->fileTime1, 7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c154_i65);
    sf_mex_addfield(c154_m0, sf_mex_create("nameCaptureInfo",
      &c154_r0->fileTime2, 7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c154_i65);
  }

  sf_mex_assign(&c154_nameCaptureInfo, c154_m0);
  return c154_nameCaptureInfo;
}

static void c154_info_helper(c154_ResolvedFunctionInfo c154_info[40])
{
  c154_info[0].context = "";
  c154_info[0].name = "zeros";
  c154_info[0].dominantType = "double";
  c154_info[0].resolved = "[B]zeros";
  c154_info[0].fileLength = 0U;
  c154_info[0].fileTime1 = 0U;
  c154_info[0].fileTime2 = 0U;
  c154_info[1].context = "";
  c154_info[1].name = "abs";
  c154_info[1].dominantType = "double";
  c154_info[1].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c154_info[1].fileLength = 566U;
  c154_info[1].fileTime1 = 1221267134U;
  c154_info[1].fileTime2 = 0U;
  c154_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c154_info[2].name = "nargin";
  c154_info[2].dominantType = "";
  c154_info[2].resolved = "[B]nargin";
  c154_info[2].fileLength = 0U;
  c154_info[2].fileTime1 = 0U;
  c154_info[2].fileTime2 = 0U;
  c154_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c154_info[3].name = "gt";
  c154_info[3].dominantType = "double";
  c154_info[3].resolved = "[B]gt";
  c154_info[3].fileLength = 0U;
  c154_info[3].fileTime1 = 0U;
  c154_info[3].fileTime2 = 0U;
  c154_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c154_info[4].name = "isa";
  c154_info[4].dominantType = "double";
  c154_info[4].resolved = "[B]isa";
  c154_info[4].fileLength = 0U;
  c154_info[4].fileTime1 = 0U;
  c154_info[4].fileTime2 = 0U;
  c154_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c154_info[5].name = "ischar";
  c154_info[5].dominantType = "double";
  c154_info[5].resolved = "[B]ischar";
  c154_info[5].fileLength = 0U;
  c154_info[5].fileTime1 = 0U;
  c154_info[5].fileTime2 = 0U;
  c154_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c154_info[6].name = "islogical";
  c154_info[6].dominantType = "double";
  c154_info[6].resolved = "[B]islogical";
  c154_info[6].fileLength = 0U;
  c154_info[6].fileTime1 = 0U;
  c154_info[6].fileTime2 = 0U;
  c154_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c154_info[7].name = "size";
  c154_info[7].dominantType = "double";
  c154_info[7].resolved = "[B]size";
  c154_info[7].fileLength = 0U;
  c154_info[7].fileTime1 = 0U;
  c154_info[7].fileTime2 = 0U;
  c154_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c154_info[8].name = "class";
  c154_info[8].dominantType = "double";
  c154_info[8].resolved = "[B]class";
  c154_info[8].fileLength = 0U;
  c154_info[8].fileTime1 = 0U;
  c154_info[8].fileTime2 = 0U;
  c154_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c154_info[9].name = "eml_scalar_abs";
  c154_info[9].dominantType = "double";
  c154_info[9].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c154_info[9].fileLength = 461U;
  c154_info[9].fileTime1 = 1203447960U;
  c154_info[9].fileTime2 = 0U;
  c154_info[10].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c154_info[10].name = "isinteger";
  c154_info[10].dominantType = "double";
  c154_info[10].resolved = "[B]isinteger";
  c154_info[10].fileLength = 0U;
  c154_info[10].fileTime1 = 0U;
  c154_info[10].fileTime2 = 0U;
  c154_info[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c154_info[11].name = "isreal";
  c154_info[11].dominantType = "double";
  c154_info[11].resolved = "[B]isreal";
  c154_info[11].fileLength = 0U;
  c154_info[11].fileTime1 = 0U;
  c154_info[11].fileTime2 = 0U;
  c154_info[12].context = "";
  c154_info[12].name = "plus";
  c154_info[12].dominantType = "double";
  c154_info[12].resolved = "[B]plus";
  c154_info[12].fileLength = 0U;
  c154_info[12].fileTime1 = 0U;
  c154_info[12].fileTime2 = 0U;
  c154_info[13].context = "";
  c154_info[13].name = "ne";
  c154_info[13].dominantType = "double";
  c154_info[13].resolved = "[B]ne";
  c154_info[13].fileLength = 0U;
  c154_info[13].fileTime1 = 0U;
  c154_info[13].fileTime2 = 0U;
  c154_info[14].context = "";
  c154_info[14].name = "eq";
  c154_info[14].dominantType = "double";
  c154_info[14].resolved = "[B]eq";
  c154_info[14].fileLength = 0U;
  c154_info[14].fileTime1 = 0U;
  c154_info[14].fileTime2 = 0U;
  c154_info[15].context = "";
  c154_info[15].name = "lt";
  c154_info[15].dominantType = "double";
  c154_info[15].resolved = "[B]lt";
  c154_info[15].fileLength = 0U;
  c154_info[15].fileTime1 = 0U;
  c154_info[15].fileTime2 = 0U;
  c154_info[16].context = "";
  c154_info[16].name = "minus";
  c154_info[16].dominantType = "double";
  c154_info[16].resolved = "[B]minus";
  c154_info[16].fileLength = 0U;
  c154_info[16].fileTime1 = 0U;
  c154_info[16].fileTime2 = 0U;
  c154_info[17].context = "";
  c154_info[17].name = "mrdivide";
  c154_info[17].dominantType = "double";
  c154_info[17].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c154_info[17].fileLength = 771U;
  c154_info[17].fileTime1 = 1219752936U;
  c154_info[17].fileTime2 = 0U;
  c154_info[18].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c154_info[18].name = "ge";
  c154_info[18].dominantType = "double";
  c154_info[18].resolved = "[B]ge";
  c154_info[18].fileLength = 0U;
  c154_info[18].fileTime1 = 0U;
  c154_info[18].fileTime2 = 0U;
  c154_info[19].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c154_info[19].name = "isscalar";
  c154_info[19].dominantType = "double";
  c154_info[19].resolved = "[B]isscalar";
  c154_info[19].fileLength = 0U;
  c154_info[19].fileTime1 = 0U;
  c154_info[19].fileTime2 = 0U;
  c154_info[20].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c154_info[20].name = "rdivide";
  c154_info[20].dominantType = "double";
  c154_info[20].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c154_info[20].fileLength = 620U;
  c154_info[20].fileTime1 = 1213926766U;
  c154_info[20].fileTime2 = 0U;
  c154_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c154_info[21].name = "isempty";
  c154_info[21].dominantType = "double";
  c154_info[21].resolved = "[B]isempty";
  c154_info[21].fileLength = 0U;
  c154_info[21].fileTime1 = 0U;
  c154_info[21].fileTime2 = 0U;
  c154_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c154_info[22].name = "not";
  c154_info[22].dominantType = "logical";
  c154_info[22].resolved = "[B]not";
  c154_info[22].fileLength = 0U;
  c154_info[22].fileTime1 = 0U;
  c154_info[22].fileTime2 = 0U;
  c154_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c154_info[23].name = "strcmp";
  c154_info[23].dominantType = "char";
  c154_info[23].resolved = "[B]strcmp";
  c154_info[23].fileLength = 0U;
  c154_info[23].fileTime1 = 0U;
  c154_info[23].fileTime2 = 0U;
  c154_info[24].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c154_info[24].name = "eml_warning";
  c154_info[24].dominantType = "char";
  c154_info[24].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c154_info[24].fileLength = 274U;
  c154_info[24].fileTime1 = 1227613396U;
  c154_info[24].fileTime2 = 0U;
  c154_info[25].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c154_info[25].name = "eml_div";
  c154_info[25].dominantType = "double";
  c154_info[25].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c154_info[25].fileLength = 4269U;
  c154_info[25].fileTime1 = 1227613386U;
  c154_info[25].fileTime2 = 0U;
  c154_info[26].context = "";
  c154_info[26].name = "mpower";
  c154_info[26].dominantType = "double";
  c154_info[26].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c154_info[26].fileLength = 3623U;
  c154_info[26].fileTime1 = 1227613402U;
  c154_info[26].fileTime2 = 0U;
  c154_info[27].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c154_info[27].name = "ndims";
  c154_info[27].dominantType = "double";
  c154_info[27].resolved = "[B]ndims";
  c154_info[27].fileLength = 0U;
  c154_info[27].fileTime1 = 0U;
  c154_info[27].fileTime2 = 0U;
  c154_info[28].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c154_info[28].name = "power";
  c154_info[28].dominantType = "double";
  c154_info[28].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c154_info[28].fileLength = 5380U;
  c154_info[28].fileTime1 = 1227613402U;
  c154_info[28].fileTime2 = 0U;
  c154_info[29].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c154_info[29].name = "eml_scalar_eg";
  c154_info[29].dominantType = "double";
  c154_info[29].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c154_info[29].fileLength = 3524U;
  c154_info[29].fileTime1 = 1227613394U;
  c154_info[29].fileTime2 = 0U;
  c154_info[30].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/any_enums";
  c154_info[30].name = "false";
  c154_info[30].dominantType = "";
  c154_info[30].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c154_info[30].fileLength = 238U;
  c154_info[30].fileTime1 = 1192466720U;
  c154_info[30].fileTime2 = 0U;
  c154_info[31].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c154_info[31].name = "logical";
  c154_info[31].dominantType = "double";
  c154_info[31].resolved = "[B]logical";
  c154_info[31].fileLength = 0U;
  c154_info[31].fileTime1 = 0U;
  c154_info[31].fileTime2 = 0U;
  c154_info[32].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c154_info[32].name = "isstruct";
  c154_info[32].dominantType = "double";
  c154_info[32].resolved = "[B]isstruct";
  c154_info[32].fileLength = 0U;
  c154_info[32].fileTime1 = 0U;
  c154_info[32].fileTime2 = 0U;
  c154_info[33].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/zerosum";
  c154_info[33].name = "cast";
  c154_info[33].dominantType = "double";
  c154_info[33].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c154_info[33].fileLength = 889U;
  c154_info[33].fileTime1 = 1225989442U;
  c154_info[33].fileTime2 = 0U;
  c154_info[34].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c154_info[34].name = "double";
  c154_info[34].dominantType = "double";
  c154_info[34].resolved = "[B]double";
  c154_info[34].fileLength = 0U;
  c154_info[34].fileTime1 = 0U;
  c154_info[34].fileTime2 = 0U;
  c154_info[35].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c154_info[35].name = "eml_scalexp_alloc";
  c154_info[35].dominantType = "double";
  c154_info[35].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c154_info[35].fileLength = 794U;
  c154_info[35].fileTime1 = 1227613394U;
  c154_info[35].fileTime2 = 0U;
  c154_info[36].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c154_info[36].name = "eml_scalar_floor";
  c154_info[36].dominantType = "double";
  c154_info[36].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c154_info[36].fileLength = 260U;
  c154_info[36].fileTime1 = 1209330790U;
  c154_info[36].fileTime2 = 0U;
  c154_info[37].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c154_info[37].name = "eml_error";
  c154_info[37].dominantType = "char";
  c154_info[37].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c154_info[37].fileLength = 315U;
  c154_info[37].fileTime1 = 1213926746U;
  c154_info[37].fileTime2 = 0U;
  c154_info[38].context = "";
  c154_info[38].name = "mtimes";
  c154_info[38].dominantType = "double";
  c154_info[38].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c154_info[38].fileLength = 2408U;
  c154_info[38].fileTime1 = 1227613402U;
  c154_info[38].fileTime2 = 0U;
  c154_info[39].context = "";
  c154_info[39].name = "le";
  c154_info[39].dominantType = "double";
  c154_info[39].resolved = "[B]le";
  c154_info[39].fileLength = 0U;
  c154_info[39].fileTime1 = 0U;
  c154_info[39].fileTime2 = 0U;
}

static const mxArray *c154_emlrt_marshallOut(uint8_T c154_u)
{
  const mxArray *c154_y = NULL;
  c154_y = NULL;
  sf_mex_assign(&c154_y, sf_mex_create("y", &c154_u, 3, 0U, 0U, 0U, 0));
  return c154_y;
}

static real_T c154_emlrt_marshallIn(const mxArray *c154_CurrentlyBestSolution,
  char *c154_name)
{
  real_T c154_y;
  real_T c154_d10;
  sf_mex_import(c154_name, sf_mex_dup(c154_CurrentlyBestSolution), &c154_d10, 1,
                0, 0U, 0, 0U, 0);
  c154_y = c154_d10;
  sf_mex_destroy(&c154_CurrentlyBestSolution);
  return c154_y;
}

static void c154_b_emlrt_marshallIn(const mxArray *c154_TotalSectorConsumption,
  char *c154_name, real_T c154_y[9])
{
  real_T c154_dv3[9];
  int32_T c154_i66;
  sf_mex_import(c154_name, sf_mex_dup(c154_TotalSectorConsumption), &c154_dv3, 1,
                0, 0U, 1, 0U, 1, 9);
  for (c154_i66 = 0; c154_i66 < 9; c154_i66 = c154_i66 + 1) {
    c154_y[c154_i66] = c154_dv3[c154_i66];
  }

  sf_mex_destroy(&c154_TotalSectorConsumption);
}

static void c154_c_emlrt_marshallIn(const mxArray *c154_TotalSumofSlackVariables,
  char *c154_name, real_T c154_y[18])
{
  real_T c154_dv4[18];
  int32_T c154_i67;
  sf_mex_import(c154_name, sf_mex_dup(c154_TotalSumofSlackVariables), &c154_dv4,
                1, 0, 0U, 1, 0U, 2, 9, 2);
  for (c154_i67 = 0; c154_i67 < 18; c154_i67 = c154_i67 + 1) {
    c154_y[c154_i67] = c154_dv4[c154_i67];
  }

  sf_mex_destroy(&c154_TotalSumofSlackVariables);
}

static uint8_T c154_d_emlrt_marshallIn(const mxArray
  *c154_b_is_active_c154_MCSim, char *c154_name)
{
  uint8_T c154_y;
  uint8_T c154_u0;
  sf_mex_import(c154_name, sf_mex_dup(c154_b_is_active_c154_MCSim), &c154_u0, 1,
                3, 0U, 0, 0U, 0);
  c154_y = c154_u0;
  sf_mex_destroy(&c154_b_is_active_c154_MCSim);
  return c154_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c154_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(441837270U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(696787204U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1630938367U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2932697343U);
}

mxArray *sf_c154_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2559056842U);
    pr[1] = (double)(1728919238U);
    pr[2] = (double)(1965174709U);
    pr[3] = (double)(396362233U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,22,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,9,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }

    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,10,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,10,"type",mxType);
    }

    mxSetField(mxData,10,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,11,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,11,"type",mxType);
    }

    mxSetField(mxData,11,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,12,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,12,"type",mxType);
    }

    mxSetField(mxData,12,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,13,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,13,"type",mxType);
    }

    mxSetField(mxData,13,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,14,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,14,"type",mxType);
    }

    mxSetField(mxData,14,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,15,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,15,"type",mxType);
    }

    mxSetField(mxData,15,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,16,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,16,"type",mxType);
    }

    mxSetField(mxData,16,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,17,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,17,"type",mxType);
    }

    mxSetField(mxData,17,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,18,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,18,"type",mxType);
    }

    mxSetField(mxData,18,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,19,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,19,"type",mxType);
    }

    mxSetField(mxData,19,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,20,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,20,"type",mxType);
    }

    mxSetField(mxData,20,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,21,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,21,"type",mxType);
    }

    mxSetField(mxData,21,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(2);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c154_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[5],T\"CurrentlyBestSolution\",},{M[1],M[26],T\"TotalSectorConsumption\",},{M[1],M[27],T\"TotalSumofSlackVariables\",},{M[8],M[0],T\"is_active_c154_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c154_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          154,
          1,
          1,
          25,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Td1",0,c154_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "CurrentlyBestSolution",0,NULL);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Td2",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Td3",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Td4",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(5,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Td5",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(6,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Td6",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(7,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Td7",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(8,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Td8",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(9,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Td9",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(10,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s1",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(11,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s2",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(12,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s3",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(13,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s4",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(14,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s5",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(15,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s6",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(16,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s7",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(17,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s8",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(18,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s9",0,NULL);
          }

          _SFD_SET_DATA_PROPS(19,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"Plim",0,
                              c154_b_sf_marshall);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(20,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"powerThrustRelationVec",0,NULL);
          }

          _SFD_SET_DATA_PROPS(21,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "previousBestSolution",0,NULL);

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(22,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"TotalSectorConsumption",0,
                                c154_c_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 9;
            dimVector[1]= 2;
            _SFD_SET_DATA_PROPS(23,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"TotalSumofSlackVariables",0,
                                c154_d_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(24,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"tau_c",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,3,19,0,14,0,6,3);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,5327);
        _SFD_CV_INIT_EML_FCN(0,1,"sortingFunc",5359,-1,5763);
        _SFD_CV_INIT_EML_FCN(0,2,"findIndex",5765,-1,5943);
        _SFD_CV_INIT_EML_IF(0,0,1426,1434,1608,3099);
        _SFD_CV_INIT_EML_IF(0,1,1608,1620,1794,3099);
        _SFD_CV_INIT_EML_IF(0,2,1794,1806,1980,3099);
        _SFD_CV_INIT_EML_IF(0,3,1980,1992,2166,3099);
        _SFD_CV_INIT_EML_IF(0,4,2166,2178,2352,3099);
        _SFD_CV_INIT_EML_IF(0,5,2352,2364,2538,3099);
        _SFD_CV_INIT_EML_IF(0,6,2538,2550,2724,3099);
        _SFD_CV_INIT_EML_IF(0,7,2724,2736,2910,3099);
        _SFD_CV_INIT_EML_IF(0,8,2910,2922,-1,2922);
        _SFD_CV_INIT_EML_IF(0,9,3209,3231,3290,5323);
        _SFD_CV_INIT_EML_IF(0,10,3638,3695,-1,4004);
        _SFD_CV_INIT_EML_IF(0,11,3713,3929,-1,3988);
        _SFD_CV_INIT_EML_IF(0,12,4152,4273,4600,5315);
        _SFD_CV_INIT_EML_IF(0,13,4286,4364,-1,4463);
        _SFD_CV_INIT_EML_IF(0,14,4754,4968,5064,5303);
        _SFD_CV_INIT_EML_IF(0,15,5064,5150,-1,5151);
        _SFD_CV_INIT_EML_IF(0,16,5502,5537,-1,5583);
        _SFD_CV_INIT_EML_IF(0,17,5604,5620,-1,5748);
        _SFD_CV_INIT_EML_IF(0,18,5861,5891,-1,5931);
        _SFD_CV_INIT_EML_FOR(0,0,1406,1418,3111);
        _SFD_CV_INIT_EML_FOR(0,1,1447,1459,1599);
        _SFD_CV_INIT_EML_FOR(0,2,1633,1645,1785);
        _SFD_CV_INIT_EML_FOR(0,3,1819,1831,1971);
        _SFD_CV_INIT_EML_FOR(0,4,2005,2017,2157);
        _SFD_CV_INIT_EML_FOR(0,5,2191,2203,2343);
        _SFD_CV_INIT_EML_FOR(0,6,2377,2389,2529);
        _SFD_CV_INIT_EML_FOR(0,7,2563,2575,2715);
        _SFD_CV_INIT_EML_FOR(0,8,2749,2761,2901);
        _SFD_CV_INIT_EML_FOR(0,9,2935,2947,3087);
        _SFD_CV_INIT_EML_FOR(0,10,3419,3431,4016);
        _SFD_CV_INIT_EML_FOR(0,11,5437,5447,5756);
        _SFD_CV_INIT_EML_FOR(0,12,5476,5490,5595);
        _SFD_CV_INIT_EML_FOR(0,13,5842,5853,5939);

        {
          static int condStart[] = { 3717, 3848 };

          static int condEnd[] = { 3842, 3927 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,0,3716,3928,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 4157, 4216 };

          static int condEnd[] = { 4210, 4271 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,4156,4272,2,2,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 4758, 4889 };

          static int condEnd[] = { 4883, 4966 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,2,4757,4967,2,4,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c154_Td1)[3];
          real_T *c154_CurrentlyBestSolution;
          real_T (*c154_Td2)[3];
          real_T (*c154_Td3)[3];
          real_T (*c154_Td4)[3];
          real_T (*c154_Td5)[3];
          real_T (*c154_Td6)[3];
          real_T (*c154_Td7)[3];
          real_T (*c154_Td8)[3];
          real_T (*c154_Td9)[3];
          real_T (*c154_s1)[3];
          real_T (*c154_s2)[3];
          real_T (*c154_s3)[3];
          real_T (*c154_s4)[3];
          real_T (*c154_s5)[3];
          real_T (*c154_s6)[3];
          real_T (*c154_s7)[3];
          real_T (*c154_s8)[3];
          real_T (*c154_s9)[3];
          real_T *c154_Plim;
          real_T (*c154_powerThrustRelationVec)[3];
          real_T *c154_previousBestSolution;
          real_T (*c154_TotalSectorConsumption)[9];
          real_T (*c154_TotalSumofSlackVariables)[18];
          real_T (*c154_tau_c)[3];
          c154_s7 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 15);
          c154_Plim = (real_T *)ssGetInputPortSignal(chartInstance.S, 18);
          c154_s4 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 12);
          c154_Td8 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 7);
          c154_s9 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 17);
          c154_Td4 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
          c154_s1 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 9);
          c154_Td2 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
          c154_TotalSumofSlackVariables = (real_T (*)[18])ssGetOutputPortSignal
            (chartInstance.S, 3);
          c154_powerThrustRelationVec = (real_T (*)[3])ssGetInputPortSignal
            (chartInstance.S, 19);
          c154_Td3 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
          c154_Td7 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 6);
          c154_s3 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 11);
          c154_TotalSectorConsumption = (real_T (*)[9])ssGetOutputPortSignal
            (chartInstance.S, 2);
          c154_Td6 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 5);
          c154_Td9 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 8);
          c154_s6 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 14);
          c154_s5 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 13);
          c154_CurrentlyBestSolution = (real_T *)ssGetOutputPortSignal
            (chartInstance.S, 1);
          c154_tau_c = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 21);
          c154_Td1 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
          c154_s2 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 10);
          c154_Td5 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 4);
          c154_previousBestSolution = (real_T *)ssGetInputPortSignal
            (chartInstance.S, 20);
          c154_s8 = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 16);
          _SFD_SET_DATA_VALUE_PTR(0U, c154_Td1);
          _SFD_SET_DATA_VALUE_PTR(1U, c154_CurrentlyBestSolution);
          _SFD_SET_DATA_VALUE_PTR(2U, c154_Td2);
          _SFD_SET_DATA_VALUE_PTR(3U, c154_Td3);
          _SFD_SET_DATA_VALUE_PTR(4U, c154_Td4);
          _SFD_SET_DATA_VALUE_PTR(5U, c154_Td5);
          _SFD_SET_DATA_VALUE_PTR(6U, c154_Td6);
          _SFD_SET_DATA_VALUE_PTR(7U, c154_Td7);
          _SFD_SET_DATA_VALUE_PTR(8U, c154_Td8);
          _SFD_SET_DATA_VALUE_PTR(9U, c154_Td9);
          _SFD_SET_DATA_VALUE_PTR(10U, c154_s1);
          _SFD_SET_DATA_VALUE_PTR(11U, c154_s2);
          _SFD_SET_DATA_VALUE_PTR(12U, c154_s3);
          _SFD_SET_DATA_VALUE_PTR(13U, c154_s4);
          _SFD_SET_DATA_VALUE_PTR(14U, c154_s5);
          _SFD_SET_DATA_VALUE_PTR(15U, c154_s6);
          _SFD_SET_DATA_VALUE_PTR(16U, c154_s7);
          _SFD_SET_DATA_VALUE_PTR(17U, c154_s8);
          _SFD_SET_DATA_VALUE_PTR(18U, c154_s9);
          _SFD_SET_DATA_VALUE_PTR(19U, c154_Plim);
          _SFD_SET_DATA_VALUE_PTR(20U, c154_powerThrustRelationVec);
          _SFD_SET_DATA_VALUE_PTR(21U, c154_previousBestSolution);
          _SFD_SET_DATA_VALUE_PTR(22U, c154_TotalSectorConsumption);
          _SFD_SET_DATA_VALUE_PTR(23U, c154_TotalSumofSlackVariables);
          _SFD_SET_DATA_VALUE_PTR(24U, c154_tau_c);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c154_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c154_MCSim();
  initialize_c154_MCSim();
}

static void sf_opaque_enable_c154_MCSim(void *chartInstanceVar)
{
  enable_c154_MCSim();
}

static void sf_opaque_disable_c154_MCSim(void *chartInstanceVar)
{
  disable_c154_MCSim();
}

static void sf_opaque_gateway_c154_MCSim(void *chartInstanceVar)
{
  sf_c154_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c154_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c154_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c154_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c154_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c154_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c154_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c154_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c154_MCSim();
  }
}

static void mdlSetWorkWidths_c154_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",154);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",154,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",154,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 9, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 10, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 11, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 12, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 13, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 14, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 15, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 16, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 17, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 18, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 19, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 20, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 21, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",154,22);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",154,3);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",154);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(80286885U));
  ssSetChecksum1(S,(1325212434U));
  ssSetChecksum2(S,(178558369U));
  ssSetChecksum3(S,(719500818U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c154_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",154);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c154_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c154_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c154_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c154_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c154_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c154_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c154_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c154_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c154_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c154_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c154_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c154_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c154_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c154_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c154_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c154_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c154_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
