/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c156_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c156_IN_NO_ACTIVE_CHILD        (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc156_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c156_MCSim(void);
static void initialize_params_c156_MCSim(void);
static void enable_c156_MCSim(void);
static void disable_c156_MCSim(void);
static void c156_update_debugger_state_c156_MCSim(void);
static const mxArray *get_sim_state_c156_MCSim(void);
static void set_sim_state_c156_MCSim(const mxArray *c156_st);
static void finalize_c156_MCSim(void);
static void sf_c156_MCSim(void);
static void init_script_number_translation(uint32_T c156_machineNumber, uint32_T
  c156_chartNumber);
static const mxArray *c156_sf_marshall(void *c156_chartInstance, void *c156_u);
static const mxArray *c156_emlrt_marshallOut(uint8_T c156_u);
static real_T c156_emlrt_marshallIn(const mxArray *c156_reset, char *c156_name);
static uint8_T c156_b_emlrt_marshallIn(const mxArray
  *c156_b_is_active_c156_MCSim, char *c156_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c156_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c156_is_active_c156_MCSim = 0U;
}

static void initialize_params_c156_MCSim(void)
{
}

static void enable_c156_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c156_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c156_update_debugger_state_c156_MCSim(void)
{
}

static const mxArray *get_sim_state_c156_MCSim(void)
{
  const mxArray *c156_st = NULL;
  const mxArray *c156_y = NULL;
  real_T c156_u;
  const mxArray *c156_b_y = NULL;
  real_T *c156_reset;
  c156_reset = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c156_st = NULL;
  c156_y = NULL;
  sf_mex_assign(&c156_y, sf_mex_createcellarray(2));
  c156_u = *c156_reset;
  c156_b_y = NULL;
  sf_mex_assign(&c156_b_y, sf_mex_create("y", &c156_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c156_y, 0, c156_b_y);
  sf_mex_setcell(c156_y, 1, c156_emlrt_marshallOut
                 (chartInstance.c156_is_active_c156_MCSim));
  sf_mex_assign(&c156_st, c156_y);
  return c156_st;
}

static void set_sim_state_c156_MCSim(const mxArray *c156_st)
{
  const mxArray *c156_u;
  real_T *c156_reset;
  c156_reset = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c156_doneDoubleBufferReInit = true;
  c156_u = sf_mex_dup(c156_st);
  *c156_reset = c156_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c156_u, 0)),
    "reset");
  chartInstance.c156_is_active_c156_MCSim = c156_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c156_u, 1)), "is_active_c156_MCSim");
  sf_mex_destroy(&c156_u);
  c156_update_debugger_state_c156_MCSim();
  sf_mex_destroy(&c156_st);
}

static void finalize_c156_MCSim(void)
{
}

static void sf_c156_MCSim(void)
{
  uint8_T c156_previousEvent;
  real_T c156_Solution;
  real_T c156_prevSolution;
  real_T c156_nargout = 1.0;
  real_T c156_nargin = 2.0;
  real_T c156_reset;
  real_T *c156_b_Solution;
  real_T *c156_b_reset;
  real_T *c156_b_prevSolution;
  c156_b_reset = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c156_b_Solution = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c156_b_prevSolution = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,155);
  _SFD_DATA_RANGE_CHECK(*c156_b_Solution, 0U);
  _SFD_DATA_RANGE_CHECK(*c156_b_reset, 1U);
  _SFD_DATA_RANGE_CHECK(*c156_b_prevSolution, 2U);
  c156_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,155);
  c156_Solution = *c156_b_Solution;
  c156_prevSolution = *c156_b_prevSolution;
  sf_debug_symbol_scope_push(5U, 0U);
  sf_debug_symbol_scope_add("nargout", &c156_nargout, c156_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c156_nargin, c156_sf_marshall);
  sf_debug_symbol_scope_add("reset", &c156_reset, c156_sf_marshall);
  sf_debug_symbol_scope_add("prevSolution", &c156_prevSolution, c156_sf_marshall);
  sf_debug_symbol_scope_add("Solution", &c156_Solution, c156_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  c156_reset = 0.0;
  _SFD_EML_CALL(0,4);
  if (CV_EML_COND(0, 0, c156_Solution - c156_prevSolution > 0.5)) {
  } else if (CV_EML_COND(0, 1, c156_Solution - c156_prevSolution < -0.5)) {
  } else {
    CV_EML_MCDC(0, 0, false);
    CV_EML_IF(0, 0, false);
    goto label_1;
  }

  CV_EML_MCDC(0, 0, true);
  CV_EML_IF(0, 0, true);
  _SFD_EML_CALL(0,5);
  c156_reset = 1.0;
 label_1:
  ;
  _SFD_EML_CALL(0,-5);
  sf_debug_symbol_scope_pop();
  *c156_b_reset = c156_reset;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,155);
  _sfEvent_ = c156_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c156_machineNumber, uint32_T
  c156_chartNumber)
{
}

static const mxArray *c156_sf_marshall(void *c156_chartInstance, void *c156_u)
{
  const mxArray *c156_y = NULL;
  real_T c156_b_u;
  const mxArray *c156_b_y = NULL;
  c156_y = NULL;
  c156_b_u = *((real_T *)c156_u);
  c156_b_y = NULL;
  sf_mex_assign(&c156_b_y, sf_mex_create("y", &c156_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c156_y, c156_b_y);
  return c156_y;
}

const mxArray *sf_c156_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c156_nameCaptureInfo = NULL;
  c156_ResolvedFunctionInfo c156_info[4];
  c156_ResolvedFunctionInfo (*c156_b_info)[4];
  const mxArray *c156_m0 = NULL;
  int32_T c156_i0;
  c156_ResolvedFunctionInfo *c156_r0;
  c156_nameCaptureInfo = NULL;
  c156_b_info = (c156_ResolvedFunctionInfo (*)[4])c156_info;
  (*c156_b_info)[0].context = "";
  (*c156_b_info)[0].name = "minus";
  (*c156_b_info)[0].dominantType = "double";
  (*c156_b_info)[0].resolved = "[B]minus";
  (*c156_b_info)[0].fileLength = 0U;
  (*c156_b_info)[0].fileTime1 = 0U;
  (*c156_b_info)[0].fileTime2 = 0U;
  (*c156_b_info)[1].context = "";
  (*c156_b_info)[1].name = "gt";
  (*c156_b_info)[1].dominantType = "double";
  (*c156_b_info)[1].resolved = "[B]gt";
  (*c156_b_info)[1].fileLength = 0U;
  (*c156_b_info)[1].fileTime1 = 0U;
  (*c156_b_info)[1].fileTime2 = 0U;
  (*c156_b_info)[2].context = "";
  (*c156_b_info)[2].name = "uminus";
  (*c156_b_info)[2].dominantType = "double";
  (*c156_b_info)[2].resolved = "[B]uminus";
  (*c156_b_info)[2].fileLength = 0U;
  (*c156_b_info)[2].fileTime1 = 0U;
  (*c156_b_info)[2].fileTime2 = 0U;
  (*c156_b_info)[3].context = "";
  (*c156_b_info)[3].name = "lt";
  (*c156_b_info)[3].dominantType = "double";
  (*c156_b_info)[3].resolved = "[B]lt";
  (*c156_b_info)[3].fileLength = 0U;
  (*c156_b_info)[3].fileTime1 = 0U;
  (*c156_b_info)[3].fileTime2 = 0U;
  sf_mex_assign(&c156_m0, sf_mex_createstruct("nameCaptureInfo", 1, 4));
  for (c156_i0 = 0; c156_i0 < 4; c156_i0 = c156_i0 + 1) {
    c156_r0 = &c156_info[c156_i0];
    sf_mex_addfield(c156_m0, sf_mex_create("nameCaptureInfo", c156_r0->context,
      15, 0U, 0U, 0U, 2, 1, strlen(c156_r0->context)),
                    "context", "nameCaptureInfo", c156_i0);
    sf_mex_addfield(c156_m0, sf_mex_create("nameCaptureInfo", c156_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c156_r0->name)), "name",
                    "nameCaptureInfo", c156_i0);
    sf_mex_addfield(c156_m0, sf_mex_create("nameCaptureInfo",
      c156_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c156_r0->dominantType)
      ), "dominantType", "nameCaptureInfo", c156_i0);
    sf_mex_addfield(c156_m0, sf_mex_create("nameCaptureInfo", c156_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c156_r0->resolved)),
                    "resolved", "nameCaptureInfo", c156_i0);
    sf_mex_addfield(c156_m0, sf_mex_create("nameCaptureInfo",
      &c156_r0->fileLength, 7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c156_i0);
    sf_mex_addfield(c156_m0, sf_mex_create("nameCaptureInfo",
      &c156_r0->fileTime1, 7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c156_i0);
    sf_mex_addfield(c156_m0, sf_mex_create("nameCaptureInfo",
      &c156_r0->fileTime2, 7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c156_i0);
  }

  sf_mex_assign(&c156_nameCaptureInfo, c156_m0);
  return c156_nameCaptureInfo;
}

static const mxArray *c156_emlrt_marshallOut(uint8_T c156_u)
{
  const mxArray *c156_y = NULL;
  c156_y = NULL;
  sf_mex_assign(&c156_y, sf_mex_create("y", &c156_u, 3, 0U, 0U, 0U, 0));
  return c156_y;
}

static real_T c156_emlrt_marshallIn(const mxArray *c156_reset, char *c156_name)
{
  real_T c156_y;
  real_T c156_d0;
  sf_mex_import(c156_name, sf_mex_dup(c156_reset), &c156_d0, 1, 0, 0U, 0, 0U, 0);
  c156_y = c156_d0;
  sf_mex_destroy(&c156_reset);
  return c156_y;
}

static uint8_T c156_b_emlrt_marshallIn(const mxArray
  *c156_b_is_active_c156_MCSim, char *c156_name)
{
  uint8_T c156_y;
  uint8_T c156_u0;
  sf_mex_import(c156_name, sf_mex_dup(c156_b_is_active_c156_MCSim), &c156_u0, 1,
                3, 0U, 0, 0U, 0);
  c156_y = c156_u0;
  sf_mex_destroy(&c156_b_is_active_c156_MCSim);
  return c156_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c156_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(702179457U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3901667496U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3484695046U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1154286943U);
}

mxArray *sf_c156_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2893973736U);
    pr[1] = (double)(2596020752U);
    pr[2] = (double)(3172733527U);
    pr[3] = (double)(140120474U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c156_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"reset\",},{M[8],M[0],T\"is_active_c156_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c156_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          156,
          1,
          1,
          3,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "Solution",0,c156_sf_marshall);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"reset",0,
                              NULL);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "prevSolution",0,NULL);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,158);
        _SFD_CV_INIT_EML_IF(0,0,69,139,-1,158);

        {
          static int condStart[] = { 72, 107 };

          static int condEnd[] = { 103, 138 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,0,72,138,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T *c156_Solution;
          real_T *c156_reset;
          real_T *c156_prevSolution;
          c156_reset = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          c156_Solution = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
          c156_prevSolution = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c156_Solution);
          _SFD_SET_DATA_VALUE_PTR(1U, c156_reset);
          _SFD_SET_DATA_VALUE_PTR(2U, c156_prevSolution);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c156_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c156_MCSim();
  initialize_c156_MCSim();
}

static void sf_opaque_enable_c156_MCSim(void *chartInstanceVar)
{
  enable_c156_MCSim();
}

static void sf_opaque_disable_c156_MCSim(void *chartInstanceVar)
{
  disable_c156_MCSim();
}

static void sf_opaque_gateway_c156_MCSim(void *chartInstanceVar)
{
  sf_c156_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c156_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c156_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c156_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c156_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c156_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c156_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c156_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c156_MCSim();
  }
}

static void mdlSetWorkWidths_c156_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",156);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",156,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",156,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",156,2);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",156,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",156);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2329382702U));
  ssSetChecksum1(S,(1948877371U));
  ssSetChecksum2(S,(1538347639U));
  ssSetChecksum3(S,(160385891U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c156_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",156);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c156_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c156_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c156_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c156_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c156_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c156_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c156_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c156_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c156_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c156_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c156_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c156_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c156_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c156_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c156_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c156_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c156_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
