/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c1_MCSim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c1_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc1_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c1_MCSim(void);
static void initialize_params_c1_MCSim(void);
static void enable_c1_MCSim(void);
static void disable_c1_MCSim(void);
static void c1_update_debugger_state_c1_MCSim(void);
static const mxArray *get_sim_state_c1_MCSim(void);
static void set_sim_state_c1_MCSim(const mxArray *c1_st);
static void finalize_c1_MCSim(void);
static void sf_c1_MCSim(void);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_c_sf_marshall(void *c1_chartInstance, void *c1_u);
static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[18]);
static const mxArray *c1_emlrt_marshallOut(uint8_T c1_u);
static void c1_emlrt_marshallIn(const mxArray *c1_B_alphaPrev, char *c1_name,
  real_T c1_y[9]);
static uint8_T c1_b_emlrt_marshallIn(const mxArray *c1_b_is_active_c1_MCSim,
  char *c1_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c1_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c1_is_active_c1_MCSim = 0U;
}

static void initialize_params_c1_MCSim(void)
{
}

static void enable_c1_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c1_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c1_update_debugger_state_c1_MCSim(void)
{
}

static const mxArray *get_sim_state_c1_MCSim(void)
{
  const mxArray *c1_st = NULL;
  const mxArray *c1_y = NULL;
  int32_T c1_i0;
  real_T c1_u[9];
  const mxArray *c1_b_y = NULL;
  real_T (*c1_B_alphaPrev)[9];
  c1_B_alphaPrev = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  c1_st = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_createcellarray(2));
  for (c1_i0 = 0; c1_i0 < 9; c1_i0 = c1_i0 + 1) {
    c1_u[c1_i0] = (*c1_B_alphaPrev)[c1_i0];
  }

  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_setcell(c1_y, 0, c1_b_y);
  sf_mex_setcell(c1_y, 1, c1_emlrt_marshallOut
                 (chartInstance.c1_is_active_c1_MCSim));
  sf_mex_assign(&c1_st, c1_y);
  return c1_st;
}

static void set_sim_state_c1_MCSim(const mxArray *c1_st)
{
  const mxArray *c1_u;
  real_T c1_dv0[9];
  int32_T c1_i1;
  real_T (*c1_B_alphaPrev)[9];
  c1_B_alphaPrev = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c1_doneDoubleBufferReInit = true;
  c1_u = sf_mex_dup(c1_st);
  c1_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c1_u, 0)), "B_alphaPrev", c1_dv0);
  for (c1_i1 = 0; c1_i1 < 9; c1_i1 = c1_i1 + 1) {
    (*c1_B_alphaPrev)[c1_i1] = c1_dv0[c1_i1];
  }

  chartInstance.c1_is_active_c1_MCSim = c1_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c1_u, 1)), "is_active_c1_MCSim");
  sf_mex_destroy(&c1_u);
  c1_update_debugger_state_c1_MCSim();
  sf_mex_destroy(&c1_st);
}

static void finalize_c1_MCSim(void)
{
}

static void sf_c1_MCSim(void)
{
  int32_T c1_i2;
  int32_T c1_i3;
  int32_T c1_i4;
  int32_T c1_i5;
  uint8_T c1_previousEvent;
  int32_T c1_i6;
  real_T c1_alpha_prev[3];
  int32_T c1_i7;
  real_T c1_ly[3];
  int32_T c1_i8;
  real_T c1_lx[3];
  real_T c1_nargout = 1.0;
  real_T c1_nargin = 3.0;
  real_T c1_B_alphaPrev[9];
  real_T c1_x;
  real_T c1_a;
  real_T c1_b_x;
  real_T c1_b;
  real_T c1_y;
  real_T c1_c_x;
  real_T c1_d_x;
  real_T c1_e_x;
  real_T c1_b_a;
  real_T c1_b_b;
  real_T c1_b_y;
  real_T c1_f_x;
  real_T c1_c_a;
  real_T c1_g_x;
  real_T c1_c_b;
  real_T c1_c_y;
  real_T c1_h_x;
  real_T c1_i_x;
  real_T c1_j_x;
  real_T c1_d_a;
  real_T c1_d_b;
  real_T c1_d_y;
  real_T c1_k_x;
  real_T c1_e_a;
  real_T c1_l_x;
  real_T c1_e_b;
  real_T c1_e_y;
  real_T c1_m_x;
  real_T c1_n_x;
  real_T c1_o_x;
  real_T c1_f_a;
  real_T c1_f_b;
  real_T c1_f_y;
  real_T c1_p_x;
  real_T c1_q_x;
  real_T c1_r_x;
  real_T c1_s_x;
  real_T c1_t_x;
  real_T c1_u_x;
  real_T c1_v_x;
  real_T c1_w_x;
  real_T c1_x_x;
  real_T c1_y_x;
  real_T c1_ab_x;
  real_T c1_bb_x;
  real_T c1_cb_x;
  real_T c1_db_x;
  real_T c1_eb_x;
  real_T c1_fb_x;
  real_T c1_gb_x;
  real_T c1_hb_x;
  int32_T c1_i9;
  real_T (*c1_b_B_alphaPrev)[9];
  real_T (*c1_b_lx)[3];
  real_T (*c1_b_ly)[3];
  real_T (*c1_b_alpha_prev)[3];
  c1_b_B_alphaPrev = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  c1_b_lx = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  c1_b_alpha_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c1_b_ly = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,0);
  for (c1_i2 = 0; c1_i2 < 9; c1_i2 = c1_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_B_alphaPrev)[c1_i2], 0U);
  }

  for (c1_i3 = 0; c1_i3 < 3; c1_i3 = c1_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_alpha_prev)[c1_i3], 1U);
  }

  for (c1_i4 = 0; c1_i4 < 3; c1_i4 = c1_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_ly)[c1_i4], 2U);
  }

  for (c1_i5 = 0; c1_i5 < 3; c1_i5 = c1_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_lx)[c1_i5], 3U);
  }

  c1_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  for (c1_i6 = 0; c1_i6 < 3; c1_i6 = c1_i6 + 1) {
    c1_alpha_prev[c1_i6] = (*c1_b_alpha_prev)[c1_i6];
  }

  for (c1_i7 = 0; c1_i7 < 3; c1_i7 = c1_i7 + 1) {
    c1_ly[c1_i7] = (*c1_b_ly)[c1_i7];
  }

  for (c1_i8 = 0; c1_i8 < 3; c1_i8 = c1_i8 + 1) {
    c1_lx[c1_i8] = (*c1_b_lx)[c1_i8];
  }

  sf_debug_symbol_scope_push(6U, 0U);
  sf_debug_symbol_scope_add("nargout", &c1_nargout, c1_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c1_nargin, c1_c_sf_marshall);
  sf_debug_symbol_scope_add("B_alphaPrev", &c1_B_alphaPrev, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("lx", &c1_lx, c1_sf_marshall);
  sf_debug_symbol_scope_add("ly", &c1_ly, c1_sf_marshall);
  sf_debug_symbol_scope_add("alpha_prev", &c1_alpha_prev, c1_sf_marshall);
  CV_EML_FCN(0, 0);

  /*  Please see the article Constrained Nonlinear Control Allocation with Singularity Avoidance using  */
  /*  Sequential Quadratic Programmming by Tor.A.Johansen, Thor I. Fossen ... (2004) */
  _SFD_EML_CALL(0,6);
  c1_x = c1_alpha_prev[2];
  c1_a = c1_x;
  c1_b_x = c1_a;
  c1_a = c1_b_x;
  c1_a = muDoubleScalarSin(c1_a);
  c1_b = c1_lx[2];
  c1_y = c1_a * c1_b;
  c1_c_x = c1_alpha_prev[2];
  c1_d_x = c1_c_x;
  c1_e_x = c1_d_x;
  c1_d_x = c1_e_x;
  c1_d_x = muDoubleScalarCos(c1_d_x);
  c1_b_a = -c1_d_x;
  c1_b_b = c1_ly[2];
  c1_b_y = c1_b_a * c1_b_b;
  c1_f_x = c1_alpha_prev[1];
  c1_c_a = c1_f_x;
  c1_g_x = c1_c_a;
  c1_c_a = c1_g_x;
  c1_c_a = muDoubleScalarSin(c1_c_a);
  c1_c_b = c1_lx[1];
  c1_c_y = c1_c_a * c1_c_b;
  c1_h_x = c1_alpha_prev[1];
  c1_i_x = c1_h_x;
  c1_j_x = c1_i_x;
  c1_i_x = c1_j_x;
  c1_i_x = muDoubleScalarCos(c1_i_x);
  c1_d_a = -c1_i_x;
  c1_d_b = c1_ly[1];
  c1_d_y = c1_d_a * c1_d_b;
  c1_k_x = c1_alpha_prev[0];
  c1_e_a = c1_k_x;
  c1_l_x = c1_e_a;
  c1_e_a = c1_l_x;
  c1_e_a = muDoubleScalarSin(c1_e_a);
  c1_e_b = c1_lx[0];
  c1_e_y = c1_e_a * c1_e_b;
  c1_m_x = c1_alpha_prev[0];
  c1_n_x = c1_m_x;
  c1_o_x = c1_n_x;
  c1_n_x = c1_o_x;
  c1_n_x = muDoubleScalarCos(c1_n_x);
  c1_f_a = -c1_n_x;
  c1_f_b = c1_ly[0];
  c1_f_y = c1_f_a * c1_f_b;
  c1_p_x = c1_alpha_prev[2];
  c1_q_x = c1_p_x;
  c1_r_x = c1_q_x;
  c1_q_x = c1_r_x;
  c1_q_x = muDoubleScalarSin(c1_q_x);
  c1_s_x = c1_alpha_prev[1];
  c1_t_x = c1_s_x;
  c1_u_x = c1_t_x;
  c1_t_x = c1_u_x;
  c1_t_x = muDoubleScalarSin(c1_t_x);
  c1_v_x = c1_alpha_prev[0];
  c1_w_x = c1_v_x;
  c1_x_x = c1_w_x;
  c1_w_x = c1_x_x;
  c1_w_x = muDoubleScalarSin(c1_w_x);
  c1_y_x = c1_alpha_prev[2];
  c1_ab_x = c1_y_x;
  c1_bb_x = c1_ab_x;
  c1_ab_x = c1_bb_x;
  c1_ab_x = muDoubleScalarCos(c1_ab_x);
  c1_cb_x = c1_alpha_prev[1];
  c1_db_x = c1_cb_x;
  c1_eb_x = c1_db_x;
  c1_db_x = c1_eb_x;
  c1_db_x = muDoubleScalarCos(c1_db_x);
  c1_fb_x = c1_alpha_prev[0];
  c1_gb_x = c1_fb_x;
  c1_hb_x = c1_gb_x;
  c1_gb_x = c1_hb_x;
  c1_gb_x = muDoubleScalarCos(c1_gb_x);
  c1_B_alphaPrev[0] = c1_gb_x;
  c1_B_alphaPrev[3] = c1_db_x;
  c1_B_alphaPrev[6] = c1_ab_x;
  c1_B_alphaPrev[1] = c1_w_x;
  c1_B_alphaPrev[4] = c1_t_x;
  c1_B_alphaPrev[7] = c1_q_x;
  c1_B_alphaPrev[2] = c1_f_y + c1_e_y;
  c1_B_alphaPrev[5] = c1_d_y + c1_c_y;
  c1_B_alphaPrev[8] = c1_b_y + c1_y;
  _SFD_EML_CALL(0,-6);
  sf_debug_symbol_scope_pop();
  for (c1_i9 = 0; c1_i9 < 9; c1_i9 = c1_i9 + 1) {
    (*c1_b_B_alphaPrev)[c1_i9] = c1_B_alphaPrev[c1_i9];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  _sfEvent_ = c1_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
}

static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i10;
  real_T c1_b_u[3];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  for (c1_i10 = 0; c1_i10 < 3; c1_i10 = c1_i10 + 1) {
    c1_b_u[c1_i10] = (*((real_T (*)[3])c1_u))[c1_i10];
  }

  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i11;
  int32_T c1_i12;
  int32_T c1_i13;
  real_T c1_b_u[9];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_i11 = 0;
  for (c1_i12 = 0; c1_i12 < 3; c1_i12 = c1_i12 + 1) {
    for (c1_i13 = 0; c1_i13 < 3; c1_i13 = c1_i13 + 1) {
      c1_b_u[c1_i13 + c1_i11] = (*((real_T (*)[9])c1_u))[c1_i13 + c1_i11];
    }

    c1_i11 = c1_i11 + 3;
  }

  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_c_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

const mxArray *sf_c1_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo = NULL;
  c1_ResolvedFunctionInfo c1_info[18];
  const mxArray *c1_m0 = NULL;
  int32_T c1_i14;
  c1_ResolvedFunctionInfo *c1_r0;
  c1_nameCaptureInfo = NULL;
  c1_info_helper(c1_info);
  sf_mex_assign(&c1_m0, sf_mex_createstruct("nameCaptureInfo", 1, 18));
  for (c1_i14 = 0; c1_i14 < 18; c1_i14 = c1_i14 + 1) {
    c1_r0 = &c1_info[c1_i14];
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->context)), "context",
                    "nameCaptureInfo", c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c1_r0->name)), "name",
                    "nameCaptureInfo", c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c1_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c1_i14
                    );
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c1_i14
                    );
  }

  sf_mex_assign(&c1_nameCaptureInfo, c1_m0);
  return c1_nameCaptureInfo;
}

static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[18])
{
  c1_info[0].context = "";
  c1_info[0].name = "cos";
  c1_info[0].dominantType = "double";
  c1_info[0].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[0].fileLength = 324U;
  c1_info[0].fileTime1 = 1203447952U;
  c1_info[0].fileTime2 = 0U;
  c1_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[1].name = "nargin";
  c1_info[1].dominantType = "";
  c1_info[1].resolved = "[B]nargin";
  c1_info[1].fileLength = 0U;
  c1_info[1].fileTime1 = 0U;
  c1_info[1].fileTime2 = 0U;
  c1_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[2].name = "gt";
  c1_info[2].dominantType = "double";
  c1_info[2].resolved = "[B]gt";
  c1_info[2].fileLength = 0U;
  c1_info[2].fileTime1 = 0U;
  c1_info[2].fileTime2 = 0U;
  c1_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[3].name = "isa";
  c1_info[3].dominantType = "double";
  c1_info[3].resolved = "[B]isa";
  c1_info[3].fileLength = 0U;
  c1_info[3].fileTime1 = 0U;
  c1_info[3].fileTime2 = 0U;
  c1_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[4].name = "eml_scalar_cos";
  c1_info[4].dominantType = "double";
  c1_info[4].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c1_info[4].fileLength = 602U;
  c1_info[4].fileTime1 = 1209330788U;
  c1_info[4].fileTime2 = 0U;
  c1_info[5].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c1_info[5].name = "isreal";
  c1_info[5].dominantType = "double";
  c1_info[5].resolved = "[B]isreal";
  c1_info[5].fileLength = 0U;
  c1_info[5].fileTime1 = 0U;
  c1_info[5].fileTime2 = 0U;
  c1_info[6].context = "";
  c1_info[6].name = "sin";
  c1_info[6].dominantType = "double";
  c1_info[6].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c1_info[6].fileLength = 324U;
  c1_info[6].fileTime1 = 1203448042U;
  c1_info[6].fileTime2 = 0U;
  c1_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c1_info[7].name = "eml_scalar_sin";
  c1_info[7].dominantType = "double";
  c1_info[7].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c1_info[7].fileLength = 601U;
  c1_info[7].fileTime1 = 1209330792U;
  c1_info[7].fileTime2 = 0U;
  c1_info[8].context = "";
  c1_info[8].name = "uminus";
  c1_info[8].dominantType = "double";
  c1_info[8].resolved = "[B]uminus";
  c1_info[8].fileLength = 0U;
  c1_info[8].fileTime1 = 0U;
  c1_info[8].fileTime2 = 0U;
  c1_info[9].context = "";
  c1_info[9].name = "mtimes";
  c1_info[9].dominantType = "double";
  c1_info[9].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[9].fileLength = 2408U;
  c1_info[9].fileTime1 = 1227613402U;
  c1_info[9].fileTime2 = 0U;
  c1_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[10].name = "isinteger";
  c1_info[10].dominantType = "double";
  c1_info[10].resolved = "[B]isinteger";
  c1_info[10].fileLength = 0U;
  c1_info[10].fileTime1 = 0U;
  c1_info[10].fileTime2 = 0U;
  c1_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[11].name = "isscalar";
  c1_info[11].dominantType = "double";
  c1_info[11].resolved = "[B]isscalar";
  c1_info[11].fileLength = 0U;
  c1_info[11].fileTime1 = 0U;
  c1_info[11].fileTime2 = 0U;
  c1_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[12].name = "strcmp";
  c1_info[12].dominantType = "char";
  c1_info[12].resolved = "[B]strcmp";
  c1_info[12].fileLength = 0U;
  c1_info[12].fileTime1 = 0U;
  c1_info[12].fileTime2 = 0U;
  c1_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[13].name = "size";
  c1_info[13].dominantType = "double";
  c1_info[13].resolved = "[B]size";
  c1_info[13].fileLength = 0U;
  c1_info[13].fileTime1 = 0U;
  c1_info[13].fileTime2 = 0U;
  c1_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[14].name = "eq";
  c1_info[14].dominantType = "double";
  c1_info[14].resolved = "[B]eq";
  c1_info[14].fileLength = 0U;
  c1_info[14].fileTime1 = 0U;
  c1_info[14].fileTime2 = 0U;
  c1_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[15].name = "class";
  c1_info[15].dominantType = "double";
  c1_info[15].resolved = "[B]class";
  c1_info[15].fileLength = 0U;
  c1_info[15].fileTime1 = 0U;
  c1_info[15].fileTime2 = 0U;
  c1_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[16].name = "not";
  c1_info[16].dominantType = "logical";
  c1_info[16].resolved = "[B]not";
  c1_info[16].fileLength = 0U;
  c1_info[16].fileTime1 = 0U;
  c1_info[16].fileTime2 = 0U;
  c1_info[17].context = "";
  c1_info[17].name = "plus";
  c1_info[17].dominantType = "double";
  c1_info[17].resolved = "[B]plus";
  c1_info[17].fileLength = 0U;
  c1_info[17].fileTime1 = 0U;
  c1_info[17].fileTime2 = 0U;
}

static const mxArray *c1_emlrt_marshallOut(uint8_T c1_u)
{
  const mxArray *c1_y = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 3, 0U, 0U, 0U, 0));
  return c1_y;
}

static void c1_emlrt_marshallIn(const mxArray *c1_B_alphaPrev, char *c1_name,
  real_T c1_y[9])
{
  real_T c1_dv1[9];
  int32_T c1_i15;
  sf_mex_import(c1_name, sf_mex_dup(c1_B_alphaPrev), &c1_dv1, 1, 0, 0U, 1, 0U, 2,
                3, 3);
  for (c1_i15 = 0; c1_i15 < 9; c1_i15 = c1_i15 + 1) {
    c1_y[c1_i15] = c1_dv1[c1_i15];
  }

  sf_mex_destroy(&c1_B_alphaPrev);
}

static uint8_T c1_b_emlrt_marshallIn(const mxArray *c1_b_is_active_c1_MCSim,
  char *c1_name)
{
  uint8_T c1_y;
  uint8_T c1_u0;
  sf_mex_import(c1_name, sf_mex_dup(c1_b_is_active_c1_MCSim), &c1_u0, 1, 3, 0U,
                0, 0U, 0);
  c1_y = c1_u0;
  sf_mex_destroy(&c1_b_is_active_c1_MCSim);
  return c1_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c1_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(660187962U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1739303454U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(394939547U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4273871965U);
}

mxArray *sf_c1_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2081849140U);
    pr[1] = (double)(2736806433U);
    pr[2] = (double)(2789260076U);
    pr[3] = (double)(2247808238U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c1_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"B_alphaPrev\",},{M[8],M[0],T\"is_active_c1_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c1_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          1,
          1,
          1,
          4,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(0,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"B_alphaPrev",0,c1_b_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"alpha_prev",0,c1_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"ly",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"lx",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,654);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c1_B_alphaPrev)[9];
          real_T (*c1_alpha_prev)[3];
          real_T (*c1_ly)[3];
          real_T (*c1_lx)[3];
          c1_B_alphaPrev = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S,
            1);
          c1_lx = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
          c1_alpha_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
          c1_ly = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c1_B_alphaPrev);
          _SFD_SET_DATA_VALUE_PTR(1U, c1_alpha_prev);
          _SFD_SET_DATA_VALUE_PTR(2U, c1_ly);
          _SFD_SET_DATA_VALUE_PTR(3U, c1_lx);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c1_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c1_MCSim();
  initialize_c1_MCSim();
}

static void sf_opaque_enable_c1_MCSim(void *chartInstanceVar)
{
  enable_c1_MCSim();
}

static void sf_opaque_disable_c1_MCSim(void *chartInstanceVar)
{
  disable_c1_MCSim();
}

static void sf_opaque_gateway_c1_MCSim(void *chartInstanceVar)
{
  sf_c1_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c1_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c1_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c1_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c1_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c1_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c1_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_MCSim();
  }
}

static void mdlSetWorkWidths_c1_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",1,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",1,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",1,3);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",1,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(4037392952U));
  ssSetChecksum1(S,(2637713160U));
  ssSetChecksum2(S,(313856505U));
  ssSetChecksum3(S,(2564037237U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",1);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c1_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c1_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c1_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c1_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c1_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c1_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c1_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c1_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c1_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c1_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c1_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
