/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c27_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c27_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc27_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c27_MCSim(void);
static void initialize_params_c27_MCSim(void);
static void enable_c27_MCSim(void);
static void disable_c27_MCSim(void);
static void c27_update_debugger_state_c27_MCSim(void);
static const mxArray *get_sim_state_c27_MCSim(void);
static void set_sim_state_c27_MCSim(const mxArray *c27_st);
static void finalize_c27_MCSim(void);
static void sf_c27_MCSim(void);
static void init_script_number_translation(uint32_T c27_machineNumber, uint32_T
  c27_chartNumber);
static const mxArray *c27_sf_marshall(void *c27_chartInstance, void *c27_u);
static const mxArray *c27_b_sf_marshall(void *c27_chartInstance, void *c27_u);
static const mxArray *c27_c_sf_marshall(void *c27_chartInstance, void *c27_u);
static const mxArray *c27_emlrt_marshallOut(uint8_T c27_u);
static void c27_emlrt_marshallIn(const mxArray *c27_H_vec, char *c27_name,
  real_T c27_y[81]);
static uint8_T c27_b_emlrt_marshallIn(const mxArray *c27_b_is_active_c27_MCSim,
  char *c27_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c27_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c27_is_active_c27_MCSim = 0U;
}

static void initialize_params_c27_MCSim(void)
{
}

static void enable_c27_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c27_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c27_update_debugger_state_c27_MCSim(void)
{
}

static const mxArray *get_sim_state_c27_MCSim(void)
{
  const mxArray *c27_st = NULL;
  const mxArray *c27_y = NULL;
  int32_T c27_i0;
  real_T c27_u[81];
  const mxArray *c27_b_y = NULL;
  real_T (*c27_H_vec)[81];
  c27_H_vec = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
  c27_st = NULL;
  c27_y = NULL;
  sf_mex_assign(&c27_y, sf_mex_createcellarray(2));
  for (c27_i0 = 0; c27_i0 < 81; c27_i0 = c27_i0 + 1) {
    c27_u[c27_i0] = (*c27_H_vec)[c27_i0];
  }

  c27_b_y = NULL;
  sf_mex_assign(&c27_b_y, sf_mex_create("y", &c27_u, 0, 0U, 1U, 0U, 1, 81));
  sf_mex_setcell(c27_y, 0, c27_b_y);
  sf_mex_setcell(c27_y, 1, c27_emlrt_marshallOut
                 (chartInstance.c27_is_active_c27_MCSim));
  sf_mex_assign(&c27_st, c27_y);
  return c27_st;
}

static void set_sim_state_c27_MCSim(const mxArray *c27_st)
{
  const mxArray *c27_u;
  real_T c27_dv0[81];
  int32_T c27_i1;
  real_T (*c27_H_vec)[81];
  c27_H_vec = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c27_doneDoubleBufferReInit = true;
  c27_u = sf_mex_dup(c27_st);
  c27_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c27_u, 0)), "H_vec", c27_dv0);
  for (c27_i1 = 0; c27_i1 < 81; c27_i1 = c27_i1 + 1) {
    (*c27_H_vec)[c27_i1] = c27_dv0[c27_i1];
  }

  chartInstance.c27_is_active_c27_MCSim = c27_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c27_u, 1)), "is_active_c27_MCSim");
  sf_mex_destroy(&c27_u);
  c27_update_debugger_state_c27_MCSim();
  sf_mex_destroy(&c27_st);
}

static void finalize_c27_MCSim(void)
{
}

static void sf_c27_MCSim(void)
{
  int32_T c27_i2;
  int32_T c27_i3;
  uint8_T c27_previousEvent;
  int32_T c27_i4;
  real_T c27_H[81];
  real_T c27_nargout = 1.0;
  real_T c27_nargin = 1.0;
  real_T c27_j;
  real_T c27_i;
  real_T c27_k;
  real_T c27_H_vec[81];
  int32_T c27_i5;
  real_T c27_b_i;
  real_T c27_b_j;
  int32_T c27_i6;
  real_T (*c27_b_H_vec)[81];
  real_T (*c27_b_H)[81];
  c27_b_H = (real_T (*)[81])ssGetInputPortSignal(chartInstance.S, 0);
  c27_b_H_vec = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,26);
  for (c27_i2 = 0; c27_i2 < 81; c27_i2 = c27_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c27_b_H)[c27_i2], 0U);
  }

  for (c27_i3 = 0; c27_i3 < 81; c27_i3 = c27_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c27_b_H_vec)[c27_i3], 1U);
  }

  c27_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,26);
  for (c27_i4 = 0; c27_i4 < 81; c27_i4 = c27_i4 + 1) {
    c27_H[c27_i4] = (*c27_b_H)[c27_i4];
  }

  sf_debug_symbol_scope_push(7U, 0U);
  sf_debug_symbol_scope_add("nargout", &c27_nargout, c27_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c27_nargin, c27_c_sf_marshall);
  sf_debug_symbol_scope_add("j", &c27_j, c27_c_sf_marshall);
  sf_debug_symbol_scope_add("i", &c27_i, c27_c_sf_marshall);
  sf_debug_symbol_scope_add("k", &c27_k, c27_c_sf_marshall);
  sf_debug_symbol_scope_add("H_vec", &c27_H_vec, c27_b_sf_marshall);
  sf_debug_symbol_scope_add("H", &c27_H, c27_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  for (c27_i5 = 0; c27_i5 < 81; c27_i5 = c27_i5 + 1) {
    c27_H_vec[c27_i5] = 0.0;
  }

  _SFD_EML_CALL(0,4);
  c27_k = 1.0;
  c27_i = 1.0;
  c27_b_i = 1.0;
  while (c27_b_i <= 9.0) {
    c27_i = c27_b_i;
    CV_EML_FOR(0, 0, 1);
    c27_j = 1.0;
    c27_b_j = 1.0;
    while (c27_b_j <= 9.0) {
      c27_j = c27_b_j;
      CV_EML_FOR(0, 1, 1);
      _SFD_EML_CALL(0,7);
      c27_H_vec[_SFD_EML_ARRAY_BOUNDS_CHECK("H_vec", (int32_T)_SFD_INTEGER_CHECK
        ("k", c27_k), 1, 81, 1, 0) - 1] = c27_H[(
        _SFD_EML_ARRAY_BOUNDS_CHECK("H", (int32_T)_SFD_INTEGER_CHECK("i", c27_i),
        1, 9, 1, 0) - 1) + 9 * (_SFD_EML_ARRAY_BOUNDS_CHECK("H", (
        int32_T)_SFD_INTEGER_CHECK("j", c27_j), 1, 9, 2, 0) - 1)];
      _SFD_EML_CALL(0,8);
      c27_k = c27_k + 1.0;
      c27_b_j = c27_b_j + 1.0;
      sf_mex_listen_for_ctrl_c(chartInstance.S);
    }

    CV_EML_FOR(0, 1, 0);
    c27_b_i = c27_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,-8);
  sf_debug_symbol_scope_pop();
  for (c27_i6 = 0; c27_i6 < 81; c27_i6 = c27_i6 + 1) {
    (*c27_b_H_vec)[c27_i6] = c27_H_vec[c27_i6];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,26);
  _sfEvent_ = c27_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c27_machineNumber, uint32_T
  c27_chartNumber)
{
}

static const mxArray *c27_sf_marshall(void *c27_chartInstance, void *c27_u)
{
  const mxArray *c27_y = NULL;
  int32_T c27_i7;
  int32_T c27_i8;
  int32_T c27_i9;
  real_T c27_b_u[81];
  const mxArray *c27_b_y = NULL;
  c27_y = NULL;
  c27_i7 = 0;
  for (c27_i8 = 0; c27_i8 < 9; c27_i8 = c27_i8 + 1) {
    for (c27_i9 = 0; c27_i9 < 9; c27_i9 = c27_i9 + 1) {
      c27_b_u[c27_i9 + c27_i7] = (*((real_T (*)[81])c27_u))[c27_i9 + c27_i7];
    }

    c27_i7 = c27_i7 + 9;
  }

  c27_b_y = NULL;
  sf_mex_assign(&c27_b_y, sf_mex_create("y", &c27_b_u, 0, 0U, 1U, 0U, 2, 9, 9));
  sf_mex_assign(&c27_y, c27_b_y);
  return c27_y;
}

static const mxArray *c27_b_sf_marshall(void *c27_chartInstance, void *c27_u)
{
  const mxArray *c27_y = NULL;
  int32_T c27_i10;
  real_T c27_b_u[81];
  const mxArray *c27_b_y = NULL;
  c27_y = NULL;
  for (c27_i10 = 0; c27_i10 < 81; c27_i10 = c27_i10 + 1) {
    c27_b_u[c27_i10] = (*((real_T (*)[81])c27_u))[c27_i10];
  }

  c27_b_y = NULL;
  sf_mex_assign(&c27_b_y, sf_mex_create("y", &c27_b_u, 0, 0U, 1U, 0U, 1, 81));
  sf_mex_assign(&c27_y, c27_b_y);
  return c27_y;
}

static const mxArray *c27_c_sf_marshall(void *c27_chartInstance, void *c27_u)
{
  const mxArray *c27_y = NULL;
  real_T c27_b_u;
  const mxArray *c27_b_y = NULL;
  c27_y = NULL;
  c27_b_u = *((real_T *)c27_u);
  c27_b_y = NULL;
  sf_mex_assign(&c27_b_y, sf_mex_create("y", &c27_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c27_y, c27_b_y);
  return c27_y;
}

const mxArray *sf_c27_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c27_nameCaptureInfo = NULL;
  c27_ResolvedFunctionInfo c27_info[2];
  c27_ResolvedFunctionInfo (*c27_b_info)[2];
  const mxArray *c27_m0 = NULL;
  int32_T c27_i11;
  c27_ResolvedFunctionInfo *c27_r0;
  c27_nameCaptureInfo = NULL;
  c27_b_info = (c27_ResolvedFunctionInfo (*)[2])c27_info;
  (*c27_b_info)[0].context = "";
  (*c27_b_info)[0].name = "zeros";
  (*c27_b_info)[0].dominantType = "double";
  (*c27_b_info)[0].resolved = "[B]zeros";
  (*c27_b_info)[0].fileLength = 0U;
  (*c27_b_info)[0].fileTime1 = 0U;
  (*c27_b_info)[0].fileTime2 = 0U;
  (*c27_b_info)[1].context = "";
  (*c27_b_info)[1].name = "plus";
  (*c27_b_info)[1].dominantType = "double";
  (*c27_b_info)[1].resolved = "[B]plus";
  (*c27_b_info)[1].fileLength = 0U;
  (*c27_b_info)[1].fileTime1 = 0U;
  (*c27_b_info)[1].fileTime2 = 0U;
  sf_mex_assign(&c27_m0, sf_mex_createstruct("nameCaptureInfo", 1, 2));
  for (c27_i11 = 0; c27_i11 < 2; c27_i11 = c27_i11 + 1) {
    c27_r0 = &c27_info[c27_i11];
    sf_mex_addfield(c27_m0, sf_mex_create("nameCaptureInfo", c27_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c27_r0->context)), "context"
                    , "nameCaptureInfo", c27_i11);
    sf_mex_addfield(c27_m0, sf_mex_create("nameCaptureInfo", c27_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c27_r0->name)), "name",
                    "nameCaptureInfo", c27_i11);
    sf_mex_addfield(c27_m0, sf_mex_create("nameCaptureInfo",
      c27_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c27_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c27_i11);
    sf_mex_addfield(c27_m0, sf_mex_create("nameCaptureInfo", c27_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c27_r0->resolved)),
                    "resolved", "nameCaptureInfo", c27_i11);
    sf_mex_addfield(c27_m0, sf_mex_create("nameCaptureInfo", &c27_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c27_i11);
    sf_mex_addfield(c27_m0, sf_mex_create("nameCaptureInfo", &c27_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c27_i11);
    sf_mex_addfield(c27_m0, sf_mex_create("nameCaptureInfo", &c27_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c27_i11);
  }

  sf_mex_assign(&c27_nameCaptureInfo, c27_m0);
  return c27_nameCaptureInfo;
}

static const mxArray *c27_emlrt_marshallOut(uint8_T c27_u)
{
  const mxArray *c27_y = NULL;
  c27_y = NULL;
  sf_mex_assign(&c27_y, sf_mex_create("y", &c27_u, 3, 0U, 0U, 0U, 0));
  return c27_y;
}

static void c27_emlrt_marshallIn(const mxArray *c27_H_vec, char *c27_name,
  real_T c27_y[81])
{
  real_T c27_dv1[81];
  int32_T c27_i12;
  sf_mex_import(c27_name, sf_mex_dup(c27_H_vec), &c27_dv1, 1, 0, 0U, 1, 0U, 1,
                81);
  for (c27_i12 = 0; c27_i12 < 81; c27_i12 = c27_i12 + 1) {
    c27_y[c27_i12] = c27_dv1[c27_i12];
  }

  sf_mex_destroy(&c27_H_vec);
}

static uint8_T c27_b_emlrt_marshallIn(const mxArray *c27_b_is_active_c27_MCSim,
  char *c27_name)
{
  uint8_T c27_y;
  uint8_T c27_u0;
  sf_mex_import(c27_name, sf_mex_dup(c27_b_is_active_c27_MCSim), &c27_u0, 1, 3,
                0U, 0, 0U, 0);
  c27_y = c27_u0;
  sf_mex_destroy(&c27_b_is_active_c27_MCSim);
  return c27_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c27_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2169600051U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2603157316U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2382349039U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3160327206U);
}

mxArray *sf_c27_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(222549578U);
    pr[1] = (double)(876864768U);
    pr[2] = (double)(3432282439U);
    pr[3] = (double)(2285890142U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(9);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(81);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c27_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"H_vec\",},{M[8],M[0],T\"is_active_c27_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c27_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          27,
          1,
          1,
          2,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 9;
            dimVector[1]= 9;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"H",0,c27_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 81;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"H_vec",0,c27_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,2,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,138);
        _SFD_CV_INIT_EML_FOR(0,0,58,68,138);
        _SFD_CV_INIT_EML_FOR(0,1,72,82,134);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c27_H)[81];
          real_T (*c27_H_vec)[81];
          c27_H = (real_T (*)[81])ssGetInputPortSignal(chartInstance.S, 0);
          c27_H_vec = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c27_H);
          _SFD_SET_DATA_VALUE_PTR(1U, c27_H_vec);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c27_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c27_MCSim();
  initialize_c27_MCSim();
}

static void sf_opaque_enable_c27_MCSim(void *chartInstanceVar)
{
  enable_c27_MCSim();
}

static void sf_opaque_disable_c27_MCSim(void *chartInstanceVar)
{
  disable_c27_MCSim();
}

static void sf_opaque_gateway_c27_MCSim(void *chartInstanceVar)
{
  sf_c27_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c27_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c27_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c27_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c27_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c27_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c27_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c27_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c27_MCSim();
  }
}

static void mdlSetWorkWidths_c27_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",27);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",27,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",27,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",27,1);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",27,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",27);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1310352170U));
  ssSetChecksum1(S,(1281456450U));
  ssSetChecksum2(S,(2552640838U));
  ssSetChecksum3(S,(4137593247U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c27_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",27);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c27_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c27_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c27_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c27_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c27_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c27_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c27_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c27_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c27_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c27_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c27_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c27_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c27_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c27_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c27_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c27_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c27_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
