/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c42_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c42_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc42_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c42_MCSim(void);
static void initialize_params_c42_MCSim(void);
static void enable_c42_MCSim(void);
static void disable_c42_MCSim(void);
static void c42_update_debugger_state_c42_MCSim(void);
static const mxArray *get_sim_state_c42_MCSim(void);
static void set_sim_state_c42_MCSim(const mxArray *c42_st);
static void finalize_c42_MCSim(void);
static void sf_c42_MCSim(void);
static void init_script_number_translation(uint32_T c42_machineNumber, uint32_T
  c42_chartNumber);
static const mxArray *c42_sf_marshall(void *c42_chartInstance, void *c42_u);
static const mxArray *c42_b_sf_marshall(void *c42_chartInstance, void *c42_u);
static const mxArray *c42_c_sf_marshall(void *c42_chartInstance, void *c42_u);
static const mxArray *c42_emlrt_marshallOut(uint8_T c42_u);
static void c42_emlrt_marshallIn(const mxArray *c42_A_vec, char *c42_name,
  real_T c42_y[27]);
static uint8_T c42_b_emlrt_marshallIn(const mxArray *c42_b_is_active_c42_MCSim,
  char *c42_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c42_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c42_is_active_c42_MCSim = 0U;
}

static void initialize_params_c42_MCSim(void)
{
}

static void enable_c42_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c42_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c42_update_debugger_state_c42_MCSim(void)
{
}

static const mxArray *get_sim_state_c42_MCSim(void)
{
  const mxArray *c42_st = NULL;
  const mxArray *c42_y = NULL;
  int32_T c42_i0;
  real_T c42_u[27];
  const mxArray *c42_b_y = NULL;
  real_T (*c42_A_vec)[27];
  c42_A_vec = (real_T (*)[27])ssGetOutputPortSignal(chartInstance.S, 1);
  c42_st = NULL;
  c42_y = NULL;
  sf_mex_assign(&c42_y, sf_mex_createcellarray(2));
  for (c42_i0 = 0; c42_i0 < 27; c42_i0 = c42_i0 + 1) {
    c42_u[c42_i0] = (*c42_A_vec)[c42_i0];
  }

  c42_b_y = NULL;
  sf_mex_assign(&c42_b_y, sf_mex_create("y", &c42_u, 0, 0U, 1U, 0U, 1, 27));
  sf_mex_setcell(c42_y, 0, c42_b_y);
  sf_mex_setcell(c42_y, 1, c42_emlrt_marshallOut
                 (chartInstance.c42_is_active_c42_MCSim));
  sf_mex_assign(&c42_st, c42_y);
  return c42_st;
}

static void set_sim_state_c42_MCSim(const mxArray *c42_st)
{
  const mxArray *c42_u;
  real_T c42_dv0[27];
  int32_T c42_i1;
  real_T (*c42_A_vec)[27];
  c42_A_vec = (real_T (*)[27])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c42_doneDoubleBufferReInit = true;
  c42_u = sf_mex_dup(c42_st);
  c42_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c42_u, 0)), "A_vec", c42_dv0);
  for (c42_i1 = 0; c42_i1 < 27; c42_i1 = c42_i1 + 1) {
    (*c42_A_vec)[c42_i1] = c42_dv0[c42_i1];
  }

  chartInstance.c42_is_active_c42_MCSim = c42_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c42_u, 1)), "is_active_c42_MCSim");
  sf_mex_destroy(&c42_u);
  c42_update_debugger_state_c42_MCSim();
  sf_mex_destroy(&c42_st);
}

static void finalize_c42_MCSim(void)
{
}

static void sf_c42_MCSim(void)
{
  int32_T c42_i2;
  int32_T c42_i3;
  uint8_T c42_previousEvent;
  int32_T c42_i4;
  real_T c42_A[27];
  real_T c42_nargout = 1.0;
  real_T c42_nargin = 1.0;
  real_T c42_j;
  real_T c42_i;
  real_T c42_k;
  real_T c42_A_vec[27];
  int32_T c42_i5;
  real_T c42_b_i;
  real_T c42_b_j;
  int32_T c42_i6;
  real_T (*c42_b_A_vec)[27];
  real_T (*c42_b_A)[27];
  c42_b_A = (real_T (*)[27])ssGetInputPortSignal(chartInstance.S, 0);
  c42_b_A_vec = (real_T (*)[27])ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,41);
  for (c42_i2 = 0; c42_i2 < 27; c42_i2 = c42_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c42_b_A)[c42_i2], 0U);
  }

  for (c42_i3 = 0; c42_i3 < 27; c42_i3 = c42_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c42_b_A_vec)[c42_i3], 1U);
  }

  c42_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,41);
  for (c42_i4 = 0; c42_i4 < 27; c42_i4 = c42_i4 + 1) {
    c42_A[c42_i4] = (*c42_b_A)[c42_i4];
  }

  sf_debug_symbol_scope_push(7U, 0U);
  sf_debug_symbol_scope_add("nargout", &c42_nargout, c42_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c42_nargin, c42_c_sf_marshall);
  sf_debug_symbol_scope_add("j", &c42_j, c42_c_sf_marshall);
  sf_debug_symbol_scope_add("i", &c42_i, c42_c_sf_marshall);
  sf_debug_symbol_scope_add("k", &c42_k, c42_c_sf_marshall);
  sf_debug_symbol_scope_add("A_vec", &c42_A_vec, c42_b_sf_marshall);
  sf_debug_symbol_scope_add("A", &c42_A, c42_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  for (c42_i5 = 0; c42_i5 < 27; c42_i5 = c42_i5 + 1) {
    c42_A_vec[c42_i5] = 0.0;
  }

  _SFD_EML_CALL(0,4);
  c42_k = 1.0;
  c42_i = 1.0;
  c42_b_i = 1.0;
  while (c42_b_i <= 3.0) {
    c42_i = c42_b_i;
    CV_EML_FOR(0, 0, 1);
    c42_j = 1.0;
    c42_b_j = 1.0;
    while (c42_b_j <= 9.0) {
      c42_j = c42_b_j;
      CV_EML_FOR(0, 1, 1);
      _SFD_EML_CALL(0,7);
      c42_A_vec[_SFD_EML_ARRAY_BOUNDS_CHECK("A_vec", (int32_T)_SFD_INTEGER_CHECK
        ("k", c42_k), 1, 27, 1, 0) - 1] = c42_A[(
        _SFD_EML_ARRAY_BOUNDS_CHECK("A", (int32_T)_SFD_INTEGER_CHECK("i", c42_i),
        1, 3, 1, 0) - 1) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("A", (
        int32_T)_SFD_INTEGER_CHECK("j", c42_j), 1, 9, 2, 0) - 1)];
      _SFD_EML_CALL(0,8);
      c42_k = c42_k + 1.0;
      c42_b_j = c42_b_j + 1.0;
      sf_mex_listen_for_ctrl_c(chartInstance.S);
    }

    CV_EML_FOR(0, 1, 0);
    c42_b_i = c42_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,-8);
  sf_debug_symbol_scope_pop();
  for (c42_i6 = 0; c42_i6 < 27; c42_i6 = c42_i6 + 1) {
    (*c42_b_A_vec)[c42_i6] = c42_A_vec[c42_i6];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,41);
  _sfEvent_ = c42_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c42_machineNumber, uint32_T
  c42_chartNumber)
{
}

static const mxArray *c42_sf_marshall(void *c42_chartInstance, void *c42_u)
{
  const mxArray *c42_y = NULL;
  int32_T c42_i7;
  int32_T c42_i8;
  int32_T c42_i9;
  real_T c42_b_u[27];
  const mxArray *c42_b_y = NULL;
  c42_y = NULL;
  c42_i7 = 0;
  for (c42_i8 = 0; c42_i8 < 9; c42_i8 = c42_i8 + 1) {
    for (c42_i9 = 0; c42_i9 < 3; c42_i9 = c42_i9 + 1) {
      c42_b_u[c42_i9 + c42_i7] = (*((real_T (*)[27])c42_u))[c42_i9 + c42_i7];
    }

    c42_i7 = c42_i7 + 3;
  }

  c42_b_y = NULL;
  sf_mex_assign(&c42_b_y, sf_mex_create("y", &c42_b_u, 0, 0U, 1U, 0U, 2, 3, 9));
  sf_mex_assign(&c42_y, c42_b_y);
  return c42_y;
}

static const mxArray *c42_b_sf_marshall(void *c42_chartInstance, void *c42_u)
{
  const mxArray *c42_y = NULL;
  int32_T c42_i10;
  real_T c42_b_u[27];
  const mxArray *c42_b_y = NULL;
  c42_y = NULL;
  for (c42_i10 = 0; c42_i10 < 27; c42_i10 = c42_i10 + 1) {
    c42_b_u[c42_i10] = (*((real_T (*)[27])c42_u))[c42_i10];
  }

  c42_b_y = NULL;
  sf_mex_assign(&c42_b_y, sf_mex_create("y", &c42_b_u, 0, 0U, 1U, 0U, 1, 27));
  sf_mex_assign(&c42_y, c42_b_y);
  return c42_y;
}

static const mxArray *c42_c_sf_marshall(void *c42_chartInstance, void *c42_u)
{
  const mxArray *c42_y = NULL;
  real_T c42_b_u;
  const mxArray *c42_b_y = NULL;
  c42_y = NULL;
  c42_b_u = *((real_T *)c42_u);
  c42_b_y = NULL;
  sf_mex_assign(&c42_b_y, sf_mex_create("y", &c42_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c42_y, c42_b_y);
  return c42_y;
}

const mxArray *sf_c42_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c42_nameCaptureInfo = NULL;
  c42_ResolvedFunctionInfo c42_info[2];
  c42_ResolvedFunctionInfo (*c42_b_info)[2];
  const mxArray *c42_m0 = NULL;
  int32_T c42_i11;
  c42_ResolvedFunctionInfo *c42_r0;
  c42_nameCaptureInfo = NULL;
  c42_b_info = (c42_ResolvedFunctionInfo (*)[2])c42_info;
  (*c42_b_info)[0].context = "";
  (*c42_b_info)[0].name = "zeros";
  (*c42_b_info)[0].dominantType = "double";
  (*c42_b_info)[0].resolved = "[B]zeros";
  (*c42_b_info)[0].fileLength = 0U;
  (*c42_b_info)[0].fileTime1 = 0U;
  (*c42_b_info)[0].fileTime2 = 0U;
  (*c42_b_info)[1].context = "";
  (*c42_b_info)[1].name = "plus";
  (*c42_b_info)[1].dominantType = "double";
  (*c42_b_info)[1].resolved = "[B]plus";
  (*c42_b_info)[1].fileLength = 0U;
  (*c42_b_info)[1].fileTime1 = 0U;
  (*c42_b_info)[1].fileTime2 = 0U;
  sf_mex_assign(&c42_m0, sf_mex_createstruct("nameCaptureInfo", 1, 2));
  for (c42_i11 = 0; c42_i11 < 2; c42_i11 = c42_i11 + 1) {
    c42_r0 = &c42_info[c42_i11];
    sf_mex_addfield(c42_m0, sf_mex_create("nameCaptureInfo", c42_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c42_r0->context)), "context"
                    , "nameCaptureInfo", c42_i11);
    sf_mex_addfield(c42_m0, sf_mex_create("nameCaptureInfo", c42_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c42_r0->name)), "name",
                    "nameCaptureInfo", c42_i11);
    sf_mex_addfield(c42_m0, sf_mex_create("nameCaptureInfo",
      c42_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c42_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c42_i11);
    sf_mex_addfield(c42_m0, sf_mex_create("nameCaptureInfo", c42_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c42_r0->resolved)),
                    "resolved", "nameCaptureInfo", c42_i11);
    sf_mex_addfield(c42_m0, sf_mex_create("nameCaptureInfo", &c42_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c42_i11);
    sf_mex_addfield(c42_m0, sf_mex_create("nameCaptureInfo", &c42_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c42_i11);
    sf_mex_addfield(c42_m0, sf_mex_create("nameCaptureInfo", &c42_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c42_i11);
  }

  sf_mex_assign(&c42_nameCaptureInfo, c42_m0);
  return c42_nameCaptureInfo;
}

static const mxArray *c42_emlrt_marshallOut(uint8_T c42_u)
{
  const mxArray *c42_y = NULL;
  c42_y = NULL;
  sf_mex_assign(&c42_y, sf_mex_create("y", &c42_u, 3, 0U, 0U, 0U, 0));
  return c42_y;
}

static void c42_emlrt_marshallIn(const mxArray *c42_A_vec, char *c42_name,
  real_T c42_y[27])
{
  real_T c42_dv1[27];
  int32_T c42_i12;
  sf_mex_import(c42_name, sf_mex_dup(c42_A_vec), &c42_dv1, 1, 0, 0U, 1, 0U, 1,
                27);
  for (c42_i12 = 0; c42_i12 < 27; c42_i12 = c42_i12 + 1) {
    c42_y[c42_i12] = c42_dv1[c42_i12];
  }

  sf_mex_destroy(&c42_A_vec);
}

static uint8_T c42_b_emlrt_marshallIn(const mxArray *c42_b_is_active_c42_MCSim,
  char *c42_name)
{
  uint8_T c42_y;
  uint8_T c42_u0;
  sf_mex_import(c42_name, sf_mex_dup(c42_b_is_active_c42_MCSim), &c42_u0, 1, 3,
                0U, 0, 0U, 0);
  c42_y = c42_u0;
  sf_mex_destroy(&c42_b_is_active_c42_MCSim);
  return c42_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c42_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3950834652U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2172253082U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(420440582U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1577122341U);
}

mxArray *sf_c42_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3550758064U);
    pr[1] = (double)(760192856U);
    pr[2] = (double)(2414243788U);
    pr[3] = (double)(3064043277U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(9);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(27);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c42_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"A_vec\",},{M[8],M[0],T\"is_active_c42_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c42_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          42,
          1,
          1,
          2,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 9;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"A",0,c42_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 27;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"A_vec",0,c42_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,2,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,138);
        _SFD_CV_INIT_EML_FOR(0,0,58,68,138);
        _SFD_CV_INIT_EML_FOR(0,1,72,82,134);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c42_A)[27];
          real_T (*c42_A_vec)[27];
          c42_A = (real_T (*)[27])ssGetInputPortSignal(chartInstance.S, 0);
          c42_A_vec = (real_T (*)[27])ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c42_A);
          _SFD_SET_DATA_VALUE_PTR(1U, c42_A_vec);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c42_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c42_MCSim();
  initialize_c42_MCSim();
}

static void sf_opaque_enable_c42_MCSim(void *chartInstanceVar)
{
  enable_c42_MCSim();
}

static void sf_opaque_disable_c42_MCSim(void *chartInstanceVar)
{
  disable_c42_MCSim();
}

static void sf_opaque_gateway_c42_MCSim(void *chartInstanceVar)
{
  sf_c42_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c42_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c42_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c42_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c42_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c42_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c42_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c42_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c42_MCSim();
  }
}

static void mdlSetWorkWidths_c42_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",42);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",42,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",42,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",42,1);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",42,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",42);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2883695736U));
  ssSetChecksum1(S,(188676334U));
  ssSetChecksum2(S,(1012548967U));
  ssSetChecksum3(S,(2506711586U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c42_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",42);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c42_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c42_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c42_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c42_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c42_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c42_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c42_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c42_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c42_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c42_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c42_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c42_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c42_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c42_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c42_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c42_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c42_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
