/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c71_MCSim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c71_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc71_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c71_MCSim(void);
static void initialize_params_c71_MCSim(void);
static void enable_c71_MCSim(void);
static void disable_c71_MCSim(void);
static void c71_update_debugger_state_c71_MCSim(void);
static const mxArray *get_sim_state_c71_MCSim(void);
static void set_sim_state_c71_MCSim(const mxArray *c71_st);
static void finalize_c71_MCSim(void);
static void sf_c71_MCSim(void);
static void init_script_number_translation(uint32_T c71_machineNumber, uint32_T
  c71_chartNumber);
static void c71_eml_warning(void);
static const mxArray *c71_sf_marshall(void *c71_chartInstance, void *c71_u);
static const mxArray *c71_b_sf_marshall(void *c71_chartInstance, void *c71_u);
static const mxArray *c71_c_sf_marshall(void *c71_chartInstance, void *c71_u);
static const mxArray *c71_d_sf_marshall(void *c71_chartInstance, void *c71_u);
static void c71_info_helper(c71_ResolvedFunctionInfo c71_info[23]);
static const mxArray *c71_emlrt_marshallOut(uint8_T c71_u);
static void c71_emlrt_marshallIn(const mxArray *c71_H, char *c71_name, real_T
  c71_y[81]);
static uint8_T c71_b_emlrt_marshallIn(const mxArray *c71_b_is_active_c71_MCSim,
  char *c71_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c71_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c71_is_active_c71_MCSim = 0U;
}

static void initialize_params_c71_MCSim(void)
{
}

static void enable_c71_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c71_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c71_update_debugger_state_c71_MCSim(void)
{
}

static const mxArray *get_sim_state_c71_MCSim(void)
{
  const mxArray *c71_st = NULL;
  const mxArray *c71_y = NULL;
  int32_T c71_i0;
  real_T c71_u[81];
  const mxArray *c71_b_y = NULL;
  real_T (*c71_H)[81];
  c71_H = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
  c71_st = NULL;
  c71_y = NULL;
  sf_mex_assign(&c71_y, sf_mex_createcellarray(2));
  for (c71_i0 = 0; c71_i0 < 81; c71_i0 = c71_i0 + 1) {
    c71_u[c71_i0] = (*c71_H)[c71_i0];
  }

  c71_b_y = NULL;
  sf_mex_assign(&c71_b_y, sf_mex_create("y", &c71_u, 0, 0U, 1U, 0U, 2, 9, 9));
  sf_mex_setcell(c71_y, 0, c71_b_y);
  sf_mex_setcell(c71_y, 1, c71_emlrt_marshallOut
                 (chartInstance.c71_is_active_c71_MCSim));
  sf_mex_assign(&c71_st, c71_y);
  return c71_st;
}

static void set_sim_state_c71_MCSim(const mxArray *c71_st)
{
  const mxArray *c71_u;
  real_T c71_dv0[81];
  int32_T c71_i1;
  real_T (*c71_H)[81];
  c71_H = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c71_doneDoubleBufferReInit = true;
  c71_u = sf_mex_dup(c71_st);
  c71_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c71_u, 0)), "H", c71_dv0);
  for (c71_i1 = 0; c71_i1 < 81; c71_i1 = c71_i1 + 1) {
    (*c71_H)[c71_i1] = c71_dv0[c71_i1];
  }

  chartInstance.c71_is_active_c71_MCSim = c71_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c71_u, 1)), "is_active_c71_MCSim");
  sf_mex_destroy(&c71_u);
  c71_update_debugger_state_c71_MCSim();
  sf_mex_destroy(&c71_st);
}

static void finalize_c71_MCSim(void)
{
}

static void sf_c71_MCSim(void)
{
  int32_T c71_i2;
  int32_T c71_i3;
  int32_T c71_i4;
  int32_T c71_i5;
  int32_T c71_i6;
  uint8_T c71_previousEvent;
  int32_T c71_i7;
  real_T c71_W_u[9];
  int32_T c71_i8;
  real_T c71_Omega[9];
  int32_T c71_i9;
  real_T c71_Q[9];
  int32_T c71_i10;
  real_T c71_T_d_prev[3];
  real_T c71_nargout = 1.0;
  real_T c71_nargin = 4.0;
  real_T c71_i;
  real_T c71_W[9];
  real_T c71_H[81];
  int32_T c71_i11;
  real_T c71_b_i;
  real_T c71_A;
  real_T c71_x;
  real_T c71_b_x;
  real_T c71_y;
  real_T c71_B;
  real_T c71_c_x;
  real_T c71_b_y;
  real_T c71_d_x;
  real_T c71_c_y;
  real_T c71_e_x;
  real_T c71_d_y;
  real_T c71_e_y;
  int32_T c71_i12;
  int32_T c71_i13;
  int32_T c71_i14;
  int32_T c71_i15;
  int32_T c71_i16;
  int32_T c71_i17;
  int32_T c71_i18;
  int32_T c71_i19;
  int32_T c71_i20;
  int32_T c71_i21;
  int32_T c71_i22;
  int32_T c71_i23;
  int32_T c71_i24;
  int32_T c71_i25;
  int32_T c71_i26;
  int32_T c71_i27;
  int32_T c71_i28;
  int32_T c71_i29;
  int32_T c71_i30;
  int32_T c71_i31;
  int32_T c71_i32;
  int32_T c71_i33;
  int32_T c71_i34;
  int32_T c71_i35;
  int32_T c71_i36;
  int32_T c71_i37;
  int32_T c71_i38;
  int32_T c71_i39;
  int32_T c71_i40;
  int32_T c71_i41;
  int32_T c71_i42;
  real_T (*c71_b_H)[81];
  real_T (*c71_b_T_d_prev)[3];
  real_T (*c71_b_Q)[9];
  real_T (*c71_b_Omega)[9];
  real_T (*c71_b_W_u)[9];
  c71_b_W_u = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 0);
  c71_b_H = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
  c71_b_Omega = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 1);
  c71_b_Q = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 2);
  c71_b_T_d_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,70);
  for (c71_i2 = 0; c71_i2 < 9; c71_i2 = c71_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c71_b_W_u)[c71_i2], 0U);
  }

  for (c71_i3 = 0; c71_i3 < 81; c71_i3 = c71_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c71_b_H)[c71_i3], 1U);
  }

  for (c71_i4 = 0; c71_i4 < 9; c71_i4 = c71_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c71_b_Omega)[c71_i4], 2U);
  }

  for (c71_i5 = 0; c71_i5 < 9; c71_i5 = c71_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c71_b_Q)[c71_i5], 3U);
  }

  for (c71_i6 = 0; c71_i6 < 3; c71_i6 = c71_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c71_b_T_d_prev)[c71_i6], 4U);
  }

  c71_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,70);
  for (c71_i7 = 0; c71_i7 < 9; c71_i7 = c71_i7 + 1) {
    c71_W_u[c71_i7] = (*c71_b_W_u)[c71_i7];
  }

  for (c71_i8 = 0; c71_i8 < 9; c71_i8 = c71_i8 + 1) {
    c71_Omega[c71_i8] = (*c71_b_Omega)[c71_i8];
  }

  for (c71_i9 = 0; c71_i9 < 9; c71_i9 = c71_i9 + 1) {
    c71_Q[c71_i9] = (*c71_b_Q)[c71_i9];
  }

  for (c71_i10 = 0; c71_i10 < 3; c71_i10 = c71_i10 + 1) {
    c71_T_d_prev[c71_i10] = (*c71_b_T_d_prev)[c71_i10];
  }

  sf_debug_symbol_scope_push(9U, 0U);
  sf_debug_symbol_scope_add("nargout", &c71_nargout, c71_d_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c71_nargin, c71_d_sf_marshall);
  sf_debug_symbol_scope_add("i", &c71_i, c71_d_sf_marshall);
  sf_debug_symbol_scope_add("W", &c71_W, c71_sf_marshall);
  sf_debug_symbol_scope_add("H", &c71_H, c71_c_sf_marshall);
  sf_debug_symbol_scope_add("T_d_prev", &c71_T_d_prev, c71_b_sf_marshall);
  sf_debug_symbol_scope_add("Q", &c71_Q, c71_sf_marshall);
  sf_debug_symbol_scope_add("Omega", &c71_Omega, c71_sf_marshall);
  sf_debug_symbol_scope_add("W_u", &c71_W_u, c71_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  for (c71_i11 = 0; c71_i11 < 9; c71_i11 = c71_i11 + 1) {
    c71_W[c71_i11] = 0.0;
  }

  c71_i = 1.0;
  c71_b_i = 1.0;
  while (c71_b_i <= 3.0) {
    c71_i = c71_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,5);
    c71_A = c71_W_u[(_SFD_EML_ARRAY_BOUNDS_CHECK("W_u", (int32_T)
      _SFD_INTEGER_CHECK("i", c71_i), 1, 3, 1, 0) - 1) + 3 * (
      _SFD_EML_ARRAY_BOUNDS_CHECK("W_u", (int32_T)_SFD_INTEGER_CHECK("i", c71_i),
      1, 3, 2, 0) - 1)];
    c71_x = c71_T_d_prev[_SFD_EML_ARRAY_BOUNDS_CHECK("T_d_prev", (int32_T)
      _SFD_INTEGER_CHECK("i", c71_i), 1, 3, 1, 0) - 1];
    c71_b_x = c71_x;
    c71_y = muDoubleScalarAbs(c71_b_x);
    c71_B = c71_y + 1.0E-006;
    c71_c_x = c71_A;
    c71_b_y = c71_B;
    if (c71_b_y == 0.0) {
      c71_eml_warning();
    }

    c71_d_x = c71_c_x;
    c71_c_y = c71_b_y;
    c71_e_x = c71_d_x;
    c71_d_y = c71_c_y;
    c71_e_y = c71_e_x / c71_d_y;
    c71_W[(_SFD_EML_ARRAY_BOUNDS_CHECK("W", (int32_T)_SFD_INTEGER_CHECK("i",
             c71_i), 1, 3, 1, 0) - 1) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK
      ("W", (int32_T)_SFD_INTEGER_CHECK("i", c71_i), 1, 3, 2, 0) - 1)] = c71_e_y;
    c71_b_i = c71_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,8);
  c71_i12 = 0;
  c71_i13 = 0;
  for (c71_i14 = 0; c71_i14 < 3; c71_i14 = c71_i14 + 1) {
    for (c71_i15 = 0; c71_i15 < 3; c71_i15 = c71_i15 + 1) {
      c71_H[c71_i15 + c71_i12] = c71_W[c71_i15 + c71_i13];
    }

    c71_i12 = c71_i12 + 9;
    c71_i13 = c71_i13 + 3;
  }

  c71_i16 = 0;
  for (c71_i17 = 0; c71_i17 < 3; c71_i17 = c71_i17 + 1) {
    for (c71_i18 = 0; c71_i18 < 3; c71_i18 = c71_i18 + 1) {
      c71_H[(c71_i18 + c71_i16) + 27] = 0.0;
    }

    c71_i16 = c71_i16 + 9;
  }

  c71_i19 = 0;
  for (c71_i20 = 0; c71_i20 < 3; c71_i20 = c71_i20 + 1) {
    for (c71_i21 = 0; c71_i21 < 3; c71_i21 = c71_i21 + 1) {
      c71_H[(c71_i21 + c71_i19) + 54] = 0.0;
    }

    c71_i19 = c71_i19 + 9;
  }

  c71_i22 = 0;
  for (c71_i23 = 0; c71_i23 < 3; c71_i23 = c71_i23 + 1) {
    for (c71_i24 = 0; c71_i24 < 3; c71_i24 = c71_i24 + 1) {
      c71_H[(c71_i24 + c71_i22) + 3] = 0.0;
    }

    c71_i22 = c71_i22 + 9;
  }

  c71_i25 = 0;
  c71_i26 = 0;
  for (c71_i27 = 0; c71_i27 < 3; c71_i27 = c71_i27 + 1) {
    for (c71_i28 = 0; c71_i28 < 3; c71_i28 = c71_i28 + 1) {
      c71_H[(c71_i28 + c71_i25) + 30] = c71_Omega[c71_i28 + c71_i26];
    }

    c71_i25 = c71_i25 + 9;
    c71_i26 = c71_i26 + 3;
  }

  c71_i29 = 0;
  for (c71_i30 = 0; c71_i30 < 3; c71_i30 = c71_i30 + 1) {
    for (c71_i31 = 0; c71_i31 < 3; c71_i31 = c71_i31 + 1) {
      c71_H[(c71_i31 + c71_i29) + 57] = 0.0;
    }

    c71_i29 = c71_i29 + 9;
  }

  c71_i32 = 0;
  for (c71_i33 = 0; c71_i33 < 3; c71_i33 = c71_i33 + 1) {
    for (c71_i34 = 0; c71_i34 < 3; c71_i34 = c71_i34 + 1) {
      c71_H[(c71_i34 + c71_i32) + 6] = 0.0;
    }

    c71_i32 = c71_i32 + 9;
  }

  c71_i35 = 0;
  for (c71_i36 = 0; c71_i36 < 3; c71_i36 = c71_i36 + 1) {
    for (c71_i37 = 0; c71_i37 < 3; c71_i37 = c71_i37 + 1) {
      c71_H[(c71_i37 + c71_i35) + 33] = 0.0;
    }

    c71_i35 = c71_i35 + 9;
  }

  c71_i38 = 0;
  c71_i39 = 0;
  for (c71_i40 = 0; c71_i40 < 3; c71_i40 = c71_i40 + 1) {
    for (c71_i41 = 0; c71_i41 < 3; c71_i41 = c71_i41 + 1) {
      c71_H[(c71_i41 + c71_i38) + 60] = c71_Q[c71_i41 + c71_i39];
    }

    c71_i38 = c71_i38 + 9;
    c71_i39 = c71_i39 + 3;
  }

  _SFD_EML_CALL(0,-8);
  sf_debug_symbol_scope_pop();
  for (c71_i42 = 0; c71_i42 < 81; c71_i42 = c71_i42 + 1) {
    (*c71_b_H)[c71_i42] = c71_H[c71_i42];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,70);
  _sfEvent_ = c71_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c71_machineNumber, uint32_T
  c71_chartNumber)
{
}

static void c71_eml_warning(void)
{
  int32_T c71_i43;
  static char_T c71_cv0[15] = { 'D', 'i', 'v', 'i', 'd', 'e', ' ', 'b', 'y', ' ',
    'z', 'e', 'r', 'o', '.' };

  char_T c71_u[15];
  const mxArray *c71_y = NULL;
  int32_T c71_i44;
  static char_T c71_cv1[19] = { 'M', 'A', 'T', 'L', 'A', 'B', ':', 'd', 'i', 'v',
    'i', 'd', 'e', 'B', 'y', 'Z', 'e', 'r', 'o' };

  char_T c71_b_u[19];
  const mxArray *c71_b_y = NULL;
  for (c71_i43 = 0; c71_i43 < 15; c71_i43 = c71_i43 + 1) {
    c71_u[c71_i43] = c71_cv0[c71_i43];
  }

  c71_y = NULL;
  sf_mex_assign(&c71_y, sf_mex_create("y", &c71_u, 10, 0U, 1U, 0U, 2, 1, 15));
  for (c71_i44 = 0; c71_i44 < 19; c71_i44 = c71_i44 + 1) {
    c71_b_u[c71_i44] = c71_cv1[c71_i44];
  }

  c71_b_y = NULL;
  sf_mex_assign(&c71_b_y, sf_mex_create("y", &c71_b_u, 10, 0U, 1U, 0U, 2, 1, 19));
  sf_mex_call_debug("warning", 0U, 2U, 14, c71_b_y, 14, c71_y);
}

static const mxArray *c71_sf_marshall(void *c71_chartInstance, void *c71_u)
{
  const mxArray *c71_y = NULL;
  int32_T c71_i45;
  int32_T c71_i46;
  int32_T c71_i47;
  real_T c71_b_u[9];
  const mxArray *c71_b_y = NULL;
  c71_y = NULL;
  c71_i45 = 0;
  for (c71_i46 = 0; c71_i46 < 3; c71_i46 = c71_i46 + 1) {
    for (c71_i47 = 0; c71_i47 < 3; c71_i47 = c71_i47 + 1) {
      c71_b_u[c71_i47 + c71_i45] = (*((real_T (*)[9])c71_u))[c71_i47 + c71_i45];
    }

    c71_i45 = c71_i45 + 3;
  }

  c71_b_y = NULL;
  sf_mex_assign(&c71_b_y, sf_mex_create("y", &c71_b_u, 0, 0U, 1U, 0U, 2, 3, 3));
  sf_mex_assign(&c71_y, c71_b_y);
  return c71_y;
}

static const mxArray *c71_b_sf_marshall(void *c71_chartInstance, void *c71_u)
{
  const mxArray *c71_y = NULL;
  int32_T c71_i48;
  real_T c71_b_u[3];
  const mxArray *c71_b_y = NULL;
  c71_y = NULL;
  for (c71_i48 = 0; c71_i48 < 3; c71_i48 = c71_i48 + 1) {
    c71_b_u[c71_i48] = (*((real_T (*)[3])c71_u))[c71_i48];
  }

  c71_b_y = NULL;
  sf_mex_assign(&c71_b_y, sf_mex_create("y", &c71_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c71_y, c71_b_y);
  return c71_y;
}

static const mxArray *c71_c_sf_marshall(void *c71_chartInstance, void *c71_u)
{
  const mxArray *c71_y = NULL;
  int32_T c71_i49;
  int32_T c71_i50;
  int32_T c71_i51;
  real_T c71_b_u[81];
  const mxArray *c71_b_y = NULL;
  c71_y = NULL;
  c71_i49 = 0;
  for (c71_i50 = 0; c71_i50 < 9; c71_i50 = c71_i50 + 1) {
    for (c71_i51 = 0; c71_i51 < 9; c71_i51 = c71_i51 + 1) {
      c71_b_u[c71_i51 + c71_i49] = (*((real_T (*)[81])c71_u))[c71_i51 + c71_i49];
    }

    c71_i49 = c71_i49 + 9;
  }

  c71_b_y = NULL;
  sf_mex_assign(&c71_b_y, sf_mex_create("y", &c71_b_u, 0, 0U, 1U, 0U, 2, 9, 9));
  sf_mex_assign(&c71_y, c71_b_y);
  return c71_y;
}

static const mxArray *c71_d_sf_marshall(void *c71_chartInstance, void *c71_u)
{
  const mxArray *c71_y = NULL;
  real_T c71_b_u;
  const mxArray *c71_b_y = NULL;
  c71_y = NULL;
  c71_b_u = *((real_T *)c71_u);
  c71_b_y = NULL;
  sf_mex_assign(&c71_b_y, sf_mex_create("y", &c71_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c71_y, c71_b_y);
  return c71_y;
}

const mxArray *sf_c71_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c71_nameCaptureInfo = NULL;
  c71_ResolvedFunctionInfo c71_info[23];
  const mxArray *c71_m0 = NULL;
  int32_T c71_i52;
  c71_ResolvedFunctionInfo *c71_r0;
  c71_nameCaptureInfo = NULL;
  c71_info_helper(c71_info);
  sf_mex_assign(&c71_m0, sf_mex_createstruct("nameCaptureInfo", 1, 23));
  for (c71_i52 = 0; c71_i52 < 23; c71_i52 = c71_i52 + 1) {
    c71_r0 = &c71_info[c71_i52];
    sf_mex_addfield(c71_m0, sf_mex_create("nameCaptureInfo", c71_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c71_r0->context)), "context"
                    , "nameCaptureInfo", c71_i52);
    sf_mex_addfield(c71_m0, sf_mex_create("nameCaptureInfo", c71_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c71_r0->name)), "name",
                    "nameCaptureInfo", c71_i52);
    sf_mex_addfield(c71_m0, sf_mex_create("nameCaptureInfo",
      c71_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c71_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c71_i52);
    sf_mex_addfield(c71_m0, sf_mex_create("nameCaptureInfo", c71_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c71_r0->resolved)),
                    "resolved", "nameCaptureInfo", c71_i52);
    sf_mex_addfield(c71_m0, sf_mex_create("nameCaptureInfo", &c71_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c71_i52);
    sf_mex_addfield(c71_m0, sf_mex_create("nameCaptureInfo", &c71_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c71_i52);
    sf_mex_addfield(c71_m0, sf_mex_create("nameCaptureInfo", &c71_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c71_i52);
  }

  sf_mex_assign(&c71_nameCaptureInfo, c71_m0);
  return c71_nameCaptureInfo;
}

static void c71_info_helper(c71_ResolvedFunctionInfo c71_info[23])
{
  c71_info[0].context = "";
  c71_info[0].name = "zeros";
  c71_info[0].dominantType = "double";
  c71_info[0].resolved = "[B]zeros";
  c71_info[0].fileLength = 0U;
  c71_info[0].fileTime1 = 0U;
  c71_info[0].fileTime2 = 0U;
  c71_info[1].context = "";
  c71_info[1].name = "abs";
  c71_info[1].dominantType = "double";
  c71_info[1].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c71_info[1].fileLength = 566U;
  c71_info[1].fileTime1 = 1221267134U;
  c71_info[1].fileTime2 = 0U;
  c71_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c71_info[2].name = "nargin";
  c71_info[2].dominantType = "";
  c71_info[2].resolved = "[B]nargin";
  c71_info[2].fileLength = 0U;
  c71_info[2].fileTime1 = 0U;
  c71_info[2].fileTime2 = 0U;
  c71_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c71_info[3].name = "gt";
  c71_info[3].dominantType = "double";
  c71_info[3].resolved = "[B]gt";
  c71_info[3].fileLength = 0U;
  c71_info[3].fileTime1 = 0U;
  c71_info[3].fileTime2 = 0U;
  c71_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c71_info[4].name = "isa";
  c71_info[4].dominantType = "double";
  c71_info[4].resolved = "[B]isa";
  c71_info[4].fileLength = 0U;
  c71_info[4].fileTime1 = 0U;
  c71_info[4].fileTime2 = 0U;
  c71_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c71_info[5].name = "ischar";
  c71_info[5].dominantType = "double";
  c71_info[5].resolved = "[B]ischar";
  c71_info[5].fileLength = 0U;
  c71_info[5].fileTime1 = 0U;
  c71_info[5].fileTime2 = 0U;
  c71_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c71_info[6].name = "islogical";
  c71_info[6].dominantType = "double";
  c71_info[6].resolved = "[B]islogical";
  c71_info[6].fileLength = 0U;
  c71_info[6].fileTime1 = 0U;
  c71_info[6].fileTime2 = 0U;
  c71_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c71_info[7].name = "size";
  c71_info[7].dominantType = "double";
  c71_info[7].resolved = "[B]size";
  c71_info[7].fileLength = 0U;
  c71_info[7].fileTime1 = 0U;
  c71_info[7].fileTime2 = 0U;
  c71_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c71_info[8].name = "class";
  c71_info[8].dominantType = "double";
  c71_info[8].resolved = "[B]class";
  c71_info[8].fileLength = 0U;
  c71_info[8].fileTime1 = 0U;
  c71_info[8].fileTime2 = 0U;
  c71_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c71_info[9].name = "eml_scalar_abs";
  c71_info[9].dominantType = "double";
  c71_info[9].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c71_info[9].fileLength = 461U;
  c71_info[9].fileTime1 = 1203447960U;
  c71_info[9].fileTime2 = 0U;
  c71_info[10].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c71_info[10].name = "isinteger";
  c71_info[10].dominantType = "double";
  c71_info[10].resolved = "[B]isinteger";
  c71_info[10].fileLength = 0U;
  c71_info[10].fileTime1 = 0U;
  c71_info[10].fileTime2 = 0U;
  c71_info[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c71_info[11].name = "isreal";
  c71_info[11].dominantType = "double";
  c71_info[11].resolved = "[B]isreal";
  c71_info[11].fileLength = 0U;
  c71_info[11].fileTime1 = 0U;
  c71_info[11].fileTime2 = 0U;
  c71_info[12].context = "";
  c71_info[12].name = "plus";
  c71_info[12].dominantType = "double";
  c71_info[12].resolved = "[B]plus";
  c71_info[12].fileLength = 0U;
  c71_info[12].fileTime1 = 0U;
  c71_info[12].fileTime2 = 0U;
  c71_info[13].context = "";
  c71_info[13].name = "mrdivide";
  c71_info[13].dominantType = "double";
  c71_info[13].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c71_info[13].fileLength = 771U;
  c71_info[13].fileTime1 = 1219752936U;
  c71_info[13].fileTime2 = 0U;
  c71_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c71_info[14].name = "ge";
  c71_info[14].dominantType = "double";
  c71_info[14].resolved = "[B]ge";
  c71_info[14].fileLength = 0U;
  c71_info[14].fileTime1 = 0U;
  c71_info[14].fileTime2 = 0U;
  c71_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c71_info[15].name = "isscalar";
  c71_info[15].dominantType = "double";
  c71_info[15].resolved = "[B]isscalar";
  c71_info[15].fileLength = 0U;
  c71_info[15].fileTime1 = 0U;
  c71_info[15].fileTime2 = 0U;
  c71_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c71_info[16].name = "rdivide";
  c71_info[16].dominantType = "double";
  c71_info[16].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c71_info[16].fileLength = 620U;
  c71_info[16].fileTime1 = 1213926766U;
  c71_info[16].fileTime2 = 0U;
  c71_info[17].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c71_info[17].name = "isempty";
  c71_info[17].dominantType = "double";
  c71_info[17].resolved = "[B]isempty";
  c71_info[17].fileLength = 0U;
  c71_info[17].fileTime1 = 0U;
  c71_info[17].fileTime2 = 0U;
  c71_info[18].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c71_info[18].name = "not";
  c71_info[18].dominantType = "logical";
  c71_info[18].resolved = "[B]not";
  c71_info[18].fileLength = 0U;
  c71_info[18].fileTime1 = 0U;
  c71_info[18].fileTime2 = 0U;
  c71_info[19].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c71_info[19].name = "strcmp";
  c71_info[19].dominantType = "char";
  c71_info[19].resolved = "[B]strcmp";
  c71_info[19].fileLength = 0U;
  c71_info[19].fileTime1 = 0U;
  c71_info[19].fileTime2 = 0U;
  c71_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c71_info[20].name = "eq";
  c71_info[20].dominantType = "double";
  c71_info[20].resolved = "[B]eq";
  c71_info[20].fileLength = 0U;
  c71_info[20].fileTime1 = 0U;
  c71_info[20].fileTime2 = 0U;
  c71_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c71_info[21].name = "eml_warning";
  c71_info[21].dominantType = "char";
  c71_info[21].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c71_info[21].fileLength = 274U;
  c71_info[21].fileTime1 = 1227613396U;
  c71_info[21].fileTime2 = 0U;
  c71_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c71_info[22].name = "eml_div";
  c71_info[22].dominantType = "double";
  c71_info[22].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c71_info[22].fileLength = 4269U;
  c71_info[22].fileTime1 = 1227613386U;
  c71_info[22].fileTime2 = 0U;
}

static const mxArray *c71_emlrt_marshallOut(uint8_T c71_u)
{
  const mxArray *c71_y = NULL;
  c71_y = NULL;
  sf_mex_assign(&c71_y, sf_mex_create("y", &c71_u, 3, 0U, 0U, 0U, 0));
  return c71_y;
}

static void c71_emlrt_marshallIn(const mxArray *c71_H, char *c71_name, real_T
  c71_y[81])
{
  real_T c71_dv1[81];
  int32_T c71_i53;
  sf_mex_import(c71_name, sf_mex_dup(c71_H), &c71_dv1, 1, 0, 0U, 1, 0U, 2, 9, 9);
  for (c71_i53 = 0; c71_i53 < 81; c71_i53 = c71_i53 + 1) {
    c71_y[c71_i53] = c71_dv1[c71_i53];
  }

  sf_mex_destroy(&c71_H);
}

static uint8_T c71_b_emlrt_marshallIn(const mxArray *c71_b_is_active_c71_MCSim,
  char *c71_name)
{
  uint8_T c71_y;
  uint8_T c71_u0;
  sf_mex_import(c71_name, sf_mex_dup(c71_b_is_active_c71_MCSim), &c71_u0, 1, 3,
                0U, 0, 0U, 0);
  c71_y = c71_u0;
  sf_mex_destroy(&c71_b_is_active_c71_MCSim);
  return c71_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c71_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2323311935U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3164132819U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4095415982U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3415215364U);
}

mxArray *sf_c71_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1490502351U);
    pr[1] = (double)(2425494531U);
    pr[2] = (double)(1724114462U);
    pr[3] = (double)(2829977019U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(9);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c71_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"H\",},{M[8],M[0],T\"is_active_c71_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c71_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          71,
          1,
          1,
          5,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"W_u",0,c71_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 9;
            dimVector[1]= 9;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"H",0,c71_c_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Omega",0,NULL);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 3;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Q",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"T_d_prev",0,c71_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,1,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,258);
        _SFD_CV_INIT_EML_FOR(0,0,72,84,138);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c71_W_u)[9];
          real_T (*c71_H)[81];
          real_T (*c71_Omega)[9];
          real_T (*c71_Q)[9];
          real_T (*c71_T_d_prev)[3];
          c71_W_u = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 0);
          c71_H = (real_T (*)[81])ssGetOutputPortSignal(chartInstance.S, 1);
          c71_Omega = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 1);
          c71_Q = (real_T (*)[9])ssGetInputPortSignal(chartInstance.S, 2);
          c71_T_d_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
          _SFD_SET_DATA_VALUE_PTR(0U, c71_W_u);
          _SFD_SET_DATA_VALUE_PTR(1U, c71_H);
          _SFD_SET_DATA_VALUE_PTR(2U, c71_Omega);
          _SFD_SET_DATA_VALUE_PTR(3U, c71_Q);
          _SFD_SET_DATA_VALUE_PTR(4U, c71_T_d_prev);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c71_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c71_MCSim();
  initialize_c71_MCSim();
}

static void sf_opaque_enable_c71_MCSim(void *chartInstanceVar)
{
  enable_c71_MCSim();
}

static void sf_opaque_disable_c71_MCSim(void *chartInstanceVar)
{
  disable_c71_MCSim();
}

static void sf_opaque_gateway_c71_MCSim(void *chartInstanceVar)
{
  sf_c71_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c71_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c71_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c71_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c71_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c71_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c71_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c71_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c71_MCSim();
  }
}

static void mdlSetWorkWidths_c71_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",71);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",71,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",71,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",71,4);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",71,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",71);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2874126020U));
  ssSetChecksum1(S,(1431165833U));
  ssSetChecksum2(S,(2332525867U));
  ssSetChecksum3(S,(1126635148U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c71_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",71);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c71_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c71_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c71_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c71_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c71_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c71_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c71_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c71_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c71_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c71_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c71_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c71_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c71_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c71_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c71_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c71_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c71_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
