/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c73_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c73_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc73_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c73_MCSim(void);
static void initialize_params_c73_MCSim(void);
static void enable_c73_MCSim(void);
static void disable_c73_MCSim(void);
static void c73_update_debugger_state_c73_MCSim(void);
static const mxArray *get_sim_state_c73_MCSim(void);
static void set_sim_state_c73_MCSim(const mxArray *c73_st);
static void finalize_c73_MCSim(void);
static void sf_c73_MCSim(void);
static void c73_c73_MCSim(void);
static void init_script_number_translation(uint32_T c73_machineNumber, uint32_T
  c73_chartNumber);
static real_T c73_min(real_T c73_varargin_1, real_T c73_varargin_2);
static real_T c73_max(real_T c73_varargin_1, real_T c73_varargin_2);
static const mxArray *c73_sf_marshall(void *c73_chartInstance, void *c73_u);
static const mxArray *c73_b_sf_marshall(void *c73_chartInstance, void *c73_u);
static const mxArray *c73_c_sf_marshall(void *c73_chartInstance, void *c73_u);
static void c73_info_helper(c73_ResolvedFunctionInfo c73_info[35]);
static const mxArray *c73_emlrt_marshallOut(uint8_T c73_u);
static void c73_emlrt_marshallIn(const mxArray *c73_lbX_thrustAngleConstraint,
  char *c73_name, real_T c73_y[9]);
static void c73_b_emlrt_marshallIn(const mxArray *c73_ubX_thrustAngleConstraint,
  char *c73_name, real_T c73_y[9]);
static uint8_T c73_c_emlrt_marshallIn(const mxArray *c73_b_is_active_c73_MCSim,
  char *c73_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c73_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c73_is_active_c73_MCSim = 0U;
}

static void initialize_params_c73_MCSim(void)
{
}

static void enable_c73_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c73_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c73_update_debugger_state_c73_MCSim(void)
{
}

static const mxArray *get_sim_state_c73_MCSim(void)
{
  const mxArray *c73_st = NULL;
  const mxArray *c73_y = NULL;
  int32_T c73_i0;
  real_T c73_u[9];
  const mxArray *c73_b_y = NULL;
  int32_T c73_i1;
  real_T c73_b_u[9];
  const mxArray *c73_c_y = NULL;
  real_T (*c73_ubX_thrustAngleConstraint)[9];
  real_T (*c73_lbX_thrustAngleConstraint)[9];
  c73_lbX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 1);
  c73_ubX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 2);
  c73_st = NULL;
  c73_y = NULL;
  sf_mex_assign(&c73_y, sf_mex_createcellarray(3));
  for (c73_i0 = 0; c73_i0 < 9; c73_i0 = c73_i0 + 1) {
    c73_u[c73_i0] = (*c73_lbX_thrustAngleConstraint)[c73_i0];
  }

  c73_b_y = NULL;
  sf_mex_assign(&c73_b_y, sf_mex_create("y", &c73_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_setcell(c73_y, 0, c73_b_y);
  for (c73_i1 = 0; c73_i1 < 9; c73_i1 = c73_i1 + 1) {
    c73_b_u[c73_i1] = (*c73_ubX_thrustAngleConstraint)[c73_i1];
  }

  c73_c_y = NULL;
  sf_mex_assign(&c73_c_y, sf_mex_create("y", &c73_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_setcell(c73_y, 1, c73_c_y);
  sf_mex_setcell(c73_y, 2, c73_emlrt_marshallOut
                 (chartInstance.c73_is_active_c73_MCSim));
  sf_mex_assign(&c73_st, c73_y);
  return c73_st;
}

static void set_sim_state_c73_MCSim(const mxArray *c73_st)
{
  const mxArray *c73_u;
  real_T c73_dv0[9];
  int32_T c73_i2;
  real_T c73_dv1[9];
  int32_T c73_i3;
  real_T (*c73_lbX_thrustAngleConstraint)[9];
  real_T (*c73_ubX_thrustAngleConstraint)[9];
  c73_lbX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 1);
  c73_ubX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 2);
  chartInstance.c73_doneDoubleBufferReInit = true;
  c73_u = sf_mex_dup(c73_st);
  c73_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c73_u, 0)),
                       "lbX_thrustAngleConstraint", c73_dv0);
  for (c73_i2 = 0; c73_i2 < 9; c73_i2 = c73_i2 + 1) {
    (*c73_lbX_thrustAngleConstraint)[c73_i2] = c73_dv0[c73_i2];
  }

  c73_b_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c73_u, 1)),
    "ubX_thrustAngleConstraint", c73_dv1);
  for (c73_i3 = 0; c73_i3 < 9; c73_i3 = c73_i3 + 1) {
    (*c73_ubX_thrustAngleConstraint)[c73_i3] = c73_dv1[c73_i3];
  }

  chartInstance.c73_is_active_c73_MCSim = c73_c_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c73_u, 2)), "is_active_c73_MCSim");
  sf_mex_destroy(&c73_u);
  c73_update_debugger_state_c73_MCSim();
  sf_mex_destroy(&c73_st);
}

static void finalize_c73_MCSim(void)
{
}

static void sf_c73_MCSim(void)
{
  int32_T c73_i4;
  int32_T c73_i5;
  int32_T c73_i6;
  int32_T c73_i7;
  int32_T c73_i8;
  int32_T c73_i9;
  int32_T c73_i10;
  int32_T c73_i11;
  int32_T c73_i12;
  int32_T c73_i13;
  int32_T c73_i14;
  int32_T c73_i15;
  int32_T c73_i16;
  uint8_T c73_previousEvent;
  real_T *c73_stepLength;
  real_T *c73_c1;
  real_T (*c73_s_min)[3];
  real_T (*c73_s_max)[3];
  real_T (*c73_ubX_thrustAngleConstraint)[9];
  real_T (*c73_delta_max)[3];
  real_T (*c73_alpha_min)[3];
  real_T (*c73_alpha_max)[3];
  real_T (*c73_alpha_prev)[3];
  real_T (*c73_delta_T_min)[3];
  real_T (*c73_delta_T_max)[3];
  real_T (*c73_T_min)[3];
  real_T (*c73_T_max)[3];
  real_T (*c73_T_prev)[3];
  real_T (*c73_lbX_thrustAngleConstraint)[9];
  c73_alpha_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 5);
  c73_delta_T_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
  c73_alpha_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 7);
  c73_stepLength = (real_T *)ssGetInputPortSignal(chartInstance.S, 11);
  c73_c1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 12);
  c73_delta_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 8);
  c73_delta_T_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 4);
  c73_lbX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 1);
  c73_s_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 9);
  c73_T_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  c73_T_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c73_ubX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 2);
  c73_T_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  c73_alpha_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 6);
  c73_s_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 10);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,72);
  for (c73_i4 = 0; c73_i4 < 9; c73_i4 = c73_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_lbX_thrustAngleConstraint)[c73_i4], 0U);
  }

  for (c73_i5 = 0; c73_i5 < 3; c73_i5 = c73_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_T_prev)[c73_i5], 1U);
  }

  for (c73_i6 = 0; c73_i6 < 3; c73_i6 = c73_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_T_max)[c73_i6], 2U);
  }

  for (c73_i7 = 0; c73_i7 < 3; c73_i7 = c73_i7 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_T_min)[c73_i7], 3U);
  }

  for (c73_i8 = 0; c73_i8 < 3; c73_i8 = c73_i8 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_delta_T_max)[c73_i8], 4U);
  }

  for (c73_i9 = 0; c73_i9 < 3; c73_i9 = c73_i9 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_delta_T_min)[c73_i9], 5U);
  }

  for (c73_i10 = 0; c73_i10 < 3; c73_i10 = c73_i10 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_alpha_prev)[c73_i10], 6U);
  }

  for (c73_i11 = 0; c73_i11 < 3; c73_i11 = c73_i11 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_alpha_max)[c73_i11], 7U);
  }

  for (c73_i12 = 0; c73_i12 < 3; c73_i12 = c73_i12 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_alpha_min)[c73_i12], 8U);
  }

  for (c73_i13 = 0; c73_i13 < 3; c73_i13 = c73_i13 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_delta_max)[c73_i13], 9U);
  }

  for (c73_i14 = 0; c73_i14 < 9; c73_i14 = c73_i14 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_ubX_thrustAngleConstraint)[c73_i14], 10U);
  }

  for (c73_i15 = 0; c73_i15 < 3; c73_i15 = c73_i15 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_s_max)[c73_i15], 11U);
  }

  for (c73_i16 = 0; c73_i16 < 3; c73_i16 = c73_i16 + 1) {
    _SFD_DATA_RANGE_CHECK((*c73_s_min)[c73_i16], 12U);
  }

  _SFD_DATA_RANGE_CHECK(*c73_stepLength, 13U);
  _SFD_DATA_RANGE_CHECK(*c73_c1, 14U);
  c73_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  c73_c73_MCSim();
  _sfEvent_ = c73_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void c73_c73_MCSim(void)
{
  int32_T c73_i17;
  real_T c73_T_prev[3];
  int32_T c73_i18;
  real_T c73_T_max[3];
  int32_T c73_i19;
  real_T c73_T_min[3];
  int32_T c73_i20;
  real_T c73_delta_T_max[3];
  int32_T c73_i21;
  real_T c73_delta_T_min[3];
  int32_T c73_i22;
  real_T c73_alpha_prev[3];
  int32_T c73_i23;
  real_T c73_alpha_max[3];
  int32_T c73_i24;
  real_T c73_alpha_min[3];
  int32_T c73_i25;
  real_T c73_delta_max[3];
  int32_T c73_i26;
  real_T c73_s_max[3];
  int32_T c73_i27;
  real_T c73_s_min[3];
  real_T c73_stepLength;
  real_T c73_c1;
  real_T c73_nargout = 2.0;
  real_T c73_nargin = 13.0;
  real_T c73_iterativeConstraintLb;
  real_T c73_iterativeConstraintUb;
  real_T c73_i;
  real_T c73_alpha_minus[3];
  real_T c73_alpha_plus[3];
  real_T c73_T_minus[3];
  real_T c73_T_plus[3];
  real_T c73_ns;
  real_T c73_na;
  real_T c73_nt;
  real_T c73_ubX_thrustAngleConstraint[9];
  real_T c73_lbX_thrustAngleConstraint[9];
  int32_T c73_i28;
  int32_T c73_i29;
  int32_T c73_i30;
  int32_T c73_i31;
  real_T c73_b_i;
  real_T c73_a;
  real_T c73_b;
  real_T c73_b_a;
  real_T c73_b_b;
  real_T c73_y;
  real_T c73_c_a;
  real_T c73_c_b;
  real_T c73_b_y;
  real_T c73_d_a;
  real_T c73_d_b;
  real_T c73_e_a;
  real_T c73_e_b;
  real_T c73_c_y;
  real_T c73_f_a;
  real_T c73_f_b;
  real_T c73_d_y;
  real_T c73_c_i;
  real_T c73_g_a;
  real_T c73_g_b;
  real_T c73_h_a;
  real_T c73_h_b;
  real_T c73_i_a;
  real_T c73_i_b;
  real_T c73_e_y;
  real_T c73_j_a;
  real_T c73_j_b;
  real_T c73_f_y;
  real_T c73_k_a;
  real_T c73_k_b;
  real_T c73_l_a;
  real_T c73_l_b;
  real_T c73_m_a;
  real_T c73_m_b;
  real_T c73_g_y;
  real_T c73_n_a;
  real_T c73_n_b;
  real_T c73_h_y;
  int32_T c73_i32;
  int32_T c73_i33;
  int32_T c73_i34;
  int32_T c73_i35;
  int32_T c73_i36;
  int32_T c73_i37;
  int32_T c73_i38;
  int32_T c73_i39;
  int32_T c73_i40;
  int32_T c73_i41;
  real_T *c73_b_stepLength;
  real_T *c73_b_c1;
  real_T (*c73_b_lbX_thrustAngleConstraint)[9];
  real_T (*c73_b_ubX_thrustAngleConstraint)[9];
  real_T (*c73_b_s_min)[3];
  real_T (*c73_b_s_max)[3];
  real_T (*c73_b_delta_max)[3];
  real_T (*c73_b_alpha_min)[3];
  real_T (*c73_b_alpha_max)[3];
  real_T (*c73_b_alpha_prev)[3];
  real_T (*c73_b_delta_T_min)[3];
  real_T (*c73_b_delta_T_max)[3];
  real_T (*c73_b_T_min)[3];
  real_T (*c73_b_T_max)[3];
  real_T (*c73_b_T_prev)[3];
  c73_b_alpha_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 5);
  c73_b_delta_T_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 3);
  c73_b_alpha_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 7);
  c73_b_stepLength = (real_T *)ssGetInputPortSignal(chartInstance.S, 11);
  c73_b_c1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 12);
  c73_b_delta_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 8);
  c73_b_delta_T_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 4);
  c73_b_lbX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 1);
  c73_b_s_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 9);
  c73_b_T_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  c73_b_T_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c73_b_ubX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
    (chartInstance.S, 2);
  c73_b_T_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  c73_b_alpha_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 6);
  c73_b_s_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 10);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,72);
  for (c73_i17 = 0; c73_i17 < 3; c73_i17 = c73_i17 + 1) {
    c73_T_prev[c73_i17] = (*c73_b_T_prev)[c73_i17];
  }

  for (c73_i18 = 0; c73_i18 < 3; c73_i18 = c73_i18 + 1) {
    c73_T_max[c73_i18] = (*c73_b_T_max)[c73_i18];
  }

  for (c73_i19 = 0; c73_i19 < 3; c73_i19 = c73_i19 + 1) {
    c73_T_min[c73_i19] = (*c73_b_T_min)[c73_i19];
  }

  for (c73_i20 = 0; c73_i20 < 3; c73_i20 = c73_i20 + 1) {
    c73_delta_T_max[c73_i20] = (*c73_b_delta_T_max)[c73_i20];
  }

  for (c73_i21 = 0; c73_i21 < 3; c73_i21 = c73_i21 + 1) {
    c73_delta_T_min[c73_i21] = (*c73_b_delta_T_min)[c73_i21];
  }

  for (c73_i22 = 0; c73_i22 < 3; c73_i22 = c73_i22 + 1) {
    c73_alpha_prev[c73_i22] = (*c73_b_alpha_prev)[c73_i22];
  }

  for (c73_i23 = 0; c73_i23 < 3; c73_i23 = c73_i23 + 1) {
    c73_alpha_max[c73_i23] = (*c73_b_alpha_max)[c73_i23];
  }

  for (c73_i24 = 0; c73_i24 < 3; c73_i24 = c73_i24 + 1) {
    c73_alpha_min[c73_i24] = (*c73_b_alpha_min)[c73_i24];
  }

  for (c73_i25 = 0; c73_i25 < 3; c73_i25 = c73_i25 + 1) {
    c73_delta_max[c73_i25] = (*c73_b_delta_max)[c73_i25];
  }

  for (c73_i26 = 0; c73_i26 < 3; c73_i26 = c73_i26 + 1) {
    c73_s_max[c73_i26] = (*c73_b_s_max)[c73_i26];
  }

  for (c73_i27 = 0; c73_i27 < 3; c73_i27 = c73_i27 + 1) {
    c73_s_min[c73_i27] = (*c73_b_s_min)[c73_i27];
  }

  c73_stepLength = *c73_b_stepLength;
  c73_c1 = *c73_b_c1;
  sf_debug_symbol_scope_push(27U, 0U);
  sf_debug_symbol_scope_add("nargout", &c73_nargout, c73_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c73_nargin, c73_b_sf_marshall);
  sf_debug_symbol_scope_add("iterativeConstraintLb", &c73_iterativeConstraintLb,
    c73_b_sf_marshall);
  sf_debug_symbol_scope_add("iterativeConstraintUb", &c73_iterativeConstraintUb,
    c73_b_sf_marshall);
  sf_debug_symbol_scope_add("i", &c73_i, c73_b_sf_marshall);
  sf_debug_symbol_scope_add("alpha_minus", &c73_alpha_minus, c73_sf_marshall);
  sf_debug_symbol_scope_add("alpha_plus", &c73_alpha_plus, c73_sf_marshall);
  sf_debug_symbol_scope_add("T_minus", &c73_T_minus, c73_sf_marshall);
  sf_debug_symbol_scope_add("T_plus", &c73_T_plus, c73_sf_marshall);
  sf_debug_symbol_scope_add("ns", &c73_ns, c73_b_sf_marshall);
  sf_debug_symbol_scope_add("na", &c73_na, c73_b_sf_marshall);
  sf_debug_symbol_scope_add("nt", &c73_nt, c73_b_sf_marshall);
  sf_debug_symbol_scope_add("ubX_thrustAngleConstraint",
    &c73_ubX_thrustAngleConstraint, c73_c_sf_marshall);
  sf_debug_symbol_scope_add("lbX_thrustAngleConstraint",
    &c73_lbX_thrustAngleConstraint, c73_c_sf_marshall);
  sf_debug_symbol_scope_add("c1", &c73_c1, c73_b_sf_marshall);
  sf_debug_symbol_scope_add("stepLength", &c73_stepLength, c73_b_sf_marshall);
  sf_debug_symbol_scope_add("s_min", &c73_s_min, c73_sf_marshall);
  sf_debug_symbol_scope_add("s_max", &c73_s_max, c73_sf_marshall);
  sf_debug_symbol_scope_add("delta_max", &c73_delta_max, c73_sf_marshall);
  sf_debug_symbol_scope_add("alpha_min", &c73_alpha_min, c73_sf_marshall);
  sf_debug_symbol_scope_add("alpha_max", &c73_alpha_max, c73_sf_marshall);
  sf_debug_symbol_scope_add("alpha_prev", &c73_alpha_prev, c73_sf_marshall);
  sf_debug_symbol_scope_add("delta_T_min", &c73_delta_T_min, c73_sf_marshall);
  sf_debug_symbol_scope_add("delta_T_max", &c73_delta_T_max, c73_sf_marshall);
  sf_debug_symbol_scope_add("T_min", &c73_T_min, c73_sf_marshall);
  sf_debug_symbol_scope_add("T_max", &c73_T_max, c73_sf_marshall);
  sf_debug_symbol_scope_add("T_prev", &c73_T_prev, c73_sf_marshall);
  CV_EML_FCN(0, 0);

  /*     %% If more unequality constraints are needed, must these be added to A in the Qp problem. */
  _SFD_EML_CALL(0,3);
  c73_nt = 3.0;
  _SFD_EML_CALL(0,4);
  c73_na = 3.0;
  _SFD_EML_CALL(0,5);
  c73_ns = 3.0;
  _SFD_EML_CALL(0,6);
  for (c73_i28 = 0; c73_i28 < 3; c73_i28 = c73_i28 + 1) {
    c73_T_plus[c73_i28] = 0.0;
  }

  _SFD_EML_CALL(0,7);
  for (c73_i29 = 0; c73_i29 < 3; c73_i29 = c73_i29 + 1) {
    c73_T_minus[c73_i29] = 0.0;
  }

  _SFD_EML_CALL(0,8);
  for (c73_i30 = 0; c73_i30 < 3; c73_i30 = c73_i30 + 1) {
    c73_alpha_plus[c73_i30] = 0.0;
  }

  _SFD_EML_CALL(0,9);
  for (c73_i31 = 0; c73_i31 < 3; c73_i31 = c73_i31 + 1) {
    c73_alpha_minus[c73_i31] = 0.0;
  }

  c73_i = 1.0;
  c73_b_i = 1.0;
  while (c73_b_i <= 3.0) {
    c73_i = c73_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,11);
    c73_a = c73_c1;
    c73_b = c73_delta_T_min[_SFD_EML_ARRAY_BOUNDS_CHECK("delta_T_min", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1];
    c73_b_a = c73_a * c73_b;
    c73_b_b = c73_stepLength;
    c73_y = c73_b_a * c73_b_b;
    c73_c_a = c73_delta_T_max[_SFD_EML_ARRAY_BOUNDS_CHECK("delta_T_max",
      (int32_T)_SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1];
    c73_c_b = c73_stepLength;
    c73_b_y = c73_c_a * c73_c_b;
    c73_T_plus[_SFD_EML_ARRAY_BOUNDS_CHECK("T_plus", (int32_T)_SFD_INTEGER_CHECK
      ("i", c73_i), 1, 3, 1, 0) - 1] = c73_max(c73_min(
      c73_T_max[_SFD_EML_ARRAY_BOUNDS_CHECK("T_max", (int32_T)_SFD_INTEGER_CHECK
      ("i", c73_i), 1, 3, 1, 0) - 1], c73_T_prev[
      _SFD_EML_ARRAY_BOUNDS_CHECK("T_prev", (int32_T)_SFD_INTEGER_CHECK("i",
      c73_i), 1, 3, 1, 0) - 1] + c73_b_y), c73_T_prev[
      _SFD_EML_ARRAY_BOUNDS_CHECK("T_prev", (int32_T)_SFD_INTEGER_CHECK("i",
      c73_i), 1, 3, 1, 0) - 1] + c73_y);
    _SFD_EML_CALL(0,12);
    c73_d_a = c73_c1;
    c73_d_b = c73_delta_T_max[_SFD_EML_ARRAY_BOUNDS_CHECK("delta_T_max",
      (int32_T)_SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1];
    c73_e_a = c73_d_a * c73_d_b;
    c73_e_b = c73_stepLength;
    c73_c_y = c73_e_a * c73_e_b;
    c73_f_a = c73_delta_T_min[_SFD_EML_ARRAY_BOUNDS_CHECK("delta_T_min",
      (int32_T)_SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1];
    c73_f_b = c73_stepLength;
    c73_d_y = c73_f_a * c73_f_b;
    c73_T_minus[_SFD_EML_ARRAY_BOUNDS_CHECK("T_minus", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1] = c73_min(c73_max(
      c73_T_min[_SFD_EML_ARRAY_BOUNDS_CHECK("T_min", (int32_T)_SFD_INTEGER_CHECK
      ("i", c73_i), 1, 3, 1, 0) - 1], c73_T_prev[
      _SFD_EML_ARRAY_BOUNDS_CHECK("T_prev", (int32_T)_SFD_INTEGER_CHECK("i",
      c73_i), 1, 3, 1, 0) - 1] + c73_d_y), c73_T_prev[
      _SFD_EML_ARRAY_BOUNDS_CHECK("T_prev", (int32_T)_SFD_INTEGER_CHECK("i",
      c73_i), 1, 3, 1, 0) - 1] + c73_c_y);
    c73_b_i = c73_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  c73_i = 1.0;
  c73_c_i = 1.0;
  while (c73_c_i <= 3.0) {
    c73_i = c73_c_i;
    CV_EML_FOR(0, 1, 1);
    _SFD_EML_CALL(0,15);
    c73_g_a = c73_delta_max[_SFD_EML_ARRAY_BOUNDS_CHECK("delta_max", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1];
    c73_g_b = c73_stepLength;
    c73_h_a = c73_g_a * c73_g_b;
    c73_h_b = c73_c1;
    c73_i_a = c73_h_a * c73_h_b;
    c73_i_b = c73_stepLength;
    c73_e_y = c73_i_a * c73_i_b;
    c73_j_a = c73_delta_max[_SFD_EML_ARRAY_BOUNDS_CHECK("delta_max", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1];
    c73_j_b = c73_stepLength;
    c73_f_y = c73_j_a * c73_j_b;
    c73_alpha_plus[_SFD_EML_ARRAY_BOUNDS_CHECK("alpha_plus", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1] = c73_max(c73_min
      (c73_alpha_max[_SFD_EML_ARRAY_BOUNDS_CHECK("alpha_max", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1], c73_alpha_prev[
       _SFD_EML_ARRAY_BOUNDS_CHECK("alpha_prev", (int32_T)_SFD_INTEGER_CHECK("i",
      c73_i), 1, 3, 1, 0) - 1] + c73_f_y), c73_alpha_prev[
      _SFD_EML_ARRAY_BOUNDS_CHECK("alpha_prev", (int32_T)_SFD_INTEGER_CHECK("i",
      c73_i), 1, 3, 1, 0) - 1] - c73_e_y);
    _SFD_EML_CALL(0,16);
    c73_k_a = c73_delta_max[_SFD_EML_ARRAY_BOUNDS_CHECK("delta_max", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1];
    c73_k_b = c73_stepLength;
    c73_l_a = c73_k_a * c73_k_b;
    c73_l_b = c73_c1;
    c73_m_a = c73_l_a * c73_l_b;
    c73_m_b = c73_stepLength;
    c73_g_y = c73_m_a * c73_m_b;
    c73_n_a = c73_delta_max[_SFD_EML_ARRAY_BOUNDS_CHECK("delta_max", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1];
    c73_n_b = c73_stepLength;
    c73_h_y = c73_n_a * c73_n_b;
    c73_alpha_minus[_SFD_EML_ARRAY_BOUNDS_CHECK("alpha_minus", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1] = c73_min(
      c73_max(c73_alpha_min[_SFD_EML_ARRAY_BOUNDS_CHECK("alpha_min", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1],
              c73_alpha_prev[_SFD_EML_ARRAY_BOUNDS_CHECK("alpha_prev", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1] - c73_h_y),
      c73_alpha_prev[_SFD_EML_ARRAY_BOUNDS_CHECK("alpha_prev", (int32_T)
      _SFD_INTEGER_CHECK("i", c73_i), 1, 3, 1, 0) - 1] + c73_g_y);
    c73_c_i = c73_c_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 1, 0);
  _SFD_EML_CALL(0,19);
  c73_iterativeConstraintUb = 1.0;
  _SFD_EML_CALL(0,20);
  c73_iterativeConstraintLb = 1.0;
  _SFD_EML_CALL(0,21);
  for (c73_i32 = 0; c73_i32 < 9; c73_i32 = c73_i32 + 1) {
    c73_lbX_thrustAngleConstraint[c73_i32] = 0.0;
  }

  _SFD_EML_CALL(0,22);
  for (c73_i33 = 0; c73_i33 < 9; c73_i33 = c73_i33 + 1) {
    c73_ubX_thrustAngleConstraint[c73_i33] = 0.0;
  }

  /*  Thrust Constraints      */
  /*  Maximum Thrust Constraint */
  _SFD_EML_CALL(0,27);
  for (c73_i34 = 0; c73_i34 < 3; c73_i34 = c73_i34 + 1) {
    c73_ubX_thrustAngleConstraint[c73_i34] = c73_T_plus[c73_i34] -
      c73_T_prev[c73_i34];
  }

  _SFD_EML_CALL(0,28);
  c73_iterativeConstraintUb = 4.0;

  /* Minimum Thrust Constraint */
  _SFD_EML_CALL(0,31);
  for (c73_i35 = 0; c73_i35 < 3; c73_i35 = c73_i35 + 1) {
    c73_lbX_thrustAngleConstraint[c73_i35] = c73_T_minus[c73_i35] -
      c73_T_prev[c73_i35];
  }

  _SFD_EML_CALL(0,32);
  c73_iterativeConstraintLb = 4.0;

  /*  Azimuth Angle Constraints */
  /* iterativeA = iterativeA + ns; */
  /* Maximum Azimuth Angle */
  _SFD_EML_CALL(0,38);
  for (c73_i36 = 0; c73_i36 < 3; c73_i36 = c73_i36 + 1) {
    c73_ubX_thrustAngleConstraint[c73_i36 + 3] = c73_alpha_plus[c73_i36] -
      c73_alpha_prev[c73_i36];
  }

  _SFD_EML_CALL(0,39);
  c73_iterativeConstraintUb = 7.0;

  /* Minimum Azimuth Angle */
  _SFD_EML_CALL(0,42);
  for (c73_i37 = 0; c73_i37 < 3; c73_i37 = c73_i37 + 1) {
    c73_lbX_thrustAngleConstraint[c73_i37 + 3] = c73_alpha_minus[c73_i37] -
      c73_alpha_prev[c73_i37];
  }

  _SFD_EML_CALL(0,43);
  c73_iterativeConstraintLb = 7.0;

  /*  s constraints */
  _SFD_EML_CALL(0,46);
  for (c73_i38 = 0; c73_i38 < 3; c73_i38 = c73_i38 + 1) {
    c73_ubX_thrustAngleConstraint[c73_i38 + 6] = c73_s_max[c73_i38];
  }

  _SFD_EML_CALL(0,48);
  for (c73_i39 = 0; c73_i39 < 3; c73_i39 = c73_i39 + 1) {
    c73_lbX_thrustAngleConstraint[c73_i39 + 6] = c73_s_min[c73_i39];
  }

  _SFD_EML_CALL(0,-48);
  sf_debug_symbol_scope_pop();
  for (c73_i40 = 0; c73_i40 < 9; c73_i40 = c73_i40 + 1) {
    (*c73_b_lbX_thrustAngleConstraint)[c73_i40] =
      c73_lbX_thrustAngleConstraint[c73_i40];
  }

  for (c73_i41 = 0; c73_i41 < 9; c73_i41 = c73_i41 + 1) {
    (*c73_b_ubX_thrustAngleConstraint)[c73_i41] =
      c73_ubX_thrustAngleConstraint[c73_i41];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,72);
}

static void init_script_number_translation(uint32_T c73_machineNumber, uint32_T
  c73_chartNumber)
{
}

static real_T c73_min(real_T c73_varargin_1, real_T c73_varargin_2)
{
  real_T c73_x;
  real_T c73_y;
  real_T c73_b_x;
  real_T c73_b_y;
  real_T c73_xk;
  real_T c73_yk;
  real_T c73_c_x;
  real_T c73_c_y;
  real_T c73_rx;
  real_T c73_ry;
  real_T c73_d_x;
  boolean_T c73_b;
  c73_x = c73_varargin_1;
  c73_y = c73_varargin_2;
  c73_b_x = c73_x;
  c73_b_y = c73_y;
  c73_xk = c73_b_x;
  c73_yk = c73_b_y;
  c73_c_x = c73_xk;
  c73_c_y = c73_yk;
  c73_rx = c73_xk;
  c73_ry = c73_yk;
  if (c73_rx > c73_ry) {
  } else {
    c73_d_x = c73_rx;
    c73_b = rtIsNaN(c73_d_x);
    if (c73_b) {
    } else {
      return c73_c_x;
    }
  }

  return c73_c_y;
}

static real_T c73_max(real_T c73_varargin_1, real_T c73_varargin_2)
{
  real_T c73_x;
  real_T c73_y;
  real_T c73_b_x;
  real_T c73_b_y;
  real_T c73_xk;
  real_T c73_yk;
  real_T c73_c_x;
  real_T c73_c_y;
  real_T c73_rx;
  real_T c73_ry;
  real_T c73_d_x;
  boolean_T c73_b;
  c73_x = c73_varargin_1;
  c73_y = c73_varargin_2;
  c73_b_x = c73_x;
  c73_b_y = c73_y;
  c73_xk = c73_b_x;
  c73_yk = c73_b_y;
  c73_c_x = c73_xk;
  c73_c_y = c73_yk;
  c73_rx = c73_xk;
  c73_ry = c73_yk;
  if (c73_rx < c73_ry) {
  } else {
    c73_d_x = c73_rx;
    c73_b = rtIsNaN(c73_d_x);
    if (c73_b) {
    } else {
      return c73_c_x;
    }
  }

  return c73_c_y;
}

static const mxArray *c73_sf_marshall(void *c73_chartInstance, void *c73_u)
{
  const mxArray *c73_y = NULL;
  int32_T c73_i42;
  real_T c73_b_u[3];
  const mxArray *c73_b_y = NULL;
  c73_y = NULL;
  for (c73_i42 = 0; c73_i42 < 3; c73_i42 = c73_i42 + 1) {
    c73_b_u[c73_i42] = (*((real_T (*)[3])c73_u))[c73_i42];
  }

  c73_b_y = NULL;
  sf_mex_assign(&c73_b_y, sf_mex_create("y", &c73_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c73_y, c73_b_y);
  return c73_y;
}

static const mxArray *c73_b_sf_marshall(void *c73_chartInstance, void *c73_u)
{
  const mxArray *c73_y = NULL;
  real_T c73_b_u;
  const mxArray *c73_b_y = NULL;
  c73_y = NULL;
  c73_b_u = *((real_T *)c73_u);
  c73_b_y = NULL;
  sf_mex_assign(&c73_b_y, sf_mex_create("y", &c73_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c73_y, c73_b_y);
  return c73_y;
}

static const mxArray *c73_c_sf_marshall(void *c73_chartInstance, void *c73_u)
{
  const mxArray *c73_y = NULL;
  int32_T c73_i43;
  real_T c73_b_u[9];
  const mxArray *c73_b_y = NULL;
  c73_y = NULL;
  for (c73_i43 = 0; c73_i43 < 9; c73_i43 = c73_i43 + 1) {
    c73_b_u[c73_i43] = (*((real_T (*)[9])c73_u))[c73_i43];
  }

  c73_b_y = NULL;
  sf_mex_assign(&c73_b_y, sf_mex_create("y", &c73_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_assign(&c73_y, c73_b_y);
  return c73_y;
}

const mxArray *sf_c73_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c73_nameCaptureInfo = NULL;
  c73_ResolvedFunctionInfo c73_info[35];
  const mxArray *c73_m0 = NULL;
  int32_T c73_i44;
  c73_ResolvedFunctionInfo *c73_r0;
  c73_nameCaptureInfo = NULL;
  c73_info_helper(c73_info);
  sf_mex_assign(&c73_m0, sf_mex_createstruct("nameCaptureInfo", 1, 35));
  for (c73_i44 = 0; c73_i44 < 35; c73_i44 = c73_i44 + 1) {
    c73_r0 = &c73_info[c73_i44];
    sf_mex_addfield(c73_m0, sf_mex_create("nameCaptureInfo", c73_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c73_r0->context)), "context"
                    , "nameCaptureInfo", c73_i44);
    sf_mex_addfield(c73_m0, sf_mex_create("nameCaptureInfo", c73_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c73_r0->name)), "name",
                    "nameCaptureInfo", c73_i44);
    sf_mex_addfield(c73_m0, sf_mex_create("nameCaptureInfo",
      c73_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c73_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c73_i44);
    sf_mex_addfield(c73_m0, sf_mex_create("nameCaptureInfo", c73_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c73_r0->resolved)),
                    "resolved", "nameCaptureInfo", c73_i44);
    sf_mex_addfield(c73_m0, sf_mex_create("nameCaptureInfo", &c73_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c73_i44);
    sf_mex_addfield(c73_m0, sf_mex_create("nameCaptureInfo", &c73_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c73_i44);
    sf_mex_addfield(c73_m0, sf_mex_create("nameCaptureInfo", &c73_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c73_i44);
  }

  sf_mex_assign(&c73_nameCaptureInfo, c73_m0);
  return c73_nameCaptureInfo;
}

static void c73_info_helper(c73_ResolvedFunctionInfo c73_info[35])
{
  c73_info[0].context = "";
  c73_info[0].name = "zeros";
  c73_info[0].dominantType = "double";
  c73_info[0].resolved = "[B]zeros";
  c73_info[0].fileLength = 0U;
  c73_info[0].fileTime1 = 0U;
  c73_info[0].fileTime2 = 0U;
  c73_info[1].context = "";
  c73_info[1].name = "plus";
  c73_info[1].dominantType = "double";
  c73_info[1].resolved = "[B]plus";
  c73_info[1].fileLength = 0U;
  c73_info[1].fileTime1 = 0U;
  c73_info[1].fileTime2 = 0U;
  c73_info[2].context = "";
  c73_info[2].name = "mtimes";
  c73_info[2].dominantType = "double";
  c73_info[2].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[2].fileLength = 2408U;
  c73_info[2].fileTime1 = 1227613402U;
  c73_info[2].fileTime2 = 0U;
  c73_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[3].name = "nargin";
  c73_info[3].dominantType = "";
  c73_info[3].resolved = "[B]nargin";
  c73_info[3].fileLength = 0U;
  c73_info[3].fileTime1 = 0U;
  c73_info[3].fileTime2 = 0U;
  c73_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[4].name = "gt";
  c73_info[4].dominantType = "double";
  c73_info[4].resolved = "[B]gt";
  c73_info[4].fileLength = 0U;
  c73_info[4].fileTime1 = 0U;
  c73_info[4].fileTime2 = 0U;
  c73_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[5].name = "isa";
  c73_info[5].dominantType = "double";
  c73_info[5].resolved = "[B]isa";
  c73_info[5].fileLength = 0U;
  c73_info[5].fileTime1 = 0U;
  c73_info[5].fileTime2 = 0U;
  c73_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[6].name = "isinteger";
  c73_info[6].dominantType = "double";
  c73_info[6].resolved = "[B]isinteger";
  c73_info[6].fileLength = 0U;
  c73_info[6].fileTime1 = 0U;
  c73_info[6].fileTime2 = 0U;
  c73_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[7].name = "isscalar";
  c73_info[7].dominantType = "double";
  c73_info[7].resolved = "[B]isscalar";
  c73_info[7].fileLength = 0U;
  c73_info[7].fileTime1 = 0U;
  c73_info[7].fileTime2 = 0U;
  c73_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[8].name = "strcmp";
  c73_info[8].dominantType = "char";
  c73_info[8].resolved = "[B]strcmp";
  c73_info[8].fileLength = 0U;
  c73_info[8].fileTime1 = 0U;
  c73_info[8].fileTime2 = 0U;
  c73_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[9].name = "size";
  c73_info[9].dominantType = "double";
  c73_info[9].resolved = "[B]size";
  c73_info[9].fileLength = 0U;
  c73_info[9].fileTime1 = 0U;
  c73_info[9].fileTime2 = 0U;
  c73_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[10].name = "eq";
  c73_info[10].dominantType = "double";
  c73_info[10].resolved = "[B]eq";
  c73_info[10].fileLength = 0U;
  c73_info[10].fileTime1 = 0U;
  c73_info[10].fileTime2 = 0U;
  c73_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[11].name = "class";
  c73_info[11].dominantType = "double";
  c73_info[11].resolved = "[B]class";
  c73_info[11].fileLength = 0U;
  c73_info[11].fileTime1 = 0U;
  c73_info[11].fileTime2 = 0U;
  c73_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c73_info[12].name = "not";
  c73_info[12].dominantType = "logical";
  c73_info[12].resolved = "[B]not";
  c73_info[12].fileLength = 0U;
  c73_info[12].fileTime1 = 0U;
  c73_info[12].fileTime2 = 0U;
  c73_info[13].context = "";
  c73_info[13].name = "min";
  c73_info[13].dominantType = "double";
  c73_info[13].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c73_info[13].fileLength = 308U;
  c73_info[13].fileTime1 = 1192466634U;
  c73_info[13].fileTime2 = 0U;
  c73_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c73_info[14].name = "nargout";
  c73_info[14].dominantType = "";
  c73_info[14].resolved = "[B]nargout";
  c73_info[14].fileLength = 0U;
  c73_info[14].fileTime1 = 0U;
  c73_info[14].fileTime2 = 0U;
  c73_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c73_info[15].name = "le";
  c73_info[15].dominantType = "double";
  c73_info[15].resolved = "[B]le";
  c73_info[15].fileLength = 0U;
  c73_info[15].fileTime1 = 0U;
  c73_info[15].fileTime2 = 0U;
  c73_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c73_info[16].name = "eml_min_or_max";
  c73_info[16].dominantType = "char";
  c73_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c73_info[16].fileLength = 8839U;
  c73_info[16].fileTime1 = 1227613388U;
  c73_info[16].fileTime2 = 0U;
  c73_info[17].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c73_info[17].name = "ischar";
  c73_info[17].dominantType = "char";
  c73_info[17].resolved = "[B]ischar";
  c73_info[17].fileLength = 0U;
  c73_info[17].fileTime1 = 0U;
  c73_info[17].fileTime2 = 0U;
  c73_info[18].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c73_info[18].name = "isnumeric";
  c73_info[18].dominantType = "double";
  c73_info[18].resolved = "[B]isnumeric";
  c73_info[18].fileLength = 0U;
  c73_info[18].fileTime1 = 0U;
  c73_info[18].fileTime2 = 0U;
  c73_info[19].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c73_info[19].name = "isreal";
  c73_info[19].dominantType = "double";
  c73_info[19].resolved = "[B]isreal";
  c73_info[19].fileLength = 0U;
  c73_info[19].fileTime1 = 0U;
  c73_info[19].fileTime2 = 0U;
  c73_info[20].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_bin_extremum";
  c73_info[20].name = "islogical";
  c73_info[20].dominantType = "double";
  c73_info[20].resolved = "[B]islogical";
  c73_info[20].fileLength = 0U;
  c73_info[20].fileTime1 = 0U;
  c73_info[20].fileTime2 = 0U;
  c73_info[21].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_bin_extremum";
  c73_info[21].name = "eml_scalar_eg";
  c73_info[21].dominantType = "double";
  c73_info[21].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c73_info[21].fileLength = 3524U;
  c73_info[21].fileTime1 = 1227613394U;
  c73_info[21].fileTime2 = 0U;
  c73_info[22].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/any_enums";
  c73_info[22].name = "false";
  c73_info[22].dominantType = "";
  c73_info[22].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c73_info[22].fileLength = 238U;
  c73_info[22].fileTime1 = 1192466720U;
  c73_info[22].fileTime2 = 0U;
  c73_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c73_info[23].name = "logical";
  c73_info[23].dominantType = "double";
  c73_info[23].resolved = "[B]logical";
  c73_info[23].fileLength = 0U;
  c73_info[23].fileTime1 = 0U;
  c73_info[23].fileTime2 = 0U;
  c73_info[24].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c73_info[24].name = "isstruct";
  c73_info[24].dominantType = "double";
  c73_info[24].resolved = "[B]isstruct";
  c73_info[24].fileLength = 0U;
  c73_info[24].fileTime1 = 0U;
  c73_info[24].fileTime2 = 0U;
  c73_info[25].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/zerosum";
  c73_info[25].name = "cast";
  c73_info[25].dominantType = "double";
  c73_info[25].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c73_info[25].fileLength = 889U;
  c73_info[25].fileTime1 = 1225989442U;
  c73_info[25].fileTime2 = 0U;
  c73_info[26].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c73_info[26].name = "ge";
  c73_info[26].dominantType = "double";
  c73_info[26].resolved = "[B]ge";
  c73_info[26].fileLength = 0U;
  c73_info[26].fileTime1 = 0U;
  c73_info[26].fileTime2 = 0U;
  c73_info[27].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c73_info[27].name = "double";
  c73_info[27].dominantType = "double";
  c73_info[27].resolved = "[B]double";
  c73_info[27].fileLength = 0U;
  c73_info[27].fileTime1 = 0U;
  c73_info[27].fileTime2 = 0U;
  c73_info[28].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_bin_extremum";
  c73_info[28].name = "eml_scalexp_alloc";
  c73_info[28].dominantType = "double";
  c73_info[28].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c73_info[28].fileLength = 794U;
  c73_info[28].fileTime1 = 1227613394U;
  c73_info[28].fileTime2 = 0U;
  c73_info[29].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c73_info[29].name = "minus";
  c73_info[29].dominantType = "double";
  c73_info[29].resolved = "[B]minus";
  c73_info[29].fileLength = 0U;
  c73_info[29].fileTime1 = 0U;
  c73_info[29].fileTime2 = 0U;
  c73_info[30].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_bin_extremum";
  c73_info[30].name = "eml_index_class";
  c73_info[30].dominantType = "";
  c73_info[30].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c73_info[30].fileLength = 909U;
  c73_info[30].fileTime1 = 1192466782U;
  c73_info[30].fileTime2 = 0U;
  c73_info[31].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_bin_extremum";
  c73_info[31].name = "ones";
  c73_info[31].dominantType = "char";
  c73_info[31].resolved = "[B]ones";
  c73_info[31].fileLength = 0U;
  c73_info[31].fileTime1 = 0U;
  c73_info[31].fileTime2 = 0U;
  c73_info[32].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_scalar_bin_extremum";
  c73_info[32].name = "isnan";
  c73_info[32].dominantType = "double";
  c73_info[32].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c73_info[32].fileLength = 506U;
  c73_info[32].fileTime1 = 1227613388U;
  c73_info[32].fileTime2 = 0U;
  c73_info[33].context = "";
  c73_info[33].name = "max";
  c73_info[33].dominantType = "double";
  c73_info[33].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/datafun/max.m";
  c73_info[33].fileLength = 308U;
  c73_info[33].fileTime1 = 1192466630U;
  c73_info[33].fileTime2 = 0U;
  c73_info[34].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m/eml_scalar_bin_extremum";
  c73_info[34].name = "lt";
  c73_info[34].dominantType = "double";
  c73_info[34].resolved = "[B]lt";
  c73_info[34].fileLength = 0U;
  c73_info[34].fileTime1 = 0U;
  c73_info[34].fileTime2 = 0U;
}

static const mxArray *c73_emlrt_marshallOut(uint8_T c73_u)
{
  const mxArray *c73_y = NULL;
  c73_y = NULL;
  sf_mex_assign(&c73_y, sf_mex_create("y", &c73_u, 3, 0U, 0U, 0U, 0));
  return c73_y;
}

static void c73_emlrt_marshallIn(const mxArray *c73_lbX_thrustAngleConstraint,
  char *c73_name, real_T c73_y[9])
{
  real_T c73_dv2[9];
  int32_T c73_i45;
  sf_mex_import(c73_name, sf_mex_dup(c73_lbX_thrustAngleConstraint), &c73_dv2, 1,
                0, 0U, 1, 0U, 1, 9);
  for (c73_i45 = 0; c73_i45 < 9; c73_i45 = c73_i45 + 1) {
    c73_y[c73_i45] = c73_dv2[c73_i45];
  }

  sf_mex_destroy(&c73_lbX_thrustAngleConstraint);
}

static void c73_b_emlrt_marshallIn(const mxArray *c73_ubX_thrustAngleConstraint,
  char *c73_name, real_T c73_y[9])
{
  real_T c73_dv3[9];
  int32_T c73_i46;
  sf_mex_import(c73_name, sf_mex_dup(c73_ubX_thrustAngleConstraint), &c73_dv3, 1,
                0, 0U, 1, 0U, 1, 9);
  for (c73_i46 = 0; c73_i46 < 9; c73_i46 = c73_i46 + 1) {
    c73_y[c73_i46] = c73_dv3[c73_i46];
  }

  sf_mex_destroy(&c73_ubX_thrustAngleConstraint);
}

static uint8_T c73_c_emlrt_marshallIn(const mxArray *c73_b_is_active_c73_MCSim,
  char *c73_name)
{
  uint8_T c73_y;
  uint8_T c73_u0;
  sf_mex_import(c73_name, sf_mex_dup(c73_b_is_active_c73_MCSim), &c73_u0, 1, 3,
                0U, 0, 0U, 0);
  c73_y = c73_u0;
  sf_mex_destroy(&c73_b_is_active_c73_MCSim);
  return c73_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c73_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2828632990U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(660579879U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4071822658U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2518321598U);
}

mxArray *sf_c73_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2998020752U);
    pr[1] = (double)(4290391027U);
    pr[2] = (double)(1932639440U);
    pr[3] = (double)(3319035082U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,13,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,9,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }

    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,10,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,10,"type",mxType);
    }

    mxSetField(mxData,10,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,11,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,11,"type",mxType);
    }

    mxSetField(mxData,11,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,12,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,12,"type",mxType);
    }

    mxSetField(mxData,12,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c73_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[22],T\"lbX_thrustAngleConstraint\",},{M[1],M[10],T\"ubX_thrustAngleConstraint\",},{M[8],M[0],T\"is_active_c73_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c73_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          73,
          1,
          1,
          15,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(0,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"lbX_thrustAngleConstraint",0,
                                c73_c_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"T_prev",0,c73_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"T_max",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"T_min",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"delta_T_max",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(5,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"delta_T_min",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(6,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"alpha_prev",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(7,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"alpha_max",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(8,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"alpha_min",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(9,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"delta_max",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(10,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"ubX_thrustAngleConstraint",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(11,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s_max",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(12,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"s_min",0,NULL);
          }

          _SFD_SET_DATA_PROPS(13,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "stepLength",0,c73_b_sf_marshall);
          _SFD_SET_DATA_PROPS(14,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"c1",0,
                              NULL);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,2,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,2356);
        _SFD_CV_INIT_EML_FOR(0,0,462,473,723);
        _SFD_CV_INIT_EML_FOR(0,1,728,739,1035);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c73_lbX_thrustAngleConstraint)[9];
          real_T (*c73_T_prev)[3];
          real_T (*c73_T_max)[3];
          real_T (*c73_T_min)[3];
          real_T (*c73_delta_T_max)[3];
          real_T (*c73_delta_T_min)[3];
          real_T (*c73_alpha_prev)[3];
          real_T (*c73_alpha_max)[3];
          real_T (*c73_alpha_min)[3];
          real_T (*c73_delta_max)[3];
          real_T (*c73_ubX_thrustAngleConstraint)[9];
          real_T (*c73_s_max)[3];
          real_T (*c73_s_min)[3];
          real_T *c73_stepLength;
          real_T *c73_c1;
          c73_alpha_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S,
            5);
          c73_delta_T_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S,
            3);
          c73_alpha_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 7);
          c73_stepLength = (real_T *)ssGetInputPortSignal(chartInstance.S, 11);
          c73_c1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 12);
          c73_delta_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 8);
          c73_delta_T_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S,
            4);
          c73_lbX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
            (chartInstance.S, 1);
          c73_s_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 9);
          c73_T_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
          c73_T_prev = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
          c73_ubX_thrustAngleConstraint = (real_T (*)[9])ssGetOutputPortSignal
            (chartInstance.S, 2);
          c73_T_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
          c73_alpha_max = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 6);
          c73_s_min = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 10);
          _SFD_SET_DATA_VALUE_PTR(0U, c73_lbX_thrustAngleConstraint);
          _SFD_SET_DATA_VALUE_PTR(1U, c73_T_prev);
          _SFD_SET_DATA_VALUE_PTR(2U, c73_T_max);
          _SFD_SET_DATA_VALUE_PTR(3U, c73_T_min);
          _SFD_SET_DATA_VALUE_PTR(4U, c73_delta_T_max);
          _SFD_SET_DATA_VALUE_PTR(5U, c73_delta_T_min);
          _SFD_SET_DATA_VALUE_PTR(6U, c73_alpha_prev);
          _SFD_SET_DATA_VALUE_PTR(7U, c73_alpha_max);
          _SFD_SET_DATA_VALUE_PTR(8U, c73_alpha_min);
          _SFD_SET_DATA_VALUE_PTR(9U, c73_delta_max);
          _SFD_SET_DATA_VALUE_PTR(10U, c73_ubX_thrustAngleConstraint);
          _SFD_SET_DATA_VALUE_PTR(11U, c73_s_max);
          _SFD_SET_DATA_VALUE_PTR(12U, c73_s_min);
          _SFD_SET_DATA_VALUE_PTR(13U, c73_stepLength);
          _SFD_SET_DATA_VALUE_PTR(14U, c73_c1);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c73_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c73_MCSim();
  initialize_c73_MCSim();
}

static void sf_opaque_enable_c73_MCSim(void *chartInstanceVar)
{
  enable_c73_MCSim();
}

static void sf_opaque_disable_c73_MCSim(void *chartInstanceVar)
{
  disable_c73_MCSim();
}

static void sf_opaque_gateway_c73_MCSim(void *chartInstanceVar)
{
  sf_c73_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c73_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c73_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c73_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c73_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c73_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c73_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c73_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c73_MCSim();
  }
}

static void mdlSetWorkWidths_c73_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",73);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",73,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",73,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 9, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 10, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 11, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 12, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",73,13);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",73,2);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",73);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2496618958U));
  ssSetChecksum1(S,(3596524288U));
  ssSetChecksum2(S,(4292533699U));
  ssSetChecksum3(S,(447533151U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c73_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",73);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c73_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c73_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c73_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c73_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c73_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c73_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c73_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c73_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c73_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c73_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c73_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c73_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c73_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c73_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c73_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c73_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c73_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
