/* Include files */

#include "blascompat32.h"
#include "MCSim_sfun.h"
#include "c84_MCSim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "MCSim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c84_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc84_MCSimInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c84_MCSim(void);
static void initialize_params_c84_MCSim(void);
static void enable_c84_MCSim(void);
static void disable_c84_MCSim(void);
static void c84_update_debugger_state_c84_MCSim(void);
static const mxArray *get_sim_state_c84_MCSim(void);
static void set_sim_state_c84_MCSim(const mxArray *c84_st);
static void finalize_c84_MCSim(void);
static void sf_c84_MCSim(void);
static void init_script_number_translation(uint32_T c84_machineNumber, uint32_T
  c84_chartNumber);
static const mxArray *c84_sf_marshall(void *c84_chartInstance, void *c84_u);
static const mxArray *c84_b_sf_marshall(void *c84_chartInstance, void *c84_u);
static const mxArray *c84_c_sf_marshall(void *c84_chartInstance, void *c84_u);
static const mxArray *c84_emlrt_marshallOut(uint8_T c84_u);
static void c84_emlrt_marshallIn(const mxArray *c84_g, char *c84_name, real_T
  c84_y[9]);
static uint8_T c84_b_emlrt_marshallIn(const mxArray *c84_b_is_active_c84_MCSim,
  char *c84_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c84_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c84_is_active_c84_MCSim = 0U;
}

static void initialize_params_c84_MCSim(void)
{
}

static void enable_c84_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c84_MCSim(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c84_update_debugger_state_c84_MCSim(void)
{
}

static const mxArray *get_sim_state_c84_MCSim(void)
{
  const mxArray *c84_st = NULL;
  const mxArray *c84_y = NULL;
  int32_T c84_i0;
  real_T c84_u[9];
  const mxArray *c84_b_y = NULL;
  real_T (*c84_g)[9];
  c84_g = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  c84_st = NULL;
  c84_y = NULL;
  sf_mex_assign(&c84_y, sf_mex_createcellarray(2));
  for (c84_i0 = 0; c84_i0 < 9; c84_i0 = c84_i0 + 1) {
    c84_u[c84_i0] = (*c84_g)[c84_i0];
  }

  c84_b_y = NULL;
  sf_mex_assign(&c84_b_y, sf_mex_create("y", &c84_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_setcell(c84_y, 0, c84_b_y);
  sf_mex_setcell(c84_y, 1, c84_emlrt_marshallOut
                 (chartInstance.c84_is_active_c84_MCSim));
  sf_mex_assign(&c84_st, c84_y);
  return c84_st;
}

static void set_sim_state_c84_MCSim(const mxArray *c84_st)
{
  const mxArray *c84_u;
  real_T c84_dv0[9];
  int32_T c84_i1;
  real_T (*c84_g)[9];
  c84_g = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c84_doneDoubleBufferReInit = true;
  c84_u = sf_mex_dup(c84_st);
  c84_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c84_u, 0)), "g", c84_dv0);
  for (c84_i1 = 0; c84_i1 < 9; c84_i1 = c84_i1 + 1) {
    (*c84_g)[c84_i1] = c84_dv0[c84_i1];
  }

  chartInstance.c84_is_active_c84_MCSim = c84_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c84_u, 1)), "is_active_c84_MCSim");
  sf_mex_destroy(&c84_u);
  c84_update_debugger_state_c84_MCSim();
  sf_mex_destroy(&c84_st);
}

static void finalize_c84_MCSim(void)
{
}

static void sf_c84_MCSim(void)
{
  int32_T c84_i2;
  int32_T c84_i3;
  int32_T c84_i4;
  int32_T c84_i5;
  uint8_T c84_previousEvent;
  int32_T c84_i6;
  real_T c84_g_delta_thrust[3];
  int32_T c84_i7;
  real_T c84_g_delta_alpha[3];
  int32_T c84_i8;
  real_T c84_g_s[3];
  real_T c84_nargout = 1.0;
  real_T c84_nargin = 3.0;
  real_T c84_g[9];
  int32_T c84_i9;
  int32_T c84_i10;
  int32_T c84_i11;
  int32_T c84_i12;
  real_T (*c84_b_g)[9];
  real_T (*c84_b_g_s)[3];
  real_T (*c84_b_g_delta_alpha)[3];
  real_T (*c84_b_g_delta_thrust)[3];
  c84_b_g_delta_thrust = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c84_b_g_s = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  c84_b_g_delta_alpha = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  c84_b_g = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,83);
  for (c84_i2 = 0; c84_i2 < 3; c84_i2 = c84_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c84_b_g_delta_thrust)[c84_i2], 0U);
  }

  for (c84_i3 = 0; c84_i3 < 3; c84_i3 = c84_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c84_b_g_delta_alpha)[c84_i3], 1U);
  }

  for (c84_i4 = 0; c84_i4 < 9; c84_i4 = c84_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c84_b_g)[c84_i4], 2U);
  }

  for (c84_i5 = 0; c84_i5 < 3; c84_i5 = c84_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c84_b_g_s)[c84_i5], 3U);
  }

  c84_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,83);
  for (c84_i6 = 0; c84_i6 < 3; c84_i6 = c84_i6 + 1) {
    c84_g_delta_thrust[c84_i6] = (*c84_b_g_delta_thrust)[c84_i6];
  }

  for (c84_i7 = 0; c84_i7 < 3; c84_i7 = c84_i7 + 1) {
    c84_g_delta_alpha[c84_i7] = (*c84_b_g_delta_alpha)[c84_i7];
  }

  for (c84_i8 = 0; c84_i8 < 3; c84_i8 = c84_i8 + 1) {
    c84_g_s[c84_i8] = (*c84_b_g_s)[c84_i8];
  }

  sf_debug_symbol_scope_push(6U, 0U);
  sf_debug_symbol_scope_add("nargout", &c84_nargout, c84_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c84_nargin, c84_c_sf_marshall);
  sf_debug_symbol_scope_add("g", &c84_g, c84_b_sf_marshall);
  sf_debug_symbol_scope_add("g_s", &c84_g_s, c84_sf_marshall);
  sf_debug_symbol_scope_add("g_delta_alpha", &c84_g_delta_alpha, c84_sf_marshall);
  sf_debug_symbol_scope_add("g_delta_thrust", &c84_g_delta_thrust,
    c84_sf_marshall);
  CV_EML_FCN(0, 0);

  /* Combining all parts of the G vector */
  _SFD_EML_CALL(0,4);
  for (c84_i9 = 0; c84_i9 < 3; c84_i9 = c84_i9 + 1) {
    c84_g[c84_i9] = c84_g_delta_thrust[c84_i9];
  }

  for (c84_i10 = 0; c84_i10 < 3; c84_i10 = c84_i10 + 1) {
    c84_g[c84_i10 + 3] = c84_g_delta_alpha[c84_i10];
  }

  for (c84_i11 = 0; c84_i11 < 3; c84_i11 = c84_i11 + 1) {
    c84_g[c84_i11 + 6] = c84_g_s[c84_i11];
  }

  _SFD_EML_CALL(0,-4);
  sf_debug_symbol_scope_pop();
  for (c84_i12 = 0; c84_i12 < 9; c84_i12 = c84_i12 + 1) {
    (*c84_b_g)[c84_i12] = c84_g[c84_i12];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,83);
  _sfEvent_ = c84_previousEvent;
  sf_debug_check_for_state_inconsistency(_MCSimMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c84_machineNumber, uint32_T
  c84_chartNumber)
{
}

static const mxArray *c84_sf_marshall(void *c84_chartInstance, void *c84_u)
{
  const mxArray *c84_y = NULL;
  int32_T c84_i13;
  real_T c84_b_u[3];
  const mxArray *c84_b_y = NULL;
  c84_y = NULL;
  for (c84_i13 = 0; c84_i13 < 3; c84_i13 = c84_i13 + 1) {
    c84_b_u[c84_i13] = (*((real_T (*)[3])c84_u))[c84_i13];
  }

  c84_b_y = NULL;
  sf_mex_assign(&c84_b_y, sf_mex_create("y", &c84_b_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c84_y, c84_b_y);
  return c84_y;
}

static const mxArray *c84_b_sf_marshall(void *c84_chartInstance, void *c84_u)
{
  const mxArray *c84_y = NULL;
  int32_T c84_i14;
  real_T c84_b_u[9];
  const mxArray *c84_b_y = NULL;
  c84_y = NULL;
  for (c84_i14 = 0; c84_i14 < 9; c84_i14 = c84_i14 + 1) {
    c84_b_u[c84_i14] = (*((real_T (*)[9])c84_u))[c84_i14];
  }

  c84_b_y = NULL;
  sf_mex_assign(&c84_b_y, sf_mex_create("y", &c84_b_u, 0, 0U, 1U, 0U, 1, 9));
  sf_mex_assign(&c84_y, c84_b_y);
  return c84_y;
}

static const mxArray *c84_c_sf_marshall(void *c84_chartInstance, void *c84_u)
{
  const mxArray *c84_y = NULL;
  real_T c84_b_u;
  const mxArray *c84_b_y = NULL;
  c84_y = NULL;
  c84_b_u = *((real_T *)c84_u);
  c84_b_y = NULL;
  sf_mex_assign(&c84_b_y, sf_mex_create("y", &c84_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c84_y, c84_b_y);
  return c84_y;
}

const mxArray *sf_c84_MCSim_get_eml_resolved_functions_info(void)
{
  const mxArray *c84_nameCaptureInfo = NULL;
  c84_nameCaptureInfo = NULL;
  sf_mex_assign(&c84_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1));
  return c84_nameCaptureInfo;
}

static const mxArray *c84_emlrt_marshallOut(uint8_T c84_u)
{
  const mxArray *c84_y = NULL;
  c84_y = NULL;
  sf_mex_assign(&c84_y, sf_mex_create("y", &c84_u, 3, 0U, 0U, 0U, 0));
  return c84_y;
}

static void c84_emlrt_marshallIn(const mxArray *c84_g, char *c84_name, real_T
  c84_y[9])
{
  real_T c84_dv1[9];
  int32_T c84_i15;
  sf_mex_import(c84_name, sf_mex_dup(c84_g), &c84_dv1, 1, 0, 0U, 1, 0U, 1, 9);
  for (c84_i15 = 0; c84_i15 < 9; c84_i15 = c84_i15 + 1) {
    c84_y[c84_i15] = c84_dv1[c84_i15];
  }

  sf_mex_destroy(&c84_g);
}

static uint8_T c84_b_emlrt_marshallIn(const mxArray *c84_b_is_active_c84_MCSim,
  char *c84_name)
{
  uint8_T c84_y;
  uint8_T c84_u0;
  sf_mex_import(c84_name, sf_mex_dup(c84_b_is_active_c84_MCSim), &c84_u0, 1, 3,
                0U, 0, 0U, 0);
  c84_y = c84_u0;
  sf_mex_destroy(&c84_b_is_active_c84_MCSim);
  return c84_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c84_MCSim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2733374349U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3612020759U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4204308144U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1464810204U);
}

mxArray *sf_c84_MCSim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1017934893U);
    pr[1] = (double)(2226210902U);
    pr[2] = (double)(2185801424U);
    pr[3] = (double)(3440175685U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c84_MCSim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"g\",},{M[8],M[0],T\"is_active_c84_MCSim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c84_MCSim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_MCSimMachineNumber_,
          84,
          1,
          1,
          4,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_MCSimMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_MCSimMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_MCSimMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"g_delta_thrust",0,c84_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"g_delta_alpha",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 9;
            _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"g",0,c84_b_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 1;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"g_s",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,155);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c84_g_delta_thrust)[3];
          real_T (*c84_g_delta_alpha)[3];
          real_T (*c84_g)[9];
          real_T (*c84_g_s)[3];
          c84_g_delta_thrust = (real_T (*)[3])ssGetInputPortSignal
            (chartInstance.S, 0);
          c84_g_s = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
          c84_g_delta_alpha = (real_T (*)[3])ssGetInputPortSignal
            (chartInstance.S, 1);
          c84_g = (real_T (*)[9])ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c84_g_delta_thrust);
          _SFD_SET_DATA_VALUE_PTR(1U, c84_g_delta_alpha);
          _SFD_SET_DATA_VALUE_PTR(2U, c84_g);
          _SFD_SET_DATA_VALUE_PTR(3U, c84_g_s);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_MCSimMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c84_MCSim(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c84_MCSim();
  initialize_c84_MCSim();
}

static void sf_opaque_enable_c84_MCSim(void *chartInstanceVar)
{
  enable_c84_MCSim();
}

static void sf_opaque_disable_c84_MCSim(void *chartInstanceVar)
{
  disable_c84_MCSim();
}

static void sf_opaque_gateway_c84_MCSim(void *chartInstanceVar)
{
  sf_c84_MCSim();
}

static mxArray* sf_opaque_get_sim_state_c84_MCSim(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c84_MCSim();
  return st;
}

static void sf_opaque_set_sim_state_c84_MCSim(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c84_MCSim(sf_mex_dup(st));
}

static void sf_opaque_terminate_c84_MCSim(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c84_MCSim();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c84_MCSim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c84_MCSim();
  }
}

static void mdlSetWorkWidths_c84_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("MCSim","MCSim",84);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("MCSim","MCSim",84,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("MCSim","MCSim",84,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"MCSim","MCSim",84,3);
      sf_mark_chart_reusable_outputs(S,"MCSim","MCSim",84,1);
    }

    sf_set_rtw_dwork_info(S,"MCSim","MCSim",84);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3382696121U));
  ssSetChecksum1(S,(2936235301U));
  ssSetChecksum2(S,(458501848U));
  ssSetChecksum3(S,(3508117485U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c84_MCSim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "MCSim", "MCSim",84);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c84_MCSim(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c84_MCSim;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c84_MCSim;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c84_MCSim;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c84_MCSim;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c84_MCSim;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c84_MCSim;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c84_MCSim;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c84_MCSim;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c84_MCSim;
  chartInstance.chartInfo.mdlStart = mdlStart_c84_MCSim;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c84_MCSim;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c84_MCSim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c84_MCSim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c84_MCSim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c84_MCSim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c84_MCSim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
